#include <sourcemod>
#include <sdktools>
#include <sdkhooks>
#include <cstrike>
#include <smlib>
#include <multicolors>
#include <mapzonelib>

#include "roleplay/roleplay_level"
#include "roleplay/roleplay_crime"
#include "roleplay/roleplay_items"
#include "roleplay/roleplay_items_furniture"
#include "roleplay/roleplay_items_medic"
#include "roleplay/roleplay_items_weapon"
#include "roleplay/roleplay_items_ammo"
#include "roleplay/roleplay_money"
#include "roleplay/roleplay_npcs"
#include "roleplay/roleplay_players"
#include "roleplay/roleplay_sql"
#include "roleplay/roleplay_teams"
#include "roleplay/roleplay_vendors"
#include "roleplay/roleplay_furniture_operations"
#include "roleplay/roleplay_homes"

/* CORE */
#define PL_VERSION		"0.1b"
#define PL_AUTHOR		"Gate; Zipcore; Bara"
#define PL_URL			"fotg.net"
#define PL_PRE "  {lightred}[{green}RP{lightred}]{green}"
#define PL_PRE_N "[RP]"
#define PL_PRE_T " {lightred}[{green}RP{lightred}]{green} %t"

/* CSTRIKE */
#define CS_TEAMS_NUM 4
#define CS_SLOT_KNIFE 2
#define ITEMS_TYPES_NUM 10
#define ITEMS_STR_LEN 32
#define MAX_CASH 16000
#define DEFAULT_MAX_ARMOR 100
#define CS_MAX_ARMOR 127

/* SteamID */
stock bool:SteamID_GetCommunityID(String:AuthID[], String:CommunityID[], size)
{
	if(strlen(AuthID) < 11 || AuthID[0]!='S' || AuthID[6]=='I')
	{
		FriendID[0] = 0;
		return false;
	}
	new iUpper = 765611979;
	new CommunityID = StringToInt(AuthID[10])*2 + 60265728 + AuthID[8]-48;
	new iDiv = CommunityID/100000000;
	new iIdx = 9-(iDiv?iDiv/10+1?0);
	iUpper += iDiv;
	IntToString(CommunityID, CommunityID[iIdx], size-iIdx);
	iIdx = FriendID[9];
	IntToString(iUpper, CommunityID, size);
	FriendID[9] = iIdx;
	return true;
}

stock FindPlayer(client, String:idstr[])
{
	new uid = StringToInt(idstr);
	new id = GetClientOfUserId(uid);
	new MaxC = GetMaxClients();
	
	if(id == 0)
	{
		new numclients = 0;
		new numid = 0;
		new String:name[50];
		
		for(new i=1;i<MaxC;i++)
		{
			if(!IsClientInGame(i)) continue;
			GetClientName(i, name, 50);
			if(StrContains(name, idstr, false) != -1)
			{
				numclients++;
				if(numclients > 1) break;
				numid = i;
			}
		}
		
		if(numclients > 1)
		{
			CPrintToChat(client,"There is more than one client matching that string, please be more specific.");
			return 0;
		}
		
		id = numid;
		
		if(id == 0)
			return 0;
	}
	return id;
}

stock SteamID_GetClient(String:steamid[])
{
	new String:authid[32];
	for(new i=1;i<=MaxClients;++i)
	{
		if(!IsClientInGame(i))
			continue;
		if(!IsClientAuthorized(i))
			continue;
		GetClientAuthString(i, authid, sizeof(authid));
		if(strcmp(authid, steamid)==0)
			return i;
	}
	return 0;
}

/* Teams */
stock Team_GetPlayerCount(iTeam, bool:alive=true)
{
	new iCount = 0;
	for(new client = 1; client <= MaxClients; client++)
	{
		if(!IsClientInGame(client))
			continue;
		if(GetClientTeam(client) != iTeam)
			continue;
		if(!IsPlayerAlive(client) && alive)
			continue;
		
		iCount++;
	}
	return iCount;
}

/* Client */
stock FindMatchingPlayers(const String:matchstr[], clients[])
{
    new count=0;
    if(StrEqual(matchstr,"@all",false))
    {
        for(new x=1;x<=MaxClients;x++)
        {
            if(IsClientInGame(x))
            {
                clients[count]=x;
                count++;
            }
        }
    }
    else if(StrEqual(matchstr,"@t",false))
    {
        for(new x=1;x<=MaxClients;x++)
        {
            if(IsClientInGame(x)&&GetClientTeam(x)==CSS_TEAM_T)
            {
                clients[count]=x;
                count++;
            }
        }
    }
    else if(StrEqual(matchstr,"@ct",false))
    {
        for(new x=1;x<=MaxClients;x++)
        {
            if(IsClientInGame(x)&&GetClientTeam(x)==CSS_TEAM_CT)
            {
                clients[count]=x;
                count++;
            }
        }
    }
    else if(matchstr[0]=='@')
    {
        new userid=StringToInt(matchstr[1]);
        if(userid)
        {
            new index=GetClientOfUserId(userid);
            if(index)
            {
                if(IsClientInGame(index))
                {
                    clients[count]=index;
                    count++;
                }
            }
        }
    }
    else
    {
        decl String:name[64];
        for(new x=1;x<=MaxClients;x++)
        {
            if(IsClientInGame(x))
            {
                GetClientName(x,name,sizeof(name));
                if(StrContains(name,matchstr,false)!=-1)
                {
                    clients[count]=x;
                    count++;
                }
            }
        }
    }
    return count;
}

stock Client_StripWeapons(client)
{
	new iWeapon = -1;
	for(new i=CS_SLOT_PRIMARY;i<=CS_SLOT_C4;i++)
		while((iWeapon = GetPlayerWeaponSlot(client, i)) != -1)
			CS_DropWeapon(client, iWeapon, true, true);
}

stock Client_RemoveWeapons(client)
{
	new iWeapon = -1;
	for(new i=CS_SLOT_PRIMARY;i<=CS_SLOT_C4;i++)
		while((iWeapon = GetPlayerWeaponSlot(client, i)) != -1)
			AcceptEntityInput(iWeapon, "kill");
}

stock bool:Client_RemoveWeaponBySlot(client, iSlot)
{
	new iEntity = GetPlayerWeaponSlot(client, iSlot);
	if(IsValidEdict(iEntity))
	{
		RemovePlayerItem(client, iEntity);
		AcceptEntityInput(iEntity, "Kill");
		return true;
	}
	return false;
}

stock Client_GetPrimaryAmmo(client) 
{   
	new weapon = GetPlayerWeaponSlot(client, 0);
	new iAmmoType = GetEntProp(weapon, Prop_Send, "m_iPrimaryAmmoType");
	return GetEntData(client, (FindSendPropOffs("CBasePlayer", "m_iAmmo")+4*iAmmoType)) + GetEntProp(weapon, Prop_Data, "m_iClip1");
}

stock Client_GetSecondaryAmmo(client)
{
	new weapon = GetPlayerWeaponSlot(client, 1);
	new iAmmoType = GetEntProp(weapon, Prop_Send, "m_iPrimaryAmmoType");
	return GetEntData(client, (FindSendPropOffs("CBasePlayer", "m_iAmmo")+4*iAmmoType)) + GetEntProp(weapon, Prop_Data, "m_iClip1");
}

stock Client_GetPrimaryAmmoClip(client) 
{   
	new weapon = GetPlayerWeaponSlot(client, 0);
	return GetEntProp(weapon, Prop_Data, "m_iClip1");
}

stock Client_GetSecondaryAmmoClip(client)
{
	new weapon = GetPlayerWeaponSlot(client, 1);
	return GetEntProp(weapon, Prop_Data, "m_iClip1");
}

stock Client_GetPrimaryAmmoHolster(client) 
{   
	new weapon = GetPlayerWeaponSlot(client, 0);
	new iAmmoType = GetEntProp(weapon, Prop_Send, "m_iPrimaryAmmoType");
	return GetEntData(client, (FindSendPropOffs("CBasePlayer", "m_iAmmo")+4*iAmmoType));
}

stock Client_GetSecondaryAmmoHolster(client)
{
	new weapon = GetPlayerWeaponSlot(client, 1);
	new iAmmoType = GetEntProp(weapon, Prop_Send, "m_iPrimaryAmmoType");
	return GetEntData(client, (FindSendPropOffs("CBasePlayer", "m_iAmmo")+4*iAmmoType));
}

stock Client_SetPrimaryAmmoClip(client, value)
{
	new weapon = GetPlayerWeaponSlot(client, 0);
	SetEntProp(weapon, Prop_Data, "m_iClip1", value);
}

stock Client_SetSecondaryAmmoClip(client, value)
{
	new weapon = GetPlayerWeaponSlot(client, 1);
	SetEntProp(weapon, Prop_Data, "m_iClip1", value);
}

stock Client_SetPrimaryAmmoHolster(client, value)
{
	new client = GetClientOfUserId(GetEventInt(event, "userid"));
	new weapon = GetPlayerWeaponSlot(client, 0);	
	SetEntData(client, FindSendPropOffs("CBasePlayer", "m_iAmmo")+(GetEntProp(weapon, Prop_Send, "m_iPrimaryAmmoType")*4), value, 4, true);
}

stock Client_SetSecondaryAmmoHolster(client, value)
{
	new client = GetClientOfUserId(GetEventInt(event, "userid"));
	new weapon = GetPlayerWeaponSlot(client, 1);	
	SetEntData(client, FindSendPropOffs("CBasePlayer", "m_iAmmo")+(GetEntProp(weapon, Prop_Send, "m_iPrimaryAmmoType")*4), value, 4, true);
}

stock Client_SetHelmet(client, status)
{
	SetEntProp( client, Prop_Send, "m_bHasHelmet", status);
}

stock Client_SetSpeed(client, Float:fspeed)
{
	SetEntPropFloat(client, Prop_Data, "m_flLaggedMovementValue", fspeed);	
}

stock Client_SetNightvision(client, enable)
{
	SetEntProp(client, Prop_Send, "m_bNightVisionOn", enable);
}

stock Client_ToggleFlashlight(client)
{
	SetEntProp(client, Prop_Send, "m_fEffects", GetEntProp(client, Prop_Send, "m_fEffects") ^ 4);
}

stock Client_SetFlashMaxAlpha(client)
{
	SetEntPropFloat(client, Prop_Send, "m_flFlashMaxAlpha", 0.5);
}

/* Entity */
public Action:Entity_Delete(Handle:timer, any:entity)
{
	if (IsValidEntity(entity)) 
		AcceptEntityInput(entity, "kill");
}

stock SetCollidable(client, bool:collidable)
{
	SetEntData(entity, FindSendPropOffs("CBaseEntity", "m_CollisionGroup"), collidable ? 5 : 2, 4, true);
}

stock ExtinguishClient(client)
{
	new ent = GetEntPropEnt(client, Prop_Data, "m_hEffectEntity");
	if (IsValidEdict(ent))
	{
		decl String:classname[64];
		GetEdictClassname(ent, classname, sizeof(classname));
		if (StrEqual(classname, "entityflame", false))
			SetEntPropFloat(ent, Prop_Data, "m_flLifetime", 0.0);
	}
}

/* Weapon */

stock bool:Weapon_IsKnife(const String:sWeaponName[])
{
	return StrContains(sWeaponName, "knife", false) != -1;
}

new const String:g_sKnifes[][] = 
{
	"weapon_knife",
	"weapon_knifegg",
	"weapon_taser"
};

stock bool:IsWeaponKnife(const String:sWeaponName[])
{
	for(new i = 0; i < sizeof(g_sKnifes); i++)
		if(StrEqual(g_sKnifes[i], sWeaponName))
			return true;
		
	return false;
}

new const String:g_sSecondary[][] = 
{
	"weapon_deagle",
	"weapon_elite",
	"weapon_fiveseven",
	"weapon_glock",
	"weapon_hkp2000",
	"weapon_p228",
	"weapon_p250",
	"weapon_usp",
	"weapon_tec9"
};

stock bool:IsWeaponSecondary(const String:sWeaponName[])
{
	for(new i = 0; i < sizeof(g_sSecondary); i++)
		if(StrEqual(g_sSecondary[i], sWeaponName))
			return true;
		
	return false;
}

new const String:g_sPrimary[][] = 
{
	"weapon_mag7",
	"weapon_nova",
	"weapon_sawedoff",
	"weapon_xm1014",
	"weapon_m3",
	"weapon_bizon",
	"weapon_mac10",
	"weapon_mp7",
	"weapon_mp9",
	"weapon_p90",
	"weapon_ump45",
	"weapon_tmp",
	"weapon_mp5navy",
	"weapon_ak47",
	"weapon_aug",
	"weapon_famas",
	"weapon_galil",
	"weapon_galilar",
	"weapon_sg550",
	"weapon_sg552",
	"weapon_sg556",
	"weapon_m4a1",
	"weapon_m4a1_silencer",
	"weapon_m4a4",
	"weapon_m249",
	"weapon_negev",
	"weapon_ssg08",
	"weapon_g3sg1",
	"weapon_scar17",
	"weapon_scar20",
	"weapon_ssg08",
	"weapon_scout",
	"weapon_awp"
};

stock bool:IsWeaponPrimary(const String:sWeaponName[])
{
	for(new i = 0; i < sizeof(g_sPrimary); i++)
		if(StrEqual(g_sPrimary[i], sWeaponName))
			return true;
		
	return false;
}

new const String:g_sGrenades[][] = 
{
	"weapon_flashbang",
	"weapon_molotov",
	"weapon_smokegrenade",
	"weapon_hegrenade",
	"weapon_decoy",
	"weapon_incgrenade",
	"hegrenade_projectile",
	"molotov_projectile"
};

stock bool:IsWeaponGrenade(const String:sWeaponName[])
{
	for(new i = 0; i < sizeof(g_sGrenades); i++)
		if(StrEqual(g_sGrenades[i], sWeaponName))
			return true;
		
	return false;
}

stock WeaponGetSlot(const String:sWeaponName[])
{
	if(IsWeaponKnife(sWeaponName))
		return CS_SLOT_KNIFE;
	
	if(IsWeaponGrenade(sWeaponName))
		return CS_SLOT_GRENADE;
	
	if(IsWeaponPrimary(sWeaponName))
		return CS_SLOT_PRIMARY;
	
	if(IsWeaponSecondary(sWeaponName))
		return CS_SLOT_SECONDARY;
	
	return -1;
}

/* Timer */
stock ClearTimer(&Handle:timer)
{
	if(timer != INVALID_HANDLE)
	{
		KillTimer(timer);
		timer = INVALID_HANDLE;
	}
}

/* Menu */
stock bool:AddMenuItemEx(Handle:menu, style, String:info[], String:display[], any:...)
{
	decl String:m_display[256];
	VFormat(m_display, sizeof(m_display), display, 5);
	return (AddMenuItem(menu, info, m_display, style)?true:false);
}

stock bool:InsertMenuItemEx(Handle:menu, position, style, String:info[], String:display[], any:...)
{
	decl String:m_display[256];
	VFormat(m_display, sizeof(m_display), display, 6);
	if(GetMenuItemCount(menu)==position)
		return (AddMenuItem(menu, info, m_display, style)?true:false);
	else
		return (InsertMenuItem(menu, position, info, m_display, style)?true:false);
}

stock AutoPaginate(Handle:menu)
{
	if (menu == INVALID_HANDLE)
	{
		return;
	}
	
	new itemsPerPage = GetMaxPageItems(GetMenuStyle(menu));
	
	new bool:pageOneHasExtraItem = false;
	
	if (GetMenuExitButton(menu))
		itemsPerPage--;
	
	if (GetMenuOptionFlags(menu) | MENUFLAG_BUTTON_NOVOTE)
		pageOneHasExtraItem = true;
	
	new count = GetMenuItemCount(menu);
	
	if (count <= (pageOneHasExtraItem ? itemsPerPage - 1 : itemsPerPage ))
		SetMenuPagination(menu, MENU_NO_PAGINATION);
	else SetMenuPagination(menu, itemsPerPage - 2);
}

/* Time Format*/
stock SecondsToString(String:sBuffer[], iLength, iSecs, bool:bTextual = true)
{
	if(bTextual)
	{
		decl String:sDesc[6][8] = {"mo", 				"wk", 				"d", 			"hr", 		"min", 	"sec"};
		new iCount, 	iDiv[6] = {60 * 60 * 24 * 30, 	60 * 60 * 24 * 7, 	60 * 60 * 24, 	60 * 60, 	60, 	1};
		sBuffer[0] = '\0';
		
		for(new i = 0; i < sizeof(iDiv); i++)
		{
			if((iCount = iSecs / iDiv[i]) > 0)
			{
				Format(sBuffer, iLength, "%s%i %s, ", sBuffer, iCount, sDesc[i]);
				iSecs %= iDiv[i];
			}
		}
		sBuffer[strlen(sBuffer) - 2] = '\0';
	}
	else
	{
		new iHours = iSecs / 60 / 60;
		iSecs -= iHours * 60 * 60;
		new iMins = iSecs / 60;
		iSecs %= 60;
		Format(sBuffer, iLength, "%02i:%02i:%02i", iHours, iMins, iSecs);
	}
}