#if defined _rp_items_included
 #endinput
#endif
#define _rp_items_included

#define MAX_ITEM_SETTINGS 5

enum 
{
	IT_Other, //0
	IT_Valuable, //1
	IT_Furniture, //2
	IT_SpecialWeapon, //3
	IT_Weapon, //4
	IT_Ammo, //5
	IT_Food, //6
	IT_Drink, //7
	IT_Medic, //8
	IT_Tool, //9
	IT_Drug, //10
	IT_Document, //11
	IT_Badge, //12
	IT_Tattoo, //13
	IT_Skin, //14
	IT_Mask //15
}

enum RP_Item
{
	Item_ID,
	Item_Type,
	Item_WorthBuy,
	Item_WorthSell,
	Item_Durability,
	Item_ReqLevel,
	Item_ReqItem,
	bool:Item_Tradable,
	bool:Item_Dropable,
	bool:Item_Useable,
	bool:Item_Deleteable,
	bool:Item_VipOnly,
	String:Item_Name[64],
	String:Item_Classname[64],
	String:Item_Model[128],
	String:Item_Features[128],
	String:Item_Settings[128],
	String:Item_Description[128]
}

enum RP_Inventory
{
	Inventory_ID,
	Inventory_Durability,
	Inventory_DateCreated
}
	
native RP_GetItemCount();
native RP_GetItemID(index);

native RP_GetItemType(itemID);
native RP_GetItemWorthBuy(itemID);
native RP_GetItemWorthSell(itemID);
native RP_GetItemDurability(itemID);
native RP_GetItemReqLevel(itemID);
native RP_GetItemReqItem(itemID);

native RP_IsItemTradable(itemID);
native RP_IsItemDropable(itemID);
native RP_IsItemUseable(itemID);
native RP_IsItemDeleteable(itemID);
native RP_IsItemVipOnly(itemID);

native RP_GetItemName(itemID, String:buffer[], length_64);
native RP_GetItemClassname(itemID, String:buffer[], length_64);
native RP_GetItemModel(itemID, String:buffer[], length_128);
native RP_GetItemFeatures(itemID, String:buffer[], length_128);
native RP_GetItemSettings(itemID, String:buffer[], length_128);
native RP_GetItemDescription(itemID, String:buffer[], length_128);

native RP_GetInventoryItemCount(client);
native RP_GetInventoryItem(client, index);

native RP_AddInventoryItem(client, itemID, durability);
native RP_UsedInventoryItem(client, itemID, durability);
native RP_RemoveInventoryItem(client, itemID);
native RP_RemoveInventoryItemType(client, RP_ItemType:type);
native RP_HasInventoryItem(client, itemID);

public __pl_rp_items_SetNTVOptional() 
{
	MarkNativeAsOptional("RP_GetItemCount");
	MarkNativeAsOptional("RP_GetItemID");
	
	MarkNativeAsOptional("RP_GetItemType");
	MarkNativeAsOptional("RP_GetItemWorthBuy");
	MarkNativeAsOptional("RP_GetItemWorthSell");
	MarkNativeAsOptional("RP_GetItemDurability");
	MarkNativeAsOptional("RP_GetItemReqLevel");
	MarkNativeAsOptional("RP_GetItemReqItem");
	
	MarkNativeAsOptional("RP_IsItemTradable");
	MarkNativeAsOptional("RP_IsItemDropable");
	MarkNativeAsOptional("RP_IsItemUseable");
	MarkNativeAsOptional("RP_IsItemDeleteable");
	MarkNativeAsOptional("RP_IsItemVipOnly");
	
	MarkNativeAsOptional("RP_GetItemName");
	MarkNativeAsOptional("RP_GetItemClassname");
	MarkNativeAsOptional("RP_GetItemModel");
	MarkNativeAsOptional("RP_GetItemFeatures");
	MarkNativeAsOptional("RP_GetItemSettings");
	MarkNativeAsOptional("RP_GetItemDescription");
	
	MarkNativeAsOptional("RP_GetInventoryItemCount");
	MarkNativeAsOptional("RP_GetInventoryItem");
	
	MarkNativeAsOptional("RP_AddInventoryItem");
	MarkNativeAsOptional("RP_UsedInventoryItem");
	MarkNativeAsOptional("RP_RemoveInventoryItem");
	MarkNativeAsOptional("RP_RemoveInventoryItemType");
	MarkNativeAsOptional("RP_HasInventoryItem");
}