/* Changelog
* 
* v2.3
* - Added zombie reloaded include
* - Added cost_infected (0=disabled)
* v2.4
* - Fixed ZR_IsHuman/Infected needs an alive player
* v2.5
* - Added incendiary ammo (ignite)
* - Added explosive ammo (knockback)
* - Added german translations
* v2.6
* - Fixed IsClientInGame()
* v2.7
* - Added health/knife option
* v2.8
* - Added menu health/knife infos
* v2.9
* - Added color health/knife
* - Added map props compare
* - Added infect assist
* - Added sm_propaim
* v3.0
* - Added info menu
* v3.1
* - Added delay to avoid double hooks
* v3.2
* - Fixed invalid entity bug on spawn delay timer
* v3.3
* - Propaim return extra text sg if orginal map prop
* - Can't spawn props into walls anymore
* v3.4
* - Allow infected to spawn propsinto walls again
* v3.5
* - Added buy nades
* - Fixed prop settings OnPropSpawn
* v3.6
* - Fixed phrase not found bug
* v3.7
* - Give all props settings
* - Extended propaim command
* - Added assive server lagg detection
* v3.8
* - Fixed props with HP
* v3.9
* - Cleaned up messy code
* v4.0
* - Fixed some bugs
* - Added telekill
* - Added disablemotion
* v4.1
* - Reopen menu at old page
* v4.2
* - Use trigger_multiple to detect props at teleport destinations
* v4.3
* - Fixed settings on mapchange
* v4.4
* - Added dissolve effect
* - Fixed trigger_teleport only teleporting physic object now
* - Improved get credits back for deleted props by teleporters
* - Fixed timeleft added wrong
* - Fixed TriggerStartTouch fired more than once
* - Improved knife hits when a zombie is alone
* - Improved prop info chat output
* - Fixed reward for teamkills
* v4.5
* - Fixed credits gain of knifed props
* - Removed dissolve effect for knifed props
* - Fixed prop only teleporters
* - Fixed client id 0 OnTakeDamage
* v4.6
* - Fixed assist credits for infected
* - Improved credits given for knifeing props as infected
* - Resized trigger zones to kill props
* - Added crit damage counter for humans
* - Added assists cvars
* v4.7
* - Fixed Assistspoints for suisides
* - Added credit history
* v4.8
* - Fixed credit history to not display zero credits
* v4.9
* - Added new lagg detection, thanks to Dark Session (THC Clan)
* v5.0
* - Added Freezer
* - Open sm_propinfo with sm_props while dead
* v5.1
* - Improved status color update
*/

#pragma semicolon 1
#include <sourcemod>
#include <sdktools>
#include <cstrike>
#include <smlib>
#include <adminmenu>
#include <sdkhooks>
#include <zombiereloaded>
#include <morecolors>
	
#define VERSION "5.0"


// settings for m_takedamage
#define DAMAGE_NO		0
#define DAMAGE_EVENTS_ONLY	1	// Call damage functions, but don't modify health
#define DAMAGE_YES		2
#define DAMAGE_AIM		3

#define KNOCKBACK 250.0

enum
{
	TYPE_PROP, //0
	TYPE_AMMOINCENDIARY, //1
	TYPE_AMMOEXPLOSIVE, //2
	TYPE_HE, //3
	TYPE_FREEZER, //4
}

enum Props
{
	LifetimeMax,
	LifetimeCount,
	KnifeHitsMax,
	KnifeHitsCount,
	HealthMax,
	TeleKill,
	Paid,
	Owner
}

enum CreditsMsg
{
	String:cMsg[128],
	Float:cTime
}

new g_props[2048][Props];
new Float:g_fLastFreeze[2048];

new offsEyeAngle0;

new g_iCredits[MAXPLAYERS+1];

new g_iCreditsMsgCount[MAXPLAYERS+1];
new g_msgCredits[MAXPLAYERS+1][5][CreditsMsg];

new g_iAmmoIncendiary[MAXPLAYERS+1];
new g_iAmmoExplosive[MAXPLAYERS+1];

new g_iCritCount[MAXPLAYERS+1];

new Float:LastExecTime;
new TickWarns;

new g_Freeze;

new bool:g_bAmmoIncendiary[MAXPLAYERS+1];
new bool:g_bAmmoExplosive[MAXPLAYERS+1];

new Handle:kvProps = INVALID_HANDLE;
new Handle:g_kvDBSteamID = INVALID_HANDLE;

new Handle:cvarCreditsMax = INVALID_HANDLE;
new Handle:cvarCreditsMaxMapchange = INVALID_HANDLE;
new Handle:cvarCreditsConnect = INVALID_HANDLE;
new Handle:cvarCreditsSpawn = INVALID_HANDLE;
new Handle:cvarCreditsInfect = INVALID_HANDLE;
new Handle:cvarCreditsKill = INVALID_HANDLE;
new Handle:cvarCreditsRoundStart = INVALID_HANDLE;
new Handle:cvarDefaultKnifeHits = INVALID_HANDLE;
new Handle:cvarInfectAssistsRange = INVALID_HANDLE;
new Handle:cvarPropKnifeAssistsRange = INVALID_HANDLE;

new String:mdlDetector[] = "models/props_combine/combine_mine01.mdl";
new gGlow1;
new gHalo1;
new gLaser1;
new gSmoke1;

public Plugin:myinfo =
{
	name = "DHC Props Spawn System",
	author = "Zipcore, Darkthrone, Greyscale, Lacrimosa99",
	description = "Spawn props in game",
	version = VERSION,
	url = "www.devil-hunter-multigaming.de, zipcore#googlmail.com"
};

public OnPluginStart()
{
	LoadTranslations("dhc_zprop.phrases");

	// ======================================================================

	HookEvent("player_spawn", PlayerSpawn);
	HookEvent("player_death", PlayerDeath);
	HookEvent("player_team", PlayerTeam);
	HookEvent("round_start", RoundStart);
	
	HookEvent("player_hurt", PlayerHurt);
	HookEvent("weapon_fire", WeaponFire);

	// ======================================================================
	
	RegConsoleCmd("sm_propinfo", Command_PropInfo);
	RegConsoleCmd("sm_props", Command_Props);
	RegConsoleCmd("sm_propaim", Command_GetOwner);

	// ======================================================================

	RegAdminCmd("sm_remove_prop", AdminRemovePropAim, ADMFLAG_KICK, "Admin Prop Removal by aim");

	// ======================================================================

	offsEyeAngle0 = FindSendPropInfo("CCSPlayer", "m_angEyeAngles[0]");
	if (offsEyeAngle0 == -1)
	{
		SetFailState("Couldn't find \"m_angEyeAngles[0]\"!");
	}

	// ======================================================================

	cvarCreditsMax = CreateConVar("zprop_credits_max", "15", "Max credits that can be attained (0: No limit)");
	cvarCreditsMaxMapchange = CreateConVar("zprop_credits_max_mapchange", "25", "Max credits that can be attained on mapchange (0: Disable)");
	cvarCreditsConnect = CreateConVar("zprop_credits_connect", "4", "The number of free credits a player received when they join the game");
	cvarCreditsSpawn = CreateConVar("zprop_credits_spawn", "1", "The number of free credits given on spawn");
	cvarCreditsInfect = CreateConVar("zprop_credits_infect", "1", "The number of credits given for infecting a human as zombie");
	cvarCreditsKill = CreateConVar("zprop_credits_kill", "5", "The number of credits given for killing a zombie as human");
	cvarCreditsRoundStart = CreateConVar("zprop_credits_roundstart", "2", "The number of free credits given on start of the round");
	cvarDefaultKnifeHits = CreateConVar("zprop_default_knife_hits", "50", "Number of knife hits non-configured props need to be destroyed");
	cvarInfectAssistsRange = CreateConVar("zprop_infect_assists_range", "500.0", "All infected within this range get 1 credit for a new infect of a human");
	cvarPropKnifeAssistsRange = CreateConVar("zprop_prop_knife_assists_range", "750.0", "Double knife hits if no other zombie is within this range");

	CreateConVar("sm_dhc_zprop_version", VERSION, "[DHC Props] Current version of this plugin", FCVAR_PLUGIN|FCVAR_SPONLY|FCVAR_UNLOGGED|FCVAR_DONTRECORD|FCVAR_REPLICATED|FCVAR_NOTIFY);

	AutoExecConfig(true, "plugin.dhc_zprop");

	g_kvDBSteamID = CreateKeyValues("steamids");
	
	g_Freeze = FindSendPropOffs("CBasePlayer", "m_fFlags");
	if(g_Freeze == -1)
		SetFailState("Couldnt find the m_fFlags offset!");
	
	CreateTimer(1.0, EntitySecurity, _, TIMER_REPEAT);
}

public OnMapStart()
{
	if (kvProps != INVALID_HANDLE)
		CloseHandle(kvProps);

	kvProps = CreateKeyValues("zprops");

	decl String:path[PLATFORM_MAX_PATH];
	BuildPath(Path_SM, path, sizeof(path), "configs/dhc_zprops.txt");

	if (!FileToKeyValues(kvProps, path))
	{
		SetFailState("\"%s\" missing from server", path);
	}

	CloseHandle(g_kvDBSteamID);
	g_kvDBSteamID = CreateKeyValues("steamids");
	
	PrecacheModel("models/props_junk/wood_crate001a.mdl", true);
	
	Reset_Prop_All();
	
	PrecacheModel(mdlDetector, true);

	gGlow1 = PrecacheModel("sprites/blueglow2.vmt", true);
	gHalo1 = PrecacheModel("materials/sprites/halo01.vmt");
	gLaser1 = PrecacheModel("materials/sprites/laser.vmt");
	gSmoke1 = PrecacheModel("materials/effects/fire_cloud1.vmt");
}

stock SaveID(client)
{
	decl String:client_id[100];
	decl String:client_s[100];
	GetClientAuthString(client, client_id, sizeof(client_id));
	IntToString(client, client_s, sizeof(client_s));	
	KvSetString(g_kvDBSteamID, client_s, client_id);
}

public OnClientPutInServer(client)
{
	new credits_max_mapchange = GetConVarInt(cvarCreditsMaxMapchange);
	
	if(credits_max_mapchange == 0)
		g_iCredits[client] = -1;
	else if(g_iCredits[client] > credits_max_mapchange)
	{
		g_iCredits[client] = credits_max_mapchange;
		new String:buffer[128];
		Format(buffer, sizeof(buffer), "Connect [+%d]", credits_max_mapchange);
		CreditsMsgAdd(client, buffer);
	}
}

public OnClientDisconnect(client)
{
	g_iCredits[client] = -1;
}

public OnEntityCreated(entity, const String:classname[])
{
    if (StrEqual(classname, "trigger_teleport"))  
    {
        SDKHook(entity, SDKHook_Spawn, OnTeleportTriggerSpawned);
    }
	else if (StrEqual(classname, "info_teleport_destination"))  
    {
        SDKHook(entity, SDKHook_Spawn, OnTeleportDestinationSpawned);
    }
	else if (StrContains(classname, "prop_") > -1)  
    {
        SDKHook(entity, SDKHook_Spawn, OnPropSpawned);
    }
}

public OnTeleportTriggerSpawned(entity)
{
	if(!Entity_HasSpawnFlags(entity, 8) && Entity_HasSpawnFlags(entity, 1))
		Entity_SetSpawnFlags(entity, 9);
}

public OnTeleportDestinationSpawned(entity)
{
	CreateTimer(1.0, Timer_CreateTrigger, entity, TIMER_FLAG_NO_MAPCHANGE);
}

public Action:Timer_CreateTrigger(Handle:timer, any:entity)
{
	CreateTrigger(entity);
	return Plugin_Handled;
}
	
stock CreateTrigger(entity)
{
	if(IsValidEntity(entity))
	{
		new Float:Vec[3];
		Entity_GetAbsOrigin(entity, Vec);
		
		Vec[2] -= 64.0;
		
		new Float:minbounds[3];
		new Float:maxbounds[3];
				
		minbounds[0] = -64.0;
		minbounds[1] = -64.0;
		minbounds[2] = 0.0;
		
		maxbounds[0] = 64.0;
		maxbounds[1] = 64.0;
		maxbounds[2] = 128.0;
		
		new trigger = CreateEntityByName("trigger_multiple");
		if (trigger > 0)
		{
			if(!IsValidEntity(trigger)) 
			{
				return;
			}

			SetEntityModel(trigger, "models/props_junk/wood_crate001a.mdl");
			
			// Spawnflags:	1 - only a player can trigger this by touch, makes it so a NPC cannot fire a trigger_multiple
			// 2 - Won't fire unless triggering ent's view angles are within 45 degrees of trigger's angles (in addition to any other conditions), so if you want the player to only be able to fire the entity at a 90 degree angle you would do ",angles,0 90 0," into your spawnstring.
			// 4 - Won't fire unless player is in it and pressing use button (in addition to any other conditions), you must make a bounding box,(max\mins) for this to work.
			// 8 - Won't fire unless player/NPC is in it and pressing fire button, you must make a bounding box,(max\mins) for this to work.
			// 16 - only non-player NPCs can trigger this by touch
			// 128 - Start off, has to be activated by a target_activate to be touchable/usable
			// 256 - multiple players can trigger the entity at the same time
			DispatchKeyValue(trigger, "spawnflags", "257"); 
			DispatchKeyValue(trigger, "StartDisabled", "0");
			DispatchKeyValue(trigger, "OnTrigger", "!activator,IgnitePlayer,,0,-1");
			
			new String:EntName[256];
			Format(EntName, sizeof(EntName), "#DHC_Trigger_%d", entity);
			DispatchKeyValue(trigger, "targetname", EntName);
			
			if(DispatchSpawn(trigger))
			{
				ActivateEntity(trigger);

				SetEntPropVector(trigger, Prop_Send, "m_vecMins", minbounds);
				SetEntPropVector(trigger, Prop_Send, "m_vecMaxs", maxbounds);

				SetEntProp(trigger, Prop_Send, "m_nSolidType", 2);
				
				TeleportEntity(trigger, Vec, NULL_VECTOR, NULL_VECTOR);

				// SetVariantString(Buffer);
				AcceptEntityInput(trigger, "SetParent");
			}
			
			SDKHook(trigger, SDKHook_StartTouch, OnStartTouchTrigger);
		}
	}
}

public Action:OnStartTouchTrigger(caller, activator)
{
	new entity = activator;
	
	if(g_props[entity][TeleKill])
	{
		decl String:EntName[256];
		Entity_GetName(entity, EntName, sizeof(EntName));
		
		decl String:EntClassName[256];
		Entity_GetClassName(entity, EntClassName, sizeof(EntClassName));
		
		if (StrContains(EntClassName, "prop_") > -1)  
		{
			new client = g_props[entity][Owner];

			if(IsValidClient(client))
			{
				new credits = g_props[entity][Paid];
				
				if(credits > 10)
				{
					credits = 10+RoundToFloor((credits-10)*0.4);
				}
				
				CPrintToChat(client, "\x04[%t] {red}Your prop was deleted for touching a teleporter! {blue}You got {yellow}%d {blue}of {yellow}%d {blue}credits back. {orange}Use props listed on first page instead. ", "DHC Props", credits, g_props[entity][Paid]);
				
				AddCredits(client, credits);
				
				new String:buffer[128];
				Format(buffer, sizeof(buffer), "Prop touched teleporter [+%d]", credits);
				if(credits != 0) CreditsMsgAdd(client, buffer);
			}
			
			g_props[entity][TeleKill] = 0;
			DeleteProp(entity, true);
		}
	}
	
	return Plugin_Continue;
}

public Action:OnTakeDamage(prop, &attacker, &inflictor, &Float:damage, &damagetype, &weapon, Float:damageForce[3], Float:damagePosition[3])
{
	if(g_props[prop][KnifeHitsMax] > 0)
	{
		if(damage == 15.0 || damage == 20.0 || damage == 65.0)
		{
			new count = 0;
			
			if(attacker > 0 && ZR_IsClientZombie(attacker))
			{
				for(new i=1;i<=MaxClients;i++)
				{
					if(attacker == i)
						continue;
					
					if(!IsValidClient(i))
						continue;
					
					if(!IsPlayerAlive(i))
						continue;
					
					if(!ZR_IsClientZombie(i))
						continue;
					
					if(Entity_InRange(attacker, i, GetConVarFloat(cvarPropKnifeAssistsRange)))
					{
						count ++;
						break;
					}
				}
				
				if(count == 0) g_props[prop][KnifeHitsCount] ++;
			}
			
			g_props[prop][KnifeHitsCount] ++;
			
			if(g_props[prop][KnifeHitsCount] >= g_props[prop][KnifeHitsMax])
			{
				if(IsValidClient(attacker) && ZR_IsClientZombie(attacker))
				{
					new credits = g_props[prop][Paid];
					
					if(credits > 0)
						credits = RoundToFloor(credits*0.2);
					
					credits += 3;
					
					AddCredits(attacker, credits);
					
					new String:buffer[128];
					Format(buffer, sizeof(buffer), "Prop knifed [+%d]", credits);
					if(credits != 0) CreditsMsgAdd(attacker, buffer);
				}
				
				DeleteProp(prop);
			}
			else
			{
				Prop_UpdateColor(prop);
			}
		}
	}
	else if(g_props[prop][HealthMax] > 0)
	{
		Prop_UpdateColor(prop);
	}
}

stock Prop_UpdateColor(entity)
{
	new ttl, ttl_p, hp, hp_p, kh, kh_p, final_p;
	new health = GetEntProp(entity, Prop_Data, "m_iHealth");
	
	if(g_props[entity][LifetimeMax] > 0)
	{
		ttl = g_props[entity][LifetimeMax] - g_props[entity][LifetimeCount];
		ttl_p = ttl/g_props[entity][LifetimeMax];
		ttl_p *= 100;
		final_p = ttl_p;
	}
	if(g_props[entity][KnifeHitsMax] > 0)
	{
		kh = g_props[entity][KnifeHitsMax] - g_props[entity][KnifeHitsCount];
		kh_p = ttl/g_props[entity][KnifeHitsMax];
		kh_p *= 100;
		if(final_p > kh_p && kh > 0)
			final_p = kh_p;
	}
	if(g_props[entity][HealthMax] > 0)
	{
		hp = g_props[entity][HealthMax] - health;
		hp_p = ttl/g_props[entity][LifetimeMax];
		hp_p *= 100;
		if(final_p > hp_p && hp > 0)
			final_p = hp_p;
	}

	if(final_p > 0)
	{
		if(final_p <= 3)
		{
			SetEntityRenderColor(entity, 255, 0, 50, 255);
		}
		if(final_p <= 5)
		{
			SetEntityRenderColor(entity, 255, 0, 0, 255);
		}
		else if(final_p <= 7)
		{
			SetEntityRenderColor(entity, 255, 30, 5, 255);
		}
		else if(final_p <= 10)
		{
			SetEntityRenderColor(entity, 255, 60, 10, 255);
		}
		else if(final_p <= 13)
		{
			SetEntityRenderColor(entity, 255, 90, 15, 255);
		}
		else if(final_p <= 16)
		{
			SetEntityRenderColor(entity, 255, 120, 20, 255);
		}
		else if(final_p <= 20)
		{
			SetEntityRenderColor(entity, 255, 145, 25, 255);
		}
		else if(final_p <= 25)
		{
			SetEntityRenderColor(entity, 255, 160, 30, 255);
		}
		else if(final_p <= 30)
		{
			SetEntityRenderColor(entity, 255, 175, 35, 255);
		}
		else if(final_p <= 35)
		{
			SetEntityRenderColor(entity, 255, 190, 40, 255);
		}
		else if(final_p <= 40)
		{
			SetEntityRenderColor(entity, 255, 205, 45, 255);
		}
		else if(final_p <= 45)
		{
			SetEntityRenderColor(entity, 255, 220, 50, 255);
		}
		else
		{
			SetEntityRenderColor(entity, 255, 255, 255, 200);
		}
	}
}

public OnPropSpawned(entity)
{
	Apply_Settings(entity);
} 

Apply_Settings(entity)
{
	if(IsValidEntity(entity))
	{
		new String:sname[128];
		Entity_GetModel(entity, sname, sizeof(sname));
		
		new String:EntClassName[256];
		Entity_GetClassName(entity, EntClassName, sizeof(EntClassName));
		
		decl String:_sName[64];
		GetEntPropString(entity, Prop_Data, "m_iName", _sName, 64);
		
		new validClass = StrContains(EntClassName, "prop_p");
		
		new bool:accepted = false;
		
		if(validClass > -1)
		{
			if(kvProps != INVALID_HANDLE)
			{
				KvRewind(kvProps);
				if (KvGotoFirstSubKey(kvProps))
				{
					decl String:path[128];
					do
					{
						KvGetString(kvProps, "model", path, sizeof(path), "rofldiekatz");
						if(StrEqual(path, sname))
						{
							accepted = true;
							new health = KvGetNum(kvProps, "health", 0);
							new bool:killtele = bool:KvGetNum(kvProps, "telekill", 0);
							new bool:knife_only = false;
							
							new bool:DisableMotion = false;
							
							new lifetime = 0;
							
							if(g_props[entity][Owner] > 0)
							{
								lifetime = KvGetNum(kvProps, "lifetime", 0);
								DisableMotion = bool:KvGetNum(kvProps, "disablemotion", 0);
							}
							
							if(DisableMotion) SetEntProp(entity, Prop_Data, "m_spawnflags", 8);
							g_props[entity][TeleKill] = killtele;
							
							if(health < 0)
							{
								health = health*(-1);
								knife_only = true;
							}

							if(health != 0)
							{
								if(knife_only)
								{
									Prop_AddKnifeHits(entity, health);
								}
								else
								{	
									new Handle:pack = CreateDataPack();
									CreateTimer(0.0, Timer_HPDelay, pack, TIMER_FLAG_NO_MAPCHANGE);
									WritePackCell(pack, entity);
									WritePackCell(pack, health);
								}
							}
							
							Prop_AddLifetime(entity, lifetime);
							
							break;
						}
					} while (KvGotoNextKey(kvProps));
					KvRewind(kvProps);
					
					if(!accepted)
					{
						new hits = GetConVarInt(cvarDefaultKnifeHits);
						Prop_AddKnifeHits(entity, hits);
					}
				}
			}
		}
	}
}

public Action:Timer_HPDelay(Handle:timer, Handle:pack)
{
	new entity, health;
	ResetPack(pack);
	entity = ReadPackCell(pack);	
	health = ReadPackCell(pack);
	if(IsValidEntity(entity)) Prop_AddHealth(entity, health);
}

public Action:ZR_OnClientInfect(&client, &attacker, &bool:motherInfect, &bool:respawnOverride, &bool:respawn)
{
	new credits = 2;
	
	if(Client_IsValid(attacker) && ZR_IsClientZombie(attacker))
	{
		for(new i=1;i<=MaxClients;i++)
		{
			if(!IsClientInGame(i))
				continue;
			if(!IsPlayerAlive(i))
				continue;
			if(i == attacker)
				continue;
			if(client == attacker)
				continue;
			if(attacker == 0)
				continue;
			if(respawn)
				continue;
			if(respawnOverride)
				continue;
			if(motherInfect)
				continue;
			if(!ZR_IsClientZombie(i))
				continue;
			
			if(Entity_InRange(client, i, GetConVarFloat(cvarInfectAssistsRange)))
			{
				AddCredits(i, credits);
				
				new String:buffer[128];
				Format(buffer, sizeof(buffer), "Infect assist for %N [+%d]", client, credits);
				if(credits != 0) CreditsMsgAdd(i, buffer);
			}
		}
	}
}

public Action:WeaponFire(Handle:event, const String:name[], bool:dontBroadcast)
{
	new client = GetClientOfUserId(GetEventInt(event, "userid"));
	//new clientHealth = GetClientHealth(client);
	
	if(client <= 0)
		return Plugin_Continue;
	
	if(!IsClientInGame(client))
		return Plugin_Continue;
	
	if(0 < g_iAmmoIncendiary[client])
	{
		g_iAmmoIncendiary[client]--;
		g_bAmmoIncendiary[client] = true;
		PrintCenterText(client, "%d", g_iAmmoIncendiary[client]);
	}
	else if(0 < g_iAmmoExplosive[client])
	{
		g_iAmmoExplosive[client]--;
		g_bAmmoExplosive[client] = true;
		PrintCenterText(client, "%d", g_iAmmoExplosive[client]);
	}
	
	return Plugin_Continue;
}

public Action:PlayerHurt(Handle:event,const String:name[],bool:dontBroadcast)
{
	new String:Weapon[30];
	GetEventString(event,"weapon",Weapon,30);
	new DmgDone = GetEventInt(event,"dmg_health");
	new client = GetClientOfUserId(GetEventInt(event, "userid"));
	new attacker = GetClientOfUserId(GetEventInt(event, "attacker"));
	
	if(client <= 0)
		return Plugin_Continue;
	
	if(attacker <= 0)
		return Plugin_Continue;
	
	if(!IsClientInGame(attacker))
		return Plugin_Continue;
	
	if(!IsClientInGame(client))
		return Plugin_Continue;
	
	if(!IsPlayerAlive(attacker))
		return Plugin_Continue;
	
	if(!IsPlayerAlive(client))
		return Plugin_Continue;
	
	if(!ZR_IsClientHuman(attacker))
		return Plugin_Continue;
	
	if(DmgDone >= 89 || DmgDone == 77)
		g_iCritCount[attacker]++;
	
	if(g_iCritCount[attacker] > 50)
	{
		AddCredits(attacker, 3);
		g_iCritCount[attacker] = 0;
		
		new String:buffer[128];
		Format(buffer, sizeof(buffer), "Crit. damage [+%d]", 3);
		CreditsMsgAdd(attacker, buffer);
	}
	
	if(g_bAmmoIncendiary[attacker])
	{
		g_bAmmoIncendiary[attacker] = false;
		IgniteEntity(client, 0.5);
	}
	else if(g_bAmmoExplosive[attacker])
	{
		g_bAmmoExplosive[attacker] = false;
		
		new Float:vAngles[3], Float:vReturn[3];	
		//Since m_angEyeAngles or m_angEyeAngles[0] works, I am using the harsh number
		GetClientEyeAngles(attacker, vAngles);
		
		vReturn[0] = FloatMul( Cosine( DegToRad(vAngles[1])  ) , KNOCKBACK);
		vReturn[1] = FloatMul( Sine( DegToRad(vAngles[1])  ) , KNOCKBACK);
		vReturn[2] = FloatMul( Sine( DegToRad(vAngles[0])  ) , KNOCKBACK);
			
		TeleportEntity(client, NULL_VECTOR, NULL_VECTOR, vReturn);
	}
	
	return Plugin_Continue;
}

MainMenu(client)
{
	if(client <= 0)
		return;
	
	if(!IsClientInGame(client))
		return;
	
	if(!IsPlayerAlive(client))
		return;
	
	CreditsMsgDisplay(client);
	
	new Handle:menu_main = CreateMenu(MainMenuHandle);

	SetGlobalTransTarget(client);

	SetMenuTitle(menu_main, "%t\n ", "Menu title", g_iCredits[client]);

	decl String:name[64];
	decl String:display[64];

	KvRewind(kvProps);
	if (KvGotoFirstSubKey(kvProps))
	{
		do
		{
			KvGetSectionName(kvProps, name, sizeof(name));
			
			new type = KvGetNum(kvProps, "buytype", 0);
			new cost = KvGetNum(kvProps, "cost", 0);
			new cost_infected = KvGetNum(kvProps, "cost_infected", 0);
			new ttl = KvGetNum(kvProps, "lifetime", 0);
			new health = KvGetNum(kvProps, "health", 0);
			new bool:knife_only = false;
			
			if(health < 0)
			{
				health = health*(-1);
				knife_only = true;
			}
			
			if(ZR_IsClientHuman(client) && cost > 0) 
			{
				if(type == TYPE_PROP)
				{
					Format(display, sizeof(display), "%t", "Menu option", name, cost);
					
					if(ttl > 0) Format(display, sizeof(display), "%s [%ds]", display, ttl);
					if(health > 0 && knife_only) Format(display, sizeof(display), "%s [%dkh]", display, health);
					else if(health > 0) Format(display, sizeof(display), "%s [%dhp]", display, health);
					
					if (g_iCredits[client] >= cost)
					{
						AddMenuItem(menu_main, name, display);
					}
					else
					{
						AddMenuItem(menu_main, name, display, ITEMDRAW_DISABLED);
					}
				}
				else if(type == TYPE_AMMOINCENDIARY || type == TYPE_AMMOEXPLOSIVE)
				{
					new ammo = KvGetNum(kvProps, "ammo", 0);
					Format(display, sizeof(display), "%t", "Menu option", name, cost);
					Format(display, sizeof(display), "%s [%d shots]", display, ammo);
					
					if (g_iCredits[client] >= cost)
					{
						AddMenuItem(menu_main, name, display);
					}
					else
					{
						AddMenuItem(menu_main, name, display, ITEMDRAW_DISABLED);
					}
				}
				else if(type == TYPE_HE)
				{
					Format(display, sizeof(display), "%t", "Menu option", name, cost);
					
					if (g_iCredits[client] >= cost)
					{
						AddMenuItem(menu_main, name, display);
					}
					else
					{
						AddMenuItem(menu_main, name, display, ITEMDRAW_DISABLED);
					}
				}
				else if(type == TYPE_FREEZER)
				{
					Format(display, sizeof(display), "%t", "Menu option", name, cost);
					
					if (g_iCredits[client] >= cost)
					{
						AddMenuItem(menu_main, name, display);
					}
					else
					{
						AddMenuItem(menu_main, name, display, ITEMDRAW_DISABLED);
					}
				}
			}
			else if(ZR_IsClientZombie(client) && cost_infected > 0) 
			{
				if(type == TYPE_PROP)
				{
					Format(display, sizeof(display), "%t", "Menu option", name, cost_infected);
					
					if(ttl > 0) Format(display, sizeof(display), "%s [%ds]", display, ttl);
					if(health > 0 && knife_only) Format(display, sizeof(display), "%s [%dkh]", display, health);
					else if(health > 0) Format(display, sizeof(display), "%s [%dhp]", display, health);
					
					if (g_iCredits[client] >= cost_infected)
					{
						AddMenuItem(menu_main, name, display);
					}
					else
					{
						AddMenuItem(menu_main, name, display, ITEMDRAW_DISABLED);
					}
				}
			}
			

		} while (KvGotoNextKey(kvProps));
	}

	DisplayMenu(menu_main, client, MENU_TIME_FOREVER);
}

public MainMenuHandle(Handle:menu_main, MenuAction:action, client, slot)
{
	if(client <= 0)
		return;
	
	if(!IsClientInGame(client))
		return;
	
	if(!IsPlayerAlive(client))
		return;
	
	if (action == MenuAction_Select)
	{
		decl String:name[64];
		if (GetMenuItem(menu_main, slot, name, sizeof(name)))
		{
			KvRewind(kvProps);
			if (KvJumpToKey(kvProps, name))
			{
				new type = KvGetNum(kvProps, "buytype", 0);
				new cost = KvGetNum(kvProps, "cost", 0);
				new cost_infected = KvGetNum(kvProps, "cost_infected", 0);
				new bool:DisableMotion = bool:KvGetNum(kvProps, "disablemotion", 0);
				
				if(ZR_IsClientHuman(client) && cost > 0) 
				{
					if (g_iCredits[client] < cost)
					{
						PrintToChat(client, "\x04[%t] \x01%t", "DHC Props", "Insufficient credits", g_iCredits[client], cost);
						MainMenu(client);

						return;
					}
				}
				else if(ZR_IsClientZombie(client) && cost_infected > 0) 
				{
					if (g_iCredits[client] < cost_infected)
					{
						PrintToChat(client, "\x04[%t] \x01%t", "DHC Props", "Insufficient credits", g_iCredits[client], cost_infected);
						MainMenu(client);

						return;
					}
				}
			
				if(type == TYPE_PROP)
				{
					new Float:vecOrigin[3];
					new Float:vecAngles[3];

					GetClientAbsOrigin(client, vecOrigin);
					GetClientAbsAngles(client, vecAngles);
					
					vecAngles[0] = GetEntDataFloat(client, offsEyeAngle0);
					
					if(!DisableMotion) vecOrigin[2] += 50;

					decl Float:vecFinal[3];
					AddInFrontOf(vecOrigin, vecAngles, 35, vecFinal);
					
					if(DisableMotion) vecFinal[2] = vecOrigin[2]+3;

					decl String:propmodel[128];
					KvGetString(kvProps, "model", propmodel, sizeof(propmodel));

					decl String:proptype[24];
					KvGetString(kvProps, "type", proptype, sizeof(proptype), "prop_physics");

					new prop = CreateEntityByName(proptype);
					
					if(prop != -1) 
					{
						Reset_Prop(prop);
						g_props[prop][Owner] = client;
						if(ZR_IsClientHuman(client)) g_props[prop][Paid] = cost;
							else g_props[prop][Paid] = cost_infected;
							
						PrecacheModel(propmodel);
						SetEntityModel(prop, propmodel);

						new String:EntName[256];
						Format(EntName, sizeof(EntName), "DHCPropSpawnProp%d____%d", client+100, prop);			
						DispatchKeyValue(prop, "targetname", EntName);

						DispatchSpawn(prop);
						
						TeleportEntity(prop, vecFinal, NULL_VECTOR, NULL_VECTOR);

						PrecacheModel(propmodel);
						SetEntityModel(prop, propmodel);
						
						if(ZR_IsClientHuman(client))
						{
							if(!IsStuckinWorld(prop) || DisableMotion)
							{
								g_iCredits[client] -= cost;

								ZProp_HudHint(client, "Credits left spend", cost, g_iCredits[client]);
								PrintToChat(client, "\x04[%t] \x01%t", "DHC Props", "Spawn prop", name);

								SaveID(client);
							}
							else
							{
								vecFinal[2] -= 50;
								TeleportEntity(prop, vecFinal, NULL_VECTOR, NULL_VECTOR);
								
								if(!IsStuckinWorld(prop))
								{
									g_iCredits[client] -= cost;

									ZProp_HudHint(client, "Credits left spend", cost, g_iCredits[client]);
									PrintToChat(client, "\x04[%t] \x01%t", "DHC Props", "Spawn prop", name);

									SaveID(client);
								}
								else
								{
									DeleteProp(prop);
									PrintToChat(client, "\x04[%t] \x01You can't spawn this prop here, there isn't enough space! Try another view angle.", "DHC Props");
									if(IsClientInGame(client)) DisplayMenuAtItem(menu_main, client, GetMenuSelectionPosition(), MENU_TIME_FOREVER );
								}
							}
						}
						else
						{
							g_iCredits[client] -= cost_infected;

							ZProp_HudHint(client, "Credits left spend", cost, g_iCredits[client]);
							PrintToChat(client, "\x04[%t] \x01%t", "DHC Props", "Spawn prop", name);

							SaveID(client);
						}
					}
				}
				else if(type == TYPE_AMMOINCENDIARY)
				{
					new ammo = KvGetNum(kvProps, "ammo", 0);
					g_iAmmoIncendiary[client] += ammo;
					g_iCredits[client] -= cost;

					ZProp_HudHint(client, "Credits left spend", cost, g_iCredits[client]);
					PrintToChat(client, "\x04[%t] \x01%t", "DHC Props", "Spawn prop", name);
				}
				else if(type == TYPE_AMMOEXPLOSIVE)
				{
					new ammo = KvGetNum(kvProps, "ammo", 0);
					g_iAmmoExplosive[client] += ammo;
					g_iCredits[client] -= cost;

					ZProp_HudHint(client, "Credits left spend", cost, g_iCredits[client]);
					PrintToChat(client, "\x04[%t] \x01%t", "DHC Props", "Spawn prop", name);
				}
				else if(type == TYPE_HE)
				{
					GivePlayerItem(client, "weapon_hegrenade");
					g_iCredits[client] -= cost;

					ZProp_HudHint(client, "Credits left spend", cost, g_iCredits[client]);
					PrintToChat(client, "\x04[%t] \x01%t", "DHC Props", "Spawn prop", name);
				}
				else if(type == TYPE_FREEZER)
				{
					PlaceFreezer(client);
					g_iCredits[client] -= cost;

					ZProp_HudHint(client, "Credits left spend", cost, g_iCredits[client]);
					PrintToChat(client, "\x04[%t] \x01%t", "DHC Props", "Spawn prop", name);
				}
			}
		}
	}
	if (action == MenuAction_End)
	{
		CloseHandle(menu_main);
	}
}

InfoMenu(client)
{
	if(client <= 0)
		return;
	
	if(!IsClientInGame(client))
		return;
	
	new Handle:menu_info = CreateMenu(InfoMenuHandle);

	SetGlobalTransTarget(client);
	
	SetMenuTitle(menu_info, "Prop Info [hp=Health;kh=Knife-hits;s=Secounds]", g_iCredits[client]);

	decl String:name[64];
	decl String:display[64];

	KvRewind(kvProps);
	if (KvGotoFirstSubKey(kvProps))
	{
		do
		{
			KvGetSectionName(kvProps, name, sizeof(name));
			
			new type = KvGetNum(kvProps, "buytype", 0);
			new cost = KvGetNum(kvProps, "cost", 0);
			new cost_infected = KvGetNum(kvProps, "cost_infected", 0);
			new ttl = KvGetNum(kvProps, "lifetime", 0);
			new health = KvGetNum(kvProps, "health", 0);
			new bool:knife_only = false;
			new ammo = KvGetNum(kvProps, "ammo", 0);
			
			if(health < 0)
			{
				health = health*(-1);
				knife_only = true;
			}
			
			if(type == TYPE_PROP)
			{
				Format(display, sizeof(display), "%s - Credits(H:%d|Z:%d)", name, cost, cost_infected);
				
				if(ttl > 0) Format(display, sizeof(display), "%s [%ds]", display, ttl);
				if(health > 0 && knife_only) Format(display, sizeof(display), "%s [%dkh]", display, health);
				else if(health > 0) Format(display, sizeof(display), "%s [%dhp]", display, health);
				
				if (g_iCredits[client] >= cost)
				{
					AddMenuItem(menu_info, name, display);
				}
				else
				{
					AddMenuItem(menu_info, name, display, ITEMDRAW_DISABLED);
				}
			}
			else if(type == TYPE_AMMOINCENDIARY || type == TYPE_AMMOEXPLOSIVE)
			{
				Format(display, sizeof(display), "%s - H:%dc|Z:%dc", name, cost, cost_infected);
				Format(display, sizeof(display), "%s [%d shots]", display, ammo);
				
				if (g_iCredits[client] >= cost)
				{
					AddMenuItem(menu_info, name, display);
				}
				else
				{
					AddMenuItem(menu_info, name, display, ITEMDRAW_DISABLED);
				}
			}
			

		} while (KvGotoNextKey(kvProps));
	}

	DisplayMenu(menu_info, client, MENU_TIME_FOREVER);
}

public InfoMenuHandle(Handle:menu_info, MenuAction:action, client, slot)
{
	if(client <= 0)
		return;
	
	if(!IsClientInGame(client))
		return;
	
	if(!IsPlayerAlive(client))
		return;
	
	if (action == MenuAction_Select)
	{
		if(IsClientInGame(client)) DisplayMenuAtItem(menu_info, client, GetMenuSelectionPosition(), MENU_TIME_FOREVER );
	}
	else if (action == MenuAction_End)
	{
		CloseHandle(menu_info);
	}
}

public Action:RemoveTimer(Handle:timer, Handle:pack)
{
	new entity;
	
	ResetPack(pack);
	entity = ReadPackCell(pack);
	
	if(!Entity_IsValid(entity))
	{
		return Plugin_Stop;
	}

	if(g_props[entity][LifetimeCount] >= g_props[entity][LifetimeMax])
	{
		DeleteProp(entity, true);
		return Plugin_Stop;
	}
	
	Prop_UpdateColor(entity);

	g_props[entity][LifetimeCount]++;

	return Plugin_Continue;
}

AddInFrontOf(Float:vecOrigin[3], Float:vecAngle[3], units, Float:output[3])
{
	new Float:vecView[3];
	GetViewVector(vecAngle, vecView);

	output[0] = vecView[0] * units + vecOrigin[0];
	output[1] = vecView[1] * units + vecOrigin[1];
	output[2] = vecView[2] * units + vecOrigin[2];
}
 
GetViewVector(Float:vecAngle[3], Float:output[3])
{
	output[0] = Cosine(vecAngle[1] / (180 / FLOAT_PI));
	output[1] = Sine(vecAngle[1] / (180 / FLOAT_PI));
	output[2] = -Sine(vecAngle[0] / (180 / FLOAT_PI));
}

public Action:PlayerSpawn(Handle:event, const String:name[], bool:dontBroadcast)
{
	new client = GetClientOfUserId(GetEventInt(event, "userid"));

	ResetPlayerLite(client);
	
	new team = GetClientTeam(client);
	if (team != CS_TEAM_T && team != CS_TEAM_CT)
		return;

	new credits_spawn = GetConVarInt(cvarCreditsSpawn);

	AddCredits(client, credits_spawn);
		
	new String:buffer[128];
	Format(buffer, sizeof(buffer), "Spawn [+%d]", credits_spawn);
	if(credits_spawn != 0) CreditsMsgAdd(client, buffer);
}

public Action:PlayerDeath(Handle:event, const String:name[], bool:dontBroadcast)
{
	new attacker = GetClientOfUserId(GetEventInt(event, "attacker"));
	new victim = GetClientOfUserId(GetEventInt(event, "userid"));

	if (!attacker)
		return;
	
	//Don't earn credits from teamkills
	if(Client_IsValid(attacker, true) && Client_IsValid(victim, true))
	{
		if(GetClientTeam(attacker) == GetClientTeam(victim))
			return;
	}

	decl String:weapon[32];
	GetEventString(event, "weapon", weapon, sizeof(weapon));
	
	new bool:Infect = StrEqual(weapon, "zombie_claws_of_death");

	new credits_earned = Infect ? GetConVarInt(cvarCreditsInfect) : GetConVarInt(cvarCreditsKill);
	
	if(credits_earned != 0) AddCredits(attacker, credits_earned);
		
	new String:buffer[128];
	if(Infect) 
		Format(buffer, sizeof(buffer), "Infected %N [+%d]", victim, credits_earned);
	else 
		Format(buffer, sizeof(buffer), "Killed %N [+%d]", victim, credits_earned);
	CreditsMsgAdd(attacker, buffer);
}

public Action:PlayerTeam(Handle:event, const String:name[], bool:dontBroadcast)
{
	new client = GetClientOfUserId(GetEventInt(event, "userid"));

	if (!client)
		return;

	if (g_iCredits[client] == -1)
	{
		CreditsMsgReset(client);
		
		new credits_connect = GetConVarInt(cvarCreditsConnect);
		g_iCredits[client] = credits_connect;
			
		new String:buffer[128];
		Format(buffer, sizeof(buffer), "Connect [+%d]", credits_connect);
		CreditsMsgAdd(client, buffer);
		
		PrintToChat(client, "\x04[%t] \x01%t", "DHC Props", "Join message");
	}
}

public Action:RoundStart(Handle:event, const String:name[], bool:dontBroadcast)
{
	for(new i = 1; i <= MaxClients; i++)
	{
		if (IsClientInGame(i) && GetClientTeam(i) > 1)
		{
			new credits_roundstart = GetConVarInt(cvarCreditsRoundStart);
			AddCredits(i, credits_roundstart);
			
			new String:buffer[128];
			Format(buffer, sizeof(buffer), "Roundstart [+%d]", credits_roundstart);
			if(credits_roundstart != 0) CreditsMsgAdd(i, buffer);
		}
	}
}

ZProp_HudHint(client, any:...)
{
	SetGlobalTransTarget(client);

	decl String:phrase[192];

	VFormat(phrase, sizeof(phrase), "%t", 2);

	Client_PrintHintText(client, phrase);
}

public Action:Command_PropInfo(client, argc)
{
	if(IsClientInGame(client)) InfoMenu(client);
	return Plugin_Handled;
}

public Action:Command_Props(client, argc)
{
	if(IsClientInGame(client)) 
	{
		if(IsPlayerAlive(client)) 
		{
			MainMenu(client);
		}
		else
		{
			FakeClientCommand(client, "sm_propaim");
			FakeClientCommand(client, "sm_propinfo");
		}
	}
	return Plugin_Handled;
}

public Action:Command_GetOwner(client, argc)
{
	new prop = GetClientAimTarget(client, false);

	if(!Entity_IsValid(prop)) 
	{
		return Plugin_Handled;
	}

	new String:EntName[256];
	Entity_GetName(prop, EntName, sizeof(EntName));

	new String:EntClassName[256];
	Entity_GetClassName(prop, EntClassName, sizeof(EntClassName));

	new String:EntModelName[256];
	Entity_GetModel(prop, EntModelName, sizeof(EntModelName));
	
	new validClass = StrContains(EntClassName, "prop_");
	new validProp = StrContains(EntName, "DHCPropSpawnProp");
	
	if(validClass > -1)
	{
		PrintToConsole(client, "Model:%s", EntModelName);
		
		new String:pbuffer[512];
		
		if(validProp > -1)
		{
			/* Find the client index in the string */
			new String:tempInd[3];
			tempInd[0] = EntName[16];
			tempInd[1] = EntName[17];
			tempInd[2] = EntName[18];

			/* We should now have the numbers somewhere, let's find out where */
			ReplaceString(tempInd, sizeof(tempInd), "_", "");

			new clientIndex = StringToInt(tempInd)-100;
			
			decl String:buffer[5];

			IntToString(prop, buffer, sizeof(buffer));

			decl String:client_id[100];
			decl String:client_s[100];
			IntToString(clientIndex, client_s, sizeof(client_s));

			KvGetString(g_kvDBSteamID, client_s, client_id, sizeof(client_id), "");

			if(IsValidClient(clientIndex))
			{
				Format(pbuffer, sizeof(pbuffer), "Prop spawned by: {red}%N{default} [%s]", clientIndex, client_id);
			}
			else
			{
				Format(pbuffer, sizeof(pbuffer), "Prop spawned by: {red}Unconnected{default} [%s]", client_id);
			}
		}
		else Format(pbuffer, sizeof(pbuffer), "Prop spawned by: {red}Map{default}");
		
		if(g_props[prop][LifetimeCount] > 0 || g_props[prop][KnifeHitsMax] > 0 || g_props[prop][HealthMax] > 0)
		{
			new String:buffer[512];
			
			if(g_props[prop][LifetimeCount] > 0)
				Format(buffer, sizeof(buffer), "%s Time left: {blue}%d{default} ", buffer, g_props[prop][LifetimeMax]-g_props[prop][LifetimeCount]);
			if(g_props[prop][KnifeHitsMax] > 0)
				Format(buffer, sizeof(buffer), "%s Hits left: {blue}%d{default} ", buffer, g_props[prop][KnifeHitsMax]-g_props[prop][KnifeHitsCount]);
			if(g_props[prop][HealthMax] > 0)
			{
				new hpleft = GetEntProp(prop, Prop_Data, "m_iHealth");
				Format(buffer, sizeof(buffer), "%s HP left: {blue}%d{default} ", buffer, hpleft);
			}
			
			Format(buffer, sizeof(buffer), "[%s] %s", buffer, pbuffer);
			CPrintToChat(client, "\x04[%t] \x01Prop Info: %s", "DHC Props", buffer);
		}
	}
	else PrintToChat(client, "\x04[%t] \x01Couldn't find a valid prop as aim target", "DHC Props");

	return Plugin_Handled;
}

public Action:AdminRemovePropAim(client, args)
{
	new prop = GetClientAimTarget(client, false);

	if(!Entity_IsValid(prop)) 
	{
		return Plugin_Handled;
	}

	new String:EntName[256];
	Entity_GetName(prop, EntName, sizeof(EntName));
	new validProp = StrContains(EntName, "DHCPropSpawnProp");

	new String:EntClassName[256];
	Entity_GetClassName(prop, EntClassName, sizeof(EntClassName));
	new validClass = StrContains(EntClassName, "prop_p");

	if(validClass > -1)
	{
		if(validProp > -1)
		{
			/* Find the client index in the string */
			new String:tempInd[3];
			tempInd[0] = EntName[16];
			tempInd[1] = EntName[17];
			tempInd[2] = EntName[18];

			/* We should now have the numbers somewhere, let's find out where */
			ReplaceString(tempInd, sizeof(tempInd), "_", "");

			new clientIndex = StringToInt(tempInd)-100;
			new Handle:menu = CreateMenu(Handle_RemovePropAim_Menu);
			decl String:buffer[5];

			IntToString(prop, buffer, sizeof(buffer));

			decl String:client_id[100];
			decl String:client_s[100];
			IntToString(clientIndex, client_s, sizeof(client_s));

			KvGetString(g_kvDBSteamID, client_s, client_id, sizeof(client_id), "");

			if(IsValidClient(clientIndex)) SetMenuTitle(menu, "Delete? Owner: %N [ID:%s]", clientIndex, client_id);
			else SetMenuTitle(menu, "Delete? Owner: Unconnected [ID:%s]", client_id);

			AddMenuItem(menu, buffer, "Yes");
			AddMenuItem(menu, buffer, "No");

			SetMenuExitButton(menu, true);
			DisplayMenu(menu, client, MENU_TIME_FOREVER);
			LogToFile("addons/sourcemod/logs/sm_remove_props.log", "%N watched prop spawned by %s", client, client_id);
		}
		else
		{
			new Handle:menu = CreateMenu(Handle_RemovePropAim_Menu);
			decl String:buffer[5];
			IntToString(prop, buffer, sizeof(buffer));
			SetMenuTitle(menu, "Delete? Orginal Map Prop");
			AddMenuItem(menu, buffer, "Yes");
			AddMenuItem(menu, buffer, "No");
			AddMenuItem(menu, buffer, "Check another prop");
			LogToFile("addons/sourcemod/logs/sm_remove_props.log", "%N watched map prop", client);

			SetMenuExitButton(menu, true);
			DisplayMenu(menu, client, MENU_TIME_FOREVER);
		}

	}

	return Plugin_Handled;
}
 
public Handle_RemovePropAim_Menu(Handle:menu, MenuAction:action, client, param2)
{
	if ( action == MenuAction_Select )
	{
		switch (param2)
		{
			case 0:
			{
				decl String:info[5];
				GetMenuItem(menu, param2, info, sizeof(info));
				new prop = StringToInt(info);

				new String:EntName[256];
				Entity_GetName(prop, EntName, sizeof(EntName));
				new validProp = StrContains(EntName, "DHCPropSpawnProp");

				new String:EntClassName[256];
				Entity_GetClassName(prop, EntClassName, sizeof(EntClassName));
				new validClass = StrContains(EntClassName, "prop_p");

				if(validClass > -1)
				{
					if(validProp > -1)
					{
						//Remove the prop
						/* Find the client index in the string */
						new String:tempInd[3];
						tempInd[0] = EntName[15];
						tempInd[1] = EntName[16];
						tempInd[2] = EntName[17];

						/* We should now have the numbers somewhere, let's find out where */
						ReplaceString(tempInd, sizeof(tempInd), "_", "");

						new clientIndex = StringToInt(tempInd)-100;

						decl String:client_id[100];
						decl String:client_s[100];
						IntToString(clientIndex, client_s, sizeof(client_s));

						KvGetString(g_kvDBSteamID, client_s, client_id, sizeof(client_id), "");

						PrintToConsole(client, "Deleted Prop_ID: %d, Owner was Steam_ID: %s", prop, client_id);
						LogToFile("addons/sourcemod/logs/sm_remove_props.log", "%N removed prop spawned by %s", client, client_id);
						
						//Warn Owner
						if(IsValidClient(clientIndex))
							PrintToChat(clientIndex, "\x04[%t] \x01%t", "DHC Props", "Warn Owner");
					}
					else
					{
						
						PrintToConsole(client, "Deleted Prop_ID: %d, Orginal Map Entity", prop);
						LogToFile("addons/sourcemod/logs/sm_remove_props.log", "%N removed map prop", client);
					}
					
					DeleteProp(prop);

				}
			}
			case 1:
			{

			}
			case 2:
			{
				FakeClientCommand(client, "sm_remove_prop");
			}
		}
	}
}

bool:IsValidClient(client) 
{
	if( client <= 0 )
		return false;

	if( client > GetMaxClients() )
		return false;

	if( !IsClientConnected(client) )
		return false;

	if( !IsClientInGame(client) )
		return false;


	return true;
}

bool:IsStuckinWorld(ent)
{  
	decl Float:flOrigin[3];
	decl Float:flMins[3];
	decl Float:flMaxs[3];
	GetEntPropVector(ent, Prop_Send, "m_vecOrigin", flOrigin);
	GetEntPropVector(ent, Prop_Send, "m_vecMins", flMins);
	GetEntPropVector(ent, Prop_Send, "m_vecMaxs", flMaxs);

	TR_TraceHullFilter(flOrigin, flOrigin, flMins, flMaxs, MASK_SOLID, TraceFilterNotSelf, ent);
	return TR_DidHit();
}

public bool:TraceFilterNotSelf(entity, contentsMask, any:prop)
{
	return false;
}

public Action:Timer_KillEntity(Handle:timer, any:ref)
{
	new entity = EntRefToEntIndex(ref);
	if(entity != INVALID_ENT_REFERENCE && Entity_IsValid(entity))
		AcceptEntityInput(entity, "Kill");
}

stock ResetPlayerLite(client)
{
	g_iAmmoIncendiary[client] = 0;
	g_bAmmoIncendiary[client] = false;
	g_iAmmoExplosive[client] = 0;
	g_bAmmoExplosive[client] = false;
	g_iCritCount[client] = 0;
}

stock AddCredits(client, credits)
{
	new credits_max = GetConVarInt(cvarCreditsMax);
	
	g_iCredits[client] += credits;
	
	if (g_iCredits[client] < credits_max)
	{
		ZProp_HudHint(client, "Credits left gain", credits, g_iCredits[client]);
	}
	else
	{
		g_iCredits[client] = credits_max;
		ZProp_HudHint(client, "Credits left max", credits, g_iCredits[client]);
	}
}

stock Reset_Prop_All()
{
	for(new i=MaxClients;i<=2047;i++)
	{
		Reset_Prop(i);
	}
}

stock Reset_Prop(entity)
{
	g_props[entity][LifetimeMax] = 0;
	g_props[entity][LifetimeCount] = 0;
	g_props[entity][KnifeHitsMax] = 0;
	g_props[entity][KnifeHitsCount] = 0;
	g_props[entity][HealthMax] = 0;
	g_props[entity][TeleKill] = 0;
	g_props[entity][Paid] = 0;
	g_props[entity][Owner] = 0;
}

stock Prop_AddHealth(entity, health)
{
	if(health > 0) 
	{
		SetEntProp(entity, Prop_Data, "m_takedamage", DAMAGE_YES, 1);
		SetEntProp(entity, Prop_Data, "m_iHealth", health);
		g_props[entity][HealthMax] = health;
		SDKHook(entity, SDKHook_OnTakeDamage, OnTakeDamage);
	}
}

stock Prop_AddKnifeHits(entity, hits)
{
	if(hits > 0) 
	{
		SetEntProp(entity, Prop_Data, "m_takedamage", DAMAGE_EVENTS_ONLY, 1);
		g_props[entity][KnifeHitsMax] = hits;
		SDKHook(entity, SDKHook_OnTakeDamage, OnTakeDamage);
	}
}

stock Prop_AddLifetime(entity, lifetime)
{
	if(lifetime > 0) 
	{
		g_props[entity][LifetimeMax] = lifetime;
		new Handle:pack = CreateDataPack();
		CreateTimer(1.0, RemoveTimer, pack, TIMER_REPEAT|TIMER_FLAG_NO_MAPCHANGE);
		WritePackCell(pack, entity);
	}
}

stock DeleteProps(howmuch)
{
	new count = 0;
	
	for (new i = 2047; i > GetMaxClients(); i--)
	{
		if(!IsValidEntity(i)) continue;
		
		new String:EntName[256];
		Entity_GetName(i, EntName, sizeof(EntName));
		
		new valid = StrContains(EntName, "DHCPropSpawnProp");
		if(valid > -1)
		{
			count++;
			DeleteProp(i, false);
		}
		
		if(count > howmuch)
			break;
	}
}

stock DeleteProp(entity, bool:dissolve = false)
{
	if(dissolve)
	{
		new _iDissolve = CreateEntityByName("env_entity_dissolver");
		if(_iDissolve > 0)
		{
			decl String:_sName[64];
			GetEntPropString(entity, Prop_Data, "m_iName", _sName, 64);
			DispatchKeyValue(_iDissolve, "dissolvetype", "0");
			DispatchKeyValue(_iDissolve, "target", _sName);
			AcceptEntityInput(_iDissolve, "Dissolve");
			
			CreateTimer(1.0, Timer_KillEntity, EntIndexToEntRef(entity));
			CreateTimer(0.1, Timer_KillEntity, EntIndexToEntRef(_iDissolve));
			return;
		}
	}
	
	AcceptEntityInput(entity, "kill");
	Reset_Prop(entity);
}

stock CreditsMsgReset(client)
{
	g_iCreditsMsgCount[client] = 0;
	
	for (new i = 0; i < 5; i++)
	{
		Format(g_msgCredits[client][i][cMsg], 128, "");
		g_msgCredits[client][i][cTime] = 0.0;
	}
}

stock CreditsMsgAdd(client, String:newMsg[128])
{
	new Float:time = GetGameTime();
	new count = g_iCreditsMsgCount[client];
	
	//Sort & Add Msg
	if(count == 5)
	{
		Format(g_msgCredits[client][0][cMsg], 128, "%s", g_msgCredits[client][1][cMsg]);
		g_msgCredits[client][0][cTime] = g_msgCredits[client][1][cTime];
		Format(g_msgCredits[client][1][cMsg], 128, "%s", g_msgCredits[client][2][cMsg]);
		g_msgCredits[client][1][cTime] = g_msgCredits[client][2][cTime];
		Format(g_msgCredits[client][2][cMsg], 128, "%s", g_msgCredits[client][3][cMsg]);
		g_msgCredits[client][2][cTime] = g_msgCredits[client][3][cTime];
		Format(g_msgCredits[client][3][cMsg], 128, "%s", g_msgCredits[client][4][cMsg]);
		g_msgCredits[client][3][cTime] = g_msgCredits[client][4][cTime];
		Format(g_msgCredits[client][4][cMsg], 128, "%s", newMsg);
		g_msgCredits[client][4][cTime] = time;
	}
	//Add Msg
	else if(count > 0)
	{
		Format(g_msgCredits[client][count][cMsg], 128, "%s", newMsg);
		g_msgCredits[client][count][cTime] = time;
		g_iCreditsMsgCount[client] += 1;
	}
	//First Msg
	else if(count == 0)
	{
		Format(g_msgCredits[client][count][cMsg], 128, "%s", newMsg);
		g_msgCredits[client][count][cTime] = time;
		g_iCreditsMsgCount[client] = 1;
	}
	
	CreditsMsgDisplay(client);
}

stock CreditsMsgDisplay(client)
{
	new String:buffer[512];
	Format(buffer, sizeof(buffer), "Credits: %d\n- - - - - - - - - -\n", g_iCredits[client]);
	for (new i = 0; i < 5; i++)
	{
		if(g_msgCredits[client][i][cTime] > 0)
		{
			if(i == 4)
				Format(buffer, sizeof(buffer), "%s%s", buffer, g_msgCredits[client][i][cMsg]);
			else
				Format(buffer, sizeof(buffer), "%s%s\n", buffer, g_msgCredits[client][i][cMsg]);
		}
	}
	
	Client_PrintKeyHintText(client, buffer);
}

public Action:EntitySecurity(Handle:timer)
{
	new Float:DiffExec = (GetEngineTime()-LastExecTime);
	LastExecTime = GetEngineTime();
	
	if(DiffExec >= 1.1)
	{
		TickWarns++;
	}
	else
	{
		TickWarns = 0;
	}
	
	if(DiffExec > 2.0)
	{
		TickWarns = 5;
	}
	
	if(TickWarns >= 5)
	{
		DeleteProps(10);
		LogMessage("[PROP SPAWN] Detected massive server lagg, removing some props.");
		PrintToChatAll("[PROP SPAWN] Detected massive server lagg, removing some props.");
	}
}

stock PlaceFreezer(client)
{
	new Float:place[3];
	
	GetClientAbsOrigin(client, place);
	
	new Float:angle[3];
	new Float:place2[3];
	new Float:secondpos[3];
	
	GetClientEyeAngles(client, angle);
	GetAngleVectors(angle, secondpos, NULL_VECTOR, NULL_VECTOR);
	
	place[0] -= 0.0;
	place2[0] = 0.0;
	
	GetEntPropVector(client, Prop_Data, "m_vecVelocity", secondpos);
	AddVectors(place2, secondpos, place2);
	decl String:fullPath[100];
	FormatEx(fullPath, sizeof(fullPath), "%s", mdlDetector);
	
	new entity = CreateEntityByName("prop_physics_override");
	if (IsValidEntity(entity))
	{
		PrecacheModel(fullPath, true);
		SetEntityRenderMode(entity, RENDER_TRANSCOLOR);
		SetEntityModel(entity, fullPath);
		SetEntityMoveType(entity, MOVETYPE_NONE);
		SetEntPropEnt(entity, Prop_Send, "m_hOwnerEntity", client);
		SetEntProp(entity, Prop_Data, "m_CollisionGroup", 1);
		SetEntProp(entity, Prop_Send, "m_usSolidFlags", 12);
		SetEntProp(entity, Prop_Send, "m_nSolidType", 6);
		
		DispatchSpawn(entity);
		SetEntData(entity, g_Freeze, FL_CLIENT|FL_ATCONTROLS, 4, true);
		SetEntityMoveType(entity, MOVETYPE_NONE);
		TeleportEntity(entity, place, NULL_VECTOR, place2);
		SetEntPropEnt(entity, Prop_Data, "m_hLastAttacker", client);
		
		new Float:rotate[3];
		GetClientAbsAngles(client, rotate);
		TeleportEntity(entity, NULL_VECTOR, rotate, NULL_VECTOR);
		
		CreateTimer(0.5, Timer_CheckFreeze, entity, TIMER_FLAG_NO_MAPCHANGE|TIMER_REPEAT);
	}
}

public Action:Timer_CheckFreeze(Handle:timer, any:entity)
{
	if(!IsValidEntity(entity))
		return Plugin_Stop;
	
	new client = GetEntPropEnt(entity, Prop_Send, "m_hOwnerEntity");
	
	if(!IsValidClient(client))
	{
		DeleteProp(entity, true);
		return Plugin_Stop;
	}
	
	if(!ZR_IsClientHuman(client))
	{
		DeleteProp(entity, true);
		return Plugin_Stop;
	}
	
	new Float:fSmokeOrigin[3];
	GetEntPropVector(entity, Prop_Send, "m_vecOrigin", fSmokeOrigin);
	
	new Float:time = GetGameTime();
	
	if(time-g_fLastFreeze[entity] > 10.0)
	{
		for(new i=1;i<=MaxClients;i++)
		{
			if(IsClientInGame(i) && IsPlayerAlive(i) && ZR_IsClientZombie(i))
			{
				if(Entity_InRange(entity, i, 66.0) && GetEntityMoveType(i) == MOVETYPE_WALK)
				{
					SetEntityMoveType(i, MOVETYPE_NONE);
					CreateTimer(3.0, Timer_UnFreeze, i, TIMER_FLAG_NO_MAPCHANGE);
					DrawBoundingBox(i, 0, 3.0);
					g_fLastFreeze[entity] = time;
		
					decl Float:entityposition[3];
					GetEntPropVector(entity, Prop_Send, "m_vecOrigin", entityposition);
					
					entityposition[2] += 20;
					
					DrawIonBeam2(entityposition);
					TE_SetupBeamRingPoint(entityposition, 0.0, 500.0, gGlow1, gHalo1, 0, 0, 0.5, 10.0, 7.0, {255, 0, 0, 255}, 0, 0);
					TE_SendToAll();
					TE_SetupBeamRingPoint(entityposition, 0.0, 500.0, gGlow1, gHalo1, 0, 0, 0.7, 10.0, 7.0, {255, 0, 0, 255}, 0, 0);
					TE_SendToAll();
					TE_SetupBeamRingPoint(entityposition, 0.0, 500.0, gGlow1, gHalo1, 0, 0, 0.9, 10.0, 7.0, {255, 0, 0, 255}, 0, 0);
					TE_SendToAll();
					TE_SetupBeamRingPoint(entityposition, 0.0, 500.0, gGlow1, gHalo1, 0, 0, 1.4, 10.0, 7.0, {255, 0, 0, 255}, 0, 0);
					TE_SendToAll();
					break;
				}
			}
		}
	}
	return Plugin_Continue;
}

public Action:Timer_UnFreeze(Handle:Timer, any:client)
{
	if(Client_IsValid(client, true) && IsPlayerAlive(client))
		SetEntityMoveType(client, MOVETYPE_WALK);
	return Plugin_Handled;
}

stock DrawIonBeam2(Float:startPosition[3])
{
	decl Float:position[3];
	position[0] = startPosition[0];
	position[1] = startPosition[1];
	position[2] = startPosition[2] + 1500.0;	

	TE_SetupBeamPoints(startPosition, position, gLaser1, 0, 0, 0, 0.15, 25.0, 25.0, 0, 1.0, {255, 0, 0, 255}, 3 );
	TE_SendToAll();
	position[2] -= 1490.0;
	TE_SetupSmoke(startPosition, gSmoke1, 10.0, 2);
	TE_SendToAll();
	TE_SetupGlowSprite(startPosition, gGlow1, 1.0, 1.0, 255);
	TE_SendToAll();
}

stock DrawBoundingBox(ent, client = 0, Float:time = 10.0)
{
    new Float:posMin[4][3], Float:posMax[4][3];
    new Float:orig[3];
    
    GetEntPropVector(ent, Prop_Send, "m_vecMins", posMin[0]);
    GetEntPropVector(ent, Prop_Send, "m_vecMaxs", posMax[0]);
    GetEntPropVector(ent, Prop_Send, "m_vecOrigin", orig);

    // Incase the entity is a player i want to make the box fit..
    new String:edictname[32];
    GetEdictClassname(ent, edictname, 32);
    if (StrEqual(edictname, "player"))
    {
        posMax[0][2] += 16.0;
    }

    posMin[1][0] = posMax[0][0];
    posMin[1][1] = posMin[0][1];
    posMin[1][2] = posMin[0][2];
    posMax[1][0] = posMin[0][0];
    posMax[1][1] = posMax[0][1];
    posMax[1][2] = posMax[0][2];
    posMin[2][0] = posMin[0][0];
    posMin[2][1] = posMax[0][1];
    posMin[2][2] = posMin[0][2];
    posMax[2][0] = posMax[0][0];
    posMax[2][1] = posMin[0][1];
    posMax[2][2] = posMax[0][2];
    posMin[3][0] = posMax[0][0];
    posMin[3][1] = posMax[0][1];
    posMin[3][2] = posMin[0][2];
    posMax[3][0] = posMin[0][0];
    posMax[3][1] = posMin[0][1];
    posMax[3][2] = posMax[0][2];
    
    AddVectors(posMin[0], orig, posMin[0]);
    AddVectors(posMax[0], orig, posMax[0]);
    AddVectors(posMin[1], orig, posMin[1]);
    AddVectors(posMax[1], orig, posMax[1]);
    AddVectors(posMin[2], orig, posMin[2]);
    AddVectors(posMax[2], orig, posMax[2]);
    AddVectors(posMin[3], orig, posMin[3]);
    AddVectors(posMax[3], orig, posMax[3]);
    
    //DrawBoundingBox_Internal(posMin[0], posMax[0], client, time);
    //DrawBoundingBox_Internal(posMin[1], posMax[1], client, time);
    //DrawBoundingBox_Internal(posMin[2], posMax[2], client, time);
    //DrawBoundingBox_Internal(posMin[3], posMax[3], client, time);
    
    //UP & DOWN
    
    //BORDER
    DrawBoundingBox_Internal(posMin[0], posMax[3], client, time);
    DrawBoundingBox_Internal(posMin[1], posMax[2], client, time);
    DrawBoundingBox_Internal(posMin[3], posMax[0], client, time);
    DrawBoundingBox_Internal(posMin[2], posMax[1], client, time);
    //CROSS
    DrawBoundingBox_Internal(posMin[3], posMax[2], client, time);
    DrawBoundingBox_Internal(posMin[1], posMax[0], client, time);
    DrawBoundingBox_Internal(posMin[2], posMax[3], client, time);
    DrawBoundingBox_Internal(posMin[3], posMax[1], client, time);
    DrawBoundingBox_Internal(posMin[2], posMax[0], client, time);
    DrawBoundingBox_Internal(posMin[0], posMax[1], client, time);
    DrawBoundingBox_Internal(posMin[0], posMax[2], client, time);
    DrawBoundingBox_Internal(posMin[1], posMax[3], client, time);
    
    
    //TOP
    
    //BORDER
    DrawBoundingBox_Internal(posMax[0], posMax[1], client, time);
    DrawBoundingBox_Internal(posMax[1], posMax[3], client, time);
    DrawBoundingBox_Internal(posMax[3], posMax[2], client, time);
    DrawBoundingBox_Internal(posMax[2], posMax[0], client, time);
    //CROSS
    DrawBoundingBox_Internal(posMax[0], posMax[3], client, time);
    DrawBoundingBox_Internal(posMax[2], posMax[1], client, time);
    
    //BOTTOM
    
    //BORDER
    DrawBoundingBox_Internal(posMin[0], posMin[1], client, time);
    DrawBoundingBox_Internal(posMin[1], posMin[3], client, time);
    DrawBoundingBox_Internal(posMin[3], posMin[2], client, time);
    DrawBoundingBox_Internal(posMin[2], posMin[0], client, time);
    //CROSS
    DrawBoundingBox_Internal(posMin[0], posMin[3], client, time);
    DrawBoundingBox_Internal(posMin[2], posMin[1], client, time);
}

stock DrawBoundingBox_Internal(const Float:start[3], const Float:end[3], client = 0, Float:time = 10.0)
{
	TE_SetupBeamPoints(start, end, gLaser1, 0, 0, 0, time, 3.0, 3.0, 7, 0.0, {0, 0, 255, 200}, 0);

	if (client)
		TE_SendToClient(client);
	else
		TE_SendToAll();
}