/*
include/ss_basic.sp
SStocks
This plugin is coded by Alican "AlicanC" ubukuolu (alicancubukcuoglu@gmail.com)
Copyright (C) 2007 Alican ubukuolu
*/
/*
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

#if defined _ss_basic_included
 #endinput
#endif
#define _ss_basic_included

/**
 * Restarts the game.
 *
 * @param time			Time before game restarts.
 * @noreturn
 */
stock RestartGame(time=1)
	{
	ServerCommand("mp_restartgame %i", time);
	}

/**
 * Sets a fail state.
 *
 * @param pname			Plugin's name.
 * @param format		Formatting rules.
 * @param ...			Variable number of format parameters.
 * @noreturn
 */
stock Fail(const String:pname[], const String:format[], any:...)
	{
	new String:reason[256], String:error[256];
	VFormat(reason, sizeof(reason), format, 3);
	Format(error, sizeof(error), "[%s] %s", pname, reason);
	SetFailState(error);
	}

/**
 * Sets fail state.
 *
 * @note			'DEBUG' must be defined before compiling plugin to make this work.
 * @param pname			Plugin's name.
 * @param fname			Function's name.
 * @param format		Formatting rules.
 * @param ...			Variable number of format parameters.
 * @noreturn
 */
stock Debug(const String:pname[], const String:fname[], const String:format[], any:...)
	{
	#if defined DEBUG
	new String:debugmes[128];
	VFormat(debugmes, sizeof(debugmes), format, 4);
	PrintToChatAll("%c[%s | Debug(%c%s%c)]%c %s", COLOR_GREEN, pname, COLOR_TEAMCOLOR, command, COLOR_GREEN, COLOR_YELLOW, debugmes);
	#endif
	}

/**
 * Sends a message to all clients.
 *
 * @param pname			Plugin's name.
 * @param format		Formatting rules.
 * @param ...			Variable number of format parameters.
 * @noreturn
 */
stock MessageToAll(const String:pname[], const String:format[], any:...)
	{
	new String:message[128];
	VFormat(message, sizeof(message), format, 3);
	PrintToChatAll("%c[%s]%c %s", COLOR_GREEN, pname, COLOR_YELLOW, message);
	}

/**
 * Sends a message to a client.
 *
 * @param client		Client.
 * @param pname			Plugin's name.
 * @param format		Formatting rules.
 * @param ...			Variable number of format parameters.
 * @noreturn
 */
stock MessageToOne(client, const String:pname[], const String:format[], any:...)
	{
	new String:message[128];
	VFormat(message, sizeof(message), format, 4);
	PrintToChat(client, "%c[%s]%c %s", COLOR_GREEN, pname, COLOR_YELLOW, message);
	}