#pragma semicolon 1

#include <sourcemod>
#include <sdktools>
#include <sdkhooks>
#include <loghelper>
#include <smlib>
#include <smlib/arrays>
#include <cstrike>
#include <zipcore>
#include <timer>

#define PL_CFG_NAME ""
#define PL_LIB_TAG ""

/* PluginINFO */
public Plugin:myinfo =
{
    name        = "",
    author      = "Zipcore",
    description = "",
    version     = PL_VERSION,
    url         = "zipcore#googlemail.com"
};

new Float:vLastAngles[MAXPLAYERS + 1][3];
new bool:bLastAnglesGain[MAXPLAYERS+1];

public APLRes:AskPluginLoad2(Handle:myself, bool:late, String:error[], err_max)
{
	RegPluginLibrary(PL_LIB_TAG);
	
	//CreateNative("NAME_Callback", Native_Reset);

	return APLRes_Success;
}

public Action:OnPlayerRunCmd(client, &buttons, &impulse, Float:vel[3], Float:angles[3], &weapon, &subtype, &cmdnum, &tickcount, &seed, mouse[2])
{
	if(!IsPlayerAlive(client))
		return Plugin_Continue;
	
	new bool:onground = bool:(GetEntityFlags(client) & FL_ONGROUND);
	
	decl Float:fVelocity[3];
	GetEntPropVector(client, Prop_Data, "m_vecVelocity", fVelocity); //velocity
	
	/* Prepare angle */
	new Float:vAngles[3];
	vAngles[1] = angles[1];
	vAngles[1] += 360;
	
	/* Angle direction */
	new bool:angle_gain;
	if (vLastAngles[client][1] < vAngles[1])
		angle_gain = true;
	else
		angle_gain = false;

	/* Player is flying */
	if(bLastAnglesGain[client] != angle_gain)
	{
		Client_Push(client,Float:{-90.0,0.0,0.0}, 2000.0, VelocityOverride:{VelocityOvr_None,VelocityOvr_None,VelocityOvr_None});
	}
	
	bLastAnglesGain[client] = angle_gain;
	
	return Plugin_Continue;
}


stock Client_Push(client, Float:clientEyeAngle[3], Float:power, VelocityOverride:override[3]=VelocityOvr_None)
{
	decl	Float:forwardVector[3],
	Float:newVel[3];
	
	GetAngleVectors(clientEyeAngle, forwardVector, NULL_VECTOR, NULL_VECTOR);
	NormalizeVector(forwardVector, forwardVector);
	ScaleVector(forwardVector, power);
	
	Entity_GetAbsVelocity(client,newVel);
	
	for (new i=0;i<3;i++){
		switch(override[i]){
			case VelocityOvr_Velocity:{
				newVel[i] = 0.0;
			}
			case VelocityOvr_OnlyWhenNegative:{				
				if(newVel[i] < 0.0){
					newVel[i] = 0.0;
				}
			}
			case VelocityOvr_InvertReuseVelocity:{				
				if(newVel[i] < 0.0){
					newVel[i] *= -1.0;
				}
			}
		}
		
		newVel[i] += forwardVector[i];
	}
	
	Entity_SetAbsVelocity(client,newVel);
}
