#include "roleplay/roleplay"

#define PL_NAME		"RP_ADMIN_COMMANDS"

new bool:g_LateLoaded;

/* Database */
new Handle:g_hSQL;

public Plugin:myinfo = 
{
	name = PL_NAME,
	author = PL_AUTHOR,
	description = "",
	version = PL_VERSION,
	url = PL_URL
}

public APLRes:AskPluginLoad2(Handle:myself, bool:late, String:error[], err_max)
{
	g_LateLoaded = late;
	RegPluginLibrary(PL_NAME);
	return APLRes_Success;
}

public RP_OnSqlConnected(Handle:db)
{
	g_hSQL = db;
	SQLConnectionReady();
}

public RP_OnSqlStop()
{
	g_hSQL = INVALID_HANDLE;
}

SQLConnectionReady()
{
	//Database is now ready to use
}

public RP_OnPlayerReady(client, playerID, bool:create)
{
	//PlayerID is now cached
}

public OnPluginStart()
{
	if(g_LateLoaded)
	{
		g_hSQL = Handle:RP_GetSql();
		
		if(g_hSQL != INVALID_HANDLE)
			SQLConnectionReady();
		
		g_LateLoaded = false;
	}
	
	//rp_crime
	RegAdminCmd("rp_getcrime", CommandGetCrime, ADMFLAG_ROOT, "<Client> - Get Crime of Client");
	RegAdminCmd("rp_addcrime", CommandAddCrime, ADMFLAG_ROOT, "<Client> <Amount> <sType> - Add Crime to Client");
	RegAdminCmd("rp_takecrime", CommandTakeCrime, ADMFLAG_ROOT, "<Client> <Amount> - Take Crime from Client");
	RegAdminCmd("rp_resetcrime", CommandResetCrime, ADMFLAG_ROOT, "<Client> - Reset Crime of Client");
	RegAdminCmd("rp_getbounty", CommandGetBounty, ADMFLAG_ROOT, "<Client> - Get Bounty of Client");
	RegAdminCmd("rp_addbounty", CommandAddBounty, ADMFLAG_ROOT, "<Client> <Amount> - Add Bounty to Client");
	RegAdminCmd("rp_resetbounty", CommandResetBounty, ADMFLAG_ROOT, "<Client> - Reset Bounty of Client");
	RegAdminCmd("rp_getlastcrime", CommandGetLastCrime, ADMFLAG_ROOT, "<Client> - Get LastCrime of Client");
	RegAdminCmd("rp_getlastcrimeremoval", CommandGetLastCrimeRemoval, ADMFLAG_ROOT, "<Client> - Get LastCrimeRemoval of Client");
	RegAdminCmd("rp_getmaxcrime", CommandGetMaxCrime, ADMFLAG_ROOT, "<Client> - Get GetMaxCrime of Client");
	RegAdminCmd("rp_getmaxbounty", CommandGetMaxBounty, ADMFLAG_ROOT, "<Client> - Get MaxBounty of Client");
	
	//rp_homes doors
	RegAdminCmd("rp_gethomecount", CommandGetHomeCount, ADMFLAG_ROOT, " - How many Homes are out there?");
	RegAdminCmd("rp_gethomeid", CommandGetHomeID, ADMFLAG_ROOT, "<Index> - Get HomeID");
	RegAdminCmd("rp_createhomes", CommandCreateHomes, ADMFLAG_ROOT, "<Homename> <Price> <instance_start> <instance_end> - Create home");
	RegAdminCmd("rp_createhomedoor", CommandCreateHomeDoor, ADMFLAG_ROOT, "<Price> - Create home by looking at the door");
	RegAdminCmd("rp_deletehome", CommandDeleteHome, ADMFLAG_ROOT, "<HomeID> - Delete a Home");
	RegAdminCmd("rp_gethomeplayerid", GetHomePlayerID, ADMFLAG_ROOT, "<HomeID> - Get OwnerID of home");
	RegAdminCmd("rp_sethomeplayerid", CommandSetHomePlayerID, ADMFLAG_ROOT, "<HomeID> <PlayerID> - Set a owner");
	RegAdminCmd("rp_sethomeprice", CommandSetHomePrice, ADMFLAG_ROOT, "<HomeID> <Price> - Set Price of Home");
	RegAdminCmd("rp_sethomename", CommandSetHomename, ADMFLAG_ROOT, "<HomeID> <Homename> - Set Name of Home");
	RegAdminCmd("rp_sethomesold", CommandSetHomeSold, ADMFLAG_ROOT, "<HomeID> <Boolean> - Set Soldstate");
	RegAdminCmd("rp_gethomebyplayerid", CommandGetHomeByPlayerID, ADMFLAG_ROOT, "<PlayerID> - Get MaxBounty of Client");
	RegAdminCmd("rp_gethomeprops", CommandGetHomeProps, ADMFLAG_ROOT, "<HomeID> - Get MaxBounty of Client");
	
	//rp_items
	RegAdminCmd("rp_getitemcount", CommandGetItemCount, ADMFLAG_ROOT, " - Get Item Count");
	RegAdminCmd("rp_getitemid", CommandGetItemID, ADMFLAG_ROOT, "<Index> - Get Item ID by Index");
	RegAdminCmd("rp_getitemsprops", CommandGetItemProps, ADMFLAG_ROOT, "<Itemid> - Get Item Properties");
	RegAdminCmd("rp_getplayerinventoryitemcount", CommandGetPlayerInventoryItemCount, ADMFLAG_ROOT, "<Client> - Get Inventory Count");
	RegAdminCmd("rp_addplayerinventoryitem", CommandAddPlayerInventoryItem, ADMFLAG_ROOT, "<Client> <ItemID> <Durability> - Add Item to client inventory");
	RegAdminCmd("rp_removeplayerinventoryitem", CommandRemovePlayerInventoryItem, ADMFLAG_ROOT, "<Client> <ItemID> - Remove Item from CLient Inventory");
	RegAdminCmd("rp_removeplayerinventoryitemtype", CommandRemovePlayerInventoryItemType, ADMFLAG_ROOT, "<Client> <ItemType> - Remove Itemtype from Client Inventory");
	RegAdminCmd("rp_hasplayerinventoryitem", CommandHasPlayerInventoryItem, ADMFLAG_ROOT, "<Client> <ItemID> - Has Client Item with this ID in Inventory");
	
	//rp_money
	RegAdminCmd("rp_getmoney", CommandGetMoney, ADMFLAG_ROOT, "<Client> - Get Client Money");
	RegAdminCmd("rp_setmoney", CommandSetMoney, ADMFLAG_ROOT, "<Client> <Money> - Set Client Money");
	RegAdminCmd("rp_addmoney", CommandAddMoney, ADMFLAG_ROOT, "<Client> <Money> - Add Client Money");
	RegAdminCmd("rp_takemoney", CommandTakeMoney, ADMFLAG_ROOT, "<Client> <Money> - Take Client Money");
	
	RegAdminCmd("rp_getmoneybank", CommandGetMoneyBank, ADMFLAG_ROOT, "<Client> - Get Client Money on Bank");
	RegAdminCmd("rp_setmoneybank", CommandSetMoneyBank, ADMFLAG_ROOT, "<Client> <Money> - Set Client Money on Bank");
	RegAdminCmd("rp_addmoneybank", CommandAddMoneyBank, ADMFLAG_ROOT, "<Client> <Money> - Add Client Money on Bank");
	RegAdminCmd("rp_takemoneybank", CommandTakeMoneyBank, ADMFLAG_ROOT, "<Client> <Money> - Take Client Money on Bank");

	//rp_npcs
	RegAdminCmd("rp_reloadnpcs", CommandReloadNpcs, ADMFLAG_ROOT, " - Reload NPCS");
	RegAdminCmd("rp_getnpcprops", CommandGetNPCProps, ADMFLAG_ROOT, "<NPCID> - Get NPC Props");
	RegAdminCmd("rp_getnpcid", CommandGetNpcID, ADMFLAG_ROOT, " - Gets NPCID of Aimingtarget");
	RegAdminCmd("rp_createnpc", CommandCreateNPC, ADMFLAG_ROOT, "<npcType> <name> <team> <req_level> <req_item> <vip> <range> <model> - Spawn a Npc");
	RegAdminCmd("rp_createnpcd", CommandCreateNPCdefault, ADMFLAG_ROOT, "<npcType> - Spawn a Npc with default settings");
	RegAdminCmd("rp_rename", CommandRename, ADMFLAG_ROOT, "<Name> - Rename an entity");
	//rp_npc_list <- in rp_npcs
	
	//rp_players
	RegAdminCmd("rp_getplayerid", CommandGetPlayerID, ADMFLAG_ROOT, "<Client> - Get PlayerID of Client");
	RegAdminCmd("rp_getclientbyplayerid", Command_GetClientByPlayerID , ADMFLAG_ROOT, "<PlayerID> - Get Client by PlayerID");
	
	//rp_teams
	RegAdminCmd("rp_setcop", CommandSetCop, ADMFLAG_ROOT, "<Client> <true/false> - Give/Take Coprights");
	RegAdminCmd("rp_iscop", CommandIsCop, ADMFLAG_ROOT, "<Client> - Does Client have coprights?");
	
	//rp_clash
	RegAdminCmd("rp_cuff", CommandClientCuff, ADMFLAG_ROOT, "<Client> - Cuff Client");
	RegAdminCmd("rp_uncuff", CommandClientUncuff, ADMFLAG_ROOT, "<Client> - Uncuff Client");
	RegAdminCmd("rp_iscuffed", CommandIsClientCuffed, ADMFLAG_ROOT, "<Client> - Is Client cuffed?");
	RegAdminCmd("rp_togglecuff", CommandClientToggleCuff, ADMFLAG_ROOT, "<Client> - Toggle Cuff on client");
	
	//rp_jail
	RegAdminCmd("rp_createjail", CommandCreateJail, ADMFLAG_ROOT, "<Policedepartment> <Jailtype> <Jailname> - Create a Jail where you stand and aim");
	RegAdminCmd("rp_jail", CommandClientSendToJail, ADMFLAG_ROOT, "<Client> <jailnr> - Send Client to Jail");
	RegAdminCmd("rp_createpd", CommandCreatePD , ADMFLAG_ROOT, "<Number> <Jailname> - Create a PD");
}

/* rp_crime */
public Action:CommandGetCrime(client, args)
{
	if(args < 1)
	{
		
		CPrintToChat(client, "%s Usage: rp_getcrime <Client>", PL_PRE);
		
		return Plugin_Handled;
	}
	
	decl player;
	decl String:playerName[32]
	
	player = 0;
	GetCmdArg(1, playerName, sizeof(playerName));
	player = FindPlayer(client,playerName); 

	if(player == 0)
	{
		CPrintToChat(client, "%s Could not find client %s", PL_PRE, playerName);
		return Plugin_Handled;
    }
	
	CPrintToChat(client, "%s Player %s got %d crime", PL_PRE,playerName,RP_GetCrime(player));
	return Plugin_Handled;
}

public Action:CommandAddCrime(client, args)
{
	if(args < 3)
	{
		
		CPrintToChat(client, "%s Usage: rp_addcrime <client> <Amount> <sType>", PL_PRE);
		
		return Plugin_Handled;
	}

	decl player;
	decl String:playerName[32], String:sAmount[32],String:sType[32];
	decl amount;

	player = 0;
	GetCmdArg(1, playerName, sizeof(playerName));
	GetCmdArg(2, sAmount, sizeof(sAmount));
	GetCmdArg(3, sType, sizeof(sType));
	player = FindPlayer(client,playerName); 
	amount = StringToInt(sAmount);
	
	if(player == 0)
	{
		CPrintToChat(client, "%s Could not find client %s", PL_PRE, playerName);
		return Plugin_Handled;
    }

	RP_AddCrime(player, amount, sType);
	CPrintToChat(client, "%s Added %d crime to %s with type %d", PL_PRE, amount, playerName, sType);
	return Plugin_Handled;
}

public Action:CommandTakeCrime(client, args)
{
	if(args < 2)
	{
		
		CPrintToChat(client, "%s Usage: rp_takecrime <client> <Amount>", PL_PRE);
		
		return Plugin_Handled;
	}

	decl player;
	decl String:playerName[32], String:sAmount[32];
	decl amount;

	player = 0;
	GetCmdArg(1, playerName, sizeof(playerName));
	GetCmdArg(2, sAmount, sizeof(sAmount));
	player = FindPlayer(client,playerName); 
	amount = StringToInt(sAmount);
	
	if(player == 0)
	{
		CPrintToChat(client, "%s Could not find client %s", PL_PRE, playerName);
		return Plugin_Handled;
    }

	RP_TakeCrime(player, amount);
	CPrintToChat(client, "%s Took %d crime from %s", PL_PRE, amount, playerName);
	return Plugin_Handled;
}

public Action:CommandResetCrime(client, args)
{
	if(args < 1)
	{
		
		CPrintToChat(client, "%s Usage: rp_resetcrime <client>", PL_PRE);
		
		return Plugin_Handled;
	}
	
	decl player;
	decl String:playerName[32]
	
	player = 0;
	GetCmdArg(1, playerName, sizeof(playerName));
	player = FindPlayer(client,playerName); 

	if(player == 0)
	{
		CPrintToChat(client, "%s Could not find client %s", PL_PRE, playerName);
		return Plugin_Handled;
    }
	
	RP_ResetCrime(player);
	CPrintToChat(client, "%s You just reset %s Crimestatus", PL_PRE, playerName);
	return Plugin_Handled;
}

public Action:CommandGetBounty(client, args)
{
	if(args < 1)
	{
		
		CPrintToChat(client, "%s Usage: rp_getbounty <client>", PL_PRE);
		
		return Plugin_Handled;
	}
	
	decl player;
	decl String:playerName[32]
	
	player = 0;
	GetCmdArg(1, playerName, sizeof(playerName));
	player = FindPlayer(client,playerName); 

	if(player == 0)
	{
		CPrintToChat(client, "%s Could not find client %s", PL_PRE, playerName);
		return Plugin_Handled;
    }
	
	PrintToChat(client, "%s Player %s got %d bounty", PL_PRE,playerName,RP_GetBounty(player));
	return Plugin_Handled;
}

public Action:CommandAddBounty(client, args)
{
	if(args < 2)
	{
		
		CPrintToChat(client, "%s rp_addbounty <client> <Amount>", PL_PRE);
		
		return Plugin_Handled;
	}

	decl player;
	decl String:playerName[32], String:sAmount[32];
	decl amount;

	player = 0;
	GetCmdArg(1, playerName, sizeof(playerName));
	GetCmdArg(2, sAmount, sizeof(sAmount));
	player = FindPlayer(client,playerName); 
	amount = StringToInt(sAmount);
	
	if(player == 0)
	{
		CPrintToChat(client, "%s Could not find client %s", PL_PRE, playerName);
		return Plugin_Handled;
    }

	RP_AddBounty(player, amount);
	PrintToChat(client, "%s You added %d bounty to %s", PL_PRE,amount,playerName);
	return Plugin_Handled;
}

public Action:CommandResetBounty(client, args)
{
	if(args < 1)
	{
		
		CPrintToChat(client, "%s rp_resetbounty <client>", PL_PRE);
		
		return Plugin_Handled;
	}
	
	decl player;
	decl String:playerName[32]
	
	player = 0;
	GetCmdArg(1, playerName, sizeof(playerName));
	player = FindPlayer(client,playerName); 

	if(player == 0)
	{
		CPrintToChat(client, "%s Could not find client %s", PL_PRE, playerName);
		return Plugin_Handled;
    }
	
	RP_ResetBounty(player);
	PrintToChat(client, "%s You reset the bounty of %s", PL_PRE,playerName);
	return Plugin_Handled;
}

public Action:CommandGetLastCrime(client, args)
{
	if(args < 1)
	{
		
		CPrintToChat(client, "%s rp_getlastcrime <client>", PL_PRE);
		
		return Plugin_Handled;
	}
	
	decl player;
	decl String:playerName[32]
	
	player = 0;
	GetCmdArg(1, playerName, sizeof(playerName));
	player = FindPlayer(client,playerName); 

	if(player == 0)
	{
		CPrintToChat(client, "%s Could not find client %s", PL_PRE, playerName);
		return Plugin_Handled;
    }
	
	CPrintToChat(client, "%s Player %s got %d Lastcrime", PL_PRE,playerName,RP_GetLastCrime(player));
	return Plugin_Handled;
}

public Action:CommandGetLastCrimeRemoval(client, args)
{
	if(args < 1)
	{
		
		CPrintToChat(client, "%s rp_getlastcrimeremoval <client>", PL_PRE);
		
		return Plugin_Handled;
	}
	
	decl player;
	decl String:playerName[32]
	
	player = 0;
	GetCmdArg(1, playerName, sizeof(playerName));
	player = FindPlayer(client,playerName); 

	if(player == 0)
	{
		CPrintToChat(client, "%s Could not find client %s", PL_PRE, playerName);
		return Plugin_Handled;
    }
	
	CPrintToChat(client, "%s Player %s got %s LastCrimeRemoval", PL_PRE,playerName,RP_GetLastCrimeRemoval(player));
	return Plugin_Handled;
}

public Action:CommandGetMaxCrime(client, args)
{
	if(args < 1)
	{
		
		CPrintToChat(client, "%s Usage: rp_getmaxcrime <client>", PL_PRE);
		
		return Plugin_Handled;
	}
	
	decl player;
	decl String:playerName[32]
	
	player = 0;
	GetCmdArg(1, playerName, sizeof(playerName));
	player = FindPlayer(client,playerName); 

	if(player == 0)
	{
		CPrintToChat(client, "%s Could not find client %s", PL_PRE, playerName);
		return Plugin_Handled;
    }

	CPrintToChat(client, "%s Player %s got %d maxcrime", PL_PRE,playerName,RP_GetMaxCrime(player));
	return Plugin_Handled;
}

public Action:CommandGetMaxBounty(client, args)
{
	if(args < 1)
	{
		
		CPrintToChat(client, "%s Usage: rp_getmaxbounty <client>", PL_PRE);
		
		return Plugin_Handled;
	}
	
	decl player;
	decl String:playerName[32]
	
	player = 0;
	GetCmdArg(1, playerName, sizeof(playerName));
	player = FindPlayer(client,playerName); 

	if(player == 0)
	{
		CPrintToChat(client, "%s Could not find client %s", PL_PRE, playerName);
		return Plugin_Handled;
    }
	
	CPrintToChat(client, "%s Player %s got %d maxbounty", PL_PRE,playerName,RP_GetMaxBounty(player));
	return Plugin_Handled;
}


/* rp_homes */
public Action:CommandGetHomeCount(client, args)
{
	CPrintToChat(client, "%s Homecount : %d", PL_PRE, RP_GetHomeCount());
	return Plugin_Handled;
}

public Action:CommandGetHomeID(client, args)
{
	if(args < 1)
	{
		
		CPrintToChat(client, "%s rp_gethomeid <Index>", PL_PRE);
		
		return Plugin_Handled;
	}

	decl index;
	decl String:sindex[32];

	GetCmdArg(1, sindex, sizeof(sindex));
	index = StringToInt(sindex);

	CPrintToChat(client, "%s Homeid: %d", PL_PRE, RP_GetHomeIDByIndex(index));
	return Plugin_Handled;
}

public Action:CommandCreateHomes(client, args)
{
	if(2 != args && args != 4)
	{
		CPrintToChat(client, "%s rp_createhomes <Doorname> <Price> <Instance start> <Instance end>", PL_PRE);
		CPrintToChat(client, "%s <Instance start> and <Instance end> are optional !!!", PL_PRE);
		return Plugin_Handled;
	}

	new instanceStart = -1;
	new price, instanceEnd;
	decl String:sDoorName[32], String:sPrice[32], String:sInstanceStart[32], String:sInstanceEnd[32];
	
	GetCmdArg(1, sDoorName, sizeof(sDoorName));
	GetCmdArg(2, sPrice, sizeof(sPrice));
	price = StringToInt(sPrice);
	
	if(args == 4)
	{
		GetCmdArg(3, sInstanceStart, sizeof(sInstanceStart));
		GetCmdArg(4, sInstanceEnd, sizeof(sInstanceEnd));
		
		instanceStart = StringToInt(sInstanceStart);
		instanceEnd = StringToInt(sInstanceEnd);
	}

	RP_CreateHome(sDoorName, price, instanceStart, instanceEnd);
	CPrintToChat(client,"%s Created new %d homes: Doorname: %s Price: %d // %d - %d", PL_PRE, instanceStart == -1 ? 1 : instanceEnd-instanceStart, sDoorName, price, instanceStart, instanceEnd); 
	return Plugin_Handled;
}

public Action:CommandCreateHomeDoor(client, args)
{
	new price;
	decl String:sDoorName[32], String:sPrice[32];
	
	new target = GetClientAimTarget(client, false);
	new bool:valid_door;
	
	if(args == 1)
	{
		if(target > 0)
		{
			decl String:sClassName[20];
			GetEntityClassname(target, sClassName, 20);
			valid_door = !(StrEqual(sClassName, "func_door") || StrEqual(sClassName, "func_door_rotating") || StrEqual(sClassName, "prop_door_rotating")  || StrEqual(sClassName, "func_movelinear") || StrEqual(sClassName, "func_brush"));
		}
		
		if(!valid_door)
			CPrintToChat(client, "%s rp_createdoor <Price> - And you have to look at a door", PL_PRE);
		else
		{
			Entity_GetName(target, sDoorName, sizeof(sDoorName));
			
			GetCmdArg(1, sPrice, sizeof(sPrice));
			price = StringToInt(sPrice);
			
			RP_CreateHome(sDoorName, price, -1, 0);
			CPrintToChat(client,"%s Created new home: Doorname: %s Price: %d", PL_PRE, sDoorName, price); 
		}
	}
	else CPrintToChat(client, "%s rp_createdoor <Price> - And you have to look at a door", PL_PRE);
	
	return Plugin_Handled;
}

public Action:CommandDeleteHome(client, args)
{
	if(args < 1)
	{
		CPrintToChat(client, "%s rp_deletehome <HomeID>", PL_PRE);
		return Plugin_Handled;
	}

	decl homeID;
	decl String:shomeID[32];

	GetCmdArg(1, shomeID, sizeof(shomeID));
	homeID = StringToInt(shomeID);
	
	RP_DeleteHome(homeID);
	CPrintToChat(client, "%s Successfully deleted Home No. %d", PL_PRE, homeID);
	return Plugin_Handled;
}

public Action:GetHomePlayerID(client, args)
{
	if(args < 1)
	{
		CPrintToChat(client, "%s rp_homeplayerid <HomeID>", PL_PRE);
		return Plugin_Handled;
	}

	decl homeID;
	decl String:shomeID[32];

	GetCmdArg(1, shomeID, sizeof(shomeID));
	homeID = StringToInt(shomeID);
	
	CPrintToChat(client, "%s Homeownerid: %d", PL_PRE, RP_GetHomePlayerID(homeID));
	return Plugin_Handled;
}

public Action:CommandSetHomePlayerID(client, args)
{
	if(args < 2)
	{
		
		CPrintToChat(client, "%s rp_sethomeplayerid <HomeID> <PlayerID>", PL_PRE);
		
		return Plugin_Handled;
	}

	decl player;
	decl String:playerName[32];
	decl homeID;
	decl String:shomeID[32];

	GetCmdArg(1, shomeID, sizeof(shomeID));
	homeID = StringToInt(shomeID);
	GetCmdArg(2, playerName, sizeof(playerName));
	player = FindPlayer(client,playerName);
	
	RP_SetHomePlayerID(homeID, RP_GetPlayerID(player));
	CPrintToChat(client, "%s Player %s Owns Home %d now", PL_PRE, playerName, homeID);
	return Plugin_Handled;
}

public Action:CommandSetHomePrice(client, args)
{
	if(args < 2)
	{
		
		CPrintToChat(client, "%s rp_sethomeprice <HomeID> <Price>", PL_PRE);
		
		return Plugin_Handled;
	}

	decl price, homeid;
	decl String:shomeid[32], String:sprice[32];

	GetCmdArg(1, shomeid, sizeof(shomeid));
	GetCmdArg(2, sprice, sizeof(sprice));

	price = StringToInt(sprice);
	homeid = StringToInt(shomeid);

	RP_SetHomePrice(homeid, price);
	CPrintToChat(client,"%s Successfully Set Price %d on home no. %d",PL_PRE, price,homeid); 
	return Plugin_Handled;
}

public Action:CommandSetHomename(client, args)
{
	if(args < 2)
	{
		
		CPrintToChat(client, "%s rp_sethomename <HomeID> <Homename>", PL_PRE);
		
		return Plugin_Handled;
	}

	decl homeid;
	decl String:homename[128], String:shomeid[32];

	GetCmdArg(1, shomeid, sizeof(shomeid));

	homeid = StringToInt(shomeid);

	RP_SetDoorName(homeid, homename);
	CPrintToChat(client,"%s Successfully Set homename %s on home no. %d",PL_PRE,homename,homeid); 
	return Plugin_Handled;
}

public Action:CommandSetHomeSold(client, args)
{
	if(args < 2)
	{
		
		CPrintToChat(client, "%s rp_sethomesold <HomeID> <Boolean>", PL_PRE);
		
		return Plugin_Handled;
	}

	decl homeid;
	decl String:shomeid[32],String:sisSold[32];
	decl bool:isSold;
	

	GetCmdArg(1, shomeid, sizeof(shomeid));
	GetCmdArg(2, sisSold, sizeof(sisSold));
	
	isSold = bool:StringToInt(sisSold);
	homeid = StringToInt(shomeid);

	RP_SetHomeSold(homeid, isSold);
	CPrintToChat(client,"%s Successfully Set home no. %d %s ",PL_PRE,homeid, isSold ? "Sold" : "Not Sold"); 
	return Plugin_Handled;
}

public Action:CommandGetHomeByPlayerID(client, args)
{
	if(args < 1)
	{
		
		CPrintToChat(client, "%s rp_gethomebyplayerid <PlayerID>", PL_PRE);
		
		return Plugin_Handled;
	}

	decl player;
	decl String:playerName[32];

	player = 0;
	GetCmdArg(1, playerName, sizeof(playerName));
	player = FindPlayer(client,playerName); 
	
	if(player == 0)
	{
		CPrintToChat(client, "%s Could not find client %s", PL_PRE, playerName);
		return Plugin_Handled;
    }

	CPrintToChat(client, "%s Homeid : %d", PL_PRE, RP_GetHomeIDByPlayerID(RP_GetPlayerID(player)));
	return Plugin_Handled;
}

public Action:CommandGetHomeProps(client, args)
{
	if(args < 1)
	{
		
		CPrintToChat(client, "%s rp_gethomeprops <HomeID>", PL_PRE);
		
		return Plugin_Handled;
	}

	decl homeid;
	decl String:shomeid[32],String:bufferh[128];	

	GetCmdArg(1, shomeid, sizeof(shomeid));

	homeid = StringToInt(shomeid);
	RP_GetDoorName(homeid, bufferh, 128);
	
	CPrintToChat(client,"%s Homename %s / IsSold %s / Price %d",PL_PRE,bufferh, RP_IsHomeSold(homeid) ? "Sold" : "Not Sold",RP_GetHomePrice(homeid)); 
	return Plugin_Handled;
}


/* rp_items */
public Action:CommandGetItemCount(client, args)
{
	CPrintToChat(client, "%s Item Count : %d", PL_PRE,RP_GetItemCount());
	return Plugin_Handled;
}

public Action:CommandGetItemID(client, args)
{
	if(args < 1)
	{
		
		CPrintToChat(client, "%s Usage: rp_getitemid <Index>", PL_PRE);
		
		return Plugin_Handled;
	}
	
	decl index;
	decl String:sindex[32]
	
	GetCmdArg(1, sindex, sizeof(sindex));
	index = StringToInt(sindex);
	
	CPrintToChat(client, "%s ItemID: %d", PL_PRE,RP_GetItemID(index));
	return Plugin_Handled;
}

public Action:CommandGetItemProps(client, args)
{
	if(args < 1)
	{
		
		CPrintToChat(client, "%s Usage: rp_getitemprops <Itemid>", PL_PRE);
		
		return Plugin_Handled;
	}
	
	decl itemid;
	decl String:sitemid[32],String:sname[64],String:scname[64],String:smodel[128],String:sfeatures[128],String:ssettings[128],String:sdesc[128];
	
	GetCmdArg(1, sitemid, sizeof(sitemid));
	itemid = StringToInt(sitemid);
	
	RP_GetItemName(itemid, sname, sizeof(sname));
	RP_GetItemClassname(itemid, scname, sizeof(scname));
	RP_GetItemModel(itemid, smodel, sizeof(smodel));
	RP_GetItemFeatures(itemid, sfeatures, sizeof(sfeatures));
	RP_GetItemSettings(itemid, ssettings, sizeof(ssettings));
	RP_GetItemDescription(itemid, sdesc, sizeof(sdesc));
	
	CPrintToChat(client, "%s ItemProperties:", PL_PRE);
	CPrintToChat(client, "%s Typ: %d Buy: %d$ Sell: %d$ Durab: %d Reqlvl: %d Req:Item %d", PL_PRE,RP_GetItemType(itemid),RP_GetItemWorthBuy(itemid),RP_GetItemWorthSell(itemid),RP_GetItemDurability(itemid),RP_GetItemReqLevel(itemid),RP_GetItemReqItem(itemid));
	CPrintToChat(client, "%s %s %s %s %s %s", PL_PRE,RP_IsItemTradable(itemid) ? "Tradeable" : "!Tradeable",RP_IsItemDropable(itemid) ? "Dropable" : "!Dropable",
	RP_IsItemUseable(itemid) ? "Useable" : "!Useable",RP_IsItemDeleteable(itemid) ? "Deleteable" : "!Deleteable", RP_IsItemVipOnly(itemid) ? "VIPolny" : "!VIPolny");
	CPrintToChat(client, "%s N:%s CN:%s M:%s F:%s S:%s Desc:%s", PL_PRE,sname,scname,smodel,sfeatures,ssettings,sdesc);
	return Plugin_Handled;
}

public Action:CommandGetPlayerInventoryItemCount(client, args)
{
	if(args < 1)
	{
		
		CPrintToChat(client, "%s Usage: rp_getinventoryitemcount <Client>", PL_PRE);
		
		return Plugin_Handled;
	}
	
	decl player;
	decl String:playerName[32]
	
	player = 0;
	GetCmdArg(1, playerName, sizeof(playerName));
	player = FindPlayer(client,playerName); 
	
	CPrintToChat(client, "ItemCount: %d",RP_GetPlayerInventoryItemCount(player));
	return Plugin_Handled;
}

public Action:CommandAddPlayerInventoryItem(client, args)
{
	if(args < 3)
	{
		
		CPrintToChat(client, "%s Usage: rp_addinventoryitem <Client> <ItemID> <Durability>", PL_PRE);
		
		return Plugin_Handled;
	}
	
	decl player,itemid,durability;
	decl String:playerName[32],String:sitemid[32],String:sdurability[32];
	
	player = 0;
	GetCmdArg(1, playerName, sizeof(playerName));
	player = FindPlayer(client,playerName);
	
	GetCmdArg(2, sitemid, sizeof(sitemid));
	GetCmdArg(3, sdurability, sizeof(sdurability));
	itemid = StringToInt(sitemid);
	durability = StringToInt(sdurability);
	
	RP_AddPlayerInventoryItem(player,itemid,durability);
	
	CPrintToChat(client, "%s Successfully added Item", PL_PRE);
	return Plugin_Handled;
}

public Action:CommandRemovePlayerInventoryItem(client, args)
{
	if(args < 2)
	{
		
		CPrintToChat(client, "%s Usage: rp_removeinventoryitem <Client> <ItemID>", PL_PRE);
		
		return Plugin_Handled;
	}
	
	decl player,itemid;
	decl String:playerName[32],String:sitemid[32];
	
	player = 0;
	GetCmdArg(1, playerName, sizeof(playerName));
	player = FindPlayer(client,playerName);
	
	GetCmdArg(2, sitemid, sizeof(sitemid));
	itemid = StringToInt(sitemid);
	
	RP_RemovePlayerInventoryItem(player, itemid);
	decl String:itemname[64];
	RP_GetItemName(itemid,itemname,64);
	
	CPrintToChat(client, "%s Successfully removed Item %s from %s ", PL_PRE, itemname,playerName);
	return Plugin_Handled;
}

public Action:CommandRemovePlayerInventoryItemType(client, args)
{
	if(args < 3)
	{
		
		CPrintToChat(client, "%s Usage: rp_removeinventoryitemtype<Client> <ItemType>", PL_PRE);
		
		return Plugin_Handled;
	}
	
	decl player,itemtyp;
	decl String:playerName[32],String:sitemtyp[32];
	
	player = 0;
	GetCmdArg(1, playerName, sizeof(playerName));
	player = FindPlayer(client,playerName);
	
	GetCmdArg(2, sitemtyp, sizeof(sitemtyp));
	itemtyp = StringToInt(sitemtyp);
	
	RP_RemovePlayerInventoryItemType(player,  RP_ItemType:itemtyp);
	
	CPrintToChat(client, "%s Successfully removed Itemtyp %d from %s ", PL_PRE, itemtyp,playerName);
	return Plugin_Handled;
}

public Action:CommandHasPlayerInventoryItem(client, args)
{
	if(args < 2)
	{
		
		CPrintToChat(client, "%s Usage: rp_hasinventoryitem <Client> <ItemID>", PL_PRE);
		
		return Plugin_Handled;
	}
	
	decl player,itemid;
	decl String:playerName[32],String:sitemid[32];
	
	player = 0;
	GetCmdArg(1, playerName, sizeof(playerName));
	player = FindPlayer(client,playerName);
	
	GetCmdArg(2, sitemid, sizeof(sitemid));
	itemid = StringToInt(sitemid);
	
	CPrintToChat(client, "%s %s", PL_PRE,RP_HasPlayerInventoryItem(player, itemid) ? "Player got that Item" : "Player doesn't have that Item");
	return Plugin_Handled;
}


/* rp_money */
public Action:CommandGetMoney(client, args)
{
	if(args < 1)
	{
		
		CPrintToChat(client, "%s Usage: rp_getmoney <Client>", PL_PRE);
		
		return Plugin_Handled;
	}
	
	decl player;
	decl String:playerName[32]
	
	player = 0;
	GetCmdArg(1, playerName, sizeof(playerName));
	player = FindPlayer(client,playerName); 

	if(player == 0)
	{
		CPrintToChat(client, "%s Could not find client %s", PL_PRE, playerName);
		return Plugin_Handled;
    }
	
	CPrintToChat(client, "%s Player %s got %d Money", PL_PRE,playerName,RP_GetMoney(player));
	return Plugin_Handled;
}

public Action:CommandSetMoney(client, args)
{
	if(args < 2)
	{
		
		CPrintToChat(client, "%s Usage: rp_setmoney <client> <Amount>", PL_PRE);
		
		return Plugin_Handled;
	}

	decl player;
	decl String:playerName[32], String:sAmount[32];
	decl amount;

	player = 0;
	GetCmdArg(1, playerName, sizeof(playerName));
	GetCmdArg(2, sAmount, sizeof(sAmount));
	player = FindPlayer(client,playerName); 
	amount = StringToInt(sAmount);
	
	if(player == 0)
	{
		CPrintToChat(client, "%s Could not find client %s", PL_PRE, playerName);
		return Plugin_Handled;
    }

	RP_SetMoney(player, amount);
	CPrintToChat(client, "%s Set Money of Player %s to %d", PL_PRE,playerName,amount);
	return Plugin_Handled;
}

public Action:CommandAddMoney(client, args)
{
	if(args < 2)
	{
		
		CPrintToChat(client, "%s Usage: rp_addmoney <client> <Amount>", PL_PRE);
		
		return Plugin_Handled;
	}

	decl player;
	decl String:playerName[32], String:sAmount[32];
	decl amount;

	player = 0;
	GetCmdArg(1, playerName, sizeof(playerName));
	GetCmdArg(2, sAmount, sizeof(sAmount));
	player = FindPlayer(client,playerName); 
	amount = StringToInt(sAmount);
	
	if(player == 0)
	{
		CPrintToChat(client, "%s Could not find client %s", PL_PRE, playerName);
		return Plugin_Handled;
    }

	RP_AddMoney(player, amount);
	CPrintToChat(client, "%s Added %d Money to Player %s", PL_PRE,amount,playerName);
	return Plugin_Handled;
}

public Action:CommandTakeMoney(client, args)
{
	if(args < 2)
	{
		
		CPrintToChat(client, "%s Usage: rp_takemoney <client> <Amount>", PL_PRE);
		
		return Plugin_Handled;
	}

	decl player;
	decl String:playerName[32], String:sAmount[32];
	decl amount;

	player = 0;
	GetCmdArg(1, playerName, sizeof(playerName));
	GetCmdArg(2, sAmount, sizeof(sAmount));
	player = FindPlayer(client,playerName); 
	amount = StringToInt(sAmount);
	
	if(player == 0)
	{
		CPrintToChat(client, "%s Could not find client %s", PL_PRE, playerName);
		return Plugin_Handled;
    }

	RP_TakeMoney(player, amount);
	CPrintToChat(client, "%s Took %d money from %s", PL_PRE, amount ,playerName);
	return Plugin_Handled;
}

public Action:CommandGetMoneyBank(client, args)
{
	if(args < 1)
	{
		
		CPrintToChat(client, "%s Usage: rp_getmoneybank <Client>", PL_PRE);
		
		return Plugin_Handled;
	}
	
	decl player;
	decl String:playerName[32]
	
	player = 0;
	GetCmdArg(1, playerName, sizeof(playerName));
	player = FindPlayer(client,playerName); 

	if(player == 0)
	{
		CPrintToChat(client, "%s Could not find client %s", PL_PRE, playerName);
		return Plugin_Handled;
    }
	
	CPrintToChat(client, "%s Player %s got %d Money on Bank", PL_PRE,playerName,RP_GetMoneyBank(player));
	return Plugin_Handled;
}

public Action:CommandSetMoneyBank(client, args)
{
	if(args < 2)
	{
		
		CPrintToChat(client, "%s Usage: rp_setmoneybank <client> <Amount>", PL_PRE);
		
		return Plugin_Handled;
	}

	decl player;
	decl String:playerName[32], String:sAmount[32];
	decl amount;

	player = 0;
	GetCmdArg(1, playerName, sizeof(playerName));
	GetCmdArg(2, sAmount, sizeof(sAmount));
	player = FindPlayer(client,playerName); 
	amount = StringToInt(sAmount);
	
	if(player == 0)
	{
		CPrintToChat(client, "%s Could not find client %s", PL_PRE, playerName);
		return Plugin_Handled;
    }

	RP_SetMoneyBank(player, amount);
	CPrintToChat(client, "%s Set money on the bank of %s to %d", PL_PRE, playerName, amount);
	return Plugin_Handled;
}

public Action:CommandAddMoneyBank(client, args)
{
	if(args < 2)
	{
		
		CPrintToChat(client, "%s Usage: rp_addmoneybank <client> <Amount>", PL_PRE);
		
		return Plugin_Handled;
	}

	decl player;
	decl String:playerName[32], String:sAmount[32];
	decl amount;

	player = 0;
	GetCmdArg(1, playerName, sizeof(playerName));
	GetCmdArg(2, sAmount, sizeof(sAmount));
	player = FindPlayer(client,playerName); 
	amount = StringToInt(sAmount);
	
	if(player == 0)
	{
		CPrintToChat(client, "%s Could not find client %s", PL_PRE, playerName);
		return Plugin_Handled;
    }

	RP_AddMoneyBank(player, amount);
	CPrintToChat(client, "%s Added %d money to the bank of %s", PL_PRE, amount ,playerName);
	return Plugin_Handled;
}

public Action:CommandTakeMoneyBank(client, args)
{
	if(args < 2)
	{
		
		CPrintToChat(client, "%s Usage: rp_takemoneybank <client> <Amount>", PL_PRE);
		
		return Plugin_Handled;
	}

	decl player;
	decl String:playerName[32], String:sAmount[32];
	decl amount;

	player = 0;
	GetCmdArg(1, playerName, sizeof(playerName));
	GetCmdArg(2, sAmount, sizeof(sAmount));
	player = FindPlayer(client,playerName); 
	amount = StringToInt(sAmount);
	
	if(player == 0)
	{
		CPrintToChat(client, "%s Could not find client %s", PL_PRE, playerName);
		return Plugin_Handled;
    }

	RP_TakeMoneyBank(player, amount);
	CPrintToChat(client, "%s Took %d money from the bank of %s", PL_PRE, amount ,playerName);
	return Plugin_Handled;
}


/* rp_npcs */

public Action:CommandReloadNpcs(client, args)
{
	RP_ReloadNpcs();
	CPrintToChat(client, "%s Reloaded NPCs", PL_PRE);
	return Plugin_Handled;
}

public Action:CommandGetNPCProps(client, args)
{
	if(args < 1)
	{
		
		CPrintToChat(client, "%s rp_getnpcprops <NPC_ID>", PL_PRE);
		
		return Plugin_Handled;
	}
	
	decl npcid;
	decl String:snpcid[32],String:bufferh[64],String:bufferj[128];

	GetCmdArg(1, snpcid, sizeof(snpcid));

	npcid = StringToInt(snpcid);
	
	RP_GetNpcName(npcid, bufferh, 64);
	RP_GetNpcModel(npcid, bufferj, 128);
	
	CPrintToChat(client,"%s Typ: %d Reqlvl: %d ReqItem: %d VIPOnly %s",PL_PRE,RP_GetNpcType(npcid),RP_GetNpcReqLevel(npcid),RP_GetNpcReqItem(npcid),RP_GetNpcVipOnly(npcid) ? "Yes" : "No");
	CPrintToChat(client,"%s Team: %d Range: %d Name: %s Model %s",PL_PRE,RP_GetNpcTeam(npcid),RP_GetNpcRange(npcid),bufferh,bufferj); 
	return Plugin_Handled;
}

public Action:CommandGetNpcID(client, args)
{
	decl target;
	target = GetClientAimTarget(client);
	decl String:starget[64];
	GetEntityClassname(target, starget, sizeof(starget));
	
	if(StrContains(starget,"static"))
	{
		CPrintToChat(client, "%s NPCID %d", PL_PRE, RP_GetNpcID(target));
	}
	CPrintToChat(client, "%s Not aiming at NPC", PL_PRE);
	return Plugin_Handled;
}

public Action:CommandCreateNPC(client, args)
{
	if(args < 8)
	{
		
		CPrintToChat(client, "%s Usage: rp_createnpc <npcType> <name> <team> <req_level> <req_item> <vip> <range> <model>", PL_PRE);
		
		return Plugin_Handled;
	}
	
	decl npcType, team, req_level, req_item, vip, range;
	decl String:snpcType[32], String:steam[32], String:sreq_level[32], String:sreq_item[32], String:svip[32], String:srange[32];
	decl String:name[64], String:model[128];
	
	GetCmdArg(1, snpcType, sizeof(snpcType));
	GetCmdArg(2, name, sizeof(name));
	GetCmdArg(3, steam, sizeof(steam));
	GetCmdArg(4, sreq_level, sizeof(sreq_level));
	GetCmdArg(5, sreq_item, sizeof(sreq_item));
	GetCmdArg(6, svip, sizeof(svip));
	GetCmdArg(7, srange, sizeof(srange));
	GetCmdArg(8, model, sizeof(model));
	
	npcType = StringToInt(snpcType);
	team = StringToInt(steam);
	req_level = StringToInt(sreq_level);
	req_item = StringToInt(sreq_item);
	vip = StringToInt(svip);
	range = StringToInt(srange);
	
	new Float:origion[3];
	new Float:angel[3];
	
	GetClientAbsOrigin(client,origion);
	GetClientAbsAngles(client,angel);
	
	
	
	RP_CreateNPC(npcType, name, team, req_level, req_item, vip, range, model, origion[0], origion[1], origion[2], angel[1]);
	
	return Plugin_Handled;
}

public Action:CommandCreateNPCdefault(client, args)
{
	if(args < 1)
	{
		
		CPrintToChat(client, "%s Usage: rp_createnpcn <npcType>", PL_PRE);
		
		return Plugin_Handled;
	}
	
	new Float:origion[3];
	new Float:angel[3];
	
	GetClientAbsOrigin(client,origion);
	GetClientAbsAngles(client,angel);
	
	RP_CreateNPCdefault(origion[0], origion[1], origion[2], angel[1]);
	
	return Plugin_Handled;
}

public Action:CommandRename(client, args)
{
	if(args < 1)
	{
		
		CPrintToChat(client, "%s Usage: rp_rename <Name>", PL_PRE);
		
		return Plugin_Handled;
	}
	
	new entity = GetClientAimTarget(client, false);
	new npcid = RP_GetNpcID(entity);
	decl String:new_name[64];
	
	if(npcid != -1)
	{		
		GetCmdArg(1, new_name, sizeof(new_name));
		RP_SetNpcName(npcid,new_name);
	}
	
	return Plugin_Handled;
}


/* rp_players */
public Action:CommandGetPlayerID(client, args)
{
	if(args < 1)
	{
		
		CPrintToChat(client, "%s Usage: rp_getplayerid <Client>", PL_PRE);
		
		return Plugin_Handled;
	}
	
	decl player;
	decl String:playerName[32]
	
	player = 0;
	GetCmdArg(1, playerName, sizeof(playerName));
	player = FindPlayer(client,playerName); 

	if(player == 0)
	{
		CPrintToChat(client, "%s Could not find client %s", PL_PRE, playerName);
		return Plugin_Handled;
    }
	
	CPrintToChat(client, "%s Playerid %d", PL_PRE,RP_GetPlayerID(player));
	return Plugin_Handled;
}

public Action:Command_GetClientByPlayerID(client, args)
{
	if(args < 1)
	{
		
		CPrintToChat(client, "%s Usage: rp_getclientbyplayerid <Playerid>", PL_PRE);
		
		return Plugin_Handled;
	}
	
	decl String:sPLID[32],String:clname[32];
	decl PLID;

	GetCmdArg(1, sPLID, sizeof(sPLID));
	PLID = StringToInt(sPLID);
	
	GetClientName(RP_GetClient(PLID) , clname, sizeof(clname));
	
	CPrintToChat(client, "%s Player %s", PL_PRE, clname);
	return Plugin_Handled;
}


/*  rp_teams */
public Action:CommandSetCop(client, args)
{
	if(args < 2)
	{
		
		CPrintToChat(client, "%s rp_setcop <Client> <Boolean>", PL_PRE);
		
		return Plugin_Handled;
	}

	decl String:sset[32];
	decl bool:set;
	

	decl player;
	decl String:playerName[32]
	
	player = 0;
	GetCmdArg(1, playerName, sizeof(playerName));
	player = FindPlayer(client,playerName); 
	GetCmdArg(2, sset, sizeof(sset));
	
	set = bool:StringToInt(sset);

	RP_SetCop(player, bool:set);
	CPrintToChat(client,"%s Successfully %s %s Coprights ",PL_PRE, set ? "gave" : "took",playerName); 
	return Plugin_Handled;
}

public Action:CommandIsCop(client, args)
{
	if(args < 1)
	{
		
		CPrintToChat(client, "%s Usage: rp_iscop <Client>", PL_PRE);
		
		return Plugin_Handled;
	}
	
	decl player;
	decl String:playerName[32]
	
	player = 0;
	GetCmdArg(1, playerName, sizeof(playerName));
	player = FindPlayer(client,playerName); 

	if(player == 0)
	{
		CPrintToChat(client, "%s Could not find client %s", PL_PRE, playerName);
		return Plugin_Handled;
    }
	
	CPrintToChat(client, "%s Player %s is %s cop", PL_PRE,playerName,RP_IsCop(player) ? "a" : "no");
	return Plugin_Handled;
}

/* rp_clash */
public Action:CommandClientCuff(client, args)
{
	if(args < 1)
	{
		
		CPrintToChat(client, "%s Usage: rp_clientcuff <client>", PL_PRE);
		
		return Plugin_Handled;
	}

	decl player;
	decl String:playerName[32];

	player = 0;
	GetCmdArg(1, playerName, sizeof(playerName));
	player = FindPlayer(client,playerName); 
	
	if(player == 0)
	{
		CPrintToChat(client, "%s Could not find client %s", PL_PRE, playerName);
		return Plugin_Handled;
    }

	RP_ClientCuff(player);
	CPrintToChat(client, "%s Cuffed %s", PL_PRE, playerName);
	return Plugin_Handled;
}

public Action:CommandClientUncuff(client, args)
{
	if(args < 1)
	{
		
		CPrintToChat(client, "%s Usage: rp_clientuncuff <client>", PL_PRE);
		
		return Plugin_Handled;
	}

	decl player;
	decl String:playerName[32];

	player = 0;
	GetCmdArg(1, playerName, sizeof(playerName));
	player = FindPlayer(client,playerName); 
	
	if(player == 0)
	{
		CPrintToChat(client, "%s Could not find client %s", PL_PRE, playerName);
		return Plugin_Handled;
    }

	RP_ClientUncuff(player);
	CPrintToChat(client, "%s Uncuffed %s", PL_PRE, playerName);
	return Plugin_Handled;
}

public Action:CommandClientToggleCuff(client, args)
{
	if(args < 1)
	{
		
		CPrintToChat(client, "%s Usage: rp_clientogglecuff <client>", PL_PRE);
		
		return Plugin_Handled;
	}

	decl player;
	decl String:playerName[32];

	player = 0;
	GetCmdArg(1, playerName, sizeof(playerName));
	player = FindPlayer(client,playerName); 
	
	if(player == 0)
	{
		CPrintToChat(client, "%s Could not find client %s", PL_PRE, playerName);
		return Plugin_Handled;
    }

	RP_ClientToggleCuff(player);
	CPrintToChat(client, "%s Toggled Cuff on %s. He is now %s", PL_PRE, playerName,RP_IsClientCuffed (player) ? "Cuffed" : "Not Cuffed");
	return Plugin_Handled;
}

public Action:CommandIsClientCuffed(client, args)
{
	if(args < 1)
	{
		
		CPrintToChat(client, "%s Usage: rp_isclientcuffed <client>", PL_PRE);
		
		return Plugin_Handled;
	}

	decl player;
	decl String:playerName[32];

	player = 0;
	GetCmdArg(1, playerName, sizeof(playerName));
	player = FindPlayer(client,playerName); 
	
	if(player == 0)
	{
		CPrintToChat(client, "%s Could not find client %s", PL_PRE, playerName);
		return Plugin_Handled;
    }

	CPrintToChat(client, "%s %s is%s cuffed", PL_PRE, playerName,RP_IsClientCuffed(player) ? "" : "n't");
	return Plugin_Handled;
}

/* rp_jail */
public Action:CommandCreateJail(client, args)
{
	if(args < 3)
	{
		
		CPrintToChat(client, "%s Usage: rp_createjail <Policedepartment> <Jailtype> <Jailname>", PL_PRE);
		
		return Plugin_Handled;
	}

	decl String:spd[32], String:sjType[32],String:sjName[128];
	decl pd;
	decl jType;

	GetCmdArg(1, spd, sizeof(spd));
	GetCmdArg(2, sjType, sizeof(sjType));
	GetCmdArg(3, sjName, sizeof(sjName));
	pd = StringToInt(spd);
	jType = StringToInt(sjType);

	RP_CreateJail(client,jType,pd,sjName);
	CPrintToChat(client, "%s Created Jail PD: %d Type: %d Name: %s", PL_PRE,pd,jType,sjName);
	return Plugin_Handled;
}

public Action:CommandClientSendToJail(client, args)
{
	if(args < 2)
	{
		
		CPrintToChat(client, "%s Usage: rp_jail <Client> <jailnr>", PL_PRE);
		
		return Plugin_Handled;
	}

	decl player;
	decl String:playerName[32], String:sjailnr[32];
	decl jailnr;

	player = 0;
	GetCmdArg(1, playerName, sizeof(playerName));
	GetCmdArg(2, sjailnr, sizeof(sjailnr));
	player = FindPlayer(client,playerName); 
	jailnr = StringToInt(sjailnr);
	
	if(player == 0)
	{
		CPrintToChat(client, "%s Could not find client %s", PL_PRE, playerName);
		return Plugin_Handled;
    }

	RP_ClientSendToJail(player,jailnr);
	CPrintToChat(client, "%s Sended %s to Jail", PL_PRE, playerName);
	return Plugin_Handled;
}

public Action:CommandCreatePD(client, args)
{
	if(args < 2)
	{
		
		CPrintToChat(client, "%s Usage: rp_createpd <Nr> <Jailname>", PL_PRE);
		
		return Plugin_Handled;
	}

	decl String:spd[32],String:sPDName[128];
	decl pd;

	GetCmdArg(1, spd, sizeof(spd));
	GetCmdArg(2, sPDName, sizeof(sPDName));
	pd = StringToInt(spd);

	RP_CreatePD(pd,sPDName);
	CPrintToChat(client, "%s Created PD: %d Name: %s", PL_PRE,pd,sPDName);
	return Plugin_Handled;
}