#include "roleplay/roleplay"

#define PL_NAME		"RP_ADMINMENU"
#define MAXMODELS 32

new bool:g_LateLoaded;

new g_SelectedEntity[MAXPLAYERS + 1];
new g_SelectedNPCID[MAXPLAYERS + 1];
new g_SelectedPlayer[MAXPLAYERS + 1];
new g_SelectedPlayerMethod[MAXPLAYERS + 1];
new String:g_SelectedPlayerMethodS[MAXPLAYERS + 1][64];
new g_SelectedItemType[MAXPLAYERS + 1];
new String:g_SelectedItemTypeS[MAXPLAYERS + 1][64];

new maxmodels;
new String:g_ModelPaths[MAXMODELS][128];
new String:g_ModelNames[MAXMODELS][64];

/* Database */
new Handle:g_hSQL;

public Plugin:myinfo = 
{
	name = PL_NAME,
	author = PL_AUTHOR,
	description = "",
	version = PL_VERSION,
	url = PL_URL
}

public APLRes:AskPluginLoad2(Handle:myself, bool:late, String:error[], err_max)
{
	g_LateLoaded = late;
	RegPluginLibrary(PL_NAME);
	return APLRes_Success;
}

public RP_OnSqlConnected(Handle:db)
{
	g_hSQL = db;
	SQLConnectionReady();
}

public RP_OnSqlStop()
{
	g_hSQL = INVALID_HANDLE;
}

SQLConnectionReady()
{
	/* Create Table*/
	decl String:sQuery[2048];
	Format(sQuery, sizeof(sQuery), "CREATE TABLE IF NOT EXISTS `rp_modellist` (`name` varchar(64) NOT NULL, `path` varchar(128) NOT NULL, PRIMARY KEY (`name`)) ENGINE=InnoDB DEFAULT CHARSET=utf8;");
	LogMessage("%s [%s] Query: %s", PL_PRE_N, PL_NAME, sQuery);
	SQL_TQuery(g_hSQL, SQL_CreateTableCallback, sQuery, _, DBPrio_High);
	
	LoadModels();
}

public SQL_CreateTableCallback(Handle:owner, Handle:hndl, const String:error[], any:data)
{
	if (owner == INVALID_HANDLE || hndl == INVALID_HANDLE)
	{
		LogError("%s [%s] (SQL_CreateTableCallback) %s", PL_PRE_N, PL_NAME, error);
	}
}

LoadModels()
{
	decl String:sQuery[2048];
	Format(sQuery, sizeof(sQuery), "SELECT `name`,`path` FROM `rp_modellist`;");
	SQL_TQuery(g_hSQL, SQL_LoadModelsCallback, sQuery, _, DBPrio_Low);
}

public SQL_LoadModelsCallback(Handle:owner, Handle:hndl, const String:error[], any:data)
{
	if (owner == INVALID_HANDLE || hndl == INVALID_HANDLE)
	{
		LogError("%s [%s] (SQL_LoadModelsCallback) %s", PL_PRE_N, PL_NAME, error);
	}
	
	maxmodels = 0;
	while (SQL_FetchRow(hndl))
	{
		SQL_FetchString(hndl, 0, g_ModelNames[maxmodels], 64);
		SQL_FetchString(hndl, 1, g_ModelPaths[maxmodels], 128);
	}
}

public RP_OnPlayerReady(client, playerID, bool:create)
{
	//PlayerID is now cached
}

public OnPluginStart()
{
	if(g_LateLoaded)
	{
		g_hSQL = Handle:RP_GetSql();
		
		if(g_hSQL != INVALID_HANDLE)
			SQLConnectionReady();
		
		g_LateLoaded = false;
	}
	
	RegAdminCmd("rp_adminmenu", Command_Adminmenu, ADMFLAG_ROOT, "Opens Roleplay Admin Menu");
}

public Action:Command_Adminmenu(client, args)
{
	if(0 >= client || client > MaxClients + 1)
		return Plugin_Handled;
	
	if(!IsClientInGame(client))
		return Plugin_Handled;
	
	if(!IsPlayerAlive(client))
		return Plugin_Handled;
	
	Menu_Main(client);
	
	return Plugin_Handled;
}

Menu_Main(client)
{
	new Handle:menu = CreateMenu(MenuHandler_Main);
	SetMenuTitle(menu, "[RP] Admin Menu");

	AddMenuItemEx(menu, false, "0", "Edit Objekt in View");
	AddMenuItemEx(menu, false, "1", "Create NPC");
	AddMenuItemEx(menu, false, "2", "Give / Take Money");
	AddMenuItemEx(menu, false, "3", "Give / Take Crime");
	AddMenuItemEx(menu, false, "4", "Client Information");
	
	/*Reset Selections*/
	g_SelectedEntity[client] = -1;
	g_SelectedNPCID[client] = -1;
	g_SelectedPlayer[client] = -1;

	SetMenuExitButton(menu, true);
	DisplayMenu(menu, client, MENU_TIME_FOREVER);
}

public MenuHandler_Main(Handle:menu, MenuAction:action, client, param2)
{
	if(0 >= client || client > MaxClients + 1)
		return;
	
	if(!IsClientInGame(client))
		return;
	
	if(!IsPlayerAlive(client))
		return;
	
	if (action == MenuAction_Select)
	{
		decl String:info[100], String:info2[100];
		new bool:found = GetMenuItem(menu, param2, info, sizeof(info), _, info2, sizeof(info2));
		
		if(found)
		{
			new selection = StringToInt(info);
			
			if(selection == 0)
			{
				new entity = GetClientAimTarget(client, false);
				if(RP_GetNpcID(entity) != -1)
				{
					g_SelectedEntity[client] = entity;
					g_SelectedNPCID[client] = RP_GetNpcID(entity);
					Menu_EditNPC(client);
				}
			}				
			else if(selection == 1)
			{
				Menu_CreateNPC(client);
			}
			else if(selection == 2)
			{
				Menu_MoneyManagement(client);
			}
			else if(selection == 3)
			{
				Menu_CrimeManagement(client);
			}
			else if(selection == 4)
			{
				Menu_PlayerManagement(client);
			}
			return;
		}
	}
}

Menu_EditNPC(client)
{
	decl String:npcname[64];
	decl String:npcmodel[128];
	
	new Handle:menu = CreateMenu(MenuHandler_EditNPC);
	SetMenuTitle(menu, "[RP] Edit NPC No[%d] %s", g_SelectedNPCID[client], npcname);
	RP_GetNpcName(g_SelectedNPCID[client], npcname, sizeof(npcname));
	RP_GetNpcModel(g_SelectedNPCID[client], npcmodel, sizeof(npcmodel));
	

	AddMenuItemEx(menu, false, "0", "Set Type [%d]", RP_GetNpcType(g_SelectedNPCID[client]));
	AddMenuItemEx(menu, false, "1", "Set ReqLevel [%d]", RP_GetNpcReqLevel(g_SelectedNPCID[client]));
	AddMenuItemEx(menu, false, "2", "Set ReqItem [%d]", RP_GetNpcReqItem(g_SelectedNPCID[client]));
	AddMenuItemEx(menu, false, "3", "Set VipOnly [%d]", RP_GetNpcVipOnly(g_SelectedNPCID[client]));
	AddMenuItemEx(menu, false, "4", "Set Team [%d]", RP_GetNpcTeam(g_SelectedNPCID[client]));
	AddMenuItemEx(menu, false, "5", "Set Range [%d]",RP_GetNpcRange(g_SelectedNPCID[client]));
	AddMenuItemEx(menu, false, "6", "Set Model [%s]", npcmodel);
	AddMenuItemEx(menu, false, "7", "Set Name [%s]", npcname);
	AddMenuItemEx(menu,!( RP_GetNpcType(g_SelectedNPCID[client]) == NT_Vendor), "8", "Add Items");
	AddMenuItemEx(menu, false, "999", "Back to Main");

	SetMenuExitButton(menu, true);
	DisplayMenu(menu, client, MENU_TIME_FOREVER);
}

public MenuHandler_EditNPC(Handle:menu, MenuAction:action, client, param2)
{
	if(0 >= client || client > MaxClients + 1)
		return;
	
	if(!IsClientInGame(client))
		return;
	
	if(!IsPlayerAlive(client))
		return;
	
	if (action == MenuAction_Select)
	{
		decl String:info[100], String:info2[100];
		new bool:found = GetMenuItem(menu, param2, info, sizeof(info), _, info2, sizeof(info2));
		
		if(found)
		{
			new selection = StringToInt(info);
			
			if(selection == 0)
			{
				Menu_EditNPCType(client);
			}				
			else if(selection == 1)
			{
				Menu_EditNPCreqlevel(client);
			}
			else if(selection == 2)
			{
				PrintToChat(client, "TODO");
				Menu_EditNPC(client);
			}
			else if(selection == 3)
			{
				if(RP_GetNpcVipOnly(g_SelectedNPCID[client]))
				{
					RP_SetNpcVipOnly(g_SelectedNPCID[client], false);
				}
				else
				{
					RP_SetNpcVipOnly(g_SelectedNPCID[client],true);
				}
				Menu_EditNPC(client);
			}
			else if(selection == 4)
			{
				Menu_EditNpcTeam(client);
			}
			else if(selection == 5)
			{
				Menu_EditNPCrange(client);
			}
			else if(selection == 6)
			{
				Menu_EditNPCModel(client);
			}
			else if(selection == 7)
			{
				PrintToChat(client, "Use rp_rename <name> to rename the NPC");
				Menu_EditNPC(client);
			}
			else if(selection == 8)
			{
				Menu_SelectItemType(client);
			}
			else if(selection == 999)
			{
				Menu_Main(client);
			}
			return;
		}
	}
}

Menu_EditNPCType(client)
{
	new Handle:menu = CreateMenu(MenuHandler_EditNPCType);
	SetMenuTitle(menu, "[RP] Edit NPC Type [%d]",RP_GetNpcType(g_SelectedNPCID[client]));

	AddMenuItemEx(menu, false, "0", "0 Other");
	AddMenuItemEx(menu, false, "1", "1 Civilian");
	AddMenuItemEx(menu, false, "2", "2 Vendor");
	AddMenuItemEx(menu, false, "3", "3 Banker");
	AddMenuItemEx(menu, false, "4", "4 Bailmaster");
	AddMenuItemEx(menu, false, "5", "5 Guard");
	AddMenuItemEx(menu, false, "6", "6 Sniper");
	AddMenuItemEx(menu, false, "7", "7 Housemaid");
	AddMenuItemEx(menu, false, "998", "Back to NPC Edit");
	AddMenuItemEx(menu, false, "999", "Back to Main");

	SetMenuExitButton(menu, true);
	DisplayMenu(menu, client, MENU_TIME_FOREVER);
}

public MenuHandler_EditNPCType(Handle:menu, MenuAction:action, client, param2)
{
	if(0 >= client || client > MaxClients + 1)
		return;
	
	if(!IsClientInGame(client))
		return;
	
	if(!IsPlayerAlive(client))
		return;
	
	if (action == MenuAction_Select)
	{
		decl String:info[100], String:info2[100];
		new bool:found = GetMenuItem(menu, param2, info, sizeof(info), _, info2, sizeof(info2));
		
		if(found)
		{
			new selection = StringToInt(info);
			
			if(selection >= 0 && selection <= 7)
			{
				RP_SetNpcType(g_SelectedNPCID[client], selection);
				Menu_EditNPC(client);
			}
			else if(selection == 998)
			{
				Menu_EditNPC(client);
			}
			else if(selection == 999)
			{
				Menu_Main(client);
			}
			return;
		}
	}
}

Menu_EditNPCreqlevel(client)
{
	new npc_req_level = RP_GetNpcReqLevel(g_SelectedNPCID[client]);
	
	new Handle:menu = CreateMenu(MenuHandler_EditNPCreqlevel);
	SetMenuTitle(menu, "[RP] Edit NPC Req Level [%d]",npc_req_level);

	AddMenuItemEx(menu, false, "0", "+1");
	AddMenuItemEx(menu, false, "1", "+5");
	AddMenuItemEx(menu, !(npc_req_level >= 1), "2", "-1");
	AddMenuItemEx(menu, !(npc_req_level >= 5), "3", "-5");
	AddMenuItemEx(menu, false, "998", "Back to NPC Edit");
	AddMenuItemEx(menu, false, "999", "Back to Main");

	SetMenuExitButton(menu, true);
	DisplayMenu(menu, client, MENU_TIME_FOREVER);
}

public MenuHandler_EditNPCreqlevel(Handle:menu, MenuAction:action, client, param2)
{
	if(0 >= client || client > MaxClients + 1)
		return;
	
	if(!IsClientInGame(client))
		return;
	
	if(!IsPlayerAlive(client))
		return;
	
	if (action == MenuAction_Select)
	{
		decl String:info[100], String:info2[100];
		new bool:found = GetMenuItem(menu, param2, info, sizeof(info), _, info2, sizeof(info2));
		
		if(found)
		{
			new npcreqlevel = RP_GetNpcReqLevel(g_SelectedNPCID[client]);
			new selection = StringToInt(info);
			
			if(selection == 0)
			{
				RP_SetNpcReqLevel(g_SelectedNPCID[client],npcreqlevel + 1);
				Menu_EditNPCreqlevel(client);
			}
			else if(selection == 1)
			{
				RP_SetNpcReqLevel(g_SelectedNPCID[client],npcreqlevel + 5);
				Menu_EditNPCreqlevel(client);
			}
			else if(selection == 2)
			{
				if(npcreqlevel >= 1)
					RP_SetNpcReqLevel(g_SelectedNPCID[client],npcreqlevel - 1);
					
				Menu_EditNPCreqlevel(client);
			}
			else if(selection == 3)
			{
				if(npcreqlevel >= 5)
					RP_SetNpcReqLevel(g_SelectedNPCID[client],npcreqlevel - 5);
				
				Menu_EditNPCreqlevel(client);
			}
			else if(selection == 998)
			{
				Menu_EditNPC(client);
			}
			else if(selection == 999)
			{
				Menu_Main(client);
			}
			return;
		}
	}
}

Menu_EditNpcTeam(client)
{
	new Handle:menu = CreateMenu(MenuHandler_EditNpcTeam);
	SetMenuTitle(menu, "[RP] Edit NPC Team [%d]",RP_GetNpcTeam(g_SelectedNPCID[client]));

	AddMenuItemEx(menu, false, "0", "0 Neutral");
	AddMenuItemEx(menu, false, "1", "%d Civil", CS_TEAM_T);
	AddMenuItemEx(menu, false, "2", "%d Cop", CS_TEAM_CT);
	AddMenuItemEx(menu, false, "998", "Back to NPC Edit");
	AddMenuItemEx(menu, false, "999", "Back to Main");

	SetMenuExitButton(menu, true);
	DisplayMenu(menu, client, MENU_TIME_FOREVER);
}

public MenuHandler_EditNpcTeam(Handle:menu, MenuAction:action, client, param2)
{
	if(0 >= client || client > MaxClients + 1)
		return;
	
	if(!IsClientInGame(client))
		return;
	
	if(!IsPlayerAlive(client))
		return;
	
	if (action == MenuAction_Select)
	{
		decl String:info[100], String:info2[100];
		new bool:found = GetMenuItem(menu, param2, info, sizeof(info), _, info2, sizeof(info2));
		
		if(found)
		{
			new selection = StringToInt(info);
			
			if(selection == 0)
			{
				RP_SetNpcTeam(g_SelectedNPCID[client],0);
				Menu_EditNpcTeam(client);
			}
			else if(selection == 1)
			{
				RP_SetNpcTeam(g_SelectedNPCID[client],CS_TEAM_T);
				Menu_EditNpcTeam(client);
			}
			else if(selection == 2)
			{
				RP_SetNpcTeam(g_SelectedNPCID[client],CS_TEAM_CT);
				Menu_EditNpcTeam(client);
			}
			else if(selection == 998)
			{
				Menu_EditNPC(client);
			}
			else if(selection == 999)
			{
				Menu_Main(client);
			}
			return;
		}
	}
}

Menu_EditNPCrange(client)
{
	new npc_range = RP_GetNpcRange(g_SelectedNPCID[client]);
	
	new Handle:menu = CreateMenu(MenuHandler_EditNPCrange);
	SetMenuTitle(menu, "[RP] Edit NPC Range [%d]",npc_range);

	AddMenuItemEx(menu, false, "0", "+1");
	AddMenuItemEx(menu, false, "1", "+10");
	AddMenuItemEx(menu, false, "2", "+100");
	AddMenuItemEx(menu, !(npc_range >= 1), "3", "-1");
	AddMenuItemEx(menu, !(npc_range >= 10), "4", "-10");
	AddMenuItemEx(menu, !(npc_range >= 100), "5", "-100");
	AddMenuItemEx(menu, false, "998", "Back to NPC Edit");
	AddMenuItemEx(menu, false, "999", "Back to Main");

	SetMenuExitButton(menu, true);
	DisplayMenu(menu, client, MENU_TIME_FOREVER);
}

public MenuHandler_EditNPCrange(Handle:menu, MenuAction:action, client, param2)
{
	if(0 >= client || client > MaxClients + 1)
		return;
	
	if(!IsClientInGame(client))
		return;
	
	if(!IsPlayerAlive(client))
		return;
	
	if (action == MenuAction_Select)
	{
		decl String:info[100], String:info2[100];
		new bool:found = GetMenuItem(menu, param2, info, sizeof(info), _, info2, sizeof(info2));
		
		if(found)
		{
			new npc_range = RP_GetNpcRange(g_SelectedNPCID[client]);
			new selection = StringToInt(info);
			
			if(selection == 0)
			{
				RP_SetNpcRange(g_SelectedNPCID[client],npc_range + 1);
				Menu_EditNPCrange(client);
			}
			else if(selection == 1)
			{
				RP_SetNpcRange(g_SelectedNPCID[client],npc_range + 10);
				Menu_EditNPCrange(client);
			}
			else if(selection == 2)
			{
				RP_SetNpcRange(g_SelectedNPCID[client],npc_range + 100);
				Menu_EditNPCrange(client);
			}
			else if(selection == 3)
			{
				if(npc_range >= 1)
					RP_SetNpcRange(g_SelectedNPCID[client],npc_range - 1);
					
				Menu_EditNPCrange(client);
			}
			else if(selection == 4)
			{
				if(npc_range >= 10)
					RP_SetNpcRange(g_SelectedNPCID[client],npc_range - 10);
				
				Menu_EditNPCrange(client);
			}
			else if(selection == 5)
			{
				if(npc_range >= 100)
					RP_SetNpcRange(g_SelectedNPCID[client],npc_range - 100);
				
				Menu_EditNPCrange(client);
			}
			else if(selection == 998)
			{
				Menu_EditNPC(client);
			}
			else if(selection == 999)
			{
				Menu_Main(client);
			}
			return;
		}
	}
}

Menu_EditNPCModel(client)
{	
	new Handle:menu = CreateMenu(MenuHandler_EditNPCModel);
	SetMenuTitle(menu, "[RP] Edit NPC Model");
	new String:buffer[8];

	for (new i = 0; i < maxmodels; i++)
	{
		IntToString(i,buffer,sizeof(buffer));
		AddMenuItemEx(menu, false, buffer, "%s",g_ModelNames[i]);
	}

	AddMenuItemEx(menu, false, "998", "Back to NPC Edit");
	AddMenuItemEx(menu, false, "999", "Back to Main");

	SetMenuExitButton(menu, true);
	DisplayMenu(menu, client, MENU_TIME_FOREVER);
}

public MenuHandler_EditNPCModel(Handle:menu, MenuAction:action, client, param2)
{
	if(0 >= client || client > MaxClients + 1)
		return;
	
	if(!IsClientInGame(client))
		return;
	
	if(!IsPlayerAlive(client))
		return;
	
	if (action == MenuAction_Select)
	{
		decl String:info[100], String:info2[100];
		new bool:found = GetMenuItem(menu, param2, info, sizeof(info), _, info2, sizeof(info2));
		
		if(found)
		{
			new selection = StringToInt(info);
			
			
			if(selection == 998)
			{
				Menu_EditNPC(client);
			}
			else if(selection == 999)
			{
				Menu_Main(client);
			}
			else
			{
				RP_SetNpcModel(g_SelectedNPCID[client], g_ModelPaths[selection]);
				Menu_EditNPCModel(client);
			}
			return;
		}
	}
}

Menu_SelectItemType(client)
{
	new Handle:menu = CreateMenu(MenuHandler_SelectItemType);
	SetMenuTitle(menu, "Itemtype Selection");
	
	new maxit = RP_GetMaxItemType();
	new String:buffer[64]
	new String:sindex[10];
	
	for (new i = 0; i < maxit; i++)
	{
		if(RP_GetItemTypeUsed(i))
		{
			RP_GetItemTypeName(i, buffer, sizeof(buffer));
			
			IntToString(i, sindex, sizeof(sindex));
			AddMenuItemEx(menu, false, sindex, "%s", buffer);
			
		}
	}
	AddMenuItemEx(menu, false, "998", "Back to NPC Edit");
	AddMenuItemEx(menu, false, "999", "Back to Main");
	SetMenuExitButton(menu, true);
	DisplayMenu(menu, client, MENU_TIME_FOREVER);
}

public MenuHandler_SelectItemType(Handle:menu, MenuAction:action, client, param2)
{
	if(0 >= client || client > MaxClients + 1)
		return;
	
	if(!IsClientInGame(client))
		return;
	
	if(!IsPlayerAlive(client))
		return;
	
	if (action == MenuAction_Select)
	{
		decl String:info[100], String:info2[100];
		new bool:found = GetMenuItem(menu, param2, info, sizeof(info), _, info2, sizeof(info2));
		
		new String:buffer[64];
		
		if(found)
		{
			new selection = StringToInt(info);
			
			
			if(selection == 998)
			{
				Menu_EditNPC(client);
			}
			else if(selection == 999)
			{
				Menu_Main(client);
			}
			else
			{
				g_SelectedItemType[client] = selection;
				RP_GetItemTypeName(selection, buffer, sizeof(buffer));
				g_SelectedItemTypeS[client] = buffer;
				Menu_SelectItem(client);
			}
			return;
		}
	}
}

Menu_SelectItem(client)
{
	new items = RP_GetItemCount();
	new Handle:menu = CreateMenu(MenuHandler_SelectItem);
	SetMenuTitle(menu, "[%s] Add Item to NPC", g_SelectedItemTypeS[client]);

	new String:sItemID[10];
	
	for (new i = 0; i < items; i++)
	{
		new itemID = RP_GetItemID(i);
		
		if(RP_GetItemType(itemID) == g_SelectedItemType[client])
		{
			decl String:sItemName[64];
			RP_GetItemName(itemID, sItemName, sizeof(sItemName));
			IntToString(itemID, sItemID, sizeof(sItemID));
			AddMenuItemEx(menu, false, sItemID, "[%d] %s", itemID, sItemName);
		}
	}
	
	AddMenuItemEx(menu, false, "997", "Back to Itemtype Selection");
	AddMenuItemEx(menu, false, "998", "Back to NPC Edit");
	AddMenuItemEx(menu, false, "999", "Back to Main");
	
	SetMenuExitButton(menu, true);
	DisplayMenu(menu, client, MENU_TIME_FOREVER);
}

public MenuHandler_SelectItem(Handle:menu, MenuAction:action, client, param2)
{
	if(0 >= client || client > MaxClients + 1)
		return;
	
	if(!IsClientInGame(client))
		return;
	
	if(!IsPlayerAlive(client))
		return;
	
	if (action == MenuAction_Select)
	{
		decl String:info[100], String:info2[100];
		new bool:found = GetMenuItem(menu, param2, info, sizeof(info), _, info2, sizeof(info2));
		
		if(found)
		{
			new selection = StringToInt(info);
			
			if(selection == 997)
			{
				Menu_SelectItemType(client);
			}
			if(selection == 998)
			{
				Menu_EditNPC(client);
			}
			else if(selection == 999)
			{
				Menu_Main(client);
			}
			else
			{
				RP_AddVendorItem(g_SelectedNPCID[client], selection, 1.0);
				Menu_EditNPC(client);
			}
			return;
		}
	}
}

Menu_CreateNPC(client)
{	
	new Handle:menu = CreateMenu(MenuHandler_CreateNPC);
	SetMenuTitle(menu, "[RP] Create NPC Menu");

	AddMenuItemEx(menu, false, "0", "Create NPC Here");

	AddMenuItemEx(menu, false, "999", "Back to Main");

	SetMenuExitButton(menu, true);
	DisplayMenu(menu, client, MENU_TIME_FOREVER);
}



public MenuHandler_CreateNPC(Handle:menu, MenuAction:action, client, param2)
{
	if(0 >= client || client > MaxClients + 1)
		return;
	
	if(!IsClientInGame(client))
		return;
	
	if(!IsPlayerAlive(client))
		return;
	
	if (action == MenuAction_Select)
	{
		decl String:info[100], String:info2[100];
		new bool:found = GetMenuItem(menu, param2, info, sizeof(info), _, info2, sizeof(info2));
		
		if(found)
		{
			new selection = StringToInt(info);
			
			if(selection == 0)
			{
				new Float:origion[3];
				new Float:angel[3];
	
				GetClientAbsOrigin(client,origion);
				GetClientAbsAngles(client,angel);
				
				RP_CreateNPCdefault(origion[0], origion[1], origion[2], angel[1]);
				Menu_Main(client);
			}
			else if(selection == 999)
			{
				Menu_Main(client);
			}
			return;
		}
	}
}

Menu_MoneyManagement(client)
{	
	new Handle:menu = CreateMenu(MenuHandler_MoneyManagement);
	SetMenuTitle(menu, "[RP] Money Management [Hand/Bank]");
	new String:buffer[8];
	new String:namebuffer[64];

	for (new i = 1; i < MAXPLAYERS; i++)
	{		
		if(!IsClientInGame(i))
			continue;
		
		if(IsFakeClient(i))
			continue;
		
		GetClientName(i, namebuffer, sizeof(namebuffer));
		
		IntToString(i,buffer,sizeof(buffer));
		AddMenuItemEx(menu, false, buffer, "%s [%d/%d]",namebuffer,RP_GetMoney(i),RP_GetMoneyBank(i));
	}
	AddMenuItemEx(menu, false, "999", "Back to Main");

	SetMenuExitButton(menu, true);
	DisplayMenu(menu, client, MENU_TIME_FOREVER);
}

public MenuHandler_MoneyManagement(Handle:menu, MenuAction:action, client, param2)
{
	if(0 >= client || client > MaxClients + 1)
		return;
	
	if(!IsClientInGame(client))
		return;
	
	if(!IsPlayerAlive(client))
		return;
	
	if (action == MenuAction_Select)
	{
		decl String:info[100], String:info2[100];
		new bool:found = GetMenuItem(menu, param2, info, sizeof(info), _, info2, sizeof(info2));
		
		if(found)
		{
			new selection = StringToInt(info);
			
			if(selection == 999)
			{
				Menu_Main(client);
			}
			else
			{
				g_SelectedPlayer[client] = selection;
				Menu_MoneyManagementMethod(client);
			}
			return;
		}
	}
}

Menu_MoneyManagementMethod(client)
{	
	new Handle:menu = CreateMenu(MenuHandler_MoneyManagementMethod);
	new String:namebuffer[64];
	GetClientName(g_SelectedPlayer[client], namebuffer, sizeof(namebuffer));
	SetMenuTitle(menu, "[RP] %s [%d,%d]",namebuffer,RP_GetMoney(g_SelectedPlayer[client]),RP_GetMoneyBank(g_SelectedPlayer[client]));

	AddMenuItemEx(menu, false, "0", "Add Money",namebuffer,RP_GetMoney(g_SelectedPlayer[client]),RP_GetMoneyBank(g_SelectedPlayer[client]));
	AddMenuItemEx(menu, false, "1", "Take Money",namebuffer,RP_GetMoney(g_SelectedPlayer[client]),RP_GetMoneyBank(g_SelectedPlayer[client]));
	AddMenuItemEx(menu, false, "2", "Add Money to Bank",namebuffer,RP_GetMoney(g_SelectedPlayer[client]),RP_GetMoneyBank(g_SelectedPlayer[client]));
	AddMenuItemEx(menu, false, "3", "Take Money from Bank",namebuffer,RP_GetMoney(g_SelectedPlayer[client]),RP_GetMoneyBank(g_SelectedPlayer[client]));

	AddMenuItemEx(menu, false, "998", "Back to Player Selection");
	AddMenuItemEx(menu, false, "999", "Back to Main");

	SetMenuExitButton(menu, true);
	DisplayMenu(menu, client, MENU_TIME_FOREVER);
}

public MenuHandler_MoneyManagementMethod(Handle:menu, MenuAction:action, client, param2)
{
	if(0 >= client || client > MaxClients + 1)
		return;
	
	if(!IsClientInGame(client))
		return;
	
	if(!IsPlayerAlive(client))
		return;
	
	if (action == MenuAction_Select)
	{
		decl String:info[100], String:info2[100];
		new bool:found = GetMenuItem(menu, param2, info, sizeof(info), _, info2, sizeof(info2));
		
		if(found)
		{
			new selection = StringToInt(info);
			
			if(selection == 998)
			{
				Menu_MoneyManagement(client);
			}
			else if(selection == 999)
			{
				Menu_Main(client);
			}
			else if(selection == 0)
			{
				g_SelectedPlayerMethod[client] = 0;
				g_SelectedPlayerMethodS[client] = "Add Money to";
				Menu_MoneyManagementTransfer(client);
			}
			else if(selection == 1)
			{
				g_SelectedPlayerMethod[client] = 1;
				g_SelectedPlayerMethodS[client] = "Take Money from";
				Menu_MoneyManagementTransfer(client);
			}
			else if(selection == 2)
			{
				g_SelectedPlayerMethod[client] = 2;
				g_SelectedPlayerMethodS[client] = "Add Money to Bank of";
				Menu_MoneyManagementTransfer(client);
			}
			else if(selection == 3)
			{
				g_SelectedPlayerMethod[client] = 3;
				g_SelectedPlayerMethodS[client] = "Take Money from Bank of";
				Menu_MoneyManagementTransfer(client);
			}
			return;
		}
	}
}

Menu_MoneyManagementTransfer(client)
{
	new Handle:menu = CreateMenu(MenuHandler_MoneyManagementTransfer);
	new String:namebuffer[64];
	GetClientName(g_SelectedPlayer[client], namebuffer, sizeof(namebuffer));
	if(g_SelectedPlayerMethod[client] == 0 || g_SelectedPlayerMethod[client] == 1)
		SetMenuTitle(menu, "[RP] [%d] %s %s", RP_GetMoney(g_SelectedPlayer[client]) , g_SelectedPlayerMethodS[client],namebuffer);
	else
		SetMenuTitle(menu, "[RP] [%d] %s %s", RP_GetMoneyBank(g_SelectedPlayer[client]),g_SelectedPlayerMethodS[client],namebuffer);

	AddMenuItemEx(menu, false, "1", "1$");
	AddMenuItemEx(menu, false, "10", "10$");
	AddMenuItemEx(menu, false, "100", "100$");
	AddMenuItemEx(menu, false, "1000", "1000$");
	AddMenuItemEx(menu, false, "10000", "10000$");

	AddMenuItemEx(menu, false, "997", "Back to Player Selection");
	AddMenuItemEx(menu, false, "998", "Back to Method Selection");
	AddMenuItemEx(menu, false, "999", "Back to Main");

	SetMenuExitButton(menu, true);
	DisplayMenu(menu, client, MENU_TIME_FOREVER);
}

public MenuHandler_MoneyManagementTransfer(Handle:menu, MenuAction:action, client, param2)
{
	if(0 >= client || client > MaxClients + 1)
		return;
	
	if(!IsClientInGame(client))
		return;
	
	if(!IsPlayerAlive(client))
		return;
	
	if (action == MenuAction_Select)
	{
		decl String:info[100], String:info2[100];
		new bool:found = GetMenuItem(menu, param2, info, sizeof(info), _, info2, sizeof(info2));
		
		if(found)
		{
			new selection = StringToInt(info);
			
			if(selection == 997)
			{
				Menu_MoneyManagement(client);
			}
			else if(selection == 998)
			{
				Menu_MoneyManagementMethod(client);
			}
			else if(selection == 999)
			{
				Menu_Main(client);
			}
			else
			{
				if(g_SelectedPlayerMethod[client] == 0)
				{
					RP_AddMoney(g_SelectedPlayer[client], selection);
					Menu_MoneyManagementTransfer(client);
				}
				else if(g_SelectedPlayerMethod[client] == 1)
				{
					RP_TakeMoney(g_SelectedPlayer[client], selection);
					Menu_MoneyManagementTransfer(client);
				}
				else if(g_SelectedPlayerMethod[client] == 2)
				{
					RP_AddMoneyBank(g_SelectedPlayer[client], selection);
					Menu_MoneyManagementTransfer(client);
				}
				else
				{
					RP_TakeMoneyBank(g_SelectedPlayer[client], selection);
					Menu_MoneyManagementTransfer(client);
				}
			}
			return;
		}
	}
}

Menu_CrimeManagement(client)
{	
	new Handle:menu = CreateMenu(MenuHandler_CrimeManagement);
	SetMenuTitle(menu, "[RP] Crime Management");
	new String:buffer[8];
	new String:namebuffer[64];

	for (new i = 1; i < MAXPLAYERS; i++)
	{		
		if(!IsClientInGame(i))
			continue;
		
		if(IsFakeClient(i))
			continue;
		
		GetClientName(i, namebuffer, sizeof(namebuffer));
		
		IntToString(i,buffer,sizeof(buffer));
		AddMenuItemEx(menu, false, buffer, "%s [Crime:%d/Bounty:%d]",namebuffer,RP_GetCrime(i),RP_GetBounty(i));
	}
	AddMenuItemEx(menu, false, "999", "Back to Main");

	SetMenuExitButton(menu, true);
	DisplayMenu(menu, client, MENU_TIME_FOREVER);
}

public MenuHandler_CrimeManagement(Handle:menu, MenuAction:action, client, param2)
{
	if(0 >= client || client > MaxClients + 1)
		return;
	
	if(!IsClientInGame(client))
		return;
	
	if(!IsPlayerAlive(client))
		return;
	
	if (action == MenuAction_Select)
	{
		decl String:info[100], String:info2[100];
		new bool:found = GetMenuItem(menu, param2, info, sizeof(info), _, info2, sizeof(info2));
		
		if(found)
		{
			new selection = StringToInt(info);
			
			if(selection == 999)
			{
				Menu_Main(client);
			}
			else
			{
				g_SelectedPlayer[client] = selection;
				Menu_CrimeManagementMethod(client);
			}
			return;
		}
	}
}

Menu_CrimeManagementMethod(client)
{	
	new Handle:menu = CreateMenu(MenuHandler_CrimeManagementMethod);
	new String:namebuffer[64];
	GetClientName(g_SelectedPlayer[client], namebuffer, sizeof(namebuffer));
	SetMenuTitle(menu, "[RP] %s [%d,%d]",namebuffer,RP_GetMoney(g_SelectedPlayer[client]),RP_GetMoneyBank(g_SelectedPlayer[client]));

	AddMenuItemEx(menu, false, "0", "Add Crime",namebuffer,RP_GetMoney(g_SelectedPlayer[client]),RP_GetMoneyBank(g_SelectedPlayer[client]));
	AddMenuItemEx(menu, false, "1", "Take Crime",namebuffer,RP_GetMoney(g_SelectedPlayer[client]),RP_GetMoneyBank(g_SelectedPlayer[client]));
	AddMenuItemEx(menu, false, "2", "Add Bounty",namebuffer,RP_GetMoney(g_SelectedPlayer[client]),RP_GetMoneyBank(g_SelectedPlayer[client]));
	AddMenuItemEx(menu, false, "3", "Take Bounty",namebuffer,RP_GetMoney(g_SelectedPlayer[client]),RP_GetMoneyBank(g_SelectedPlayer[client]));

	AddMenuItemEx(menu, false, "998", "Back to Player Selection");
	AddMenuItemEx(menu, false, "999", "Back to Main");

	SetMenuExitButton(menu, true);
	DisplayMenu(menu, client, MENU_TIME_FOREVER);
}

public MenuHandler_CrimeManagementMethod(Handle:menu, MenuAction:action, client, param2)
{
	if(0 >= client || client > MaxClients + 1)
		return;
	
	if(!IsClientInGame(client))
		return;
	
	if(!IsPlayerAlive(client))
		return;
	
	if (action == MenuAction_Select)
	{
		decl String:info[100], String:info2[100];
		new bool:found = GetMenuItem(menu, param2, info, sizeof(info), _, info2, sizeof(info2));
		
		if(found)
		{
			new selection = StringToInt(info);
			
			if(selection == 998)
			{
				Menu_CrimeManagement(client);
			}
			else if(selection == 999)
			{
				Menu_Main(client);
			}
			else if(selection == 0)
			{
				g_SelectedPlayerMethod[client] = 0;
				g_SelectedPlayerMethodS[client] = "Add Crime to";
				Menu_CrimeManagementTransfer(client);
			}
			else if(selection == 1)
			{
				g_SelectedPlayerMethod[client] = 1;
				g_SelectedPlayerMethodS[client] = "Take Crime from";
				Menu_CrimeManagementTransfer(client);
			}
			else if(selection == 2)
			{
				g_SelectedPlayerMethod[client] = 2;
				g_SelectedPlayerMethodS[client] = "Add Bounty to";
				Menu_CrimeManagementTransfer(client);
			}
			else if(selection == 3)
			{
				g_SelectedPlayerMethod[client] = 3;
				g_SelectedPlayerMethodS[client] = "Take Bounty from";
				Menu_CrimeManagementTransfer(client);
			}
			return;
		}
	}
}

Menu_CrimeManagementTransfer(client)
{
	new Handle:menu = CreateMenu(MenuHandler_CrimeManagementTransfer);
	new String:namebuffer[64];
	GetClientName(g_SelectedPlayer[client], namebuffer, sizeof(namebuffer));
	if(g_SelectedPlayerMethod[client] == 0 || g_SelectedPlayerMethod[client] == 1)
		SetMenuTitle(menu, "[RP] [%d] %s %s", RP_GetCrime(g_SelectedPlayer[client]) , g_SelectedPlayerMethodS[client],namebuffer);
	else
		SetMenuTitle(menu, "[RP] [%d] %s %s", RP_GetBounty(g_SelectedPlayer[client]),g_SelectedPlayerMethodS[client],namebuffer);
		
	AddMenuItemEx(menu, false, "1", "1");
	AddMenuItemEx(menu, false, "10", "10");
	AddMenuItemEx(menu, false, "100", "100");
	AddMenuItemEx(menu, false, "1000", "1000");
	AddMenuItemEx(menu, false, "10000", "10000");

	AddMenuItemEx(menu, false, "997", "Back to Player Selection");
	AddMenuItemEx(menu, false, "998", "Back to Method Selection");
	AddMenuItemEx(menu, false, "999", "Back to Main");

	SetMenuExitButton(menu, true);
	DisplayMenu(menu, client, MENU_TIME_FOREVER);
}

public MenuHandler_CrimeManagementTransfer(Handle:menu, MenuAction:action, client, param2)
{
	if(0 >= client || client > MaxClients + 1)
		return;
	
	if(!IsClientInGame(client))
		return;
	
	if(!IsPlayerAlive(client))
		return;
	
	if (action == MenuAction_Select)
	{
		decl String:info[100], String:info2[100];
		new bool:found = GetMenuItem(menu, param2, info, sizeof(info), _, info2, sizeof(info2));
		
		if(found)
		{
			new selection = StringToInt(info);
			
			if(selection == 997)
			{
				Menu_CrimeManagement(client);
			}
			else if(selection == 998)
			{
				Menu_CrimeManagementMethod(client);
			}
			else if(selection == 999)
			{
				Menu_Main(client);
			}
			else
			{
				if(g_SelectedPlayerMethod[client] == 0)
				{
					RP_AddCrime(g_SelectedPlayer[client], selection,"Admin");
					Menu_CrimeManagementTransfer(client);
				}
				else if(g_SelectedPlayerMethod[client] == 1)
				{
					RP_TakeCrime(g_SelectedPlayer[client], selection);
					Menu_CrimeManagementTransfer(client);
				}
				else if(g_SelectedPlayerMethod[client] == 2)
				{
					RP_AddBounty(g_SelectedPlayer[client], selection);
					Menu_CrimeManagementTransfer(client);
				}
				else
				{
					RP_TakeBounty(g_SelectedPlayer[client], selection);
					Menu_CrimeManagementTransfer(client);
				}
			}
			return;
		}
	}
}

Menu_PlayerManagement(client)
{	
	new Handle:menu = CreateMenu(MenuHandler_PlayerManagement);
	SetMenuTitle(menu, "[RP] Player Management");
	new String:buffer[8];
	new String:namebuffer[64];

	for (new i = 1; i < MAXPLAYERS; i++)
	{		
		if(!IsClientInGame(i))
			continue;
		
		if(IsFakeClient(i))
			continue;
		
		GetClientName(i, namebuffer, sizeof(namebuffer));
		
		IntToString(i,buffer,sizeof(buffer));
		AddMenuItemEx(menu, false, buffer, "%s [Crime:%d/Bounty:%d]",namebuffer,RP_GetCrime(i),RP_GetBounty(i));
	}
	AddMenuItemEx(menu, false, "999", "Back to Main");

	SetMenuExitButton(menu, true);
	DisplayMenu(menu, client, MENU_TIME_FOREVER);
}

public MenuHandler_PlayerManagement(Handle:menu, MenuAction:action, client, param2)
{
	if(0 >= client || client > MaxClients + 1)
		return;
	
	if(!IsClientInGame(client))
		return;
	
	if(!IsPlayerAlive(client))
		return;
	
	if (action == MenuAction_Select)
	{
		decl String:info[100], String:info2[100];
		new bool:found = GetMenuItem(menu, param2, info, sizeof(info), _, info2, sizeof(info2));
		
		if(found)
		{
			new selection = StringToInt(info);
			
			if(selection == 999)
			{
				Menu_Main(client);
			}
			else
			{
				g_SelectedPlayer[client] = selection;
				Menu_PlayerPanel(client);
			}
			return;
		}
	}
}

Menu_PlayerPanel(client)
{	
	new Handle:panel = CreateMenuEx(_,MenuHandler_PlayerPanel,MENU_ACTIONS_ALL);
	SetMenuPagination(panel,4);
	new String:text[255];
	new String:temp[255];
	
	Format(temp,sizeof(temp),"[%d] %N \n",RP_GetPlayerID(g_SelectedPlayer[client]) ,g_SelectedPlayer[client]);
	StrCat(text,255,temp);
	AddMenuItem(panel,"",text);
	text="";
	
	Format(temp,sizeof(temp),"Money: %d / Bank: %d \n",RP_GetMoney(g_SelectedPlayer[client]),RP_GetMoneyBank(g_SelectedPlayer[client]));
	StrCat(text,255,temp);
	AddMenuItem(panel,"",text);
	text="";
	
	Format(temp,sizeof(temp),"Crime: %d / Bounty: %d \n",RP_GetCrime(g_SelectedPlayer[client]),RP_GetBounty(g_SelectedPlayer[client]));
	StrCat(text,255,temp);
	AddMenuItem(panel,"",text);
	text="";
	
	Format(temp,sizeof(temp),"Level: %d / Items: %d \n",RP_GetLevel(g_SelectedPlayer[client]),RP_GetPlayerInventoryItemCount(g_SelectedPlayer[client]));
	StrCat(text,255,temp);
	AddMenuItem(panel,"",text);
	text="";

	Format(temp,sizeof(temp),"Back to Main \n",RP_GetLevel(g_SelectedPlayer[client]),RP_GetPlayerInventoryItemCount(g_SelectedPlayer[client]));
	StrCat(text,255,temp);
	AddMenuItem(panel,"999",text);
	text="";

	DisplayMenu(panel,client,MENU_TIME_FOREVER);
}

public MenuHandler_PlayerPanel(Handle:menu, MenuAction:action, client, param2){
	if(0 >= client || client > MaxClients + 1)
		return;
	
	if(!IsClientInGame(client))
		return;
	
	if(!IsPlayerAlive(client))
		return;
	
	if (action == MenuAction_Select)
	{
		decl String:info[100], String:info2[100];
		new bool:found = GetMenuItem(menu, param2, info, sizeof(info), _, info2, sizeof(info2));
		
		if(found)
		{
			new selection = StringToInt(info);
			
			if(selection == 999)
			{
				Menu_Main(client);
			}
			return;
		}
	}
	
	if (action == MenuAction_End)
	{
		CloseHandle(menu);
	}
}