#include "roleplay/roleplay"

#define PL_NAME		"RP_Appartments"

new bool:g_LateLoaded;

/* Database */
new Handle:g_hSQL;

new nAppartmentTeamplate[RP_Appartments];
new Handle:g_hAppartments = INVALID_HANDLE;

public Plugin:myinfo = 
{
	name = PL_NAME,
	author = PL_AUTHOR,
	description = "",
	version = PL_VERSION,
	url = PL_URL
}

public APLRes:AskPluginLoad2(Handle:myself, bool:late, String:error[], err_max)
{
	g_LateLoaded = late;
	RegPluginLibrary(PL_NAME);
	
	CreateNative("RP_GetAppartmentCount", Native_GetAppartmentCount);
	
	CreateNative("RP_GetAppartmentIDByIndex", Native_GetAppartmentIDByIndex);
	CreateNative("RP_GetAppartmentIDByPlayerID", Native_GetAppartmentIDByPlayerID);
	
	CreateNative("RP_CreateAppartment", Native_CreateAppartment);
	CreateNative("RP_DeleteAppartment", Native_DeleteAppartment);
	
	CreateNative("RP_GetAppartmentPlayerID", Native_GetAppartmentPlayerID);
	CreateNative("RP_SetAppartmentPlayerID", Native_SetAppartmentPlayerID);

	CreateNative("RP_GetAppartmentPrice", Native_GetAppartmentPrice);
	CreateNative("RP_SetAppartmentPrice", Native_SetAppartmentPrice);
	
	CreateNative("RP_IsAppartmentSold", Native_IsAppartmentSold);
	CreateNative("RP_SetAppartmentSold", Native_SetAppartmentSold);
	
	CreateNative("RP_GetAppartmentMaxInh", Native_GetAppartmentMaxInh);
	CreateNative("RP_SetAppartmentMaxInh", Native_SetAppartmentMaxInh);
	
	CreateNative("RP_GetAppartmentbuildingID", Native_GetAppartmentbuildingID);
	CreateNative("RP_SetAppartmentbuildingID", Native_SetAppartmentbuildingID);
	
	CreateNative("RP_GetAppartmentRoomnumber", Native_GetAppartmentRoomnumber);
	CreateNative("RP_SetAppartmentRoomnumber", Native_SetAppartmentRoomnumber);
	
	return APLRes_Success;
}

public OnPluginStart()
{
	// Init ADT arrays
	g_hAppartments = CreateArray(sizeof(nAppartmentTeamplate));
	nAppartmentTeamplate[Appartment_ID] = 0;
	
	if(g_LateLoaded)
	{
		g_hSQL = Handle:RP_GetSql();
		
		if(g_hSQL != INVALID_HANDLE)
			SQLConnectionReady();
		
		g_LateLoaded = false;
	}
}

public RP_OnSqlConnected(Handle:db)
{
	g_hSQL = db;
	SQLConnectionReady();
}

public RP_OnSqlStop()
{
	g_hSQL = INVALID_HANDLE;
}

SQLConnectionReady()
{
	decl String:sQuery[2048];
	Format(sQuery, sizeof(sQuery), "CREATE TABLE IF NOT EXISTS `rp_appartments` (`appartmentID` int(10) NOT NULL AUTO_INCREMENT, `playerID` int(10) NOT NULL, `price` int(10) NOT NULL, `sold` BOOL NOT NULL DEFAULT '0', `maxinhabitants` int(10) NOT NULL,`buildingID` int(10) NOT NULL,`roomnumber` int(10) NOT NULL, PRIMARY KEY (`appartmentID`)) ENGINE=InnoDB DEFAULT CHARSET=utf8;");
	LogMessage("%s [%s] Query: %s", PL_PRE_N, PL_NAME, sQuery);
	SQL_TQuery(g_hSQL, SQL_CreateTableCallback, sQuery, _, DBPrio_High);
	
	ResetAppartments();
	LoadAppartments();
}

public SQL_CreateTableCallback(Handle:owner, Handle:hndl, const String:error[], any:data)
{
	if (owner == INVALID_HANDLE || hndl == INVALID_HANDLE)
	{
		LogError("%s [%s] (SQL_CreateTableCallback) %s", PL_PRE_N, PL_NAME, error);
	}
}

/* Appartments */

ResetAppartments()
{
	ClearArray(g_hAppartments);
	g_hAppartments = CreateArray(sizeof(nAppartmentTeamplate));
}

LoadAppartments()
{
	decl String:sQuery[2048];
	Format(sQuery, sizeof(sQuery), "SELECT `appartmentID`,`sold`,`playerID`,`price`, `maxinhabitants`,buildingID`,`roomnumber` FROM `rp_appartments`");
	SQL_TQuery(g_hSQL, SQL_LoadAppartmentsCallback, sQuery, _, DBPrio_Low);
}

public SQL_LoadAppartmentsCallback(Handle:owner, Handle:hndl, const String:error[], any:data)
{
	if (owner == INVALID_HANDLE || hndl == INVALID_HANDLE)
	{
		LogError("%s [%s] (SQL_LoadAppartmentsCallback) %s", PL_PRE_N, PL_NAME, error);
	}
	
	while (SQL_FetchRow(hndl))
	{
		new nNew[RP_Appartments];
		
		nNew[Appartment_ID] = SQL_FetchInt(hndl, 0);
		nNew[Appartment_Sold] = bool:SQL_FetchInt(hndl, 1);
		nNew[Appartment_PlayerID] = SQL_FetchInt(hndl, 2);
		nNew[Appartment_Price] = SQL_FetchInt(hndl, 3);
		nNew[Appartment_MaxInh] = SQL_FetchInt(hndl, 4);
		nNew[Building_ID] = SQL_FetchInt(hndl, 5);
		nNew[Appartment_Roomnumber] = SQL_FetchInt(hndl, 6);
		
		PushArrayArray(g_hAppartments, nNew[0]);
	}
}

DeleteAppartment(appartmentID)
{
	decl String:sQuery[2048];
	FormatEx(sQuery, sizeof(sQuery), "DELETE FROM `rp_appartments` WHERE appartmentID = %d", appartmentID);
	SQL_TQuery(g_hSQL, SQL_DeleteAppartmentCallback, sQuery, _);
}

public SQL_DeleteAppartmentCallback(Handle:owner, Handle:hndl, const String:error[], any:userid)
{
	if (owner == INVALID_HANDLE || hndl == INVALID_HANDLE)
	{
		LogError("%s [%s] (SQL_DeleteAppartmentCallback) %s", PL_PRE_N, PL_NAME, error);
	}
}

CreateAppartments(price, instance_start, instance_end)
{
	if(instance_start != -1)
	{
		decl String:sBuffer[128];
		
		for (new i = instance_start; i < instance_end; i++)
		{
			Format(sBuffer, sizeof(sBuffer), "%d", i);
			CreateAppartment(price);
		}
	}
	else
	{
		CreateAppartment(price)
	}
	
	ResetAppartments();
	LoadAppartments();
}

CreateAppartment(price)
{
	decl String:sQuery[2048];
	FormatEx(sQuery, sizeof(sQuery), "INSERT INTO `rp_appartments` (price, sold, playerID, maxinhabitants,buildingID,roomnumber) VALUES (%d, 0, 0, 1,0 ,1337)", price);
	SQL_TQuery(g_hSQL, SQL_AppartmentCreateCallback, sQuery, _, DBPrio_Normal);
}

public SQL_AppartmentCreateCallback(Handle:owner, Handle:hndl, const String:error[], any:userid)
{
	if (owner == INVALID_HANDLE || hndl == INVALID_HANDLE)
	{
		LogError("%s [%s] (SQL_AppartmentCreateCallback) %s", PL_PRE_N, PL_NAME, error);
	}
}

/*
Menu_DoorMain(client)
{
	new homeID = g_iHomeSelection[client];
	new playerID = RP_GetPlayerID(client);
	new access = GetPlayerAccess(playerID, homeID);
	
	new Handle:menu = CreateMenu(MenuHandler_DoorMain);
	SetMenuTitle(menu, "Door Menu for ");
	
	AddMenuItemEx(menu, false, "info", "Home Info");
	
	// Buy it! 
	if(!RP_IsHomeSold(homeID))
	{
		AddMenuItemEx(menu, false, "buy", "Buy for %d$", RP_GetHomePrice(homeID));
	}
	
	// You're welcome
	else if(access != -1)
	{
		// Guest 
		AddMenuItemEx(menu, false, "open", "Open");
		AddMenuItemEx(menu, false, "close", "Close");
		AddMenuItemEx(menu, false, "lock", "Lock");
		
		// Confidant 
		if(access <= 4)
			AddMenuItemEx(menu, false, "unlock", "Unlock");
		
		// Insider 
		if(access <= 3)
			AddMenuItemEx(menu, false, "door", "Door Manager");
		
		// Supporter 
		if(access <= 2)
			AddMenuItemEx(menu, false, "rent", "Pay Rent");
		
		// Keeper 
		if(access <= 1)
			AddMenuItemEx(menu, false, "access", "Access Manager");
		
		// Owner 
		if(access == 0)
			AddMenuItemEx(menu, false, "sell", "Sell Home");
	}
	
	// Knock knock ... 
	else
	{
		new owner = RP_GetHomePlayerID(homeID);
		new bool:bOnline = RP_GetClient(owner) != -1;
		new bool:bAtHome = false; new todo_check_at_home;
		
		new todo_check_player_at_home;
		
		//...it's the police
		if(RP_IsCop(client))
		{
			if(RP_GetCrime(owner) > HOUSE_SEARCH_MIN_CRIME)
			{
				if(bOnline)
				{
					AddMenuItemEx(menu, false, "house_search", "House Search");
					
					if(bAtHome)
					{
						AddMenuItemEx(menu, false, "flash", "Flash Assault");
						AddMenuItemEx(menu, false, "gas", "Gas Assault");
					}
				}
			}
		}
		// Break-In 
		else
		{
			AddMenuItemEx(menu, false, "crack", "Door Cracking");
		}
	}
}

public MenuHandler_DoorMain(Handle:menu, MenuAction:action, client, param2)
{
	if(0 >= client > MaxClients)
		return;
	
	if(!IsClientInGame(client))
		return;
	
	if(!IsPlayerAlive(client))
		return;
	
	if (action == MenuAction_Select)
	{
		decl String:info[100], String:info2[100];
		new bool:found = GetMenuItem(menu, param2, info, sizeof(info), _, info2, sizeof(info2));
		
		if(found)
		{
			new homeID = g_iHomeSelection[client];
			
			new todo_fix_fix_this_here;
			new entity = 0;
			
			if(!IsValidEntity(entity))
				return;
			
			// All 
			if(StrEqual(info, "info"))
			{
				new todo_display_door_info;
			}
			else if(StrEqual(info, "buy"))
			{
				if(RP_IsHomeSold(homeID))
				{
					CPrintToChat(client, "%s  home is already sold.", PL_PRE);
					return;
				}
				
				new todo_buy_home;
			}
			
			// Owner 
			else if(StrEqual(info, "open"))
			{
				AcceptEntityInput(entity, "open");
			}
			else if(StrEqual(info, "close"))
			{
				AcceptEntityInput(entity, "close");
			}
			else if(StrEqual(info, "lock"))
			{
				AcceptEntityInput(entity, "lock");
				CPrintToChat(client, "%s Door locked.", PL_PRE);
			}
			else if(StrEqual(info, "unlock"))
			{
				AcceptEntityInput(entity, "unlock");
				CPrintToChat(client, "%s Door unlocked.", PL_PRE);
			}
			else if(StrEqual(info, "door"))
			{
				new todo_display_door_mgr;
			}
			else if(StrEqual(info, "access"))
			{
				new todo_display_access_mgr;
			}
			else if(StrEqual(info, "sell"))
			{
				new todo_sell_home;
			}
			
			// Officer 
			else if(StrEqual(info, "house_search"))
			{
				AcceptEntityInput(entity, "kill");
				CPrintToChat(client, "%s Door kicked.", PL_PRE);
				new todo_balance_cops;
			}
			else if(StrEqual(info, "gas"))
			{
				new todo_gas_assault;
			}
			else if(StrEqual(info, "flash"))
			{
				new todo_flash_assault;
			}
			else if(StrEqual(info, "crack"))
			{
				new todo_display_door_crack_mgr;
			}
		}
	}
}
*/


SetAppartmentPlayerID(appartmentID, playerID)
{
	for (new i = 0; i < GetArraySize(g_hAppartments); i++)
	{
		new nNew[RP_Appartments];
		GetArrayArray(g_hAppartments, i, nNew[0]);
		
		if (nNew[Appartment_ID] == appartmentID)
		{
			nNew[Appartment_PlayerID] = playerID;
			SetArrayArray(g_hAppartments, i, nNew[0]);
			break;
		}
	}
	
	decl String:sQuery[2048];
	FormatEx(sQuery, sizeof(sQuery), "UPDATE `rp_appartments` SET playerID = %d WHERE appartmentID = %d", playerID, appartmentID);
	SQL_TQuery(g_hSQL, SQL_AppartmentUpdateCallback, sQuery, _);
}

SetAppartmentPrice(appartmentID, price)
{
	for (new i = 0; i < GetArraySize(g_hAppartments); i++)
	{
		new nNew[RP_Appartments];
		GetArrayArray(g_hAppartments, i, nNew[0]);
		
		if (nNew[Appartment_ID] == appartmentID)
		{
			nNew[Appartment_Price] = price;
			SetArrayArray(g_hAppartments, i, nNew[0]);
			break;
		}
	}
	
	decl String:sQuery[2048];
	FormatEx(sQuery, sizeof(sQuery), "UPDATE `rp_appartments` SET price = %d WHERE appartmentID = %d", price, appartmentID);
	SQL_TQuery(g_hSQL, SQL_AppartmentUpdateCallback, sQuery, _);
}

SetAppartmentMaxInh(appartmentID, new_max)
{
	for (new i = 0; i < GetArraySize(g_hAppartments); i++)
	{
		new nNew[RP_Appartments];
		GetArrayArray(g_hAppartments, i, nNew[0]);
		
		if (nNew[Appartment_ID] == appartmentID)
		{
			nNew[Appartment_MaxInh] = new_max;
			SetArrayArray(g_hAppartments, i, nNew[0]);
			break;
		}
	}
	
	decl String:sQuery[2048];
	FormatEx(sQuery, sizeof(sQuery), "UPDATE `rp_appartments` SET maxinhabitants = %d WHERE appartmentID = %d", new_max, appartmentID);
	SQL_TQuery(g_hSQL, SQL_AppartmentUpdateCallback, sQuery, _);
}

public SQL_AppartmentUpdateCallback(Handle:owner, Handle:hndl, const String:error[], any:userid)
{
	if (owner == INVALID_HANDLE || hndl == INVALID_HANDLE)
	{
		LogError("%s [%s] (SQL_AppartmentUpdateCallback) %s", PL_PRE_N, PL_NAME, error);
	}
}

SetAppartmentSold(appartmentID, bool:sold)
{
	decl String:sQuery[2048];
	FormatEx(sQuery, sizeof(sQuery), "UPDATE `rp_appartments` SET sold = %d WHERE appartmentID = %d", sold, appartmentID);
	SQL_TQuery(g_hSQL, SQL_AppartmentUpdateCallback, sQuery, _);
}

SetAppartmentbuildingID(appartmentID,new_buildingID)
{
	
	for (new i = 0; i < GetArraySize(g_hAppartments); i++)
	{
		new nNew[RP_Appartments];
		GetArrayArray(g_hAppartments, i, nNew[0]);
		
		if (nNew[Appartment_ID] == appartmentID)
		{
			nNew[Building_ID] = new_buildingID;
			SetArrayArray(g_hAppartments, i, nNew[0]);
			break;
		}
	}
	
	decl String:sQuery[2048];
	FormatEx(sQuery, sizeof(sQuery), "UPDATE `rp_appartments` SET buildingID = %d WHERE appartmentID = %d", new_buildingID, appartmentID);
	SQL_TQuery(g_hSQL, SQL_AppartmentUpdateCallback, sQuery, _);
}

SetAppartmentRoomnumber(appartmentID,new_roomnumber)
{	
	for (new i = 0; i < GetArraySize(g_hAppartments); i++)
	{
		new nNew[RP_Appartments];
		GetArrayArray(g_hAppartments, i, nNew[0]);
		
		if (nNew[Appartment_ID] == appartmentID)
		{
			nNew[Appartment_Roomnumber] = new_roomnumber;
			SetArrayArray(g_hAppartments, i, nNew[0]);
			break;
		}
	}
	
	decl String:sQuery[2048];
	FormatEx(sQuery, sizeof(sQuery), "UPDATE `rp_appartments` SET roomnumber = %d WHERE appartmentID = %d", new_roomnumber, appartmentID);
	SQL_TQuery(g_hSQL, SQL_AppartmentUpdateCallback, sQuery, _);
}

GetAppartmentID(playerID)
{
	for (new i = 0; i < GetArraySize(g_hAppartments); i++)
	{
		new nNew[RP_Appartments];
		GetArrayArray(g_hAppartments, i, nNew[0]);
		
		if (nNew[Appartment_PlayerID] == playerID)
		{
			return nNew[Appartment_ID];
		}
	}
	
	return -1;
}

GetAppartmentPlayerID(appartmentID)
{
	for (new i = 0; i < GetArraySize(g_hAppartments); i++)
	{
		new nNew[RP_Appartments];
		GetArrayArray(g_hAppartments, i, nNew[0]);
		
		if (nNew[Appartment_ID] == appartmentID)
		{
			return nNew[Appartment_PlayerID];
		}
	}
	
	return -1;
}

GetAppartmentPrice(appartmentID)
{
	for (new i = 0; i < GetArraySize(g_hAppartments); i++)
	{
		new nNew[RP_Appartments];
		GetArrayArray(g_hAppartments, i, nNew[0]);
		
		if (nNew[Appartment_ID] == appartmentID)
		{
			return nNew[Appartment_Price];
		}
	}
	
	return -1;
}

bool:IsAppartmentSold(appartmentID)
{
	for (new i = 0; i < GetArraySize(g_hAppartments); i++)
	{
		new nNew[RP_Appartments];
		GetArrayArray(g_hAppartments, i, nNew[0]);
		
		if (nNew[Appartment_ID] == appartmentID)
		{
			return nNew[Appartment_Sold];
		}
	}
	
	return false;
}

GetAppartmentMaxInh(appartmentID)
{
	for (new i = 0; i < GetArraySize(g_hAppartments); i++)
	{
		new nNew[RP_Appartments];
		GetArrayArray(g_hAppartments, i, nNew[0]);
		
		if (nNew[Appartment_ID] == appartmentID)
		{
			return nNew[Appartment_MaxInh];
		}
	}
	
	return -1;
}

GetAppartmentbuildingID(appartmentID)
{
	for (new i = 0; i < GetArraySize(g_hAppartments); i++)
	{
		new nNew[RP_Appartments];
		GetArrayArray(g_hAppartments, i, nNew[0]);
		
		if (nNew[Appartment_ID] == appartmentID)
		{
			return nNew[Building_ID];
		}
	}
	
	return -1;
}

GetAppartmentRoomnumber(appartmentID)
{
	for (new i = 0; i < GetArraySize(g_hAppartments); i++)
	{
		new nNew[RP_Appartments];
		GetArrayArray(g_hAppartments, i, nNew[0]);
		
		if (nNew[Appartment_ID] == appartmentID)
		{
			return nNew[Appartment_Roomnumber];
		}
	}
	
	return -1;
}

/* Player */

public RP_OnPlayerReady(client, playerID, bool:create)
{
	
}

/* Natives */

public Native_GetAppartmentCount(Handle:plugin, numParams)
{
	return GetArraySize(g_hAppartments);
}

public Native_GetAppartmentIDByIndex(Handle:plugin, numParams)
{
	new nNew[RP_Appartments];
	GetArrayArray(g_hAppartments, GetNativeCell(1), nNew[0]);
	return nNew[Appartment_ID];
}

public Native_GetAppartmentIDByPlayerID(Handle:plugin, numParams)
{
	return GetAppartmentID(GetNativeCell(1));
}

public Native_CreateAppartment(Handle:plugin, numParams)
{
	
	CreateAppartments(GetNativeCell(2), GetNativeCell(3), GetNativeCell(4));
}

public Native_DeleteAppartment(Handle:plugin, numParams)
{
	DeleteAppartment(GetNativeCell(1));
}

public Native_SetAppartmentPlayerID(Handle:plugin, numParams)
{
	SetAppartmentPlayerID(GetNativeCell(1), GetNativeCell(2));
}

public Native_GetAppartmentPlayerID(Handle:plugin, numParams)
{
	return GetAppartmentPlayerID(GetNativeCell(1));
}

public Native_GetAppartmentPrice(Handle:plugin, numParams)
{
	return GetAppartmentPrice(GetNativeCell(1));
}

public Native_GetAppartmentMaxInh(Handle:plugin, numParams)
{
	return GetAppartmentMaxInh(GetNativeCell(1));
}

public Native_GetAppartmentbuildingID(Handle:plugin, numParams)
{
	return GetAppartmentbuildingID(GetNativeCell(1));
}

public Native_GetAppartmentRoomnumber(Handle:plugin, numParams)
{
	return GetAppartmentRoomnumber(GetNativeCell(1));
}

public Native_SetAppartmentPrice(Handle:plugin, numParams)
{
	SetAppartmentPrice(GetNativeCell(1), GetNativeCell(2));
}

public Native_IsAppartmentSold(Handle:plugin, numParams)
{
	return IsAppartmentSold(GetNativeCell(1));
}

public Native_SetAppartmentSold(Handle:plugin, numParams)
{
	SetAppartmentSold(GetNativeCell(1), GetNativeCell(2));
}

public Native_SetAppartmentMaxInh(Handle:plugin, numParams)
{
	SetAppartmentMaxInh(GetNativeCell(1),GetNativeCell(2));
}

public Native_SetAppartmentbuildingID(Handle:plugin, numParams)
{
	SetAppartmentbuildingID(GetNativeCell(1),GetNativeCell(2));
}
public Native_SetAppartmentRoomnumber(Handle:plugin, numParams)
{
	SetAppartmentRoomnumber(GetNativeCell(1),GetNativeCell(2));
}