#include "roleplay/roleplay"

#define PL_NAME		"RP_BUILDING_CLUB_ACCESS"

new bool:g_LateLoaded;

/* Database */
new Handle:g_hSQL;

/* ADT ARRAY */
new nClubDoorAccessTeamplate[RP_ClubAccess];
new Handle:g_hClubDoorAccess = INVALID_HANDLE;

public Plugin:myinfo = 
{
	name = PL_NAME,
	author = PL_AUTHOR,
	description = "",
	version = PL_VERSION,
	url = PL_URL
}

public APLRes:AskPluginLoad2(Handle:myself, bool:late, String:error[], err_max)
{
	g_LateLoaded = late;
	RegPluginLibrary(PL_NAME);
	
	CreateNative("RP_GetPlayerClubAccess", Native_GetPlayerClubAccess);
	CreateNative("RP_SetPlayerClubAccess", Native_SetPlayerClubAccess);
	
	return APLRes_Success;
}

public OnPluginStart()
{
	g_hClubDoorAccess = CreateArray(sizeof(nClubDoorAccessTeamplate));
	nClubDoorAccessTeamplate[ClubAccess_PlayerID] = 0;
	
	if(g_LateLoaded)
	{
		g_hSQL = Handle:RP_GetSql();
		
		if(g_hSQL != INVALID_HANDLE)
			SQLConnectionReady();
		
		g_LateLoaded = false;
	}
	
	decl String:sQuery[2048];
	
	Format(sQuery, sizeof(sQuery), "CREATE TABLE IF NOT EXISTS `rp_building_Club_doors` (  `PlayerID` int(10) NOT NULL, `BuildingID` int(10) NOT NULL, `AccessID` int(10) NOT NULL, PRIMARY KEY (`PlayerID`,`BuildingID`)) ENGINE=InnoDB DEFAULT CHARSET=utf8;");
	LogMessage("%s [%s] Query: %s", PL_PRE_N, PL_NAME, sQuery);
	SQL_TQuery(g_hSQL, SQL_CreateTableCallback, sQuery, _, DBPrio_High);
	
	ResetClubDoorAccess();
	LoadClubDoorAccess();
}

public SQL_CreateTableCallback(Handle:owner, Handle:hndl, const String:error[], any:data)
{
	if (owner == INVALID_HANDLE || hndl == INVALID_HANDLE)
	{
		LogError("%s [%s] (SQL_CreateTableCallback) %s", PL_PRE_N, PL_NAME, error);
	}
}

ResetClubDoorAccess()
{
	ClearArray(g_hClubDoorAccess);
	g_hClubDoorAccess = CreateArray(sizeof(nClubDoorAccessTeamplate));
}

LoadClubDoorAccess()
{
	decl String:sQuery[2048];
	Format(sQuery, sizeof(sQuery), "SELECT `PlayerID`, `AccessID`, `BuildingID` FROM `rp_building_Club_doors`;");
	SQL_TQuery(g_hSQL, SQL_LoadClubDoorAccessCallback, sQuery, _, DBPrio_Low);
}

public SQL_LoadClubDoorAccessCallback(Handle:owner, Handle:hndl, const String:error[], any:data)
{
	if (owner == INVALID_HANDLE || hndl == INVALID_HANDLE)
	{
		LogError("%s [%s] (SQL_LoadClubDoorAccessCallback) %s", PL_PRE_N, PL_NAME, error);
	}
	
	while (SQL_FetchRow(hndl))
	{
		new nNew[RP_ClubAccess];
		
		nNew[ClubAccess_PlayerID] = SQL_FetchInt(hndl, 0);
		nNew[ClubAccess_AccessID] = SQL_FetchInt(hndl, 1);
		nNew[ClubAccess_BuildingID] = SQL_FetchInt(hndl, 2);
		
		PushArrayArray(g_hClubDoorAccess, nNew[0]);
	}
}

public RP_OnSqlConnected(Handle:db)
{
	g_hSQL = db;
	SQLConnectionReady();
}

public RP_OnSqlStop()
{
	g_hSQL = INVALID_HANDLE;
}

SQLConnectionReady()
{
	//Database is now ready to use
}

public RP_OnPlayerReady(client, playerID, bool:create)
{
	//PlayerID is now cached
}

public RP_OnDoorUse(doorID,type,client)
{
	if(0 >= client || client > MaxClients + 1)
		return;
	
	if(!IsClientInGame(client))
		return;
	
	if(!IsPlayerAlive(client))
		return;
	
	if(type == Door_Club)
	{
		
	}
}

GetPlayerClubAccess(client, buildingID)
{
	if(0 >= client || client > MaxClients + 1)
		return -1;
	
	if(!IsClientInGame(client))
		return -1;
	
	if(!IsPlayerAlive(client))
		return -1;
	
	new playerID = RP_GetPlayerID(client);
	
	for (new i = 0; i < GetArraySize(g_hClubDoorAccess); i++)
	{
		new nNew[RP_ClubAccess];
		GetArrayArray(g_hClubDoorAccess, i, nNew[0]);
		
		if (nNew[ClubAccess_PlayerID] == playerID && nNew[BankAccess_BuildingID] == buildingID)
		{
			return nNew[ClubAccess_AccessID];
		}
	}
	
	return -1;

}

SetPlayerClubAccess(client, buildingID, new_accessID)
{
	if(0 >= client || client > MaxClients + 1)
		return;
	
	if(!IsClientInGame(client))
		return;
	
	if(!IsPlayerAlive(client))
		return;
	
	new playerID = RP_GetPlayerID(client);
	new bool:insert = true;
	
	for (new i = 0; i < GetArraySize(g_hClubDoorAccess); i++)
	{
		new nNew[RP_ClubAccess];
		GetArrayArray(g_hClubDoorAccess, i, nNew[0]);
		
		if (nNew[ClubAccess_PlayerID] == playerID && nNew[BankAccess_BuildingID] == buildingID)
		{
			nNew[ClubAccess_AccessID] = new_accessID;
			SetArrayArray(g_hClubDoorAccess, i, nNew[0]); 
			insert = false;
		}
	}
	
	if(insert)
	{
		decl String:sQuery[2048];
	
		Format(sQuery, sizeof(sQuery), "INSERT INTO `rp_building_Club_doors` ( PlayerID, BuildingID , AccessID) VALUES (%d, %d, %d);",playerID, buildingID,new_accessID);
		LogMessage("%s [%s] Query: %s", PL_PRE_N, PL_NAME, sQuery);
		SQL_TQuery(g_hSQL, SQL_InsertPlayerClubAccessTableCallback, sQuery, _, DBPrio_High);
	}
}

public SQL_InsertPlayerClubAccessTableCallback(Handle:owner, Handle:hndl, const String:error[], any:data)
{
	if (owner == INVALID_HANDLE || hndl == INVALID_HANDLE)
	{
		LogError("%s [%s] (SQL_InsertPlayerClubAccessTableCallback) %s", PL_PRE_N, PL_NAME, error);
	}
}

public Native_GetPlayerClubAccess(Handle:plugin, numParams)
{
	return GetPlayerClubAccess(GetNativeCell(1),GetNativeCell(2));
}

public Native_SetPlayerClubAccess(Handle:plugin, numParams)
{
	SetPlayerClubAccess(GetNativeCell(1),GetNativeCell(2),GetNativeCell(3));
}