#include "roleplay/roleplay"

#define PL_NAME		"RP_BUILDING_SHOP_ACCESS"

new bool:g_LateLoaded;

/* Database */
new Handle:g_hSQL;

/* ADT ARRAY */
new nShopDoorAccessTeamplate[RP_ShopAccess];
new Handle:g_hShopDoorAccess = INVALID_HANDLE;

public Plugin:myinfo = 
{
	name = PL_NAME,
	author = PL_AUTHOR,
	description = "",
	version = PL_VERSION,
	url = PL_URL
}

public APLRes:AskPluginLoad2(Handle:myself, bool:late, String:error[], err_max)
{
	g_LateLoaded = late;
	RegPluginLibrary(PL_NAME);
	
	CreateNative("RP_GetPlayerShopAccess", Native_GetPlayerShopAccess);
	CreateNative("RP_SetPlayerShopAccess", Native_SetPlayerShopAccess);
	
	return APLRes_Success;
}

public OnPluginStart()
{
	g_hShopDoorAccess = CreateArray(sizeof(nShopDoorAccessTeamplate));
	nShopDoorAccessTeamplate[ShopAccess_PlayerID] = 0;
	
	if(g_LateLoaded)
	{
		g_hSQL = Handle:RP_GetSql();
		
		if(g_hSQL != INVALID_HANDLE)
			SQLConnectionReady();
		
		g_LateLoaded = false;
	}
	
	decl String:sQuery[2048];
	
	Format(sQuery, sizeof(sQuery), "CREATE TABLE IF NOT EXISTS `rp_building_Shop_doors` (  `PlayerID` int(10) NOT NULL, `BuildingID` int(10) NOT NULL, `AccessID` int(10) NOT NULL, PRIMARY KEY (`PlayerID`,`BuildingID`)) ENGINE=InnoDB DEFAULT CHARSET=utf8;");
	LogMessage("%s [%s] Query: %s", PL_PRE_N, PL_NAME, sQuery);
	SQL_TQuery(g_hSQL, SQL_CreateTableCallback, sQuery, _, DBPrio_High);
	
	ResetShopDoorAccess();
	LoadShopDoorAccess();
}

public SQL_CreateTableCallback(Handle:owner, Handle:hndl, const String:error[], any:data)
{
	if (owner == INVALID_HANDLE || hndl == INVALID_HANDLE)
	{
		LogError("%s [%s] (SQL_CreateTableCallback) %s", PL_PRE_N, PL_NAME, error);
	}
}

ResetShopDoorAccess()
{
	ClearArray(g_hShopDoorAccess);
	g_hShopDoorAccess = CreateArray(sizeof(nShopDoorAccessTeamplate));
}

LoadShopDoorAccess()
{
	decl String:sQuery[2048];
	Format(sQuery, sizeof(sQuery), "SELECT `PlayerID`, `AccessID`, `BuildingID` FROM `rp_building_Shop_doors`;");
	SQL_TQuery(g_hSQL, SQL_LoadShopDoorAccessCallback, sQuery, _, DBPrio_Low);
}

public SQL_LoadShopDoorAccessCallback(Handle:owner, Handle:hndl, const String:error[], any:data)
{
	if (owner == INVALID_HANDLE || hndl == INVALID_HANDLE)
	{
		LogError("%s [%s] (SQL_LoadShopDoorAccessCallback) %s", PL_PRE_N, PL_NAME, error);
	}
	
	while (SQL_FetchRow(hndl))
	{
		new nNew[RP_ShopAccess];
		
		nNew[ShopAccess_PlayerID] = SQL_FetchInt(hndl, 0);
		nNew[ShopAccess_AccessID] = SQL_FetchInt(hndl, 1);
		nNew[ShopAccess_BuildingID] = SQL_FetchInt(hndl, 2);
		
		PushArrayArray(g_hShopDoorAccess, nNew[0]);
	}
}

public RP_OnSqlConnected(Handle:db)
{
	g_hSQL = db;
	SQLConnectionReady();
}

public RP_OnSqlStop()
{
	g_hSQL = INVALID_HANDLE;
}

SQLConnectionReady()
{
	//Database is now ready to use
}

public RP_OnPlayerReady(client, playerID, bool:create)
{
	//PlayerID is now cached
}

public RP_OnDoorUse(doorID,type,client)
{
	if(0 >= client || client > MaxClients + 1)
		return;
	
	if(!IsClientInGame(client))
		return;
	
	if(!IsPlayerAlive(client))
		return;
	
	if(type == Door_Shop)
	{
		
	}
}

GetPlayerShopAccess(client, buildingID)
{
	if(0 >= client || client > MaxClients + 1)
		return -1;
	
	if(!IsClientInGame(client))
		return -1;
	
	if(!IsPlayerAlive(client))
		return -1;
	
	new playerID = RP_GetPlayerID(client);
	
	for (new i = 0; i < GetArraySize(g_hShopDoorAccess); i++)
	{
		new nNew[RP_ShopAccess];
		GetArrayArray(g_hShopDoorAccess, i, nNew[0]);
		
		if (nNew[ShopAccess_PlayerID] == playerID && nNew[BankAccess_BuildingID] == buildingID)
		{
			return nNew[ShopAccess_AccessID];
		}
	}
	
	return -1;

}

SetPlayerShopAccess(client, buildingID, new_accessID)
{
	if(0 >= client || client > MaxClients + 1)
		return;
	
	if(!IsClientInGame(client))
		return;
	
	if(!IsPlayerAlive(client))
		return;
	
	new playerID = RP_GetPlayerID(client);
	new bool:insert = true;
	
	for (new i = 0; i < GetArraySize(g_hShopDoorAccess); i++)
	{
		new nNew[RP_ShopAccess];
		GetArrayArray(g_hShopDoorAccess, i, nNew[0]);
		
		if (nNew[ShopAccess_PlayerID] == playerID && nNew[BankAccess_BuildingID] == buildingID)
		{
			nNew[ShopAccess_AccessID] = new_accessID;
			SetArrayArray(g_hShopDoorAccess, i, nNew[0]); 
			insert = false;
		}
	}
	
	if(insert)
	{
		decl String:sQuery[2048];
	
		Format(sQuery, sizeof(sQuery), "INSERT INTO `rp_building_Shop_doors` ( PlayerID, BuildingID , AccessID) VALUES (%d, %d, %d);",playerID, buildingID,new_accessID);
		LogMessage("%s [%s] Query: %s", PL_PRE_N, PL_NAME, sQuery);
		SQL_TQuery(g_hSQL, SQL_InsertPlayerShopAccessTableCallback, sQuery, _, DBPrio_High);
	}
}

public SQL_InsertPlayerShopAccessTableCallback(Handle:owner, Handle:hndl, const String:error[], any:data)
{
	if (owner == INVALID_HANDLE || hndl == INVALID_HANDLE)
	{
		LogError("%s [%s] (SQL_InsertPlayerShopAccessTableCallback) %s", PL_PRE_N, PL_NAME, error);
	}
}

public Native_GetPlayerShopAccess(Handle:plugin, numParams)
{
	return GetPlayerShopAccess(GetNativeCell(1),GetNativeCell(2));
}

public Native_SetPlayerShopAccess(Handle:plugin, numParams)
{
	SetPlayerShopAccess(GetNativeCell(1),GetNativeCell(2),GetNativeCell(3));
}