#include "roleplay/roleplay"

#define PL_NAME		"RP_CRIME"

#define INTERVAL 1.0
#define INTERVAL2 60.0

#define CRIME_KILL_COP 1000
#define CRIME_KILL_CIVILIAN 500

#define CRIME_HURT_COP 200
#define CRIME_HURT_CIVILIAN 100

new bool:g_LateLoaded;

/* Database */
new Handle:g_hSQL;

public g_iCrime[MAXPLAYERS+1];
public g_iCrimeMax[MAXPLAYERS+1];
public g_iLastCrime[MAXPLAYERS+1];
public g_iLastCrimeRemoval[MAXPLAYERS+1];
public g_iBounty[MAXPLAYERS+1];
public g_iBountyMax[MAXPLAYERS+1];

public Plugin:myinfo = 
{
	name = PL_NAME,
	author = PL_AUTHOR,
	description = "",
	version = PL_VERSION,
	url = PL_URL
}

public APLRes:AskPluginLoad2(Handle:myself, bool:late, String:error[], err_max)
{
	g_LateLoaded = late;
	RegPluginLibrary(PL_NAME);
	
	CreateNative("RP_GetCrime", Native_GetCrime);
	CreateNative("RP_AddCrime", Native_AddCrime);
	CreateNative("RP_TakeCrime", Native_TakeCrime);
	CreateNative("RP_ResetCrime", Native_ResetCrime);
	
	CreateNative("RP_GetLastCrime", Native_GetLastCrime);
	CreateNative("RP_GetLastCrimeRemoval", Native_GetLastCrimeRemoval);
	
	CreateNative("RP_GetBounty", Native_GetBounty);
	CreateNative("RP_ResetBounty", Native_ResetBounty);
	CreateNative("RP_AddBounty", Native_AddBounty);
	CreateNative("RP_TakeBounty", Native_TakeBounty);
	
	CreateNative("RP_GetMaxCrime", Native_GetMaxCrime);
	CreateNative("RP_GetMaxBounty", Native_GetMaxBounty);
	
	return APLRes_Success;
}

public OnPluginStart()
{
	if(g_LateLoaded)
	{
		g_hSQL = Handle:RP_GetSql();
		
		if(g_hSQL != INVALID_HANDLE)
			SQLConnectionReady();
		
		g_LateLoaded = false;
	}
	
	CreateTimer(INTERVAL, Timer_CrimeExpire, _, TIMER_REPEAT);
	CreateTimer(INTERVAL2, Timer_SaveCrime, _, TIMER_REPEAT);
}

public RP_OnSqlConnected(Handle:db)
{
	g_hSQL = db;
	SQLConnectionReady();
}

public RP_OnSqlStop()
{
	g_hSQL = INVALID_HANDLE;
}

SQLConnectionReady()
{
	decl String:sQuery[2048];
	Format(sQuery, sizeof(sQuery), "CREATE TABLE IF NOT EXISTS `rp_crime` (`playerID` int(10) NOT NULL, `crime` int(11) NOT NULL, `max_crime` int(11) NOT NULL, `last_crime` int(11) NOT NULL, `last_crime_removal` int(11) NOT NULL, `bounty` int(11) NOT NULL, `max_bounty` int(11) NOT NULL, PRIMARY KEY (`playerID`)) ENGINE=InnoDB DEFAULT CHARSET=utf8;");
	LogMessage("%s [%s] Query: %s", PL_PRE_N, PL_NAME, sQuery);
	SQL_TQuery(g_hSQL, SQL_CreateTableCallback, sQuery, _, DBPrio_High);
	
	Format(sQuery, sizeof(sQuery), "CREATE TABLE IF NOT EXISTS `rp_crimes` (`crimeID` int(10) NOT NULL AUTO_INCREMENT, `playerID` int(10) NOT NULL, `crime` int(10) NOT NULL, `type` varchar(128) NOT NULL, `date` int(11) NOT NULL, PRIMARY KEY (`crimeID`)) ENGINE=InnoDB DEFAULT CHARSET=utf8;");
	LogMessage("%s [%s] Query: %s", PL_PRE_N, PL_NAME, sQuery);
	SQL_TQuery(g_hSQL, SQL_CreateTableCallback, sQuery, _, DBPrio_High);
}

public SQL_CreateTableCallback(Handle:owner, Handle:hndl, const String:error[], any:data)
{
	if (owner == INVALID_HANDLE || hndl == INVALID_HANDLE)
	{
		LogError("%s [%s] (SQL_CreateTableCallback) %s", PL_PRE_N, PL_NAME, error);
	}
}

public OnClientDisconnect(client)
{
	SavePlayer(client);
	g_iCrime[client] = 0;
	g_iCrimeMax[client] = 0;
	g_iLastCrime[client] = 0;
	g_iLastCrimeRemoval[client] = 0;
	g_iBounty[client] = 0;
	g_iBountyMax[client] = 0;
}

public RP_OnPlayerReady(client, playerID, bool:create)
{
	if(create)
	{
		decl String:sQuery[2048];
		FormatEx(sQuery, sizeof(sQuery), "INSERT INTO `rp_crime` (playerID, crime, max_crime, last_crime, last_crime_removal, bounty, max_bounty) VALUES (%d, 0, 0, 0, 0, 0, 0)", playerID);
		SQL_TQuery(g_hSQL, SQL_ClientCreateCallback, sQuery, GetClientUserId(client), DBPrio_Normal);
	}
	
	LoadPlayer(client);
}

public SQL_ClientCreateCallback(Handle:owner, Handle:hndl, const String:error[], any:userid)
{
	if (owner == INVALID_HANDLE || hndl == INVALID_HANDLE)
	{
		LogError("%s [%s] (SQL_ClientCreateCallback) %s", PL_PRE_N, PL_NAME, error);
	}
}

LoadPlayer(client)
{
	decl String:sQuery[2048];
	Format(sQuery, sizeof(sQuery), "SELECT `crime`,`max_crime`,`last_crime`, last_crime_removal,`bounty`, `max_bounty` FROM `rp_crime` WHERE `playerID` = %d", RP_GetPlayerID(client));
	SQL_TQuery(g_hSQL, SQL_ClientLoadCallback, sQuery, GetClientUserId(client), DBPrio_Low);
}

public SQL_ClientLoadCallback(Handle:owner, Handle:hndl, const String:error[], any:userid)
{
	if (owner == INVALID_HANDLE || hndl == INVALID_HANDLE)
	{
		LogError("%s [%s] (SQL_ClientConnectCallback) %s", PL_PRE_N, PL_NAME, error);
	}

	new client = GetClientOfUserId(userid);
	if(!client || !IsClientInGame(client))
		return;
	
	if(SQL_GetRowCount(hndl))
	{
		SQL_FetchRow(hndl);
		g_iCrime[client] = SQL_FetchInt(hndl, 0);
		g_iCrimeMax[client] = SQL_FetchInt(hndl, 1);
		g_iLastCrime[client] = SQL_FetchInt(hndl, 2);
		g_iLastCrimeRemoval[client] = SQL_FetchInt(hndl, 3);
		g_iBounty[client] = SQL_FetchInt(hndl, 4);
		g_iBountyMax[client] = SQL_FetchInt(hndl, 5);
	}
}

SavePlayer(client)
{
	decl String:sQuery[2048];
	FormatEx(sQuery, sizeof(sQuery), "UPDATE `rp_crime` SET `crime` = %d, `last_crime` = %d, `last_crime_removal` = %d, `bounty` = %d, `max_bounty` = %d WHERE `playerID` = %d", g_iCrime[client], g_iLastCrime[client], g_iLastCrimeRemoval[client], g_iBounty[client], g_iBountyMax[client], RP_GetPlayerID(client));
	SQL_TQuery(g_hSQL, SQL_ClientUpdateCallback, sQuery, GetClientUserId(client), DBPrio_Low);
 }

public SQL_ClientUpdateCallback(Handle:owner, Handle:hndl, const String:error[], any:userid)
{
	if (owner == INVALID_HANDLE || hndl == INVALID_HANDLE)
	{
		LogError("%s [%s] (SQL_ClientUpdateCallback) %s", PL_PRE_N, PL_NAME, error);
	}
}

LogCrime(playerID, crime, String:sType[128])
{
	decl String:sQuery[2048];
	FormatEx(sQuery, sizeof(sQuery), "INSERT INTO `rp_crimes` (playerID, crime, type, date) VALUES (%d, %d, '%s', %d)", playerID, crime, sType, GetTime());
	SQL_TQuery(g_hSQL, SQL_LogCrimeCallback, sQuery, _, DBPrio_Normal);
}

public SQL_LogCrimeCallback(Handle:owner, Handle:hndl, const String:error[], any:data)
{
	if (owner == INVALID_HANDLE || hndl == INVALID_HANDLE)
	{
		LogError("%s [%s] (SQL_LogCrimeCallback) %s", PL_PRE_N, PL_NAME, error);
	}
}

/* Reduce crime each interval */
public Action:Timer_CrimeExpire(Handle:timer, any:data)
{
	if(g_hSQL == INVALID_HANDLE)
		return Plugin_Continue;
		
	for (new client = 1; client < MAXPLAYERS ; client++)
	{
		if (!IsClientInGame(client))
			continue;
		
		if (!IsPlayerAlive(client))
			continue;
		
		if (GetClientTeam(client) != CS_TEAM_T)
			continue;
		
		if (RP_GetCrime(client) <= 0)
			continue;
		
		if(RP_TakeCrime(client, 1) == 0)
			g_iLastCrimeRemoval[client] = GetTime();
	}
	
	return Plugin_Continue;
}

public Action:Timer_SaveCrime(Handle:timer, any:data)
{
	if(g_hSQL == INVALID_HANDLE)
		return Plugin_Continue;
	
	for (new client = 1; client < MAXPLAYERS ; client++)
	{
		if (!IsClientInGame(client))
			continue;
		
		if (!IsPlayerAlive(client))
			continue;
		
		if (GetClientTeam(client) != CS_TEAM_T)
			continue;
		
		SavePlayer(client);
	}
	
	return Plugin_Continue;
}

/* Crime Events */

public RP_OnUseItem(client, itemID, itemType)
{
	/* Add crime for using this item */
	new crime = RP_GetItemCrimeUse(itemID);
	if(crime > 0)
	{
		decl String:sBuffer[128];
		RP_GetItemName(itemID, sBuffer, sizeof(sBuffer));
		Format(sBuffer, sizeof(sBuffer), "Used item %s", sBuffer);
		RP_AddCrime(client, crime, sBuffer);
	}
}

public RP_OnPlayerKilled(victim, attacker)
{
	/* Cops don't get crime for this */
	if(GetClientTeam(attacker) == CS_TEAM_T)
	{
		/* You killed a cop omg */
		if(GetClientTeam(victim) == CS_TEAM_CT)
		{
			RP_AddCrime(attacker, CRIME_KILL_COP, "Killed Cop");
		}
		else RP_AddCrime(attacker, CRIME_KILL_CIVILIAN, "Killed Civilian");
	}
}

public RP_OnPlayerHurt(victim, attacker)
{
	/* Cops don't get crime for this */
	if(GetClientTeam(attacker) == CS_TEAM_T)
	{
		/* You shot a cop omg */
		if(GetClientTeam(victim) == CS_TEAM_CT)
		{
			RP_AddCrime(attacker, CRIME_HURT_COP, "Hurt Cop");
		}
		else RP_AddCrime(attacker, CRIME_HURT_CIVILIAN, "Hurt Civilian");
	}
}

/* Natives */

public Native_GetCrime(Handle:plugin, numParams)
{
	return g_iCrime[GetNativeCell(1)];
}

public Native_AddCrime(Handle:plugin, numParams)
{
	new client = GetNativeCell(1);
	new amount = GetNativeCell(2);
	g_iCrime[client] += amount;
	
	new String:sType[128];
	GetNativeString(3, sType, 128);
	
	if(g_iCrime[client] > g_iCrimeMax[client])
		g_iCrimeMax[client] = g_iCrime[client];
	
	g_iLastCrime[client] = GetTime();
	LogCrime(RP_GetPlayerID(client), amount, sType);
	
	return g_iCrime[client];
}

public Native_TakeCrime(Handle:plugin, numParams)
{
	new client = GetNativeCell(1);
	g_iCrime[client] -= GetNativeCell(2);
	
	if(g_iCrime[client] < 0)
		g_iCrime[client] = 0;
	
	return g_iCrime[client];
}

public Native_ResetCrime(Handle:plugin, numParams)
{
	new client = GetNativeCell(1);
	
	new crimebuff = g_iCrime[client];
	
	g_iCrime[client] = 0;
	g_iLastCrimeRemoval[client] = GetTime();
	
	return crimebuff;
}

public Native_GetLastCrime(Handle:plugin, numParams)
{
	return g_iLastCrime[GetNativeCell(1)];
}

public Native_GetLastCrimeRemoval(Handle:plugin, numParams)
{
	return g_iLastCrimeRemoval[GetNativeCell(1)];
}

public Native_GetBounty(Handle:plugin, numParams)
{
	return g_iBounty[GetNativeCell(1)];
}

public Native_ResetBounty(Handle:plugin, numParams)
{
	new client = GetNativeCell(1);
	g_iBounty[client] = 0;
}

public Native_AddBounty(Handle:plugin, numParams)
{
	new client = GetNativeCell(1);
	g_iBounty[client] += GetNativeCell(2);
	
	if(g_iBounty[client] > g_iBountyMax[client])
		g_iBountyMax[client] = g_iBounty[client];
	
	return g_iBounty[client];
}

public Native_TakeBounty(Handle:plugin, numParams)
{
	new client = GetNativeCell(1);
	g_iBounty[client] -= GetNativeCell(2);
	
	if(g_iBounty[client] > g_iBountyMax[client])
		g_iBountyMax[client] = g_iBounty[client];
	
	return g_iBounty[client];
}

public Native_GetMaxCrime(Handle:plugin, numParams)
{
	return g_iCrimeMax[GetNativeCell(1)];
}

public Native_GetMaxBounty(Handle:plugin, numParams)
{
	return g_iBountyMax[GetNativeCell(1)];
}