#include "roleplay/roleplay"

#define PL_NAME		"RP_Doors"

#define DOORS_SEARCH_OFFSET 40.0;

new bool:g_LateLoaded;

/* Database */
new Handle:g_hSQL;

new nDoorTeamplate[RP_Doors];
new Handle:g_hDoors = INVALID_HANDLE;

new Handle:g_OnDoorUse = INVALID_HANDLE;

new nDoor_SetUpHelperTeamplate[Door_SetUpHelper];
new Handle:g_hDoor_SetUpHelper = INVALID_HANDLE;

new bool:g_bMapLoaded = false;

new g_iPrevButtons[MAXPLAYERS+1];

public Plugin:myinfo = 
{
	name = PL_NAME,
	author = PL_AUTHOR,
	description = "",
	version = PL_VERSION,
	url = PL_URL
}

public APLRes:AskPluginLoad2(Handle:myself, bool:late, String:error[], err_max)
{
	g_LateLoaded = late;
	RegPluginLibrary(PL_NAME);
	
	g_OnDoorUse = CreateGlobalForward("RP_OnDoorUse", ET_Event, Param_Cell, Param_Cell, Param_Cell);
	
	CreateNative("RP_IsValidDoorEnt", Native_IsValidDoorEnt);
	
	CreateNative("RP_GetDoorIDbyEntity", Native_GetDoorIDbyEntity);
	CreateNative("RP_IsDoorEntityRegistered", Native_IsDoorEntityRegistered);
	
	CreateNative("RP_OpenDoor", Native_OpenDoor);
	CreateNative("RP_CloseDoor", Native_CloseDoor);
	CreateNative("RP_LockDoor", Native_LockDoor);
	CreateNative("RP_UnlockDoor", Native_UnlockDoor);
	
	CreateNative("RP_OpenDoorByEntity", Native_OpenDoorByEntity);
	CreateNative("RP_CloseDoorByEntity", Native_CloseDoorByEntity);
	CreateNative("RP_LockDoorByEntity", Native_LockDoorByEntity);
	CreateNative("RP_UnlockDoorByEntity", Native_UnlockDoorByEntity);
	
	CreateNative("RP_GetDoorCount", Native_GetDoorCount);
	CreateNative("RP_GetDoorIDByArrayIndex", Native_GetDoorIDByArrayIndex);
	
	CreateNative("RP_GetDoorAlarmID", Native_GetDoorAlarmID);
	CreateNative("RP_GetDoorName", Native_GetDoorName);
	CreateNative("RP_GetDoorLockID", Native_GetDoorLockID);
	CreateNative("RP_GetDoorScannerID", Native_GetDoorScannerID);
	CreateNative("RP_GetDoorSensorID", Native_GetDoorSensorID);
	CreateNative("RP_GetDoorTrapID", Native_GetDoorTrapID);
	CreateNative("RP_GetDoorType", Native_GetDoorType);
	CreateNative("RP_GetDoorBuildingID", Native_GetDoorBuildingID);
	
	CreateNative("RP_IsDoorLockedDefault", Native_IsDoorLockedDefault);
	CreateNative("RP_IsDoorLocked", Native_IsDoorLocked);
	
	CreateNative("RP_SetDoorAlarmID", Native_SetDoorAlarmID);
	CreateNative("RP_SetDoorName", Native_SetDoorName);
	CreateNative("RP_SetDoorLockID", Native_SetDoorLockID);
	CreateNative("RP_SetDoorScannerID", Native_SetDoorScannerID);
	CreateNative("RP_SetDoorSensorID", Native_SetDoorSensorID);
	CreateNative("RP_SetDoorTrapID", Native_SetDoorTrapID);
	CreateNative("RP_SetDoorType", Native_GetDoorType);
	CreateNative("RP_SetDoorBuildingID", Native_GetDoorBuildingID);
	CreateNative("RP_SetDoorLockedDefault", Native_SetDoorLockedDefault);
	
	CreateNative("RP_ResetDoor", Native_ResetDoor);
	
	return APLRes_Success;
}

SQLConnectionReady()
{
	decl String:sQuery[2048];
	
	Format(sQuery, sizeof(sQuery), "CREATE TABLE IF NOT EXISTS `rp_door` (`doorID` int(10) NOT NULL,  `alarmID` int(10) NOT NULL, `lockID` int(10) NOT NULL, `ScannerID` int(10)  NOT NULL, `SensorID` int(10) NOT NULL, `TrapID` int(10) NOT NULL, `LocksAmount` int(10) NOT NULL, `DoorName` varchar(128) UNIQUE NOT NULL, `x` float NOT NULL, `y` float NOT NULL, `z` float NOT NULL,`DoorType` int(10) NOT NULL,`BuildingID` int(10) NOT NULL, `LockDefault` BOOL NOT NULL DEFAULT '0', PRIMARY KEY (`doorID`)) ENGINE=InnoDB DEFAULT CHARSET=utf8;");
	LogMessage("%s [%s] Query: %s", PL_PRE_N, PL_NAME, sQuery);
	SQL_TQuery(g_hSQL, SQL_CreateTableCallback, sQuery, _, DBPrio_High);
	
	ResetDoors();
	LoadDoors();
}

public Action:OnRoundStart(Handle:event, const String:name[], bool:dontBroadcast)
{
	CreateTimer(5.0, Timer_SetUpDoorRoundstart);
}

public Action:Timer_SetUpDoorRoundstart(Handle:timer)
{
	SetUpDoorRoundstart();
	return Plugin_Handled;
}

SetUpDoorRoundstart()
{
	new nNew[RP_Doors];
	
	for (new i = 0; i < RP_GetDoorCount(); i++)
	{
		GetArrayArray(g_hDoors, i, nNew[0]);
		if(RP_IsValidDoorEnt(nNew[Door_Entity]))
		{
			if(!nNew[Door_IsLockedDefault])
				RP_LockDoor(nNew[Door_ID]);
		}
	}
}

public OnMapStart()
{
	g_bMapLoaded = true;
	
	LockAllDoors();
}

public OnMapEnd()
{
	g_bMapLoaded = false;
}

public OnPluginStart()
{	
	// Init ADT array
	g_hDoors = CreateArray(sizeof(nDoorTeamplate));
	nDoorTeamplate[Door_ID] = 0;
	
	g_hDoor_SetUpHelper = CreateArray(sizeof(nDoor_SetUpHelperTeamplate));
	nDoor_SetUpHelperTeamplate[Entity] = 0;	
	
	if(g_LateLoaded)
	{
		g_hSQL = Handle:RP_GetSql();
		
		if(g_hSQL != INVALID_HANDLE)
			SQLConnectionReady();
		
		g_LateLoaded = false;
	}
	
	HookEvent("round_start", OnRoundStart);
}

public SQL_CreateTableCallback(Handle:owner, Handle:hndl, const String:error[], any:data)
{
	if (owner == INVALID_HANDLE || hndl == INVALID_HANDLE)
	{
		LogError("%s [%s] (SQL_CreateTableCallback) %s", PL_PRE_N, PL_NAME, error);
	}
}

ResetDoors()
{
	ClearArray(g_hDoors);
	g_hDoors = CreateArray(sizeof(nDoorTeamplate));
}

LoadDoors()
{
	LogMessage("---LoadDoors Start---");
	if(g_bMapLoaded)
	{
		decl String:sQuery[2048];
		Format(sQuery, sizeof(sQuery), "SELECT `doorID`,`alarmID`,`lockID`,`ScannerID`,`SensorID`,`TrapID`,`LocksAmount`,`DoorName`,`x`,`y`,`z`,`DoorType`,`BuildingID`,`LockDefault` FROM `rp_door`;");
		SQL_TQuery(g_hSQL, SQL_LoadDoorsCallback, sQuery, _, DBPrio_Low);
	}
	else
	{
		LogMessage("---LoadDoors Timer---");
		CreateTimer(1.0, Timer_LoadDoors);
	}
}

public Action:Timer_LoadDoors(Handle:timer)
{
	LoadDoors();
	return Plugin_Handled;
}

public SQL_LoadDoorsCallback(Handle:owner, Handle:hndl, const String:error[], any:data)
{
	if (owner == INVALID_HANDLE || hndl == INVALID_HANDLE)
	{
		LogError("%s [%s] (SQL_LoadDoorsCallback) %s", PL_PRE_N, PL_NAME, error);
	}
	
	ResetDoors();
	
	LogMessage("---Start Loading Doors---");
	
	while (SQL_FetchRow(hndl))
	{
		
		new nNew[RP_Doors];
		
		nNew[Door_ID] = SQL_FetchInt(hndl, 0);
		nNew[Door_AlarmID] = SQL_FetchInt(hndl, 1);
		nNew[Door_LockID] = SQL_FetchInt(hndl, 2);
		nNew[Door_ScannerID] = SQL_FetchInt(hndl, 3);
		nNew[Door_SensorID] = SQL_FetchInt(hndl, 4);
		nNew[Door_TrapID] = SQL_FetchInt(hndl, 5);
		nNew[Door_LocksAmount] = SQL_FetchInt(hndl, 6);
		SQL_FetchString(hndl, 7, nNew[Door_Name], 128);
		nNew[Door_Pos][0] = SQL_FetchFloat(hndl, 8);
		nNew[Door_Pos][1] = SQL_FetchFloat(hndl, 9);
		nNew[Door_Pos][2] = SQL_FetchFloat(hndl, 10);
		nNew[Door_Type] = SQL_FetchInt(hndl, 11);
		nNew[Building_ID] = SQL_FetchInt(hndl, 12);
		nNew[Door_IsLockedDefault] = bool:SQL_FetchInt(hndl, 13);
		nNew[Door_IsLocked] = true;
		
		PushArrayArray(g_hDoors, nNew[0]);
	}
	LogMessage("---End Loading Doors---");
	LogMessage("---Start Adding Missing Doors---");
	new bool:reload = false;

	new MaxEntities = GetMaxEntities();
	new String:entclsname[64], String:entname[64];
	for (new i = MaxClients+1; i < MaxEntities; i++) 
	{
		if (RP_IsValidDoorEnt(i)) 
		{
			new nNew[Door_SetUpHelper];
			
			new Float:buffer[3];
			GetEntityClassname(i, entclsname, sizeof(entclsname));
			
			GetEntityName(i, entname, sizeof(entname));
			Entity_GetAbsOrigin(i,buffer);
			
			LogMessage("[%d] %s / %s is a valid Door", i, entclsname, entname);
			
			nNew[Entity] = i;
			nNew[Door_Pos] = buffer;
			
			PushArrayArray(g_hDoor_SetUpHelper, nNew[0]);
		}
	}
	LogMessage("---Start Adding Missing Doors---");
	new Float:offset = 10.0;
	new bool:foundDoor;
	
	for (new i = 0; i < GetArraySize(g_hDoor_SetUpHelper); i++)
	{
		new nNew[Door_SetUpHelper];
		GetArrayArray(g_hDoor_SetUpHelper, i, nNew[0]);
		foundDoor = false;

		for (new y = 0; y < GetArraySize(g_hDoors); y++)
		{
			new nNew2[RP_Doors];
			
			GetArrayArray(g_hDoors, y, nNew2[0]);
			
			//Look for Door in +-offset and Save the Entity and Pos
			if(
			(nNew2[Door_Pos][0] <= (nNew[Door_Pos][0] + offset)) 	&&
			(nNew2[Door_Pos][0] >= (nNew[Door_Pos][0] - offset))	&&
			(nNew2[Door_Pos][1] <= (nNew[Door_Pos][1] + offset))	&&
			(nNew2[Door_Pos][1] >= (nNew[Door_Pos][1] - offset))	&&
			(nNew2[Door_Pos][2] <= (nNew[Door_Pos][2] + offset))	&&
			(nNew2[Door_Pos][2] >= (nNew[Door_Pos][2] - offset))
			)
			{
				nNew2[Door_Entity] = nNew[Entity];
				nNew2[Door_Pos] = nNew[Door_Pos];
				SetArrayArray(g_hDoors, y, nNew2[0]);
				foundDoor = true;
			}
			
		}
		//Door not known / Insert into Database and set reload = 1 to Reload doors again to get the Door_ID
		if(!foundDoor)
		{
			decl String:sQuery[2048];
			Format(sQuery, sizeof(sQuery), "INSERT INTO `rp_door` (alarmID, lockID, ScannerID, SensorID, TrapID, LocksAmount, DoorName, x, y, z, DoorType, BuildingID, LockDefault) VALUES ( -1, -1, -1, -1, -1,-1,'%s','%.2f','%.2f',0,-1,0)","RP_DOOR_DEFAULT",nNew[Door_Pos][0],nNew[Door_Pos][1],nNew[Door_Pos][2]);
			SQL_TQuery(g_hSQL, SQL_SaveDoorsCallback, sQuery, _, DBPrio_Low);
			reload = true;
		}
	}
	
	ClearArray(g_hDoor_SetUpHelper);
	g_hDoor_SetUpHelper = CreateArray(sizeof(nDoor_SetUpHelperTeamplate));
	
	if(reload)
	{
		ResetDoors();
		LoadDoors();
		return;
	}
}

LockAllDoors()
{
	new MaxEntities = GetMaxEntities();
	for (new i = MaxClients+1; i < MaxEntities; i++) 
	{
		if (RP_IsValidDoorEnt(i)) 
		{
			AcceptEntityInput(i, "Lock");
		}
	}
}

SaveDoor(doorID)
{
	for (new i = 0; i < GetArraySize(g_hDoors); i++)
	{
		new nNew[RP_Doors];
		GetArrayArray(g_hDoors, i, nNew[0]);
		
		if (nNew[Door_ID] == doorID)
		{
			decl String:sQuery[2048];
			Format(sQuery, sizeof(sQuery), "UPDATE `rp_door` SET `alarmID` = %d,`lockID` = %d,`ScannerID` = %d,`SensorID` = %d,`TrapID` = %d,`LocksAmount` = %d,`DoorName`= `%s`, `DoorType` = %d,`BuildingID` = %d,LockDefault = %d WHERE `doorID` = %d;",nNew[Door_AlarmID],nNew[Door_LockID],nNew[Door_ScannerID],nNew[Door_SensorID],nNew[Door_TrapID],nNew[Door_LocksAmount],nNew[Door_Name],nNew[Door_ID],nNew[Door_Type],nNew[Building_ID],nNew[Door_IsLockedDefault]);
			SQL_TQuery(g_hSQL, SQL_SaveDoorsCallback, sQuery, _, DBPrio_Low);		
		}
	}
}

public SQL_SaveDoorsCallback(Handle:owner, Handle:hndl, const String:error[], any:data)
{
	if (owner == INVALID_HANDLE || hndl == INVALID_HANDLE)
	{
		LogError("%s [%s] (SQL_SaveDoorsCallback) %s", PL_PRE_N, PL_NAME, error);
	}
}

public RP_OnSqlConnected(Handle:db)
{
	LogError("RP_OnSqlConnected Doors");
	g_hSQL = db;
	SQLConnectionReady();
}

public RP_OnSqlStop()
{
	g_hSQL = INVALID_HANDLE;
}

public RP_OnPlayerReady(client, playerID, bool:create)
{
	//PlayerID is now cached
}

public Action:OnPlayerRunCmd(client, &buttons, &impulse, Float:vel[3], Float:angles[3], &weapon, &subtype, &cmdnum, &tickcount, &seed, mouse[2])
{
	new iInitialButtons = buttons;

	if(!IsPlayerAlive(client))
		return Plugin_Continue;
	
	if((buttons & IN_USE) && !(g_iPrevButtons[client] & IN_USE))
	{
		new entity = GetClientAimTarget(client);
		if(RP_IsValidDoorEnt(entity) && RP_IsDoorEntityRegistered(entity))
		{
			new nDoorID = RP_GetDoorIDbyEntity(entity);
			new nDoorType = RP_GetDoorType(nDoorID);
			
			/* Forward: g_OnDoorRoundstart */
			Call_StartForward(g_OnDoorUse);
			Call_PushCell(nDoorID);
			Call_PushCell(nDoorType);
			Call_PushCell(client);
			Call_Finish();
		}
	}
	
	g_iPrevButtons[client] = buttons;

	if(iInitialButtons != buttons)
		return Plugin_Changed;

	return Plugin_Continue;
}

bool:IsValidDoorEnt(entity)
{
	if (entity == -1)
		return false;
		
	if (!IsValidEntity(entity))
		return false;
	
	new String:clsname[64];
	
	GetEntityClassname(entity, clsname, sizeof(clsname));
	
	if(
	StrEqual("func_movelinear", clsname) 	||
	StrEqual("func_door", clsname) 			||
	StrEqual("func_door_rotating", clsname) ||
	StrEqual("prop_door_rotating", clsname)
	)
	{
		return true;
	}
	
	return false;
}

bool:IsDoorEntityRegistered(entity)
{
	for (new i = 0; i < GetArraySize(g_hDoors); i++)
	{
		new nNew[RP_Doors];
		GetArrayArray(g_hDoors, i, nNew[0]);
		
		if (nNew[Door_Entity] == entity)
			return true;
	}
	return false;
}

OpenDoor(doorID)
{
	new entity;
	
	for (new i = 0; i < GetArraySize(g_hDoors); i++)
	{
		new nNew[RP_Doors];
		GetArrayArray(g_hDoors, i, nNew[0]);
		
		if (nNew[Door_ID] == doorID)
		{
			entity = nNew[Door_Entity];
		}
	}
	
	if(IsValidDoorEnt(entity) && RP_IsDoorEntityRegistered(entity))
	{
		AcceptEntityInput(entity, "Open");
	}
}

CloseDoor(doorID)
{
	new entity;
	
	for (new i = 0; i < GetArraySize(g_hDoors); i++)
	{
		new nNew[RP_Doors];
		GetArrayArray(g_hDoors, i, nNew[0]);
		
		if (nNew[Door_ID] == doorID)
		{
			entity = nNew[Door_Entity];
		}
	}
	
	if(IsValidDoorEnt(entity) && RP_IsDoorEntityRegistered(entity))
	{
		AcceptEntityInput(entity, "Close");
	}
}

LockDoor(doorID)
{
	new entity;
	
	for (new i = 0; i < GetArraySize(g_hDoors); i++)
	{
		new nNew[RP_Doors];
		GetArrayArray(g_hDoors, i, nNew[0]);
		
		if (nNew[Door_ID] == doorID)
		{
			entity = nNew[Door_Entity];
			SetArrayArray(g_hDoors, i, nNew[0]);
			nNew[Door_IsLocked] = true;
		}
	}
	
	if(IsValidDoorEnt(entity) && RP_IsDoorEntityRegistered(entity))
	{
		AcceptEntityInput(entity, "Lock");
	}
}

UnlockDoor(doorID)
{
	new entity;
	
	for (new i = 0; i < GetArraySize(g_hDoors); i++)
	{
		new nNew[RP_Doors];
		GetArrayArray(g_hDoors, i, nNew[0]);
		
		if (nNew[Door_ID] == doorID)
		{
			entity = nNew[Door_Entity];
			SetArrayArray(g_hDoors, i, nNew[0]);
			nNew[Door_IsLocked] = true;
		}
	}

	if(IsValidDoorEnt(entity) && RP_IsDoorEntityRegistered(entity))
	{
		AcceptEntityInput(entity, "Unlock");
	}
}

OpenDoorByEntity(entity)
{
	if (IsValidDoorEnt(entity) && RP_IsDoorEntityRegistered(entity))
	{
		AcceptEntityInput(entity, "Open");
	}
}

CloseDoorByEntity(entity)
{
	if (IsValidDoorEnt(entity) && RP_IsDoorEntityRegistered(entity))
	{
		AcceptEntityInput(entity, "Close");
	}
}

LockDoorByEntity(entity)
{
	if (IsValidDoorEnt(entity) && RP_IsDoorEntityRegistered(entity))
	{
		AcceptEntityInput(entity, "Lock");
		for (new i = 0; i < GetArraySize(g_hDoors); i++)
		{
			new nNew[RP_Doors];
			GetArrayArray(g_hDoors, i, nNew[0]);
		
			if (nNew[Door_Entity] == entity)
			{
				nNew[Door_IsLocked] = true;
				SetArrayArray(g_hDoors, i, nNew[0]);
				break;
			}
		}
	}
}

UnlockDoorByEntity(entity)
{
	if (IsValidDoorEnt(entity) && RP_IsDoorEntityRegistered(entity))
	{
		AcceptEntityInput(entity, "Unlock");
		for (new i = 0; i < GetArraySize(g_hDoors); i++)
		{
			new nNew[RP_Doors];
			GetArrayArray(g_hDoors, i, nNew[0]);
		
			if (nNew[Door_Entity] == entity)
			{
				nNew[Door_IsLocked] = false;
				SetArrayArray(g_hDoors, i, nNew[0]);
				break;
			}
		}
	}
}

GetDoorIDbyEntity(entity)
{
	for (new i = 0; i < GetArraySize(g_hDoors); i++)
	{
		new nNew[RP_Doors];
		GetArrayArray(g_hDoors, i, nNew[0]);
		
		if (nNew[Door_Entity] == entity)
			return nNew[Door_ID];
	}
	
	return -1;	
}

GetDoorAlarmID(doorID)
{
	for (new i = 0; i < GetArraySize(g_hDoors); i++)
	{
		new nNew[RP_Doors];
		GetArrayArray(g_hDoors, i, nNew[0]);
		
		if (nNew[Door_ID] == doorID)
			return nNew[Door_AlarmID];
	}
	
	return -1;
}

GetDoorName(doorID,String:buffer[],length_128)
{
	for (new i = 0; i < GetArraySize(g_hDoors); i++)
	{
		new nNew[RP_Doors];
		GetArrayArray(g_hDoors, i, nNew[0]);
		
		if (nNew[Door_ID] == doorID)
		{
			strcopy(buffer,length_128, nNew[Door_Name]);
		}
		return true;
	}
	
	return false;
}

GetDoorLockID(doorID)
{
	for (new i = 0; i < GetArraySize(g_hDoors); i++)
	{
		new nNew[RP_Doors];
		GetArrayArray(g_hDoors, i, nNew[0]);
		
		if (nNew[Door_ID] == doorID)
			return nNew[Door_LockID];
	}
	
	return -1;
}
GetDoorScannerID(doorID)
{
	for (new i = 0; i < GetArraySize(g_hDoors); i++)
	{
		new nNew[RP_Doors];
		GetArrayArray(g_hDoors, i, nNew[0]);
		
		if (nNew[Door_ID] == doorID)
			return nNew[Door_ScannerID];
	}
	
	return -1;
}
GetDoorSensorID(doorID)
{
	for (new i = 0; i < GetArraySize(g_hDoors); i++)
	{
		new nNew[RP_Doors];
		GetArrayArray(g_hDoors, i, nNew[0]);
		
		if (nNew[Door_ID] == doorID)
			return nNew[Door_SensorID];
	}
	
	return -1;
}
GetDoorTrapID(doorID)
{
	for (new i = 0; i < GetArraySize(g_hDoors); i++)
	{
		new nNew[RP_Doors];
		GetArrayArray(g_hDoors, i, nNew[0]);
		
		if (nNew[Door_ID] == doorID)
			return nNew[Door_TrapID];
	}
	
	return -1;
}

GetDoorType(doorID)
{
	for (new i = 0; i < GetArraySize(g_hDoors); i++)
	{
		new nNew[RP_Doors];
		GetArrayArray(g_hDoors, i, nNew[0]);
		
		if (nNew[Door_ID] == doorID)
			return nNew[Door_Type];
	}
	
	return -1;
}

GetDoorBuildingID(doorID)
{
	for (new i = 0; i < GetArraySize(g_hDoors); i++)
	{
		new nNew[RP_Doors];
		GetArrayArray(g_hDoors, i, nNew[0]);
		
		if (nNew[Door_ID] == doorID)
			return nNew[Building_ID];
	}
	
	return -1;
}

bool:IsDoorLocked(doorID)
{
	for (new i = 0; i < GetArraySize(g_hDoors); i++)
	{
		new nNew[RP_Doors];
		GetArrayArray(g_hDoors, i, nNew[0]);
		
		if (nNew[Door_ID] == doorID)
			return nNew[Door_IsLocked];
	}
	
	return true;
}

bool:IsDoorLockedDefault(doorID)
{
	for (new i = 0; i < GetArraySize(g_hDoors); i++)
	{
		new nNew[RP_Doors];
		GetArrayArray(g_hDoors, i, nNew[0]);
		
		if (nNew[Door_ID] == doorID)
			return nNew[Door_IsLockedDefault];
	}
	
	return true;
}

SetDoorAlarmID(doorID,new_arlarmid)
{
	for (new i = 0; i < GetArraySize(g_hDoors); i++)
	{
		new nNew[RP_Doors];
		GetArrayArray(g_hDoors, i, nNew[0]);
		
		if (nNew[Door_ID] == doorID)
		{
			nNew[Door_AlarmID] = new_arlarmid;
			SetArrayArray(g_hDoors, i, nNew[0]);
			break;
		}
	}
	SaveDoor(doorID);
}

SetDoorName(doorID,String:new_doorname[])
{
	for (new i = 0; i < GetArraySize(g_hDoors); i++)
	{
		new nNew[RP_Doors];
		GetArrayArray(g_hDoors, i, nNew[0]);
		
		if (nNew[Door_ID] == doorID)
		{
			strcopy(nNew[Door_Name], 128, new_doorname);
			SetArrayArray(g_hDoors, i, nNew[0]);
			break;
		}
	}
	SaveDoor(doorID);
}

SetDoorLockID(doorID,new_lockid)
{
	for (new i = 0; i < GetArraySize(g_hDoors); i++)
	{
		new nNew[RP_Doors];
		GetArrayArray(g_hDoors, i, nNew[0]);
		
		if (nNew[Door_ID] == doorID)
		{
			nNew[Door_LockID] = new_lockid;
			SetArrayArray(g_hDoors, i, nNew[0]);
			break;
		}
	}
	SaveDoor(doorID);
}

SetDoorScannerID(doorID,new_scannerid)
{
	for (new i = 0; i < GetArraySize(g_hDoors); i++)
	{
		new nNew[RP_Doors];
		GetArrayArray(g_hDoors, i, nNew[0]);
		
		if (nNew[Door_ID] == doorID)
		{
			nNew[Door_ScannerID] = new_scannerid;
			SetArrayArray(g_hDoors, i, nNew[0]);
			break;
		}
	}
	SaveDoor(doorID);
}

SetDoorSensorID(doorID,new_sensorid)
{
	for (new i = 0; i < GetArraySize(g_hDoors); i++)
	{
		new nNew[RP_Doors];
		GetArrayArray(g_hDoors, i, nNew[0]);
		
		if (nNew[Door_ID] == doorID)
		{
			nNew[Door_SensorID] = new_sensorid;
			SetArrayArray(g_hDoors, i, nNew[0]);
			break;
		}
	}
	SaveDoor(doorID);
}

SetDoorTrapID(doorID,new_trapid)
{
	for (new i = 0; i < GetArraySize(g_hDoors); i++)
	{
		new nNew[RP_Doors];
		GetArrayArray(g_hDoors, i, nNew[0]);
		
		if (nNew[Door_ID] == doorID)
		{
			nNew[Door_TrapID] = new_trapid;
			SetArrayArray(g_hDoors, i, nNew[0]);
			break;
		}
	}
	SaveDoor(doorID);
}

ResetDoor(doorID)
{
	for (new i = 0; i < GetArraySize(g_hDoors); i++)
	{
		new nNew[RP_Doors];
		GetArrayArray(g_hDoors, i, nNew[0]);
		
		if (nNew[Door_ID] == doorID)
		{
			nNew[Door_AlarmID] = -1;
			nNew[Door_LockID] = -1;
			nNew[Door_ScannerID] = -1;
			nNew[Door_SensorID] = -1;
			nNew[Door_TrapID] = -1;
			nNew[Door_LocksAmount] = 0;
			strcopy(nNew[Door_Name], 64, "RP_DOOR_DEFAULT");
			nNew[Door_Type] = 0;
			nNew[Building_ID] = -1;
			nNew[Door_IsLocked] = false;
		
			SetArrayArray(g_hDoors,i, nNew[0]);
			
			UnlockDoor(nNew[Door_Entity])
			break;
		}
	}
	
	decl String:sQuery[2048];
	Format(sQuery, sizeof(sQuery), "UPDATE `rp_door` SET `alarmID` = -1,`lockID` = -1,`ScannerID` = -1,`SensorID` = -1,`TrapID` = -1,`LocksAmount` = 0,`DoorName`= `RP_DOOR_DEFAULT`, `DoorType` = 0,`BuildingID` = -1,`LockDefault` = 0 WHERE `doorID` = %d;");
	SQL_TQuery(g_hSQL, SQL_SaveDoorsCallback, sQuery, _, DBPrio_Low);	
}

SetDoorType(doorID,new_doortype)
{
	for (new i = 0; i < GetArraySize(g_hDoors); i++)
	{
		new nNew[RP_Doors];
		GetArrayArray(g_hDoors, i, nNew[0]);
		
		if (nNew[Door_ID] == doorID)
		{
			nNew[Door_Type] = new_doortype;
			SetArrayArray(g_hDoors, i, nNew[0]);
			break;
		}
	}
	SaveDoor(doorID);
}

SetDoorBuildingID(doorID,new_buildingID)
{
	for (new i = 0; i < GetArraySize(g_hDoors); i++)
	{
		new nNew[RP_Doors];
		GetArrayArray(g_hDoors, i, nNew[0]);
		
		if (nNew[Door_ID] == doorID)
		{
			nNew[Building_ID] = new_buildingID;
			SetArrayArray(g_hDoors, i, nNew[0]);
			break;
		}
	}
	SaveDoor(doorID);
}

SetDoorLockedDefault(doorID,bool:new_lockedDefault)
{
	for (new i = 0; i < GetArraySize(g_hDoors); i++)
	{
		new nNew[RP_Doors];
		GetArrayArray(g_hDoors, i, nNew[0]);
		
		if (nNew[Door_ID] == doorID)
		{
			nNew[Door_IsLockedDefault] = new_lockedDefault;
			SetArrayArray(g_hDoors, i, nNew[0]);
			break;
		}
	}
	SaveDoor(doorID);
}

public SQL_ResetDoorCallback(Handle:owner, Handle:hndl, const String:error[], any:data)
{
	if (owner == INVALID_HANDLE || hndl == INVALID_HANDLE)
	{
		LogError("%s [%s] (SQL_ResetDoorCallback) %s", PL_PRE_N, PL_NAME, error);
	}
}

/*NATIVES*/

public Native_GetDoorCount(Handle:plugin, numParams)
{
	return GetArraySize(g_hDoors);
}

public Native_GetDoorIDByArrayIndex(Handle:plugin, numParams)
{
	new arrayIndex = GetNativeCell(1);
	if(arrayIndex >= 0 || GetArraySize(g_hDoors) > arrayIndex )
	{
		new nNew[RP_Doors];
		GetArrayArray(g_hDoors, arrayIndex, nNew[0]);
		return nNew[Door_ID];
	}
	
	return -1;
}

public Native_GetDoorAlarmID(Handle:plugin, numParams)
{
	return GetDoorAlarmID(GetNativeCell(1));
}
public Native_GetDoorName(Handle:plugin, numParams)
{
	new String:buffer[64];

	SetNativeString(2, buffer, GetNativeCell(3), true)
	return GetDoorName(GetNativeCell(1),buffer,GetNativeCell(3));
}

public Native_GetDoorLockID(Handle:plugin, numParams)
{
	return GetDoorLockID(GetNativeCell(1));
}

public Native_GetDoorScannerID(Handle:plugin, numParams)
{
	return GetDoorScannerID(GetNativeCell(1));
}

public Native_GetDoorSensorID(Handle:plugin, numParams)
{
	return GetDoorSensorID(GetNativeCell(1));
}

public Native_GetDoorTrapID(Handle:plugin, numParams)
{
	return GetDoorTrapID(GetNativeCell(1));
}

public Native_GetDoorType(Handle:plugin, numParams)
{
	return GetDoorType(GetNativeCell(1));
}

public Native_GetDoorBuildingID(Handle:plugin, numParams)
{
	return GetDoorBuildingID(GetNativeCell(1));
}

public Native_IsDoorLocked(Handle:plugin, numParams)
{
	return IsDoorLocked(GetNativeCell(1));
}

public Native_IsDoorLockedDefault(Handle:plugin, numParams)
{
	return IsDoorLockedDefault(GetNativeCell(1));
}

public Native_SetDoorAlarmID(Handle:plugin, numParams)
{
	SetDoorAlarmID(GetNativeCell(1),GetNativeCell(2));
}
public Native_SetDoorName(Handle:plugin, numParams)
{
	new String:buffer[64];
	
	SetNativeString(2, buffer, 64, true);
	SetDoorName(GetNativeCell(1),buffer);
}

public Native_SetDoorLockID(Handle:plugin, numParams)
{
	SetDoorLockID(GetNativeCell(1),GetNativeCell(2));
}

public Native_SetDoorScannerID(Handle:plugin, numParams)
{
	SetDoorScannerID(GetNativeCell(1),GetNativeCell(2));
}

public Native_SetDoorSensorID(Handle:plugin, numParams)
{
	SetDoorSensorID(GetNativeCell(1),GetNativeCell(2));
}

public Native_SetDoorTrapID(Handle:plugin, numParams)
{
	SetDoorTrapID(GetNativeCell(1),GetNativeCell(2));
}

public Native_SetDoorType(Handle:plugin, numParams)
{
	SetDoorType(GetNativeCell(1),GetNativeCell(2));
}
public Native_SetDoorBuildingID(Handle:plugin, numParams)
{
	SetDoorBuildingID(GetNativeCell(1),GetNativeCell(2));
}

public Native_SetDoorLockedDefault(Handle:plugin, numParams)
{
	SetDoorLockedDefault(GetNativeCell(1),GetNativeCell(2));
}

public Native_ResetDoor(Handle:plugin, numParams)
{
	ResetDoor(GetNativeCell(1));
}

public Native_OpenDoor(Handle:plugin, numParams)
{
	OpenDoor(GetNativeCell(1));
}

public Native_CloseDoor(Handle:plugin, numParams)
{
	CloseDoor(GetNativeCell(1));
}

public Native_LockDoor(Handle:plugin, numParams)
{
	LockDoor(GetNativeCell(1));
}

public Native_UnlockDoor(Handle:plugin, numParams)
{
	UnlockDoor(GetNativeCell(1));
}

public Native_OpenDoorByEntity(Handle:plugin, numParams)
{
	OpenDoorByEntity(GetNativeCell(1));
}

public Native_CloseDoorByEntity(Handle:plugin, numParams)
{
	CloseDoorByEntity(GetNativeCell(1));
}

public Native_LockDoorByEntity(Handle:plugin, numParams)
{
	LockDoorByEntity(GetNativeCell(1));
}

public Native_UnlockDoorByEntity(Handle:plugin, numParams)
{
	UnlockDoorByEntity(GetNativeCell(1));
}

public Native_IsValidDoorEnt(Handle:plugin, numParams)
{
	IsValidDoorEnt(GetNativeCell(1));
}

public Native_GetDoorIDbyEntity(Handle:plugin, numParams)
{
	GetDoorIDbyEntity(GetNativeCell(1));
}

public Native_IsDoorEntityRegistered(Handle:plugin, numParams)
{
	IsDoorEntityRegistered(GetNativeCell(1));
}