#include "roleplay/roleplay"

#define PL_NAME		"RP_ITEMS_AMMO"

new bool:g_LateLoaded;
new g_PlayerPrimaryAmmo[MAXPLAYERS+1] = {0, ...};
new g_PlayerSecondaryAmmo[MAXPLAYERS+1] = {0, ...};
new g_PlayerPrimaryAmmoType[MAXPLAYERS+1] = {0, ...};
new g_PlayerSecondaryAmmoType[MAXPLAYERS+1] = {0, ...};

enum Slots
{
	Slot_Primary,
	Slot_Secondary,
	Slot_Knife,
	Slot_Grenade,
	Slot_C4,
	Slot_None
};

/* Database */

public Plugin:myinfo = 
{
	name = PL_NAME,
	author = PL_AUTHOR,
	description = "",
	version = PL_VERSION,
	url = PL_URL
}

public APLRes:AskPluginLoad2(Handle:myself, bool:late, String:error[], err_max)
{
	g_LateLoaded = late;
	RegPluginLibrary(PL_NAME);
	
	CreateNative("RP_GetPlayerPrimaryAmmo", Native_GetPlayerPrimaryAmmo);
	CreateNative("RP_GetPlayerSecondaryAmmo", Native_GetPlayerSecondaryAmmo);
	CreateNative("RP_GetPlayerPrimaryAmmoType", Native_GetPlayerPrimaryAmmoType);
	CreateNative("RP_GetPlayerSecondaryAmmoType", Native_GetPlayerSecondaryAmmoType);
	
	return APLRes_Success;
}

public OnPluginStart()
{
	// Perform action if plugin is late loaded
	if(g_LateLoaded)
	{
		g_LateLoaded = false;
	}
}

public RP_OnPlayerReady(client, playerID, bool:create)
{
	//PlayerID is now cached
}

public RP_OnUseItem(client, itemID, itemType)
{
	if(itemType != IT_Ammo)
		return;
	
	decl String:sFeatures[MAX_FEATURE_LENGTH], String:sSettings[MAX_FEATURE_LENGTH], String:sName[64], String:sClassname[64];
	
	RP_GetItemFeatures(itemID, sFeatures, MAX_FEATURE_LENGTH);
	RP_GetItemSettings(itemID, sSettings, MAX_FEATURE_LENGTH);
	RP_GetItemClassname(itemID, sClassname, 128);
	RP_GetItemName(itemID, sName, 64);
	
	decl String:sFeature[MAX_ITEM_SETTINGS][MAX_FEATURE_LENGTH], String:sSetting[MAX_ITEM_SETTINGS][MAX_FEATURE_LENGTH];
	
	ExplodeString(sFeatures, ":", sFeature, sizeof(sFeature), sizeof(sFeatures));
	ExplodeString(sSettings, ":", sSetting, sizeof(sSetting), sizeof(sSettings));
	
	/*
	new entity = GivePlayerItem(client, sClassname);
	
	if(entity != -1)
	{
		CPrintToChat(client, "%s You got a %s", PL_PRE, sName);
		
		for (new i = 0; i < MAX_ITEM_SETTINGS; i++)
		{
			if(StrEqual(sFeature[i], "damage"))
			{
				
			}
		}
		
		RP_UsedPlayerInventoryItem(client, itemID, 1);
	}
	else CPrintToChat(client, "%s Failed to equip %s", PL_PRE, sName);
	*/
	
	return;
}

public Event_PlayerSpawn(Handle:event, const String:name[], bool:dontBroadcast)
{
	new client_index = GetClientOfUserId(GetEventInt(event, "userid"));

	new String:sClassname[32];
	
	// Primary
	new entity_index = GetPlayerWeaponSlot(client_index, _:Slot_Primary);
	if (IsValidEdict(entity_index))
	{
		GetEdictClassname(entity_index, sClassname, sizeof(sClassname));
		CacheClipSize(client_index, sClassname[7]);
	}
	
	// Secondary
	entity_index = GetPlayerWeaponSlot(client_index, _:Slot_Secondary);
	if (IsValidEdict(entity_index))
	{
		GetEdictClassname(entity_index, sClassname, sizeof(sClassname));
		CacheClipSize(client_index, sClassname[7]);
	}
}

public Event_ItemPickup(Handle:event, const String:name[], bool:dontBroadcast)
{
	new String:sItem[32];
	GetEventString(event, "item", sItem, sizeof(sItem));
	CacheClipSize(GetClientOfUserId(GetEventInt(event, "userid")), sItem);
}

stock CacheClipSize(client, const String:sItem[])
{
	// Convert first 4 characters of item into an integer for fast comparison
	new gun = (sItem[0] << 24) + (sItem[1] << 16) + (sItem[2] << 8) + (sItem[3]);
	
	//Ammotypes
	//9x19mm Parabellum = 1 | 11.43x23mm (.45 ACP) = 2 | 9x22mm (.357 SIG) = 3
	//5.7×28mm FN = 4 | 12.7x33mm (.50 Action Express) = 5 | 5.56x45mm NATO = 6
	//7.62x51mm NATO = 7 | 8.58x70mm (.338 Lapua Magnum) = 8 | 18.53x69.85 mm (12 Gauge) = 9
	
	if  (gun == 0x6D616737)													// mag7
	{
		g_PlayerPrimaryAmmo[client]=5;
		g_PlayerPrimaryAmmoType[client]=9;
	}
	else if  (gun == 0x786D3130 || gun == 0x73617765)							// xm1014,  sawedoff
	{
		g_PlayerPrimaryAmmo[client]=7;
		g_PlayerPrimaryAmmoType[client]=9;
	}
	else if  (gun == 0x6D330000 || gun == 0x6E6F7661)							// m3,  nova
	{
		g_PlayerPrimaryAmmo[client]=8;
		g_PlayerPrimaryAmmoType[client]=9;
	}
	else if  (gun == 0x73736730)												// ssg08
	{
		g_PlayerPrimaryAmmo[client]=10;
		g_PlayerPrimaryAmmoType[client]=7;
	}
	else if  (gun == 0x61777000)												//awp
	{
		g_PlayerPrimaryAmmo[client]=10;
		g_PlayerPrimaryAmmoType[client]=8;
	}
	else if  (gun == 0x67337367 || gun == 0x73636172)							// g3sg1,  scar20
	{
		g_PlayerPrimaryAmmo[client]=20;
		g_PlayerPrimaryAmmoType[client]=7;
	}
	else if  (gun == 0x756D7034)												// ump45
	{
		g_PlayerPrimaryAmmo[client]=25;
		g_PlayerPrimaryAmmoType[client]=2;
	}
	else if  (gun == 0x66616D61)												// famas
	{
		g_PlayerPrimaryAmmo[client]=25;
		g_PlayerPrimaryAmmoType[client]=6;
	}
	else if  (gun == 0x6D616331)												// mac10
	{
		g_PlayerPrimaryAmmo[client]=30;
		g_PlayerPrimaryAmmoType[client]=2;
	}
	else if  (gun == 0x616B3437)												//  ak47
	{
		g_PlayerPrimaryAmmo[client]=30;
		g_PlayerPrimaryAmmoType[client]=7;
	}
	else if  (gun == 0x6D703700 || gun == 0x6D703900)							//  mp7,  mp9
	{
		g_PlayerPrimaryAmmo[client]=30;
		g_PlayerPrimaryAmmoType[client]=1;
	}
	else if  (gun == 0x6D346131 || gun == 0x61756700 || gun == 0x73673535)		// m4a1, AUG, SG556
	{
		g_PlayerPrimaryAmmo[client]=30;
		g_PlayerPrimaryAmmoType[client]=6;
	}
	else if  (gun == 0x67616C69)												// galil
	{
		g_PlayerPrimaryAmmo[client]=35;
		g_PlayerPrimaryAmmoType[client]=6;
	}
	else if  (gun == 0x70393000)												// p90
	{
		g_PlayerPrimaryAmmo[client]=50;
		g_PlayerPrimaryAmmoType[client]=4;
	}
	else if  (gun == 0x62697A6F)												// bizon
	{
		g_PlayerPrimaryAmmo[client]=64;
		g_PlayerPrimaryAmmoType[client]=1;
	}
	else if  (gun == 0x6D323439)												// m249
	{
		g_PlayerPrimaryAmmo[client]=100;
		g_PlayerPrimaryAmmoType[client]=6;
	}
	else if  (gun == 0x6E656765)												// negev
	{
		g_PlayerPrimaryAmmo[client]=150;
		g_PlayerPrimaryAmmoType[client]=6;
	}
	else if  (gun == 0x64656167)												// deagle
	{
		g_PlayerSecondaryAmmo[client]=7;
		g_PlayerSecondaryAmmoType[client]=5;
	}
	else if  (gun == 0x75737000)												// usp
	{
		g_PlayerSecondaryAmmo[client]=12;
		g_PlayerSecondaryAmmoType[client]=2;
	}
	else if  (gun == 0x70323530)												//p250
	{
		g_PlayerSecondaryAmmo[client]=13;
		g_PlayerSecondaryAmmoType[client]=3;
	}
	else if  (gun == 0x686B7032)												//hkp2000
	{
		g_PlayerSecondaryAmmo[client]=13;
		g_PlayerSecondaryAmmoType[client]=1;
	}
	else if  (gun == 0x676C6F63)												// glock
	{
		g_PlayerSecondaryAmmo[client]=20;
		g_PlayerSecondaryAmmoType[client]=1;
	}
	else if  (gun == 0x66697665)												//fiveseven
	{
		g_PlayerSecondaryAmmo[client]=20;
		g_PlayerSecondaryAmmoType[client]=4;
	}
	else if  (gun == 0x656C6974)												// elite
	{
		g_PlayerSecondaryAmmo[client]=30;
		g_PlayerSecondaryAmmoType[client]=1;
	}
	else if  (gun == 0x74656339)												// tec9
	{
		g_PlayerSecondaryAmmo[client]=32;
		g_PlayerSecondaryAmmoType[client]=1;
	}
	else LogError("Can't cache ammo for --> Gun %d Items: %s", gun, sItem);
}

/* Natives */

public Native_GetPlayerPrimaryAmmo(Handle:plugin, numParams)
{
	return g_PlayerPrimaryAmmo[GetNativeCell(1)];
}

public Native_GetPlayerSecondaryAmmo(Handle:plugin, numParams)
{
	return g_PlayerSecondaryAmmo[GetNativeCell(1)];
}

public Native_GetPlayerPrimaryAmmoType(Handle:plugin, numParams)
{
	return g_PlayerPrimaryAmmoType[GetNativeCell(1)];
}

public Native_GetPlayerSecondaryAmmoType(Handle:plugin, numParams)
{
	return g_PlayerSecondaryAmmoType[GetNativeCell(1)];
}