#include "roleplay/roleplay"

#define PL_NAME		"RP_ITEMS_INVENTORY"

new bool:g_LateLoaded;

/* Forwards */
new Handle:g_OnUseItem;
new Handle:g_OnDropItem;
new Handle:g_OnDeleteItem;

public Plugin:myinfo = 
{
	name = PL_NAME,
	author = PL_AUTHOR,
	description = "",
	version = PL_VERSION,
	url = PL_URL
}

public APLRes:AskPluginLoad2(Handle:myself, bool:late, String:error[], err_max)
{
	RegPluginLibrary(PL_NAME);
	
	/* Register Forwards */
	g_OnUseItem = CreateGlobalForward("RP_OnUseItem", ET_Event, Param_Cell, Param_Cell, Param_Cell);
	g_OnDropItem = CreateGlobalForward("RP_OnDropItem", ET_Event, Param_Cell, Param_Cell, Param_Cell);
	g_OnDeleteItem = CreateGlobalForward("RP_OnDeleteItem", ET_Event, Param_Cell, Param_Cell, Param_Cell);
	
	return APLRes_Success;
}

public OnPluginStart()
{
	RegConsoleCmd("sm_inventory", Command_Inventory);
	RegConsoleCmd("sm_inv", Command_Inventory);
	RegConsoleCmd("sm_gear", Command_Inventory);
	RegConsoleCmd("sm_backpack", Command_Inventory);
	
	/* Perform action if plugin is late loaded */
	if(g_LateLoaded)
	{
		g_LateLoaded = false;
	}
}

public Action:Command_Inventory(client, args)
{
	if(0 >= client || client > MaxClients + 1)
		return Plugin_Handled;
	
	if(!IsClientInGame(client))
		return Plugin_Handled;
	
	if(!IsPlayerAlive(client))
		return Plugin_Handled;
	
	if(RP_GetPlayerInventoryItemCount(client) > 0)
		Menu_Inventory(client);
	else CPrintToChat(client, "%s You have no items in your inventory.", PL_PRE);
	
	return Plugin_Handled;
}

Menu_Inventory(client)
{
	new items = RP_GetPlayerInventoryItemCount(client);
	new Handle:menu = CreateMenu(MenuHandler_Inventory);
	SetMenuTitle(menu, "Inventory [Items: %d Cash: $%d]", items, RP_GetMoney(client));
	
	for (new i = 0; i < items; i++)
	{
		new itemID = RP_GetPlayerInventoryItem(client, i);
		new durability = RP_HasPlayerInventoryItem(client, itemID);
		
		/* Remove items which are empty */
		if(durability < 1)
		{
			RP_RemovePlayerInventoryItem(client, itemID);
			continue;
		}
		
		decl String:sItemID[10];
		IntToString(itemID, sItemID, sizeof(sItemID));
		
		decl String:sItemName[64];
		RP_GetItemName(itemID, sItemName, sizeof(sItemName));
		
		AddMenuItemEx(menu, false, sItemID, "%dx %s", durability, sItemName);
	}
	
	SetMenuExitButton(menu, true);
	DisplayMenu(menu, client, MENU_TIME_FOREVER);
}

public MenuHandler_Inventory(Handle:menu, MenuAction:action, client, param2)
{
	if(0 >= client || client > MaxClients + 1)
		return;
	
	if(!IsClientInGame(client))
		return;
	
	if(!IsPlayerAlive(client))
		return;
	
	if (action == MenuAction_Select)
	{
		decl String:info[100], String:info2[100];
		new bool:found = GetMenuItem(menu, param2, info, sizeof(info), _, info2, sizeof(info2));
		
		if(found)
		{
			new itemID = StringToInt(info);
			Menu_ItemInfo(client, itemID);
			return;
		}
	}
}

new g_iSelectedItemID[MAXPLAYERS+1];

Menu_ItemInfo(client, itemID)
{
	g_iSelectedItemID[client] = itemID;
	
	decl String:sItemName[64];
	RP_GetItemName(itemID, sItemName, sizeof(sItemName));
	
	decl String:sItemID[10];
	IntToString(itemID, sItemID, sizeof(sItemID));
	
	decl String:sItemDescription[64];
	RP_GetItemDescription(itemID, sItemDescription, sizeof(sItemDescription));
	
	new Handle:menu = CreateMenu(MenuHandler_ItemInfo);
	SetMenuTitle(menu, "Item: %dx %s%s\nDescription: %s", RP_HasPlayerInventoryItem(client, itemID), RP_IsItemVipOnly(itemID) ? "(VIP) ":"", sItemName, sItemDescription);
	
	AddMenuItemEx(menu, false, "inventory", "Back to inventory");
	AddMenuItemEx(menu, !RP_IsItemUseable(itemID), "use", "Use Item");
	AddMenuItemEx(menu, !RP_IsItemDropable(itemID), "drop", "Drop Item");
	AddMenuItemEx(menu, !RP_IsItemDeleteable(itemID), "delete", "Delete Item !!!");
	
	SetMenuExitButton(menu, true);
	DisplayMenu(menu, client, MENU_TIME_FOREVER);
}

public MenuHandler_ItemInfo(Handle:menu, MenuAction:action, client, param2)
{
	if(0 >= client || client > MaxClients + 1)
		return;
	
	if(!IsClientInGame(client))
		return;
	
	if(!IsPlayerAlive(client))
		return;
	
	if (action == MenuAction_Select)
	{
		decl String:info[100], String:info2[100];
		new bool:found = GetMenuItem(menu, param2, info, sizeof(info), _, info2, sizeof(info2));
		
		if(found)
		{
			new itemID = g_iSelectedItemID[client];
			
			/* Back || Invalid item */
			if(StrEqual(info, "inventory") ||RP_HasPlayerInventoryItem(client, itemID) < 1)
			{
				Menu_Inventory(client);
				return;
			}
			
			/* Use item */
			if(StrEqual(info, "use"))
			{
				if(RP_IsItemUseable(itemID))
				{
					/* Forward: RP_OnUseItem */
					Call_StartForward(g_OnUseItem);
					Call_PushCell(client);
					Call_PushCell(itemID);
					Call_PushCell(RP_GetItemType(itemID));
					Call_Finish();
					
					RP_UsedPlayerInventoryItem(client, itemID, 1);
				}
				else
				{
					CPrintToChat(client, "%s Item is not useable.", PL_PRE);
					Menu_ItemInfo(client, itemID);
				}
			}
			/* Drop item on ground */
			else if(StrEqual(info, "drop"))
			{
				if(RP_IsItemDropable(itemID))
				{
					DropItem(client, itemID);
					
					/* Forward: RP_OnDropItem */
					Call_StartForward(g_OnDropItem);
					Call_PushCell(client);
					Call_PushCell(itemID);
					Call_PushCell(RP_GetItemType(itemID));
					Call_Finish();
				}
				else
				{
					CPrintToChat(client, "%s Item is not dropable.", PL_PRE);
					Menu_ItemInfo(client, itemID);
				}
			}
			/* Delete item from inventory */
			else if(StrEqual(info, "delete"))
			{
				if(RP_IsItemDeleteable(itemID))
				{
					/* Forward: RP_OnDeleteItem */
					Call_StartForward(g_OnDeleteItem);
					Call_PushCell(client);
					Call_PushCell(itemID);
					Call_PushCell(RP_GetItemType(itemID));
					Call_Finish();
					
					decl String:sItemName[64];
					RP_GetItemName(itemID, sItemName, sizeof(sItemName));
					CPrintToChat(client, "%s You have successfully deleted %dx %s.", PL_PRE, RP_HasPlayerInventoryItem(client, itemID), sItemName);
					
					RP_RemovePlayerInventoryItem(client, itemID);
				}
				else
				{
					CPrintToChat(client, "%s Item is not deleteable.", PL_PRE);
					Menu_ItemInfo(client, itemID);
				}
			}
			
			/* Re-Open Menu */
			if(RP_HasPlayerInventoryItem(client, itemID) < 1)
				Menu_Inventory(client);
			else Menu_ItemInfo(client, itemID);
		}
	}
}

/* Drop Items */
DropItem(client, itemID)
{
	decl String:sName[64], String:sClassname[64], String:sModel[64];
	
	RP_GetItemModel(itemID, sModel, 128);
	RP_GetItemClassname(itemID, sClassname, 128);
	RP_GetItemName(itemID, sName, 64);
	
	CPrintToChat(client, "%s You dropped a %s.", PL_PRE, sName);
	
	if(StrEqual("", sClassname))
		Format(sClassname, sizeof(sClassname), "prop_physics_override");
	
	if(!StrEqual("", sModel) && RP_GetItemType(itemID) != IT_Weapon)
		Format(sModel, sizeof(sModel), "models/props_furniture/drawer1.mdl");
	
	new entity = CreateEntityByName(sClassname);
	
	new todo_finish_this_lol;
}