#include "roleplay/roleplay"

#define PL_NAME		"RP_ITEMS_MEDIC"

new bool:g_LateLoaded;

/* Database */

public Plugin:myinfo = 
{
	name = PL_NAME,
	author = PL_AUTHOR,
	description = "",
	version = PL_VERSION,
	url = PL_URL
}

public APLRes:AskPluginLoad2(Handle:myself, bool:late, String:error[], err_max)
{
	g_LateLoaded = late;
	RegPluginLibrary(PL_NAME);
	
	return APLRes_Success;
}

public OnPluginStart()
{
	// Perform action if plugin is late loaded
	if(g_LateLoaded)
	{
		g_LateLoaded = false;
	}
	
	CreateTimer(1.0, Timer_Regen, _, TIMER_REPEAT);
}

new g_iRegenHealth[MAXPLAYERS+1];
new g_iRegenArmor[MAXPLAYERS+1];

public RP_OnPlayerReady(client, playerID, bool:create)
{
	g_iRegenHealth[client] = 0;
	g_iRegenArmor[client] = 0;
}

public Action:Timer_Regen(Handle:timer, any:data)
{
	for (new client = 1; client < MAXPLAYERS ; client++)
	{
		if(g_iRegenHealth[client] > 0)
		{
			HealPlayer(client, 1);
			g_iRegenHealth[client]--;
		}
		
		if(g_iRegenArmor[client] > 0)
		{
			ArmorPlayer(client, 1);
			g_iRegenArmor[client]--;
		}
	}
}

public RP_OnUseItem(client, itemID, itemType)
{
	if(itemType != IT_Medic)
		return;
	
	decl String:sFeatures[MAX_FEATURE_LENGTH], String:sSettings[MAX_FEATURE_LENGTH], String:sName[64];
	
	RP_GetItemFeatures(itemID, sFeatures, MAX_FEATURE_LENGTH);
	RP_GetItemSettings(itemID, sSettings, MAX_FEATURE_LENGTH);
	RP_GetItemName(itemID, sName, 64);
	
	decl String:sFeature[MAX_ITEM_SETTINGS][MAX_FEATURE_LENGTH], String:sSetting[MAX_ITEM_SETTINGS][MAX_FEATURE_LENGTH];
	
	new iFeatures = ExplodeString(sFeatures, ":", sFeature, sizeof(sFeature), sizeof(sFeatures));
	new iSettings = ExplodeString(sSettings, ":", sSetting, sizeof(sSetting), sizeof(sSettings));
	
	if(iFeatures != iSettings)
	{
		LogError("%s [%s] itemID %d reported on UseMedicItem: Number of features and settings doesn't match (F:%d/S:%d)", PL_PRE_N, PL_NAME, iFeatures, iSettings);
		return;
	}
	
	new bool:used;
	
	for (new i = 0; i < MAX_ITEM_SETTINGS; i++)
	{
		// Instant health
		if(StrEqual(sFeature[i], "heal"))
		{
			new healed = HealPlayer(client, StringToInt(sSetting[i]));
			if(healed >= 1)
				used = true;
		}
		
		// Regen over time
		else if(StrEqual(sFeature[i], "regen"))
		{
			if(Entity_GetHealth(client) < 100 && g_iRegenHealth[client] < StringToInt(sSetting[i]))
			{
				g_iRegenHealth[client] = StringToInt(sSetting[i]);
				used = true;
			}
		}
		
		//Regen armor
		else if(StrEqual(sFeature[i], "armor"))
		{
			if(Client_GetArmor(client) < 100 && g_iRegenArmor[client] < StringToInt(sSetting[i]))
			{
				g_iRegenArmor[client] = StringToInt(sSetting[i]);
				used = true;
			}
		}
	}
	
	if(used) 
	{
		CPrintToChat(client, "%s You have used your %s", PL_PRE, sName);
		RP_UsedPlayerInventoryItem(client, itemID, 1);
		return;
	}
	else CPrintToChat(client, "%s Yout can't use this item now.", PL_PRE);
	
	return;
}

HealPlayer(client, amount)
{
	if(amount < 1)
		return 0;
	
	new hp = Entity_GetHealth(client);
	
	if(hp >= 100)
		return 0;
	
	if(hp + amount > 100)
		amount = 100-hp;
	
	hp += amount;
	
	Entity_SetHealth(client, hp, true, false);
	return amount;
}

ArmorPlayer(client, amount)
{
	if(amount < 1)
		return 0;
	
	new armor = Client_GetArmor(client);
	
	if(armor>= 100)
		return 0;
	
	if(armor + amount > 100)
		amount = 100-armor;
	
	armor += amount;
	
	Client_SetArmor(client, armor);
	return amount;
}