#include "roleplay/roleplay"

#define PL_NAME		"RP_ITEMS_WEAPON"

new bool:g_LateLoaded;

new g_iClientWeaponEntity[MAXPLAYERS+1][5];
new g_iClientWeaponItemID[MAXPLAYERS+1][5];

public Plugin:myinfo = 
{
	name = PL_NAME,
	author = PL_AUTHOR,
	description = "",
	version = PL_VERSION,
	url = PL_URL
}

public APLRes:AskPluginLoad2(Handle:myself, bool:late, String:error[], err_max)
{
	g_LateLoaded = late;
	RegPluginLibrary(PL_NAME);
	
	CreateNative("RP_GetWeaponSlotItem", Native_GetWeaponSlotItem);
	CreateNative("RP_SetWeaponSlotItem", Native_SetWeaponSlotItem);
	CreateNative("RP_GetWeaponSlotEntity", Native_GetWeaponSlotEntity);
	
	return APLRes_Success;
}

public OnPluginStart()
{
	// Perform action if plugin is late loaded
	if(g_LateLoaded)
	{
		g_LateLoaded = false;
	}
}

public RP_OnPlayerReady(client, playerID, bool:create)
{
	//PlayerID is now cached
}

public Action:CS_OnCSWeaponDrop(client, weaponIndex)
{
	/* Get weapon slot and item */
	new itemID = RP_GetEntityItem(weaponIndex);
	
	/* Force drop without firing CS_OnCSWeaponDrop again */
	if(RP_IsItemDropable(itemID))
	{
		CS_DropWeapon(client, weaponIndex, true, true);
	}
	
	return Plugin_Handled;
}

public RP_OnUseItem(client, itemID, itemType)
{
	if(itemType != IT_Weapon)
		return;
	
	/* Get Item Settings */
	
	decl String:sName[64], String:sClassname[64];
	RP_GetItemClassname(itemID, sClassname, 128);
	RP_GetItemName(itemID, sName, 64);
	
	decl String:sFeatures[256], String:sSettings[256];
	RP_GetItemFeatures(itemID, sFeatures, 128);
	RP_GetItemSettings(itemID, sSettings, 128);
	
	decl String:sFeature[MAX_ITEM_SETTINGS][128], String:sSetting[MAX_ITEM_SETTINGS][128];
	ExplodeString(sFeatures, ":", sFeature, sizeof(sFeature), sizeof(sFeatures));
	ExplodeString(sSettings, ":", sSetting, sizeof(sSetting), sizeof(sSettings));
	
	/* Get and validate weapon slot */
	
	new slot;
	if(IsWeaponKnife(sClassname))
		slot = CS_SLOT_KNIFE;
	else if(IsWeaponSecoundary(sClassname))
		slot = CS_SLOT_SECONDARY;
	else if(IsWeaponPrimary(sClassname))
		slot = CS_SLOT_PRIMARY;
	else if(IsWeaponGrenade(sClassname))
		slot = CS_SLOT_GRENADE;
	else
	{
		LogError("%s [%s] itemID %d reported: %s is not a valid classname for a weapon.", PL_PRE_N, PL_NAME, itemID, sClassname);
		return;
	}
	
	/* Remove the old weapon on this slot */
	
	new iOldWeapon = -1;
	while((iOldWeapon = GetPlayerWeaponSlot(client, slot)) != -1)
	{
		RemovePlayerItem(client, iOldWeapon);
		RemoveEdict(iOldWeapon);
	}
	
	/* Spawn weapon */
	
	new entity = GivePlayerItem(client, sClassname);
	
	if(entity <= 0)
	{
		CPrintToChat(client, "%s Failed to equip %s", PL_PRE, sName);
		return;
	}
	
	/* Save itemID and entity */
	RP_SetEntityItem(entity, itemID);
	g_iClientWeaponEntity[client][slot] = entity;
	g_iClientWeaponItemID[client][slot] = itemID;
	
	/* Apply settings */
	for (new i = 0; i < MAX_ITEM_SETTINGS; i++)
	{
		/* Weapon color */
		
		if(StrEqual(sFeature[i], "color"))
		{			
			decl String:sColors[4][128];
			ExplodeString(sSettings, ":", sColors, sizeof(sColors), 128);
			
			SetEntityRenderMode(entity, RENDER_TRANSCOLOR);
			SetEntityRenderColor(entity, StringToInt(sColors[0]), StringToInt(sColors[1]), StringToInt(sColors[2]), StringToInt(sColors[3]));
		}
		
		/* Ammo type */
		
		else if(StrEqual(sFeature[i], "ammoType"))
		{
			/* m_iItemDefinitionIndex */
			//
			//	iAmmoType:	Weapon:
			//	1			Deagle					"weapon_deagle"
			//	2			Elite					"weapon_elite"
			//	3			Five-Seven				"weapon_fiveseven"
			//	4			Glock					"weapon_glock"
			//	7			AK 47					"weapon_ak47"
			//	8			AUG						"weapon_aug"
			//	9			AWP bullet				"weapon_awp"
			//	10			Famas					"weapon_famas"
			//	11			G3SG1					"weapon_g3sg1"
			//	14			M249					"weapon_m249"
			//	16			M4A1					"weapon_m4a1"
			//	17			MAC 10					"weapon_mac10"
			//	19			P90						"weapon_p90"
			//	24			UMP-45					"weapon_ump45"
			//	25			XM1014					"weapon_xm1014"
			//	26			Bizon					"weapon_bizon"
			//	27			MAG7					"weapon_mag7"
			//	28			Negev					"weapon_negev"
			//	29			Sawedoff				"weapon_sawedoff"
			//	30			Tec9					"weapon_tec9"
			//	31			Zeus					"weapon_taser"
			//	32			Hpk 2000				"weapon_hkp2000"
			//	33			MP7						"weapon_mp7"
			//	34			MP9						"weapon_mp9"
			//	35			Nova					"weapon_nova"
			//	36			P250					"weapon_p250"
			//	38			SCAR 20					"weapon_scar20"
			//	39			SG 556					"weapon_sg556"
			//	40			Scout					"weapon_ssg08"
			//	42			Knife					"weapon_knife"
			//	43			Flashbang				"weapon_flashbang"
			//	44			HE Grenade				"weapon_hegrenade"
			//	45			Smoke Grenade			"weapon_smokegrenade"
			//	46			Molotov					"weapon_molotov"
			//	47			Decoy Grenade			"weapon_decoy"
			//	48			INC Grenade				"weapon_incgrenade"
			//	49			C4						"weapon_c4"
			//	59			Knife T					"weapon_knife_t"
			//	60			M4A1-S					"weapon_m4a1_silencer"
			//	61			USP-S					"weapon_usp_silencer"
			//	63			CZ						"weapon_cz75a"
			//	500			Knife Bayonet			"weapon_bayonet"
			//	505			Knife Flip				"weapon_knife_flip"
			//	506			Knife Gut				"weapon_knife_gut"
			//	507			Knife Gut				"weapon_knife_karambit"
			//	508			Knife M9				"weapon_knife_m9_bayonet"
			//	509			Knife Tactical			"weapon_knife_tactical"
			//	515			Knife Butterfly			"weapon_knife_butterfly"
			SetEntProp(entity, Prop_Send, "m_iItemDefinitionIndex", StringToInt(sSetting[i]));
		}
	}
	
	EquipPlayerWeapon(client, entity);
	CPrintToChat(client, "%s You equipped your %s", PL_PRE, sName);
}

/* Weapon Features */

public OnEntityDestroyed(entity)
{
	new todo_remove_from_feature_weapon_list;
}

/* Natives */

public Native_GetWeaponSlotItem(Handle:plugin, numParams)
{
	return g_iClientWeaponItemID[GetNativeCell(1)][GetNativeCell(2)];
}

public Native_SetWeaponSlotItem(Handle:plugin, numParams)
{
	g_iClientWeaponItemID[GetNativeCell(1)][GetNativeCell(2)] = GetNativeCell(3);
}

public Native_GetWeaponSlotEntity(Handle:plugin, numParams)
{
	return g_iClientWeaponEntity[GetNativeCell(1)][GetNativeCell(2)];
}