#include "roleplay/roleplay"

#define PL_NAME		"RP_Jail"

#define RANDOMSPEEDMIN -500.0
#define RANDOMSPEEDMAX 500.0

new bool:g_LateLoaded;

/* Jails */

new nJailTeamplate[RP_Jail];
new Handle:g_hJail = INVALID_HANDLE;

new nPDTeamplate[RP_PD];
new Handle:g_hPD = INVALID_HANDLE;


/* Database */
new Handle:g_hSQL;

public Plugin:myinfo = 
{
	name = PL_NAME,
	author = PL_AUTHOR,
	description = "",
	version = PL_VERSION,
	url = PL_URL
}

public APLRes:AskPluginLoad2(Handle:myself, bool:late, String:error[], err_max)
{
	CreateNative("RP_CreateJail", Native_CreateJail);
	CreateNative("RP_ClientSendToJail", Native_ClientSendToJail);
	CreateNative("RP_PDHasJailtype", Native_PDHasJailtype);
	CreateNative("RP_ClientSendToPD", Native_ClientSendToPD);
	CreateNative("RP_CreatePD", Native_CreatePD);
	CreateNative("RP_getPDcount", Native_getPDcount);
	CreateNative("RP_GetPDName", Native_GetPDName);
	
	g_LateLoaded = late;
	RegPluginLibrary(PL_NAME);
	return APLRes_Success;
}

public OnPluginStart()
{
	// Init ADT arrays
	g_hJail = CreateArray(sizeof(nJailTeamplate));
	nJailTeamplate[Jail_ID] = 0;
	
	g_hPD = CreateArray(sizeof(nPDTeamplate));
	nPDTeamplate[PD_ID] = 0;
	
	if(g_LateLoaded)
	{
		g_hSQL = Handle:RP_GetSql();
		
		if(g_hSQL != INVALID_HANDLE)
			SQLConnectionReady();
		
		g_LateLoaded = false;
	}
}

public RP_OnSqlConnected(Handle:db)
{
	g_hSQL = db;
	SQLConnectionReady();
}

public RP_OnSqlStop()
{
	g_hSQL = INVALID_HANDLE;
}

SQLConnectionReady()
{
	decl String:sQuery[2048];
	//JailID / Jailtype / Policedepartment of Jail / Origion / Angel
	Format(sQuery, sizeof(sQuery), "CREATE TABLE IF NOT EXISTS `rp_jail` (`jailid` int(11) NOT NULL AUTO_INCREMENT, `jailname` varchar(128) NOT NULL, `jailtype` int(11) NOT NULL, `PD` int(11) NOT NULL, `origionx` float NOT NULL,`origiony` float NOT NULL,`origionz` float NOT NULL, `angelx` float NOT NULL,`angely` float NOT NULL,`angelz` float NOT NULL, PRIMARY KEY (`jailid`)) ENGINE=InnoDB DEFAULT CHARSET=utf8;");
	LogMessage("%s [%s] Query: %s", PL_PRE_N, PL_NAME, sQuery);
	SQL_TQuery(g_hSQL, SQL_CreateTableCallback, sQuery, _, DBPrio_High);
	
	decl String:sQuery2[2048];
	//PD_ID / PD_Name / PD_count
	Format(sQuery2, sizeof(sQuery2), "CREATE TABLE IF NOT EXISTS `rp_pd` (`pdid` int(11) NOT NULL, `pdname` varchar(128) NOT NULL, `pdcount` int(11) NOT NULL, PRIMARY KEY (`pdid`)) ENGINE=InnoDB DEFAULT CHARSET=utf8;");
	LogMessage("%s [%s] Query: %s", PL_PRE_N, PL_NAME, sQuery2);
	SQL_TQuery(g_hSQL, SQL_CreateTableCallback, sQuery2, _, DBPrio_High);
	
	LoadPDs();
	LoadJails();
}

public SQL_CreateTableCallback(Handle:owner, Handle:hndl, const String:error[], any:data)
{
	if (owner == INVALID_HANDLE || hndl == INVALID_HANDLE)
	{
		LogError("%s [%s] (SQL_CreateTableCallback) %s", PL_PRE_N, PL_NAME, error);
	}
}

LoadPDs()
{
	decl String:sQuery[2048];
	Format(sQuery, sizeof(sQuery), "SELECT `pdid`,`pdname`, `pdcount` FROM `rp_pd`");
	SQL_TQuery(g_hSQL, SQL_LoadPDsCallback, sQuery, _, DBPrio_Low);
}

public SQL_LoadPDsCallback(Handle:owner, Handle:hndl, const String:error[], any:data)
{
	if (owner == INVALID_HANDLE || hndl == INVALID_HANDLE)
	{
		LogError("%s [%s] (SQL_LoadPDsCallback) %s", PL_PRE_N, PL_NAME, error);
	}
	
	while (SQL_FetchRow(hndl))
	{
		
		new nNew[RP_PD];
		
		nNew[PD_ID] = SQL_FetchInt(hndl, 0);
		SQL_FetchString(hndl, 1, nNew[PD_Name], 128);
		nNew[PD_Jailcount] = SQL_FetchInt(hndl, 2);
		
		PushArrayArray(g_hPD, nNew[0]);

	}
}

public getPDcount()
{
	return GetArraySize(g_hPD);
}

LoadJails()
{
	decl String:sQuery[2048];
	Format(sQuery, sizeof(sQuery), "SELECT `jailid`, `jailname`, `jailtype`, `PD`, `origionx`,`origiony`,`origionz`,`angelx`,`angely`,`angelz` FROM `rp_jail`");
	SQL_TQuery(g_hSQL, SQL_LoadJailsCallback, sQuery, _, DBPrio_Low);
}

public SQL_LoadJailsCallback(Handle:owner, Handle:hndl, const String:error[], any:data)
{
	if (owner == INVALID_HANDLE || hndl == INVALID_HANDLE)
	{
		LogError("%s [%s] (SQL_LoadJailsCallback) %s", PL_PRE_N, PL_NAME, error);
	}
	
	while (SQL_FetchRow(hndl))
	{
		
		new nNew[RP_Jail];
		
		nNew[Jail_ID] = SQL_FetchInt(hndl, 0);
		SQL_FetchString(hndl, 1, nNew[Jail_Name], 128);
		nNew[Jail_Type] = SQL_FetchInt(hndl, 2);
		nNew[Jail_PD] = SQL_FetchInt(hndl, 3);
		nNew[Jail_Pos][0] = SQL_FetchFloat(hndl, 4);
		nNew[Jail_Pos][1] = SQL_FetchFloat(hndl, 5);
		nNew[Jail_Pos][2] = SQL_FetchFloat(hndl, 6);
		nNew[Jail_Angle][0] = SQL_FetchFloat(hndl, 7);
		nNew[Jail_Angle][1] = SQL_FetchFloat(hndl, 8);
		nNew[Jail_Angle][2] = SQL_FetchFloat(hndl, 9);
		
		PushArrayArray(g_hJail, nNew[0]);

		CountJailsInPDs();
	}
}

CountJailsInPDs()
{
	new nNew[RP_Jail];
	new nNew2[RP_PD];
	for (new i = 0; i < GetArraySize(g_hJail); i++)
	{
		GetArrayArray(g_hJail, i, nNew[0]);
		
		for (new y = 0; y < GetArraySize(g_hPD); y++)
		{
			GetArrayArray(g_hPD, y, nNew2[0]);
			
			if(nNew[Jail_PD] == nNew2[PD_ID])
			{
				nNew2[PD_Jailcount]++;
			}
		}			
	}
}

CreatePD(pdid,String:pdname[128])
{
	new nNew[RP_PD];
		
	strcopy(nNew[PD_Name],128,pdname);
		
	nNew[PD_ID] = pdid;
		
	PushArrayArray(g_hPD, nNew[0]);
		
	decl String:sQuery[2048];
	FormatEx(sQuery, sizeof(sQuery), "INSERT INTO `rp_pd` (pdid,pdname, pdcount) VALUES (%d,'%s',0)",pdid, pdname);
	LogMessage("%s [%s] Query: %s", PL_PRE_N, PL_NAME, sQuery);
	SQL_TQuery(g_hSQL, SQL_PDCreateCallback, sQuery, _, DBPrio_Normal);
	
}

public SQL_PDCreateCallback(Handle:owner, Handle:hndl, const String:error[], any:userid)
{
	if (owner == INVALID_HANDLE || hndl == INVALID_HANDLE)
	{
		LogError("%s [%s] (SQL_PDCreateCallback) %s", PL_PRE_N, PL_NAME, error);
	}
}

CreateJail(client,jtyp,policeDepartment,String:jailname[128])
{
	if(Client_IsValid(client))
	{
		new Float:origion[3];
		new Float:angel[3];
	
		GetClientAbsOrigin(client,origion);
		GetClientAbsAngles(client,angel);
		
		new nNew[RP_Jail];
		strcopy(nNew[Jail_Name],128,jailname);
		
		nNew[Jail_Type] = jtyp;
		nNew[Jail_PD] = policeDepartment;
		nNew[Jail_Pos] = origion;
		nNew[Jail_Angle] = angel;
		
		PushArrayArray(g_hJail, nNew[0]);
		PrintToChatAll("%d",jailname);
		decl String:sQuery[2048];
		FormatEx(sQuery, sizeof(sQuery), "INSERT INTO `rp_jail` (jailname,jailtype, PD, origionx,origiony,origionz,angelx,angely,angelz) VALUES ('%s',%d,%d,%.2f,%.2f,%.2f,%.2f,%.2f,%.2f)",jailname, jtyp,policeDepartment,origion[0],origion[1],origion[2],angel[0],angel[1],angel[2]);
		LogMessage("%s [%s] Query: %s", PL_PRE_N, PL_NAME, sQuery);
		SQL_TQuery(g_hSQL, SQL_JailCreateCallback, sQuery, GetClientUserId(client), DBPrio_Normal);		
	}	
}

public SQL_JailCreateCallback(Handle:owner, Handle:hndl, const String:error[], any:userid)
{
	if (owner == INVALID_HANDLE || hndl == INVALID_HANDLE)
	{
		LogError("%s [%s] (SQL_JailCreateCallback) %s", PL_PRE_N, PL_NAME, error);
	}
}

public ClientSendToPD(client,type,pd)
{
	if(PDHasJailtype(pd,type) && Client_IsValid(client))
	{
		new nNew[RP_PD];
		
		for (new i = 0; i < GetArraySize(g_hPD); i++)
		{
			GetArrayArray(g_hPD, i, nNew[0]);
		
			if (nNew[PD_ID] == pd)
			{
				break;
			}
		}
		new nNew2[RP_Jail];
		new counter = 0;
		new posJails[10];
		
		for (new i = 0; i < GetArraySize(g_hJail); i++)
		{
			GetArrayArray(g_hJail, i, nNew2[0]);
		
			if (nNew2[Jail_PD] == pd && nNew2[Jail_Type] == type)
			{
				posJails[counter] = nNew2[Jail_ID];
				counter++;
			}
		}
		
		new random = GetRandomInt(0,counter-1);
		ClientSendToJail(client,posJails[random]);
	}
}

ClientSendToJail(client,jailnr)
{
	if(Client_IsValid(client))
	{
		//Remove client from Teleporter
		new Float:randomspeed[3];
		new Float:origionWorkaround[3];
		new Float:angelWorkaround[3];
		new nNew[RP_Jail];
		
		for (new i = 0; i < GetArraySize(g_hJail); i++)
		{
			GetArrayArray(g_hJail, i, nNew[0]);
		
			if (nNew[Jail_ID] == jailnr)
			{
				break;
			}
		}
		
		randomspeed[0] = GetRandomFloat(RANDOMSPEEDMIN, RANDOMSPEEDMAX);
		randomspeed[1] = GetRandomFloat(RANDOMSPEEDMIN, RANDOMSPEEDMAX);
		randomspeed[2] = GetRandomFloat(0.0, RANDOMSPEEDMAX);
		
		origionWorkaround[0] = GetRandomFloat(RANDOMSPEEDMIN, RANDOMSPEEDMAX);
		origionWorkaround[1] = GetRandomFloat(RANDOMSPEEDMIN, RANDOMSPEEDMAX);
		origionWorkaround[2] = GetRandomFloat(0.0, RANDOMSPEEDMAX);
		
		angelWorkaround[0] = GetRandomFloat(RANDOMSPEEDMIN, RANDOMSPEEDMAX);
		angelWorkaround[1] = GetRandomFloat(RANDOMSPEEDMIN, RANDOMSPEEDMAX);
		angelWorkaround[2] = GetRandomFloat(0.0, RANDOMSPEEDMAX);		
		
		TeleportEntity(client,origionWorkaround,angelWorkaround,randomspeed);
		//TeleportEntity(client,nNew[Jail_Pos],nNew[Jail_Angle],randomspeed);		
	}
}

bool:PDHasJailtype(pd,jtype)
{
	new nNew[RP_Jail];
		
	for (new i = 0; i < GetArraySize(g_hJail); i++)
	{
		GetArrayArray(g_hJail, i, nNew[0]);
		
		if (nNew[Jail_PD] == pd && nNew[Jail_Type] == jtype)
		{
			return true;
		}
	}
	return false;
}


public RP_OnPlayerReady(client, playerID, bool:create)
{
	//PlayerID is now cached
}

public Native_CreateJail(Handle:plugin, numParams)
{
	new String:cellname[128];
	GetNativeString(4, cellname, sizeof(cellname));
	
	CreateJail(GetNativeCell(1),GetNativeCell(2),GetNativeCell(3),cellname);
}

public Native_ClientSendToJail(Handle:plugin, numParams)
{
	ClientSendToJail(GetNativeCell(1),GetNativeCell(2));
}

public Native_PDHasJailtype(Handle:plugin, numParams)
{
	return PDHasJailtype(GetNativeCell(1),GetNativeCell(2));
}

public Native_ClientSendToPD(Handle:plugin, numParams)
{
	ClientSendToPD(GetNativeCell(1),GetNativeCell(2),GetNativeCell(3));
}

public Native_CreatePD(Handle:plugin, numParams)
{
	decl String:sName[128];
	GetNativeString(2, sName, sizeof(sName));
	CreatePD(GetNativeCell(1),sName);
}

public Native_getPDcount(Handle:plugin, numParams)
{
	return getPDcount();
}

public Native_GetPDName(Handle:plugin, numParams)
{
	new pdid = GetNativeCell(1);
	
	for (new i = 0; i < GetArraySize(g_hPD); i++)
	{
		new nNew[RP_PD];
		GetArrayArray(g_hPD, i, nNew[0]);
		
		if (nNew[PD_ID] == pdid)
		{
			decl String:buffer[128];
			FormatEx(buffer, 128, "%s", nNew[PD_Name]);
			
			return (SetNativeString(2, buffer, 128, true) == SP_ERROR_NONE);
		}
	}
	
	return false;
}
