#include "roleplay/roleplay"

#define PL_NAME		"RP_MONEY_PAYCHECK"

#define INTERVAL 60.0
#define WAGE 50

new bool:g_LateLoaded;

/* Database */
new Handle:g_hSQL;

public Plugin:myinfo = 
{
	name = PL_NAME,
	author = PL_AUTHOR,
	description = "",
	version = PL_VERSION,
	url = PL_URL
}

public APLRes:AskPluginLoad2(Handle:myself, bool:late, String:error[], err_max)
{
	RegPluginLibrary(PL_NAME);
	return APLRes_Success;
}

public OnPluginStart()
{
	if(g_LateLoaded)
	{
		g_hSQL = Handle:RP_GetSql();
		
		if(g_hSQL != INVALID_HANDLE)
			SQLConnectionReady();
		
		g_LateLoaded = false;
	}
	
	CreateTimer(INTERVAL, Timer_PayCheck, _, TIMER_REPEAT);
}

public RP_OnSqlConnected(Handle:db)
{
	g_hSQL = db;
	SQLConnectionReady();
}

public RP_OnSqlStop()
{
	g_hSQL = INVALID_HANDLE;
}

SQLConnectionReady()
{
	decl String:sQuery[2048];
	Format(sQuery, sizeof(sQuery), "CREATE TABLE IF NOT EXISTS `rp_paycheck` (`paycheckID` int(10) NOT NULL AUTO_INCREMENT, `playerID` int(10) NOT NULL, `wage` int(11) NOT NULL, PRIMARY KEY (`paycheckID`)) ENGINE=InnoDB DEFAULT CHARSET=utf8;");
	LogMessage("%s [%s] Query: %s", PL_PRE_N, PL_NAME, sQuery);
	SQL_TQuery(g_hSQL, SQL_CreateTableCallback, sQuery, _, DBPrio_High);
}

public SQL_CreateTableCallback(Handle:owner, Handle:hndl, const String:error[], any:data)
{
	if (owner == INVALID_HANDLE || hndl == INVALID_HANDLE)
	{
		LogError("%s [%s] (SQL_CreateTableCallback) %s", PL_PRE_N, PL_NAME, error);
	}
}

public Action:Timer_PayCheck(Handle:timer, any:data)
{
	if(g_hSQL == INVALID_HANDLE)
		return Plugin_Continue;
	
	for (new client = 1; client < MAXPLAYERS ; client++)
	{
		if (!IsClientInGame(client))
			continue;
		
		if (!IsPlayerAlive(client))
			continue;
		
		RP_AddMoney(client, WAGE);
		LogPaycheck(client, WAGE);
	}
	
	return Plugin_Continue;
}

LogPaycheck(client, wage)
{
	decl String:sQuery[2048];
	FormatEx(sQuery, sizeof(sQuery), "INSERT INTO `rp_paycheck` (playerID, wage) VALUES (%d, %d)", RP_GetPlayerID(client), wage);
	SQL_TQuery(g_hSQL, SQL_LogPaycheckCallback, sQuery, _, DBPrio_Normal);
}

public SQL_LogPaycheckCallback(Handle:owner, Handle:hndl, const String:error[], any:data)
{
	if (owner == INVALID_HANDLE || hndl == INVALID_HANDLE)
	{
		LogError("%s [%s] (SQL_LogPaycheckCallback) %s", PL_PRE_N, PL_NAME, error);
	}
}