#include "roleplay/roleplay"

#define PL_NAME		"RP_NPCS"

new bool:g_LateLoaded;

/* Database */
new Handle:g_hSQL;

new nNpcTeamplate[RP_Npc];
new Handle:g_hNpcs = INVALID_HANDLE;

/* Forwards */
new Handle:g_OnPlayerNpcUse;

/* Button Uses */
new iPrevButtons[MAXPLAYERS+1];

public Plugin:myinfo = 
{
	name = PL_NAME,
	author = PL_AUTHOR,
	description = "",
	version = PL_VERSION,
	url = PL_URL
}

public APLRes:AskPluginLoad2(Handle:myself, bool:late, String:error[], err_max)
{
	g_LateLoaded = late;
	RegPluginLibrary(PL_NAME);
	
	/* Register Natives */
	CreateNative("RP_ReloadNpcs", Native_ReloadNpcs);

	CreateNative("RP_GetNpcType", Native_GetNpcType);
	CreateNative("RP_GetNpcName", Native_GetNpcName);

	CreateNative("RP_GetNpcReqLevel", Native_GetNpcReqLevel);
	CreateNative("RP_GetNpcReqItem", Native_GetNpcReqItem);
	CreateNative("RP_GetNpcVipOnly", Native_GetNpcVipOnly);
	CreateNative("RP_GetNpcTeam", Native_GetNpcTeam);
	CreateNative("RP_GetNpcRange", Native_GetNpcRange);

	CreateNative("RP_GetNpcModel", Native_GetNpcModel);
	CreateNative("RP_GetNpcEntity", Native_GetNpcEntity);
	
	CreateNative("RP_SetNpcType", Native_SetNpcType);
	CreateNative("RP_SetNpcName", Native_SetNpcName);

	CreateNative("RP_SetNpcReqLevel", Native_SetNpcReqLevel);
	CreateNative("RP_SetNpcReqItem", Native_SetNpcReqItem);
	CreateNative("RP_SetNpcVipOnly", Native_GetNpcVipOnly);
	CreateNative("RP_SetNpcTeam", Native_SetNpcTeam);
	CreateNative("RP_SetNpcRange", Native_SetNpcRange);

	CreateNative("RP_SetNpcModel", Native_SetNpcModel);

	CreateNative("RP_ResetNpcAnimation", Native_ResetNpcAnimation);
	CreateNative("RP_PlayNpcAnimation", Native_PlayNpcAnimation);
	
	CreateNative("RP_CreateNPC", Native_CreateNpc);
	CreateNative("RP_CreateNPCdefault", Native_CreateNpcdefault);
	
	CreateNative("RP_GetNpcID", Native_GetNpcID);
	
	/* Register Forwards */
	g_OnPlayerNpcUse = CreateGlobalForward("RP_OnPlayerNpcUse", ET_Event, Param_Cell, Param_Cell);
	
	return APLRes_Success;
}

public OnPluginStart()
{
	RegAdminCmd("rp_npc_list", Command_NpcList, ADMFLAG_ROOT, "List all NPCs");
	
	/* Init ADT arrays */
	g_hNpcs = CreateArray(sizeof(nNpcTeamplate));
	nNpcTeamplate[Npc_ID] = 0;
	
	/* Perform action if plugin is late loaded */
	if(g_LateLoaded)
	{
		g_hSQL = Handle:RP_GetSql();
		
		if(g_hSQL != INVALID_HANDLE)
			SQLConnectionReady();
		
		g_LateLoaded = false;
	}
	
	/* Spawn NPCs */
	HookEvent("round_start", Event_RoundStart, EventHookMode_Post);
}

public RP_OnSqlConnected(Handle:db)
{
	g_hSQL = db;
	SQLConnectionReady();
}

public RP_OnSqlStop()
{
	g_hSQL = INVALID_HANDLE;
}

SQLConnectionReady()
{
	/* Create Table*/
	decl String:sQuery[2048];
	Format(sQuery, sizeof(sQuery), "CREATE TABLE IF NOT EXISTS `rp_npcs` (`npcID` int(10) NOT NULL AUTO_INCREMENT, `npcType` int(10) NOT NULL, `name` varchar(128) NOT NULL,`team` varchar(128) NOT NULL, `dist` int(10) NOT NULL, `req_level` int(11) NOT NULL, `req_item` int(11) NOT NULL, `vip` int(1) NOT NULL, `model` varchar(128) NOT NULL, `animation` varchar(64) NOT NULL, `x` float NOT NULL, `y` float NOT NULL, `z` float NOT NULL, `angle` float NOT NULL, PRIMARY KEY (`npcID`)) ENGINE=InnoDB DEFAULT CHARSET=utf8;");
	LogMessage("%s [%s] Query: %s", PL_PRE_N, PL_NAME, sQuery);
	SQL_TQuery(g_hSQL, SQL_CreateTableCallback, sQuery, _, DBPrio_High);
	
}

public OnMapStart()
{
	CreateTimer(10.0, TimerLoadNPCs);
}

public Action:TimerLoadNPCs(Handle:timer, any:data)
{
	ResetNPCs();
	LoadNPCs();
}

public SQL_CreateTableCallback(Handle:owner, Handle:hndl, const String:error[], any:data)
{
	if (owner == INVALID_HANDLE || hndl == INVALID_HANDLE)
	{
		LogError("%s [%s] (SQL_CreateTableCallback) %s", PL_PRE_N, PL_NAME, error);
	}
}

ResetNPCs()
{
	ClearArray(g_hNpcs);
	g_hNpcs = CreateArray(sizeof(nNpcTeamplate));
}

LoadNPCs()
{
	decl String:sQuery[2048];
	Format(sQuery, sizeof(sQuery), "SELECT `npcID`,`npcType`,`name`,`team`,`req_level`,`req_item`,`vip`,`dist`,`model`,`animation`,`x`,`y`,`z`,`angle` FROM `rp_npcs`;");
	SQL_TQuery(g_hSQL, SQL_LoadNPCsCallback, sQuery, _, DBPrio_Low);
}

public SQL_LoadNPCsCallback(Handle:owner, Handle:hndl, const String:error[], any:data)
{
	if (owner == INVALID_HANDLE || hndl == INVALID_HANDLE)
	{
		LogError("%s [%s] (SQL_LoadNPCsCallback) %s", PL_PRE_N, PL_NAME, error);
	}
	
	/* Get NPCs */
	while (SQL_FetchRow(hndl))
	{
		new nNew[RP_Npc];
		
		nNew[Npc_ID] = SQL_FetchInt(hndl, 0);
		nNew[Npc_Type] = SQL_FetchInt(hndl, 1);
		SQL_FetchString(hndl, 2, nNew[Npc_Name], 128);
		nNew[Npc_Team] = SQL_FetchInt(hndl, 3);
		nNew[Npc_ReqLevel] = SQL_FetchInt(hndl, 4);
		nNew[Npc_ReqItem] = SQL_FetchInt(hndl, 5);
		nNew[Npc_VipOnly] = bool:SQL_FetchInt(hndl, 6);
		nNew[Npc_Range] = SQL_FetchInt(hndl, 7);
		SQL_FetchString(hndl, 8, nNew[Npc_Model], 128);
		SQL_FetchString(hndl, 9, nNew[Npc_Animation], 64);
		nNew[Npc_Pos][0] = SQL_FetchFloat(hndl, 10);
		nNew[Npc_Pos][1] = SQL_FetchFloat(hndl, 11);
		nNew[Npc_Pos][2] = SQL_FetchFloat(hndl, 12);
		nNew[Npc_Angle] = SQL_FetchFloat(hndl, 13);
		nNew[Npc_Entity] = -1;
		
		PushArrayArray(g_hNpcs, nNew[0]);
		
		if(!IsModelPrecached(nNew[Npc_Model]))
			PrecacheModel(nNew[Npc_Model]);
	}
	
	/* Spawn NPC Entitys */
	SpawnNPCs();
}

/* Delete all prop_dynamic entitys with "RP_NPC_" in it's name*/
DeleteSpawnedNPCs()
{
	new entindex=-1;
	decl String:stringname[20];
	while ((entindex = FindEntityByClassname(entindex, "prop_dynamic")) != -1)
	{
		GetEntPropString(entindex, Prop_Data, "m_iName", stringname, sizeof(stringname));
		
		if (StrContains(stringname, "RP_NPC_") != -1)
			AcceptEntityInput(entindex, "Kill");
	}
}

/* We have to respawn all NPCs every round start */
public Action:Event_RoundStart(Handle:event,const String:name[],bool:dontBroadcast)
{
	SpawnNPCs();
}

/* Spawns all NPCs */
SpawnNPCs()
{
	DeleteSpawnedNPCs();
	
	for (new i = 0; i < GetArraySize(g_hNpcs); i++)
	{
		new nNew[RP_Npc];
		GetArrayArray(g_hNpcs, i, nNew[0]);
		
		/* Give each NPC a unique entity name */
		new String:npc_name[64];
		Format(npc_name, sizeof(npc_name), "RP_NPC_%d", i);
		
		new entity = CreateEntityByName("prop_dynamic");
		
		DispatchKeyValue(entity, "targetname", npc_name);
		DispatchKeyValue(entity, "model", nNew[Npc_Model]);
		DispatchKeyValue(entity, "DefaultAnim", nNew[Npc_Animation]);
		DispatchKeyValue(entity, "solid", "2"); //Use bounding box
		
		DispatchSpawn(entity);
		
		new Float:pos[3], Float:angle[3];
		Array_Copy(nNew[Npc_Pos], pos, 3);
		angle[1] = nNew[Npc_Angle];
		
		TeleportEntity(entity, pos, angle, NULL_VECTOR);
		
		/* Save Entity ID */
		nNew[Npc_Entity] = entity;
		
		SetArrayArray(g_hNpcs, i, nNew[0]);
	}
}

/* Creates a NPC and spawns it */
CreateNPC(type, String:name[64], team, req_level, req_item,vip, range, String:model[128], Float:xpos, Float:ypos, Float:zpos, Float:angel)
{
	decl String:sQuery[2048];
	FormatEx(sQuery, sizeof(sQuery),
	"INSERT INTO `rp_npcs` (npcType,name,team,req_level,req_item,vip,dist,model,x,y,z,angle) VALUES ('%d','%s','%d','%d','%d','%d','%d','%s','%.2f','%.2f','%.2f','%.2f')",
	type, name, team, req_level, req_item, vip, range, model, xpos, ypos, zpos, angel);
	SQL_TQuery(g_hSQL, SQL_NPCCreateCallback, sQuery, _, DBPrio_Normal);
	
	//Respawn NPCs
	ResetNPCs();
	LoadNPCs();
	
	
}

/* Creates a NPC and spawns it */
CreateNPCdefault(Float:xpos, Float:ypos, Float:zpos, Float:angel)
{
	decl String:sQuery[2048];
	FormatEx(sQuery, sizeof(sQuery),
	"INSERT INTO `rp_npcs` (npcType,name,team,req_level,req_item,vip,model,animation,x,y,z,angle,dist) VALUES (0,'NO_NAME',0,0,0,%d,'models/characters/hostage_01.mdl','ACT_IDLE',%.2f,%.2f,%.2f,%.2f,140)", false, xpos, ypos, zpos, angel);
	SQL_TQuery(g_hSQL, SQL_NPCCreateCallback, sQuery, _, DBPrio_Normal);
	
	//Respawn NPCs
	ResetNPCs();
	LoadNPCs();
	
	
}

public SQL_NPCCreateCallback(Handle:owner, Handle:hndl, const String:error[], any:userid)
{
	if (owner == INVALID_HANDLE || hndl == INVALID_HANDLE)
	{
		LogError("%s [%s] (SQL_NPCCreateCallback) %s", PL_PRE_N, PL_NAME, error);
	}
}

/* Admin Commands */

public Action:Command_NpcList(Client, Args)
{
	PrintToConsole(Client, "[RP] Listing %d NPCs", GetArraySize(g_hNpcs));
	PrintToConsole(Client, "[RP] <id> <range> <name> <team> <req. item> <req. level> <npctype> <> <>");
	
	new npcID = -1, range = 0, team, itemID, level, npctype;
	decl String:sName[64];
	
	for (new i = 0; i < GetArraySize(g_hNpcs); i++)
	{
		new nNew[RP_Npc];
		GetArrayArray(g_hNpcs, i, nNew[0]);
		
		npcID = nNew[Npc_ID];
		range = nNew[Npc_Range];
		strcopy(sName, 64, nNew[Npc_Name]);
		team = nNew[Npc_Team];
		itemID = nNew[Npc_ReqItem];
		level = nNew[Npc_ReqLevel];
		npctype = nNew[Npc_Type];
		
		PrintToConsole(Client, "#%d - <%d> <%s> <%d> <%d> <%d> <%d>", npcID, range, sName, team, itemID, level, npctype);
		PrintToChat(Client, "#%d - <%d> <%s> <%d> <%d> <%d> <%d>", npcID, range, sName, team, itemID, level, npctype);
	}
	
	return Plugin_Handled;
}

/* Interact with NPCs */

public Action:OnPlayerRunCmd(client, &buttons, &impulse, Float:vel[3], Float:angles[3], &weapon, &subtype, &cmdnum, &tickcount, &seed, mouse[2])
{
	if (buttons & IN_USE && !(iPrevButtons[client] & IN_USE))
	{
		/* Client is looking at something */
		new entity = GetClientAimTarget(client, false);
		
		new npcID = -1, range = 0, team, itemID, level;
		decl String:sName[64];
		
		/* Check if it's a NPC */
		for (new i = 0; i < GetArraySize(g_hNpcs); i++)
		{
			new nNew[RP_Npc];
			GetArrayArray(g_hNpcs, i, nNew[0]);
			
			if (nNew[Npc_Entity] == entity)
			{
				npcID = nNew[Npc_ID];
				range = nNew[Npc_Range];
				strcopy(sName, 64, nNew[Npc_Name]);
				team = nNew[Npc_Team];
				itemID = nNew[Npc_ReqItem];
				level = nNew[Npc_ReqLevel];
				break;
			}
		}
		
		/* Valid NPCs lets interact with it */
		if(npcID != -1)
		{
			new bool:valid = true;
			
			if(range != 0 && !Entity_InRange(client, entity, float(range)))
				valid = false;
			
			/* This NPC is only talking to cops */
			if(team == CS_TEAM_CT && GetClientTeam(client) != team)
			{
				valid = false;
				
				CPrintToChat(client, "%s %s: I'm only talking to cops!", PL_PRE, sName);
			}
			
			/* This NPC is not talking to cops */
			if(team == CS_TEAM_T && GetClientTeam(client) != team)
			{
				valid = false;
				
				CPrintToChat(client, "%s %s: I'm not talking to cops!", PL_PRE, sName);
			}
			
			/* This NPC needs a special item */
			if(itemID != 0 && !RP_HasPlayerInventoryItem(client, itemID))
			{
				valid = false;
				
				decl String:sItem[64];
				RP_GetItemName(itemID, sItem, sizeof(sItem));
				CPrintToChat(client, "%s %s: Come back when you have a %s.", PL_PRE, sName, sItem);
			}
			
			/* This NPC needs a special item + level to interact with */
			if(level != 0 && RP_GetLevel(client) < level)
			{
				valid = false;
				
				CPrintToChat(client, "%s %s: Come back when reached level %d.", PL_PRE, sName, level);
			}
			
			/* This NPC has passed all checks an is ready to interact */
			if(valid)
			{
				CPrintToChat(client, "%s %s: Hello!", PL_PRE, sName);
				
				/* Forward: RP_OnPlayerNpcUse */
				Call_StartForward(g_OnPlayerNpcUse);
				Call_PushCell(client);
				Call_PushCell(npcID);
				Call_Finish();
			}
		}
	}
	
	iPrevButtons[client] = buttons;
    
	return Plugin_Continue;
}


/* GETTER / SETTER */

SetNpcType(npcID,new_type)
{
	decl String:sQuery[2048];
	FormatEx(sQuery, sizeof(sQuery), "UPDATE `rp_npcs` SET npcType = %d WHERE npcID = %d", new_type, npcID);
	SQL_TQuery(g_hSQL, SQL_NPCUpdateCallback, sQuery, _);
	
	for (new i = 0; i < GetArraySize(g_hNpcs); i++)
	{
		new nNew[RP_Npc];
		GetArrayArray(g_hNpcs, i, nNew[0]);
		
		if (nNew[Npc_ID] == npcID)
		{
			nNew[Npc_Type] = new_type;			
			SetArrayArray(g_hNpcs, i, nNew[0]);
		}
	}
}

SetNpcName(npcID,String:new_name[64])
{
	decl String:sQuery[2048];
	FormatEx(sQuery, sizeof(sQuery), "UPDATE `rp_npcs` SET name = %s WHERE npcID = %d", new_name, npcID);
	SQL_TQuery(g_hSQL, SQL_NPCUpdateCallback, sQuery, _);
	
	for (new i = 0; i < GetArraySize(g_hNpcs); i++)
	{
		new nNew[RP_Npc];
		GetArrayArray(g_hNpcs, i, nNew[0]);
		
		if (nNew[Npc_ID] == npcID)
		{
			strcopy(new_name, 64, nNew[Npc_Name]);
			SetArrayArray(g_hNpcs, i, nNew[0]);
		}
	}
}

SetNpcModel(npcID,String:new_model[128])
{
	decl String:sQuery[2048];
	FormatEx(sQuery, sizeof(sQuery), "UPDATE `rp_npcs` SET model = %s WHERE npcID = %d", new_model, npcID);
	SQL_TQuery(g_hSQL, SQL_NPCUpdateCallback, sQuery, _);
	
	for (new i = 0; i < GetArraySize(g_hNpcs); i++)
	{
		new nNew[RP_Npc];
		GetArrayArray(g_hNpcs, i, nNew[0]);
		
		if (nNew[Npc_ID] == npcID)
		{
			strcopy(new_model, 128, nNew[Npc_Model]);
			SetArrayArray(g_hNpcs, i, nNew[0]);
		}
	}
}

SetNpcReqLevel(npcID,new_req_lvl)
{
	decl String:sQuery[2048];
	FormatEx(sQuery, sizeof(sQuery), "UPDATE `rp_npcs` SET req_level = %d WHERE npcID = %d", new_req_lvl, npcID);
	SQL_TQuery(g_hSQL, SQL_NPCUpdateCallback, sQuery, _);
	
	for (new i = 0; i < GetArraySize(g_hNpcs); i++)
	{
		new nNew[RP_Npc];
		GetArrayArray(g_hNpcs, i, nNew[0]);
		
		if (nNew[Npc_ID] == npcID)
		{
			nNew[Npc_ReqLevel] = new_req_lvl;
			SetArrayArray(g_hNpcs, i, nNew[0]);
		}
	}
}

SetNpcReqItem(npcID,new_req_item)
{
	decl String:sQuery[2048];
	FormatEx(sQuery, sizeof(sQuery), "UPDATE `rp_npcs` SET req_item = %d WHERE npcID = %d", new_req_item, npcID);
	SQL_TQuery(g_hSQL, SQL_NPCUpdateCallback, sQuery, _);
	
	for (new i = 0; i < GetArraySize(g_hNpcs); i++)
	{
		new nNew[RP_Npc];
		GetArrayArray(g_hNpcs, i, nNew[0]);
		
		if (nNew[Npc_ID] == npcID)
		{
			nNew[Npc_ReqItem] = new_req_item;
			SetArrayArray(g_hNpcs, i, nNew[0]);
		}
	}
}

SetNpcVipOnly(npcID,bool:new_vip)
{
	decl String:sQuery[2048];
	FormatEx(sQuery, sizeof(sQuery), "UPDATE `rp_npcs` SET vip = %d WHERE npcID = %d", new_vip, npcID);
	SQL_TQuery(g_hSQL, SQL_NPCUpdateCallback, sQuery, _);
	
	for (new i = 0; i < GetArraySize(g_hNpcs); i++)
	{
		new nNew[RP_Npc];
		GetArrayArray(g_hNpcs, i, nNew[0]);
		
		if (nNew[Npc_ID] == npcID)
		{
			nNew[Npc_VipOnly] = new_vip;
			SetArrayArray(g_hNpcs, i, nNew[0]);
		}
	}
}

SetNpcTeam(npcID,new_team)
{
	decl String:sQuery[2048];
	FormatEx(sQuery, sizeof(sQuery), "UPDATE `rp_npcs` SET team = %d WHERE npcID = %d", new_team, npcID);
	SQL_TQuery(g_hSQL, SQL_NPCUpdateCallback, sQuery, _);
	
	for (new i = 0; i < GetArraySize(g_hNpcs); i++)
	{
		new nNew[RP_Npc];
		GetArrayArray(g_hNpcs, i, nNew[0]);
		
		if (nNew[Npc_ID] == npcID)
		{
			nNew[Npc_Team] = new_team;
			SetArrayArray(g_hNpcs, i, nNew[0]);
		}
	}
}

SetNpcRange(npcID,new_range)
{
	decl String:sQuery[2048];
	FormatEx(sQuery, sizeof(sQuery), "UPDATE `rp_npcs` SET dist = %d WHERE npcID = %d", new_range, npcID);
	SQL_TQuery(g_hSQL, SQL_NPCUpdateCallback, sQuery, _);
	
	for (new i = 0; i < GetArraySize(g_hNpcs); i++)
	{
		new nNew[RP_Npc];
		GetArrayArray(g_hNpcs, i, nNew[0]);
		
		if (nNew[Npc_ID] == npcID)
		{
			nNew[Npc_Range] = new_range;
			SetArrayArray(g_hNpcs, i, nNew[0]);
		}
	}
}

public SQL_NPCUpdateCallback(Handle:owner, Handle:hndl, const String:error[], any:userid)
{
	if (owner == INVALID_HANDLE || hndl == INVALID_HANDLE)
	{
		LogError("%s [%s] (SQL_NPCUpdateCallback) %s", PL_PRE_N, PL_NAME, error);
	}
}

//---//

GetNpcType(npcID)
{
	for (new i = 0; i < GetArraySize(g_hNpcs); i++)
	{
		new nNew[RP_Npc];
		GetArrayArray(g_hNpcs, i, nNew[0]);
		
		if (nNew[Npc_ID] == npcID)
		{
			return nNew[Npc_Type];
		}
	}
	
	return -1;
}

GetNpcReqLevel(npcID)
{
	for (new i = 0; i < GetArraySize(g_hNpcs); i++)
	{
		new nNew[RP_Npc];
		GetArrayArray(g_hNpcs, i, nNew[0]);
		
		if (nNew[Npc_ID] == npcID)
		{
			return nNew[Npc_ReqLevel];
		}
	}
	
	return -1;
}

GetNpcReqItem(npcID)
{
	for (new i = 0; i < GetArraySize(g_hNpcs); i++)
	{
		new nNew[RP_Npc];
		GetArrayArray(g_hNpcs, i, nNew[0]);
		
		if (nNew[Npc_ID] == npcID)
		{
			return nNew[Npc_ReqItem];
		}
	}
	
	return -1;
}

GetNpcVipOnly(npcID)
{
	for (new i = 0; i < GetArraySize(g_hNpcs); i++)
	{
		new nNew[RP_Npc];
		GetArrayArray(g_hNpcs, i, nNew[0]);
		
		if (nNew[Npc_ID] == npcID)
		{
			return nNew[Npc_VipOnly];
		}
	}
	
	return -1;
}

GetNpcTeam(npcID)
{
	for (new i = 0; i < GetArraySize(g_hNpcs); i++)
	{
		new nNew[RP_Npc];
		GetArrayArray(g_hNpcs, i, nNew[0]);
		
		if (nNew[Npc_ID] == npcID)
		{
			return nNew[Npc_Team];
		}
	}
	
	return -1;
}

GetNpcRange(npcID)
{
	for (new i = 0; i < GetArraySize(g_hNpcs); i++)
	{
		new nNew[RP_Npc];
		GetArrayArray(g_hNpcs, i, nNew[0]);
		
		if (nNew[Npc_ID] == npcID)
		{
			return nNew[Npc_Range];
		}
	}
	
	return -1;
}

GetNpcEntity(npcID)
{
	for (new i = 0; i < GetArraySize(g_hNpcs); i++)
	{
		new nNew[RP_Npc];
		GetArrayArray(g_hNpcs, i, nNew[0]);
		
		if (nNew[Npc_ID] == npcID)
		{
			return nNew[Npc_Entity];
		}
	}
	
	return -1;
}

GetNpcID(entity)
{
	for (new i = 0; i < GetArraySize(g_hNpcs); i++)
	{
		new nNew[RP_Npc];
		GetArrayArray(g_hNpcs, i, nNew[0]);
		
		if (nNew[Npc_Entity] == entity)
		{
			return nNew[Npc_ID];
		}
	}
	
	return -1;
}

/* Natives */
public Native_ReloadNpcs(Handle:plugin, numParams)
{
	ResetNPCs();
	LoadNPCs();
}

public Native_CreateNpc(Handle:plugin, numParams)
{
	new type = GetNativeCell(1);
	
	decl String:sName[64];
	GetNativeString(2, sName, sizeof(sName));
	
	new team = GetNativeCell(3);
	new req_level = GetNativeCell(4);
	new req_item = GetNativeCell(5);
	new vip= GetNativeCell(6);
	new range= GetNativeCell(7);
	
	decl String:sModel[128];
	GetNativeString(8, sModel, sizeof(sModel));
	
	new Float:xpos= GetNativeCell(9);
	new Float:ypos= GetNativeCell(10);
	new Float:zpos= GetNativeCell(11);
	new Float:angel= GetNativeCell(12);
	
	CreateNPC(type, sName, team, req_level, req_item, vip, range, sModel, xpos, ypos, zpos, angel);
}

public Native_CreateNpcdefault(Handle:plugin, numParams)
{
	new Float:xpos= GetNativeCell(1);
	new Float:ypos= GetNativeCell(2);
	new Float:zpos= GetNativeCell(3);
	new Float:angel= GetNativeCell(4);
	
	CreateNPCdefault(xpos, ypos, zpos, angel);
}

public Native_SetNpcType(Handle:plugin, numParams)
{
	SetNpcType(GetNativeCell(1),GetNativeCell(2));
}

public Native_SetNpcName(Handle:plugin, numParams)
{
	decl String:buffer[64];
	SetNativeString(2, buffer, 64, true);
	
	SetNpcName(GetNativeCell(1),buffer);
}

public Native_SetNpcReqLevel(Handle:plugin, numParams)
{
	SetNpcReqLevel(GetNativeCell(1),GetNativeCell(2));
}

public Native_SetNpcReqItem(Handle:plugin, numParams)
{
	SetNpcReqItem(GetNativeCell(1),GetNativeCell(2));
}

public Native_SetNpcVipOnly(Handle:plugin, numParams)
{
	SetNpcVipOnly(GetNativeCell(1),GetNativeCell(2));
}

public Native_SetNpcTeam(Handle:plugin, numParams)
{
	SetNpcTeam(GetNativeCell(1),GetNativeCell(2));
}

public Native_SetNpcRange(Handle:plugin, numParams)
{
	SetNpcRange(GetNativeCell(1),GetNativeCell(2));
}

public Native_SetNpcModel(Handle:plugin, numParams)
{
	decl String:buffer[128];
	SetNativeString(2, buffer, 128, true);
	
	SetNpcModel(GetNativeCell(1),buffer);
}

public Native_GetNpcType(Handle:plugin, numParams)
{
	return GetNpcType(GetNativeCell(1));
}

public Native_GetNpcName(Handle:plugin, numParams)
{
	new npcID = GetNativeCell(1);
	new nlen = GetNativeCell(3);
	
	for (new i = 0; i < GetArraySize(g_hNpcs); i++)
	{
		new nNew[RP_Npc];
		GetArrayArray(g_hNpcs, i, nNew[0]);
		
		if (nNew[Npc_ID] == npcID)
		{
			decl String:buffer[nlen];
			FormatEx(buffer, nlen, "%s", nNew[Npc_Name]);
			if (SetNativeString(2, buffer, nlen, true) == SP_ERROR_NONE)
				return true;
			else return false;
		}
	}
	
	return false;
}

public Native_GetNpcReqLevel(Handle:plugin, numParams)
{
	return GetNpcReqLevel(GetNativeCell(1));
}

public Native_GetNpcReqItem(Handle:plugin, numParams)
{
	return GetNpcReqItem(GetNativeCell(1));
}

public Native_GetNpcVipOnly(Handle:plugin, numParams)
{
	return GetNpcVipOnly(GetNativeCell(1));
}

public Native_GetNpcTeam(Handle:plugin, numParams)
{
	return GetNpcTeam(GetNativeCell(1));
}

public Native_GetNpcRange(Handle:plugin, numParams)
{
	return GetNpcRange(GetNativeCell(1));
}

public Native_GetNpcModel(Handle:plugin, numParams)
{
	new npcID = GetNativeCell(1);
	new nlen = GetNativeCell(3);
	
	for (new i = 0; i < GetArraySize(g_hNpcs); i++)
	{
		new nNew[RP_Npc];
		GetArrayArray(g_hNpcs, i, nNew[0]);
		
		if (nNew[Npc_ID] == npcID)
		{
			decl String:buffer[nlen];
			FormatEx(buffer, nlen, "%s", nNew[Npc_Model]);
			if (SetNativeString(2, buffer, nlen, true) == SP_ERROR_NONE)
				return true;
			else return false;
		}
	}
	
	return false;
}

public Native_GetNpcEntity(Handle:plugin, numParams)
{
	return GetNpcEntity(GetNativeCell(1));
}

public Native_ResetNpcAnimation(Handle:plugin, numParams)
{
	new npcID = GetNativeCell(1);
	
	for (new i = 0; i < GetArraySize(g_hNpcs); i++)
	{
		new nNew[RP_Npc];
		GetArrayArray(g_hNpcs, i, nNew[0]);
		
		if (nNew[Npc_ID] == npcID)
		{
			SetVariantString(nNew[Npc_Animation]);
			AcceptEntityInput(GetNpcEntity(npcID), "SetAnimation");
			break;
		}
	}
}

public Native_PlayNpcAnimation(Handle:plugin, numParams)
{
	new npcID = GetNativeCell(1);
	
	decl String:sAnimation[64];
	GetNativeString(2, sAnimation, sizeof(sAnimation));
	
	SetVariantString(sAnimation);
	AcceptEntityInput(GetNpcEntity(npcID), "SetAnimation");
}

public Native_GetNpcID(Handle:plugin, numParams)
{
	return GetNpcID(GetNativeCell(1));
}