#include "roleplay/roleplay"

#define PL_NAME		"RP_Playerinteraction"

#define INTERACTIONRANGE 300.0
#define MAXJAILTYPES 6

new iPrevButtons[MAXPLAYERS+1];

new g_MenuTarget[MAXPLAYERS+1];
new g_iSelectedItemID[MAXPLAYERS+1];
new g_iSelectedPDID[MAXPLAYERS+1];

new bool:g_LateLoaded;

/* Database */
new Handle:g_hSQL;

public Plugin:myinfo = 
{
	name = PL_NAME,
	author = PL_AUTHOR,
	description = "",
	version = PL_VERSION,
	url = PL_URL
}

public APLRes:AskPluginLoad2(Handle:myself, bool:late, String:error[], err_max)
{
	g_LateLoaded = late;
	RegPluginLibrary(PL_NAME);
	return APLRes_Success;
}

public OnPluginStart()
{
	if(g_LateLoaded)
	{
		g_hSQL = Handle:RP_GetSql();
		
		if(g_hSQL != INVALID_HANDLE)
			SQLConnectionReady();
		
		g_LateLoaded = false;
	}
}

public RP_OnSqlConnected(Handle:db)
{
	g_hSQL = db;
	SQLConnectionReady();
}

public RP_OnSqlStop()
{
	g_hSQL = INVALID_HANDLE;
}

SQLConnectionReady()
{
	//Database is now ready to use
}

public RP_OnPlayerReady(client, playerID, bool:create)
{
	//PlayerID is now cached
}

public Action:OnPlayerRunCmd(client, &buttons, &impulse, Float:vel[3], Float:angles[3], &weapon, &subtype, &cmdnum, &tickcount, &seed, mouse[2])
{
	if (buttons & IN_USE && !(iPrevButtons[client] & IN_USE))
	{
		new entity = GetClientAimTarget(client, false);
		
		/* Interact with Player if it is one */
		if(entity > 0 && Client_IsValid(entity) && Client_IsValid(client))
		{
			
			
			/* Is Ent in Range? */
			if(Entity_InRange(client, entity, INTERACTIONRANGE))
			{
				g_MenuTarget[client] = entity;
				Menu_Main(client, entity);
			}
			else
			{
				PrintToChat(client, "Player not in range");
			}
		}
	}
	
	iPrevButtons[client] = buttons;
    
	return Plugin_Continue;
}

Menu_Main(client, target)
{
	new Handle:menu = CreateMenu(MenuHandler_Player);
	new String:buffer[64];
	RP_GetName(target,buffer,sizeof(buffer));
	SetMenuTitle(menu, "Interact with %s", buffer);

	AddMenuItemEx(menu, false, "0", "Give Money");
	AddMenuItemEx(menu, false, "1", "Give Item");

	PrintToChatAll("CuffedCT : %d / CuffedT : %d" , RP_IsCop(client),RP_IsCop(target));
	if(RP_IsCop(client) && !RP_IsCop(target))
	{
		AddMenuItemEx(menu, false, "2", "Inspect");
						
		if(RP_IsClientCuffed(target))
		{
			AddMenuItemEx(menu, false, "3", "Send to Jail");
		}
	}

	SetMenuExitButton(menu, true);
	DisplayMenu(menu, client, MENU_TIME_FOREVER);
}

public MenuHandler_Player(Handle:menu, MenuAction:action, client, param2)
{
	new target = g_MenuTarget[client];
	if(0 >= client || client > MaxClients + 1)
		return;
	
	if(!IsClientInGame(client))
		return;
	
	if(!IsPlayerAlive(client))
		return;
		
	if(!Entity_InRange(client, g_MenuTarget[client], INTERACTIONRANGE))
		return;
	
	if (action == MenuAction_Select)
	{
		decl String:info[100], String:info2[100];
		new bool:found = GetMenuItem(menu, param2, info, sizeof(info), _, info2, sizeof(info2));
		
		if(found)
		{
			new selection = StringToInt(info);
			if(selection == 0)
				Menu_GiveMoney(client, target);
			else if(selection == 1)
				Menu_Inventory(client);
			else if(selection == 2)
				ShowPlayerStatsToClient(client, target);
			else
				Menu_PD(client);
			return;
		}
	}
}

Menu_PD(client)
{
	if(RP_getPDcount() >= 2)
	{
		new Handle:menu = CreateMenu(MenuHandler_PD);
		SetMenuTitle(menu, "[PD] Choose PD");
		for(new i = 0 ; i < RP_getPDcount() ; i++)
		{
			new String:bufferx[128];
			new String:bufferx2[128];
			RP_GetPDName(i,bufferx);
			IntToString(i,bufferx2,sizeof(bufferx2));
			AddMenuItemEx(menu, false, bufferx2, bufferx);
		}
		SetMenuExitButton(menu, true);
		DisplayMenu(menu, client, MENU_TIME_FOREVER);
	}
	else if(RP_getPDcount() == 1)
	{
		g_iSelectedPDID[client] = 0;
		Menu_SelectJailType(client);
	}
	else
	{
		PrintToChat(client, "No PDs / Call Admin to create one");
	}
}

public MenuHandler_PD(Handle:menu, MenuAction:action, client, param2)
{
	if(0 >= client > MaxClients)
		return;
	
	new target = g_MenuTarget[client];
	
	if(!target)
		return;
	
	if(!IsClientInGame(client) || !IsPlayerAlive(client))
		return;
	
	if(!IsClientInGame(target) || !IsPlayerAlive(target))
		return;
		
	if(!Entity_InRange(client, target, INTERACTIONRANGE))
		return;
	
	if (action == MenuAction_Select)
	{
		decl String:info[100], String:info2[100];
		new bool:found = GetMenuItem(menu, param2, info, sizeof(info), _, info2, sizeof(info2));
		
		if(found)
		{
			new pdid = StringToInt(info);
			g_iSelectedPDID[client] = pdid;
			Menu_SelectJailType(client);
		}
	}
}

Menu_SelectJailType(client)
{
	new pdid = g_iSelectedPDID[client];
	new Handle:menu = CreateMenu(MenuHandler_SelectJailType);
	SetMenuTitle(menu, "[PD] Choose Jailtype");
	for(new i = 0 ; i < MAXJAILTYPES ; i++)
	{
		if(RP_PDHasJailtype(pdid,i))
		{
			if(i == 0)
			{
				AddMenuItemEx(menu, false, "150", "2:30Min Jail");
				AddMenuItemEx(menu, false, "300", "5Min Jail");
				AddMenuItemEx(menu, false, "600", "10Min Jail");
				AddMenuItemEx(menu, false, "1200", "20Min Jail");
			}
			else if(i == 1)
			{
				AddMenuItemEx(menu, false, "1800", "30Min Isolation Chamber");
			}
			else if(i == 2)
			{
				AddMenuItemEx(menu, false, "0", "Burning Chamber");
			}
		}
				
	}
	SetMenuExitButton(menu, true);
	DisplayMenu(menu, client, MENU_TIME_FOREVER);
}

public MenuHandler_SelectJailType(Handle:menu, MenuAction:action, client, param2)
{
	if(0 >= client > MaxClients)
		return;
	
	new target = g_MenuTarget[client];
	new pdid = g_iSelectedPDID[client];
	
	if(!target)
		return;
	
	if(!IsClientInGame(client) || !IsPlayerAlive(client))
		return;
	
	if(!IsClientInGame(target) || !IsPlayerAlive(target))
		return;
		
	if(!Entity_InRange(client, target, INTERACTIONRANGE))
		return;
	
	if (action == MenuAction_Select)
	{
		decl String:info[100], String:info2[100];
		new bool:found = GetMenuItem(menu, param2, info, sizeof(info), _, info2, sizeof(info2));
		
		if(found)
		{
			new type = StringToInt(info);
			//Burning
			if(type == 0)
			{
				//Set Burning Chamber
			}
			//Normal Jail
			else if(type > 0 && type < 1800)
			{
				RP_ClientSetJail(target,type,pdid,0);
			}
			//Isolation
			else
			{
				RP_ClientSetJail(target,type,pdid,1);
			}	
		}
	}
}

/* Give Money */

Menu_GiveMoney(client, target)
{
	new money = RP_GetMoney(client);
	
	new Handle:menu = CreateMenu(MenuHandler_GiveMoney);
	SetMenuTitle(menu, "[Cash: $%d] Give cash to %N", money, target);
	
	AddMenuItemEx(menu, !(money > 1), "1", "$1");
	AddMenuItemEx(menu, !(money > 10), "10", "$10");
	AddMenuItemEx(menu, !(money > 100), "100", "$100");
	AddMenuItemEx(menu, !(money > 1000), "1000", "$1000");
	AddMenuItemEx(menu, !(money > 10000), "10000", "$10000");
	
	decl String:sAll[32];
	IntToString(money, sAll, sizeof(sAll));
	AddMenuItemEx(menu, !(money > 0), sAll, "$%d", RP_GetMoney(client))
	
	SetMenuExitButton(menu, true);
	DisplayMenu(menu, client, MENU_TIME_FOREVER);
}

public MenuHandler_GiveMoney(Handle:menu, MenuAction:action, client, param2)
{
	if(0 >= client > MaxClients)
		return;
	
	new target = g_MenuTarget[client];
	
	if(!target)
		return;
	
	if(!IsClientInGame(client))
		return;
	
	if(!IsClientInGame(target))
		return;
	
	if(!IsPlayerAlive(client))
		return;
	
	if(!IsPlayerAlive(target))
		return;
		
	if(!Entity_InRange(client, target, INTERACTIONRANGE))
		return;
	
	if (action == MenuAction_Select)
	{
		decl String:info[100], String:info2[100];
		new bool:found = GetMenuItem(menu, param2, info, sizeof(info), _, info2, sizeof(info2));
		
		if(found)
		{
			new amount = StringToInt(info);
			
			if(RP_TransferMoneyCash(client, target, amount))
			{
				CPrintToChat(client, "%s You have given $%d to %N.", PL_PRE, amount, target);
				CPrintToChat(target, "%s %N has given $%d to you.", PL_PRE, client, amount);
			}
			else CPrintToChat(client, "%s Transfer failed!", PL_PRE);
			
			Menu_GiveMoney(client, target);
		}
	}
}

/* Give Item */

Menu_Inventory(client)
{
	new items = RP_GetPlayerInventoryItemCount(client);
	new Handle:menu = CreateMenu(MenuHandler_Inventory);
	SetMenuTitle(menu, "Inventory [Items: %d]", items);
	
	for (new i = 0; i < items; i++)
	{
		new itemID = RP_GetPlayerInventoryItem(client, i);
		new durability = RP_HasPlayerInventoryItem(client, itemID);
		
		/* Remove items which are empty */
		if(durability < 1)
		{
			RP_RemovePlayerInventoryItem(client, itemID);
			continue;
		}
		
		decl String:sItemID[10];
		IntToString(itemID, sItemID, sizeof(sItemID));
		
		decl String:sItemName[64];
		RP_GetItemName(itemID, sItemName, sizeof(sItemName));
		
		AddMenuItemEx(menu, false, sItemID, "%dx %s", durability, sItemName);
	}
	
	SetMenuExitButton(menu, true);
	DisplayMenu(menu, client, MENU_TIME_FOREVER);
}

public MenuHandler_Inventory(Handle:menu, MenuAction:action, client, param2)
{
	if(0 >= client > MaxClients)
		return;
	
	if(!IsClientInGame(client))
		return;
	
	if(!IsPlayerAlive(client))
		return;
		
	if(!Entity_InRange(client, g_MenuTarget[client], INTERACTIONRANGE))
		return;
	
	if (action == MenuAction_Select)
	{
		decl String:info[100], String:info2[100];
		new bool:found = GetMenuItem(menu, param2, info, sizeof(info), _, info2, sizeof(info2));
		
		if(found)
		{
			new itemID = StringToInt(info);
			Menu_GiveItem(client, itemID);
			return;
		}
	}
}

Menu_GiveItem(client, itemID)
{
	g_iSelectedItemID[client] = itemID;
	
	decl String:sItemName[64];
	RP_GetItemName(itemID, sItemName, sizeof(sItemName));
	
	decl String:sItemDescription[64];
	RP_GetItemDescription(itemID, sItemDescription, sizeof(sItemDescription));
	
	new Handle:menu = CreateMenu(MenuHandler_GiveItem);
	SetMenuTitle(menu, "Item: %dx %s%s\nDescription: %s", RP_HasPlayerInventoryItem(client, itemID), RP_IsItemVipOnly(itemID) ? "(VIP) ":"", sItemName, sItemDescription);
	
	AddMenuItemEx(menu, false, "inventory", "Back to inventory");
	AddMenuItemEx(menu, !(RP_HasPlayerInventoryItem(client, itemID) < 1), "1", "Give 1");
	AddMenuItemEx(menu, !(RP_HasPlayerInventoryItem(client, itemID) < 5), "5", "Give 5");
	AddMenuItemEx(menu, !(RP_HasPlayerInventoryItem(client, itemID) < 25), "25", "Give 25");
	AddMenuItemEx(menu, !(RP_HasPlayerInventoryItem(client, itemID) < 100), "100", "Give 100");
	AddMenuItemEx(menu, false, "main", "Back to Main");
	
	SetMenuExitButton(menu, true);
	DisplayMenu(menu, client, MENU_TIME_FOREVER);
}

public MenuHandler_GiveItem(Handle:menu, MenuAction:action, client, param2)
{	
	if(0 >= client > MaxClients)
		return;
	
	new target = g_MenuTarget[client];
	
	if(!target)
		return;
	
	if(!IsClientInGame(client))
		return;
	
	if(!IsClientInGame(target))
		return;
	
	if(!IsPlayerAlive(client))
		return;
	
	if(!IsPlayerAlive(target))
		return;
		
	if(!Entity_InRange(client, target, INTERACTIONRANGE))
		return;
		
		
	
	if (action == MenuAction_Select)
	{
		decl String:info[100], String:info2[100];
		new bool:found = GetMenuItem(menu, param2, info, sizeof(info), _, info2, sizeof(info2));
		
		if(found)
		{
			new itemID = g_iSelectedItemID[client];
			
			/* Back || Invalid item */
			if(StrEqual(info, "inventory") ||RP_HasPlayerInventoryItem(client, itemID) < 1)
			{
				Menu_Inventory(client);
				return;
			}
			
			if(StrEqual(info, "main"))
			{
				Menu_Main(client, target);
				return;
			}
			
			/* Give item */
			if(StrEqual(info, "1") && RP_HasPlayerInventoryItem(client, itemID) >= 1)
			{
				if(RP_IsItemUseable(itemID))
				{
					RP_AddPlayerInventoryItem(target, itemID, 1);
					RP_AddPlayerInventoryItem(client, itemID, -1);
				}
			}
			
			if(StrEqual(info, "5") && RP_HasPlayerInventoryItem(client, itemID) >= 5)
			{
				if(RP_IsItemUseable(itemID))
				{
					RP_AddPlayerInventoryItem(target, itemID, 5);
					RP_AddPlayerInventoryItem(client, itemID, -5);
				}
			}
			
			if(StrEqual(info, "25") && RP_HasPlayerInventoryItem(client, itemID) >= 25)
			{
				if(RP_IsItemUseable(itemID))
				{
					RP_AddPlayerInventoryItem(target, itemID, 25);
					RP_AddPlayerInventoryItem(client, itemID, -25);
				}
			}
			
			if(StrEqual(info, "100") && RP_HasPlayerInventoryItem(client, itemID) >= 100)
			{
				if(RP_IsItemUseable(itemID))
				{
					RP_AddPlayerInventoryItem(target, itemID, 100);
					RP_AddPlayerInventoryItem(client, itemID, -100);
				}
			}


			
			/* Re-Open Menu */
			if(RP_HasPlayerInventoryItem(client, itemID) < 1)
				Menu_Main(client,target);
			else Menu_GiveItem(client, itemID);
		}
	}
}

/* Playerstats */

ShowPlayerStatsToClient(client, target)
{
	PrintToChat(client,"Name: %N",target);
	PrintToChat(client,"Money: %d | Bank: %d",RP_GetMoney(target),RP_GetMoneyBank(target));
	PrintToChat(client,"Crime: %d | MaxCrime: %d | Bounty: %d | MaxBounty: %d",RP_GetCrime(target),RP_GetMaxCrime(target),RP_GetBounty(target),RP_GetMaxBounty(target));
	PrintToChat(client,"LastCrime: %d | LastCrime: %d | LastCrimeRemoval: %d",RP_GetLastCrime(target),RP_GetLastCrimeRemoval(target));
	Menu_Main(client, target);
}