#include "roleplay/roleplay"

#define PL_NAME		"RP_SQL"

public Plugin:myinfo = 
{
	name = PL_NAME,
	author = PL_AUTHOR,
	description = "",
	version = PL_VERSION,
	url = PL_URL
}

new bool:g_LateLoaded;

new g_reconnectCounter = 0;

/* Database */
new Handle:g_hSQL;

/* Forwards */
new Handle:g_OnSqlConnected;
new Handle:g_OnSqlStop;

public APLRes:AskPluginLoad2(Handle:myself, bool:late, String:error[], err_max)
{
	g_LateLoaded = late;
	RegPluginLibrary(PL_NAME);
	
	CreateNative("RP_GetSql", Native_SqlGetConnection);
	
	g_OnSqlConnected = CreateGlobalForward("RP_OnSqlConnected", ET_Event, Param_Cell);
	g_OnSqlStop = CreateGlobalForward("RP_OnSqlStop", ET_Event);

	if(g_LateLoaded)
	{
		Call_StartForward(g_OnSqlStop);
		Call_Finish();
	}
	
	return APLRes_Success;
}

public OnPluginStart()
{
	ConnectSQL();
}

public OnPluginEnd()
{
	Call_StartForward(g_OnSqlStop);
	Call_Finish();
}

ConnectSQL()
{
	if(g_hSQL != INVALID_HANDLE)
	{
		Call_StartForward(g_OnSqlStop);
		Call_Finish();
		
		CloseHandle(g_hSQL);
		g_hSQL = INVALID_HANDLE;
	}
	
	if (SQL_CheckConfig("roleplay"))
		SQL_TConnect(ConnectSQLCallback, "roleplay");
	else SetFailState("PLUGIN STOPPED - Reason: no config entry found for 'roleplay' in databases.cfg - PLUGIN STOPPED");
}

public ConnectSQLCallback(Handle:owner, Handle:hndl, const String:error[], any:data)
{
	if (hndl == INVALID_HANDLE)
	{
		g_reconnectCounter++;
		
		LogError("%s [%s] (ConnectSQLCallback) Connection to SQL database has failed, Try %d, Reason: %s", PL_PRE_N, PL_NAME, g_reconnectCounter, error);
		
		if(g_reconnectCounter >= 10) 
		{
			Call_StartForward(g_OnSqlStop);
			Call_Finish();
		}
		else if(g_reconnectCounter > 5) 
			CreateTimer(10.0, Timer_ReConnect);
		else if(g_reconnectCounter > 3)
			CreateTimer(5.0, Timer_ReConnect);
		else CreateTimer(1.0, Timer_ReConnect);
		
		return;
	}
	
	g_reconnectCounter = 1;

	g_hSQL = CloneHandle(hndl);
	
	LogMessage("%s [%s] SQL connection established and ready.", PL_PRE_N, PL_NAME);
	Call_StartForward(g_OnSqlConnected);
	Call_PushCell(_:g_hSQL);
	Call_Finish();
	
}

public Action:Timer_ReConnect(Handle:timer, any:data)
{
	ConnectSQL();
	return Plugin_Stop;
}

public Native_SqlGetConnection(Handle:plugin, numParams)
{
	return _:g_hSQL;
}