#include "roleplay/roleplay"
#include <sourcemod>

#define PL_NAME		"RP_TEAMS"

new bool:g_LateLoaded;
new bool:g_CopMode[MAXPLAYERS+1];
new bool:g_CopRights[MAXPLAYERS+1];

/* Database */
new Handle:g_hSQL;

public Plugin:myinfo = 
{
	name = PL_NAME,
	author = PL_AUTHOR,
	description = "",
	version = PL_VERSION,
	url = PL_URL
}

public APLRes:AskPluginLoad2(Handle:myself, bool:late, String:error[], err_max)
{
	g_LateLoaded = late;
	RegPluginLibrary(PL_NAME);
	CreateNative("RP_SetCop", Native_SetCop);
	CreateNative("RP_IsCop", Native_IsCop);
	CreateNative("RP_ChangeCopMode", Native_ChangeCopMode);
	return APLRes_Success;
}

public OnPluginStart()
{
	if(g_LateLoaded)
	{
		g_hSQL = Handle:RP_GetSql();
		
		if(g_hSQL != INVALID_HANDLE)
			SQLConnectionReady();
		
		g_LateLoaded = false;
	}
	
	RegConsoleCmd("kill", InterceptKill);
	RegConsoleCmd("jointeam", InterceptKill);
	RegConsoleCmd("spectate", InterceptKill);
	//HookEvent("player_team", Event_PlayerTeam, EventHookMode_Pre)
	RegConsoleCmd("sm_switch", Command_Switch);
	HookEvent("player_spawn",Event_Spawn);
}

public Action:Command_Switch(client, args)
{
	if(0 >= client > MaxClients)
		return Plugin_Handled;
	
	if(!IsClientInGame(client))
		return Plugin_Handled;
	
	if(!IsPlayerAlive(client))
		return Plugin_Handled;
	
	if(g_CopRights[client])
	{
		RP_ChangeCopMode(client);
		ForcePlayerSuicide(client);
	}
	else CPrintToChat(client, "%s You are no cop.", PL_PRE);
	
	return Plugin_Handled;
}

public Action:Event_Spawn(Handle:event,const String:name[],bool:dontBroadcast)
{
	new client = GetClientOfUserId(GetEventInt(event, "userid"));
	new team = GetClientTeam(client);
	
	if(team == CS_TEAM_CT)
	{
		// Don't allow joining CT team when player is not a cop
		if(!g_CopRights[client] || !g_CopMode[client])
		{
			//Switch to Ts instead
			switchFix(client , CS_TEAM_T);
			CreateTimer(1.5, SuicideTimer, client);
			return Plugin_Handled;
		}
	}
	
	return Plugin_Continue;
}

/*public Action:Event_PlayerTeam(Handle:event, const String:name[], bool:dontBroadcast)
{
	new client = GetClientOfUserId(GetEventInt(event, "userid"));
	new team = GetEventInt(event, "team");
	
	if(team == CS_TEAM_CT)
	{
		// Don't allow joining CT team when player is not a cop
		if(!g_CopRights[client] || !g_CopMode[client])
		{
			//Switch to Ts instead
			switchFix(client , CS_TEAM_T);
			CreateTimer(1.5, SuicideTimer, client);
			return Plugin_Handled;
		}
	}
	
	return Plugin_Continue;
}*/

public OnMapStart()
{
	ServerCommand("mp_teamname_1 Cops");
	ServerCommand("mp_teamname_2 Civilian");
}
public RP_OnSqlConnected(Handle:db)
{
	g_hSQL = db;
	SQLConnectionReady();
}

public RP_OnSqlStop()
{
	g_hSQL = INVALID_HANDLE;
}

public RP_OnPlayerReady(client, playerID, bool:create)
{
	if(create)
	{		
		decl String:sQuery[2048];
		FormatEx(sQuery, sizeof(sQuery), "INSERT INTO `rp_player_cop` (playerID, isCop) VALUES (%d, 0)", RP_GetPlayerID(client));
		SQL_TQuery(g_hSQL, SQL_ClientCreateCallback, sQuery, _, DBPrio_Normal);
	}
	
	LoadPlayer(client);
}

public SQL_ClientCreateCallback(Handle:owner, Handle:hndl, const String:error[], any:userid)
{
	if (owner == INVALID_HANDLE || hndl == INVALID_HANDLE)
	{
		LogError("%s [%s] (SQL_ClientCreateCallback) %s", PL_PRE_N, PL_NAME, error);
	}
}

LoadPlayer(client)
{
	g_CopMode[client] = false;
	decl String:sQuery[2048];
	Format(sQuery, sizeof(sQuery), "SELECT `isCop` FROM `rp_player_cop` WHERE `playerID` = %d", RP_GetPlayerID(client));
	SQL_TQuery(g_hSQL, SQL_ClientLoadCallback, sQuery, GetClientUserId(client), DBPrio_Low);
}

public SQL_ClientLoadCallback(Handle:owner, Handle:hndl, const String:error[], any:userid)
{
	if (owner == INVALID_HANDLE || hndl == INVALID_HANDLE)
	{
		LogError("%s [%s] (SQL_ClientConnectCallback) %s", PL_PRE_N, PL_NAME, error);
	}

	new client = GetClientOfUserId(userid);
	if(!client || !IsClientInGame(client))
		return;
	
	if(SQL_GetRowCount(hndl))
	{
		SQL_FetchRow(hndl);
		g_CopRights[client] = bool:SQL_FetchInt(hndl, 0);
	}
}

SQLConnectionReady()
{
	decl String:sQuery[2048];
	Format(sQuery, sizeof(sQuery), "CREATE TABLE IF NOT EXISTS `rp_player_cop` (`playerID` int(10) NOT NULL, `isCop` BOOL NOT NULL DEFAULT '0', PRIMARY KEY (`playerID`)) ENGINE=InnoDB DEFAULT CHARSET=utf8;");
	LogMessage("%s [%s] Query: %s", PL_PRE_N, PL_NAME, sQuery);
	SQL_TQuery(g_hSQL, SQL_CreateTableCallback, sQuery, _, DBPrio_High);
}

public SQL_CreateTableCallback(Handle:owner, Handle:hndl, const String:error[], any:data)
{
	if (owner == INVALID_HANDLE || hndl == INVALID_HANDLE)
	{
		LogError("%s [%s] (SQL_CreateTableCallback) %s", PL_PRE_N, PL_NAME, error);
	}
}

public OnClientConnected(client)
{
	g_CopMode[client] = false;
}

public Action:InterceptKill(client, args)
{
	if(!IsClientInGame(client))
		return Plugin_Continue;
	
	if(!IsPlayerAlive(client))
		return Plugin_Continue;
	
	new team = GetClientTeam(client);
	
	//Ignore players in spec
	if(team < CS_TEAM_T)
		return Plugin_Continue;
	
	//Just double check
	if(team == CS_TEAM_CT && !g_CopMode[client] && !g_CopRights[client])
	{
		switchFix(client , CS_TEAM_T);
		CreateTimer(1.5, SuicideTimer, client);
		return Plugin_Continue;
	}
	
	if(RP_GetCrime(client) == 0 || !RP_IsClientCuffed(client) /*|| !knockedout*/)
	{
		//Check player is moving to abort?
		PrintToChat(client, "%s You'll die in 10 seconds [Anti Escape]", PL_PRE);
		CreateTimer(10.0, SuicideTimer, client);
		return Plugin_Handled;
	}
	else
	{
		CPrintToChat(client, "%s You can't kill yourself right now!", PL_PRE);
		return Plugin_Handled;
	}
}

public switchFix(client , toteam)
{
	new Handle:data = CreateDataPack();
	WritePackCell(data, client);
	WritePackCell(data, toteam);
	ChangeClientTeam(client, CS_TEAM_SPECTATOR);
	CreateTimer(1.0, TeamChangeTimer, data);
}

public Action:SuicideTimer(Handle:timer, any:client)
{
	if(IsPlayerAlive(client) && IsClientInGame(client))
	{
		ForcePlayerSuicide(client);
		return Plugin_Continue;
	}
	return Plugin_Continue;
}

public Action:TeamChangeTimer(Handle:timer, any:data)
{
	ResetPack(data);
	new client = ReadPackCell(data);
	new toteam = ReadPackCell(data);
	CloseHandle(data);
	
	if(IsClientInGame(client))
		ChangeClientTeam(client, toteam);
	return Plugin_Handled;
}

public IsCop(client)
{
	return (g_CopMode[client] && g_CopRights[client]);
}

public SetCop(client,bool:set)
{
	if(set)
	{
		g_CopRights[client] = true;
		CPrintToChat(client, "%s You have Coprights now", PL_PRE);
		SavePlayer(client);
	}
	else
	{
		g_CopRights[client] = false;
		CPrintToChat(client, "%s You have no Coprights anymore", PL_PRE);
		if(GetClientTeam(client) == CS_TEAM_CT || g_CopMode[client] == true)
		{
			switchFix(client , CS_TEAM_T);
			CreateTimer(1.5, SuicideTimer, client);
		}
		SavePlayer(client);
	}
}

SavePlayer(client)
{
	decl String:sQuery[2048];
	FormatEx(sQuery, sizeof(sQuery), "UPDATE `rp_player_cop` SET isCop = %d WHERE playerID = %d", g_CopRights[client], RP_GetPlayerID(client));
	SQL_TQuery(g_hSQL, SQL_ClientUpdateCallback, sQuery, _);
}

public SQL_ClientUpdateCallback(Handle:owner, Handle:hndl, const String:error[], any:userid)
{
	if (owner == INVALID_HANDLE || hndl == INVALID_HANDLE)
	{
		LogError("%s [%s] (SQL_ClientUpdateCallback) %s", PL_PRE_N, PL_NAME, error);
	}
}

public ChangeCopMode(client)
{
	//Cop not in Copmode
	if(g_CopMode[client] == false && g_CopRights[client] == true)
	{
		g_CopMode[client] = true;
		switchFix(client , CS_TEAM_CT);
		CreateTimer(1.5, SuicideTimer, client);
	}
	//Cop in Copmode
	else if(g_CopMode[client] == true && g_CopRights[client] == true)
	{
		g_CopMode[client] = false;
		switchFix(client , CS_TEAM_T);
		CreateTimer(1.5, SuicideTimer, client);
	}
	//No Cop
	else
	{
		CPrintToChat(client, "%s You have no Coprights", PL_PRE);
	}
}

public Native_SetCop(Handle:plugin, numParams)
{
	SetCop(GetNativeCell(1), GetNativeCell(2));
}

public Native_IsCop(Handle:plugin, numParams)
{
	return IsCop(GetNativeCell(1));
}

public Native_ChangeCopMode(Handle:plugin, numParams)
{
	ChangeCopMode(GetNativeCell(1));
}