#include "roleplay/roleplay"

#define PL_NAME		"RP_ZONES"

new bool:g_LateLoaded;

/* Database */
new Handle:g_hSQL;

new String:g_currentMap[64];

/* Forwards */
new Handle:g_OnAllZonesLoaded;

new Handle:g_OnPlayerStartTouchZone;
new Handle:g_OnPlayerEndTouchZone;

/* Zones */

enum RP_Zone
{
    ZN_Id,
    ZN_Type,
    ZN_SubType,
	String:ZN_Name[32],
	String:ZN_Settings[512],
    Float:ZN_Point1[3],
    Float:ZN_Point2[3],
	ZN_Entity
}

/* ADT Templates */

new nZoneTeamplate[RP_Zone];
new Handle:g_hZones = INVALID_HANDLE;

new g_MapZoneEntityZID[2048];
new bool:g_bZone[2048][2048]; //Store all zones which are touched by entitys

public Plugin:myinfo = 
{
	name = PL_NAME,
	author = PL_AUTHOR,
	description = "",
	version = PL_VERSION,
	url = PL_URL
}

public APLRes:AskPluginLoad2(Handle:myself, bool:late, String:error[], err_max)
{
	g_LateLoaded = late;
	RegPluginLibrary(PL_NAME);
	
	/*
	CreateNative("RP_IsPlayerTouchingZoneType", Native_IsPlayerTouchingZoneType);
	CreateNative("RP_IsPlayerTouchingZoneSubType", Native_IsPlayerTouchingZoneSubType);
	CreateNative("RP_IsEntityTouchingZoneType", Native_IsEntityTouchingZoneType);
	CreateNative("RP_IsEntityTouchingZoneSubType", Native_IsEntityTouchingZoneSubType);
	
	CreateNative("RP_GetZoneIndexByEnity", Native_GetZoneIndexByEnity);
	CreateNative("RP_GetZoneIndexById", Native_GetZoneIndexById);
	CreateNative("RP_GetZoneIdByEnity", Native_GetZoneIdByEnity);
	CreateNative("RP_GetZoneIdByIndex", Native_GetZoneIdByIndex);
	CreateNative("RP_GetZoneEnityById", Native_GetZoneEnityById);
	CreateNative("RP_GetZoneEnityByIndex", Native_GetZoneEnityByIndex);
	*/
	
	CreateNative("RP_GetZoneType", Native_GetZoneType);
	CreateNative("RP_GetZoneSubType", Native_GetZoneSubType);
	CreateNative("RP_GetZonePoints", Native_GetZonePoints);
	CreateNative("RP_GetZoneName", Native_GetZoneName);
	CreateNative("RP_GetZoneSettings", Native_GetZoneSettings);
	
	CreateNative("RP_IsPosInsideZone", Native_IsPosInsideZone);
	
	g_OnAllZonesLoaded = CreateGlobalForward("RP_OnAllZonesLoaded", ET_Event);
	
	g_OnPlayerStartTouchZone = CreateGlobalForward("RP_OnPlayerStartTouchZone", ET_Event, Param_Cell, Param_Cell, Param_Cell, Param_Cell, Param_Cell);
	g_OnPlayerEndTouchZone = CreateGlobalForward("RP_OnPlayerEndTouchZone", ET_Event, Param_Cell, Param_Cell, Param_Cell, Param_Cell, Param_Cell);
	
	return APLRes_Success;
}

public OnPluginStart()
{
	/* Init ADT arrays */
	g_hZones = CreateArray(sizeof(nZoneTeamplate));
	nZoneTeamplate[Item_ID] = 0;
	
	if(g_LateLoaded)
	{
		g_hSQL = Handle:RP_GetSql();
		
		if(g_hSQL != INVALID_HANDLE)
			SQLConnectionReady();
		
		g_LateLoaded = false;
	}
}

public OnMapStart()
{
	GetCurrentMap(g_currentMap, sizeof(g_currentMap));
}

public RP_OnSqlConnected(Handle:db)
{
	g_hSQL = db;
	SQLConnectionReady();
}

public RP_OnSqlStop()
{
	g_hSQL = INVALID_HANDLE;
}

SQLConnectionReady()
{
	/* SQL: Create Table */
	decl String:sQuery[2048];
	Format(sQuery, sizeof(sQuery), "CREATE TABLE IF NOT EXISTS `rp_zones` (`id` int(11) NOT NULL AUTO_INCREMENT, `map` varchar(64) NOT NULL, `type` int(11) NOT NULL, `subType` int(11) NOT NULL, `name` varchar(32), `settings` varchar(512), `point1_x` float NOT NULL, `point1_y` float NOT NULL, `point1_z` float NOT NULL, `point2_x` float NOT NULL, `point2_y` float NOT NULL, `point2_z` float NOT NULL, PRIMARY KEY (`id`)) ENGINE=InnoDB DEFAULT CHARSET=utf8;");
	LogMessage("%s [%s] Query: %s", PL_PRE_N, PL_NAME, sQuery);
	SQL_TQuery(g_hSQL, SQL_CreateTableCallback, sQuery, _, DBPrio_High);
	
	/* SQL: Load Zones */
	decl String:query[512];
	FormatEx(query, sizeof(query), "SELECT `id`,`type`,`subType`,`type`,`name`,`settings`,`point1_x`,`point1_y`,`point1_z`,`point2_x`,`point2_y`,`point2_z`,`type` FROM `rp_zones` WHERE map = '%s';", g_currentMap);// ORDER BY level_id ASC
	SQL_TQuery(g_hSQL, SQL_LoadZonesCallback, query, _, DBPrio_High);
}

/* SQL: Create Table Callback */

public SQL_CreateTableCallback(Handle:owner, Handle:hndl, const String:error[], any:data)
{
	if (owner == INVALID_HANDLE || hndl == INVALID_HANDLE)
	{
		LogError("%s [%s] (SQL_CreateTableCallback) %s", PL_PRE_N, PL_NAME, error);
	}
}

/* SQL: Load Zones Callback */

public SQL_LoadZonesCallback(Handle:owner, Handle:hndl, const String:error[], any:data)
{
	if (owner == INVALID_HANDLE || hndl == INVALID_HANDLE)
	{
		LogError("%s [%s] (SQL_LoadZonesCallback) %s", PL_PRE_N, PL_NAME, error);
	}
	
	/* Fetch all items */
	while (SQL_FetchRow(hndl))
	{
		new nNew[RP_Zone];
		
		nNew[ZN_Id] = SQL_FetchInt(hndl, 0);
		nNew[ZN_Type] = SQL_FetchInt(hndl, 1);
		nNew[ZN_SubType] = SQL_FetchInt(hndl, 2);
		SQL_FetchString(hndl, 3, nNew[ZN_Name], 32);
		SQL_FetchString(hndl, 4, nNew[ZN_Settings], 512);
		
		nNew[ZN_Point1][0] = SQL_FetchFloat(hndl, 5);
		nNew[ZN_Point1][1] = SQL_FetchFloat(hndl, 6);
		nNew[ZN_Point1][2] = SQL_FetchFloat(hndl, 7);

		nNew[ZN_Point2][0] = SQL_FetchFloat(hndl, 8);
		nNew[ZN_Point2][1] = SQL_FetchFloat(hndl, 9);
		nNew[ZN_Point2][2] = SQL_FetchFloat(hndl, 10);
		
		nNew[ZN_Entity] = -1;
		
		PushArrayArray(g_hZones, nNew[0]);
	}
	
	/* Spawn Zone Entitys */
	SpawnZones();
	
	/* Let other plugins know all zones are ready */
	Call_StartForward(g_OnAllZonesLoaded);
	Call_Finish();
}

/* Delete all prop_dynamic entitys with "RP_ZONE_" in it's name*/
DeleteSpawnedZones()
{
	new entity=-1;
	decl String:sBuffer[20];
	while ((entity = FindEntityByClassname(entity, "trigger_multiple")) != -1)
	{
		GetEntPropString(entity, Prop_Data, "m_iName", sBuffer, sizeof(sBuffer));
		
		if (StrContains(sBuffer, "RP_ZONE_") != -1)
		{
			AcceptEntityInput(entity, "Kill");
			g_MapZoneEntityZID[entity] = -1;
		}
	}
}

/* We have to respawn all Zones every round start */
public Action:Event_RoundStart(Handle:event,const String:name[],bool:dontBroadcast)
{
	SpawnZones();
}

SpawnZones()
{
	DeleteSpawnedZones();
	
	for (new i = 0; i < GetArraySize(g_hZones); i++)
	{
		/* Cache Zone */
		new nNew[RP_Zone];
		GetArrayArray(g_hZones, i, nNew[0]);
		
		// Center
		new Float:center[3];
		center[0] = (nNew[ZN_Point1][0] + nNew[ZN_Point2][0]) / 2.0;
		center[1] = (nNew[ZN_Point1][1] + nNew[ZN_Point2][1]) / 2.0;
		center[2] = nNew[ZN_Point1][2];
		
		// Min & max bounds
		new Float:minbounds[3];
		new Float:maxbounds[3];
		
		minbounds[0] = FloatAbs(nNew[ZN_Point1][0] - nNew[ZN_Point2][0]) / -2.0;
		minbounds[1] = FloatAbs(nNew[ZN_Point1][1] - nNew[ZN_Point2][1]) / -2.0;
		minbounds[2] = -1.0; // Just to be save it's not buggy like a defective contact
		
		maxbounds[0] = FloatAbs(nNew[ZN_Point1][0] - nNew[ZN_Point2][0]) / 2.0;
		maxbounds[1] = FloatAbs(nNew[ZN_Point1][1] - nNew[ZN_Point2][1]) / 2.0;
		maxbounds[2] = FloatAbs(nNew[ZN_Point1][2] - nNew[ZN_Point2][2]);
		
		// Resize trigger (by default it's set to 16.0).  
		// A player is 32.0 unity wide, 
		// so we need to resize the trigger to have a touching border between the legs
		minbounds[0] += 16.0;
		minbounds[1] += 16.0;
		minbounds[2] += 16.0;
		maxbounds[0] -= 16.0;
		maxbounds[1] -= 16.0;
		maxbounds[2] -= 16.0;
		
		/* Give each Zone a unique entity name */
		new String:zone_name[64];
		Format(zone_name, sizeof(zone_name), "RP_ZONE_%d", i);
		
		new entity = CreateEntityByName("trigger_multiple");
		
		if(entity <= 0)
			return;
		
		SetEntityModel(entity, "models/props_junk/wood_crate001a.mdl"); // Doesn't matter which model, we funtional min/max vecs 
		
		DispatchKeyValue(entity, "targetname", zone_name);
		
		DispatchKeyValue(entity, "StartDisabled", "0");
		
		// Spawnflags for "trigger_multiple"
		// 1 - only a player can trigger this by touch, makes it so a NPC cannot fire a trigger_multiple
		// 2 - Won't fire unless triggering ent's view angles are within 45 degrees of trigger's angles (in addition to any other conditions), so if you want the player to only be able to fire the entity at a 90 degree angle you would do ",angles,0 90 0," into your spawnstring.
		// 4 - Won't fire unless player is in it and pressing use button (in addition to any other conditions), you must make a bounding box,(max\mins) for this to work.
		// 8 - Won't fire unless player/NPC is in it and pressing fire button, you must make a bounding box,(max\mins) for this to work.
		// 16 - only non-player NPCs can trigger this by touch
		// 128 - Start off, has to be activated by a target_activate to be touchable/usable
		// 256 - multiple players can trigger the entity at the same time
		DispatchKeyValue(entity, "spawnflags", "256");
		
		DispatchSpawn(entity);
		ActivateEntity(entity);
		
		// Set the size of our trigger_multiple box
		SetEntPropVector(entity, Prop_Send, "m_vecMins", minbounds);
		SetEntPropVector(entity, Prop_Send, "m_vecMaxs", maxbounds);
		
		SetEntProp(entity, Prop_Send, "m_nSolidType", 2);
		
		SetEntProp(entity, Prop_Send, "m_fEffects", GetEntProp(entity, Prop_Send, "m_fEffects") | 32);
		
		TeleportEntity(entity, center, NULL_VECTOR, NULL_VECTOR);
		
		SDKHook(entity, SDKHook_StartTouch,  StartTouchTrigger);
		SDKHook(entity, SDKHook_EndTouch, EndTouchTrigger);
		
		/* Save Entity ID */
		nNew[ZN_Entity] = entity;
		g_MapZoneEntityZID[entity] = i;
		
		/* Overwrite Zone */
		SetArrayArray(g_hZones, i, nNew[0]);
	}
}

public Action:StartTouchTrigger(entity, client)
{
	TouchZone(client, entity, true);
}

public Action:EndTouchTrigger(entity, client)
{
	TouchZone(client, entity, false);
}

TouchZone(entity, zoneEntity, bool:touch)
{
	if (entity < 1)
		return;

	new zoneIndex = g_MapZoneEntityZID[zoneEntity];

	if(zoneIndex < 0)
		return;
	
	new nNew[RP_Zone];
	GetArrayArray(g_hZones, zoneIndex, nNew[0]);
	
	new type = nNew[Item_ID];
	new subType = nNew[Item_ID];
	
	/* Let other plugins know the player touch status changed */
	if(IsPlayer(entity))
	{
		new client = entity;
		if (!IsClientInGame(client))
			return;
		
		if(touch)
			Call_StartForward(g_OnPlayerStartTouchZone);
		else  Call_StartForward(g_OnPlayerEndTouchZone);
		
		Call_PushCell(client);
		Call_PushCell(zoneEntity);
		Call_PushCell(zoneIndex);
		Call_PushCell(type);
		Call_PushCell(subType);
		Call_Finish();
	}
	
	/* Save Touch Status */
	g_bZone[zoneEntity][entity] = touch;
}

public RP_OnPlayerReady(client, playerID, bool:create)
{
	//PlayerID is now cached
}

/* Natives */

public Native_GetZoneType(Handle:plugin, numParams)
{
	new zoneIndex = GetNativeCell(1);
	
	new nNew[RP_Zone];
	GetArrayArray(g_hZones, zoneIndex, nNew[0]);
	
	return nNew[ZN_Type]
}

public Native_GetZoneSubType(Handle:plugin, numParams)
{
	new zoneIndex = GetNativeCell(1);
	
	new nNew[RP_Zone];
	GetArrayArray(g_hZones, zoneIndex, nNew[0]);
	
	return nNew[ZN_SubType]
}

public Native_GetZonePoints(Handle:plugin, numParams)
{
	new zoneIndex = GetNativeCell(1);
	
	new nNew[RP_Zone];
	GetArrayArray(g_hZones, zoneIndex, nNew[0]);
	
	new Float:fPoint1[3], Float:fPoint2[3], Float:fCenter[3];
	
	fPoint1[0] = nNew[ZN_Point1][0];
	fPoint1[1] = nNew[ZN_Point1][1];
	fPoint1[2] = nNew[ZN_Point1][2];
	
	fPoint2[0] = nNew[ZN_Point2][0];
	fPoint2[1] = nNew[ZN_Point2][1];
	fPoint2[2] = nNew[ZN_Point2][2];
	
	SetNativeArray(2, fPoint1, 3);
	SetNativeArray(3, fPoint2, 3);
	SetNativeArray(4, fCenter, 3);
}

public Native_GetZoneName(Handle:plugin, numParams)
{
	new zoneIndex = GetNativeCell(1);
	new nlen = GetNativeCell(3);
	
	new nNew[RP_Zone];
	GetArrayArray(g_hZones, zoneIndex, nNew[0]);
	
	decl String:buffer[nlen];
	FormatEx(buffer, nlen, "%s", nNew[ZN_Name]);
	
	if (SetNativeString(2, buffer, nlen, true) == SP_ERROR_NONE)
		return true;
	
	return false;
}

public Native_GetZoneSettings(Handle:plugin, numParams)
{
	new zoneIndex = GetNativeCell(1);
	new nlen = GetNativeCell(3);
	
	new nNew[RP_Zone];
	GetArrayArray(g_hZones, zoneIndex, nNew[0]);
	
	decl String:buffer[nlen];
	FormatEx(buffer, nlen, "%s", nNew[ZN_Settings]);
	
	if (SetNativeString(2, buffer, nlen, true) == SP_ERROR_NONE)
		return true;
	
	return false;
}

public Native_IsPosInsideZone(Handle:plugin, numParams)
{
	new zoneIndex = GetNativeCell(1);
	
	new Float:fPos[3];
	GetNativeArray(2, fPos, 3);
	
	new nNew[RP_Zone];
	GetArrayArray(g_hZones, zoneIndex, nNew[0]);
	
	new Float:fPoint1[3], Float:fPoint2[3];
	
	fPoint1[0] = nNew[ZN_Point1][0];
	fPoint1[1] = nNew[ZN_Point1][1];
	fPoint1[2] = nNew[ZN_Point1][2];
	
	fPoint2[0] = nNew[ZN_Point2][0];
	fPoint2[1] = nNew[ZN_Point2][1];
	fPoint2[2] = nNew[ZN_Point2][2];
	
	if (IsInsideBox(fPos, fPoint1[0], fPoint1[1], fPoint1[2], fPoint2[0], fPoint2[1], fPoint2[2]))
		return true;
	
	return false;
}

IsInsideBox(Float:fPCords[3], Float:fbsx, Float:fbsy, Float:fbsz, Float:fbex, Float:fbey, Float:fbez)
{
	new Float:fpx = fPCords[0];
	new Float:fpy = fPCords[1];
	new Float:fpz = fPCords[2]+1;

	new bool:bX = false;
	new bool:bY = false;
	new bool:bZ = false;

	if (fbsx > fbex && fpx <= fbsx && fpx >= fbex)
		bX = true;
	else if (fbsx < fbex && fpx >= fbsx && fpx <= fbex)
		bX = true;

	if (fbsy > fbey && fpy <= fbsy && fpy >= fbey)
		bY = true;
	else if (fbsy < fbey && fpy >= fbsy && fpy <= fbey)
		bY = true;

	if (fbsz > fbez && fpz <= fbsz && fpz >= fbez)
		bZ = true;
	else if (fbsz < fbez && fpz >= fbsz && fpz <= fbez)
		bZ = true;

	if (bX && bY && bZ)
		return true;

	return false;
}