/*
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
REPLACE XXX WITH BUILDING NAME
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
*/


#include "roleplay/roleplay"

#define PL_NAME		"RP_BUILDING_XXX_ACCESS"

new bool:g_LateLoaded;

/* Database */
new Handle:g_hSQL;

/* ADT ARRAY */
new nXXXDoorAccessTeamplate[RP_XXXAccess];
new Handle:g_hXXXDoorAccess = INVALID_HANDLE;

public Plugin:myinfo = 
{
	name = PL_NAME,
	author = PL_AUTHOR,
	description = "",
	version = PL_VERSION,
	url = PL_URL
}

public APLRes:AskPluginLoad2(Handle:myself, bool:late, String:error[], err_max)
{
	g_LateLoaded = late;
	RegPluginLibrary(PL_NAME);
	
	CreateNative("RP_GetPlayerXXXAccess", Native_GetPlayerXXXAccess);
	CreateNative("RP_SetPlayerXXXAccess", Native_SetPlayerXXXAccess);
	
	return APLRes_Success;
}

public OnPluginStart()
{
	g_hXXXDoorAccess = CreateArray(sizeof(nXXXDoorAccessTeamplate));
	nXXXDoorAccessTeamplate[XXXAccess_PlayerID] = 0;
	
	if(g_LateLoaded)
	{
		g_hSQL = Handle:RP_GetSql();
		
		if(g_hSQL != INVALID_HANDLE)
			SQLConnectionReady();
		
		g_LateLoaded = false;
	}
	
	decl String:sQuery[2048];
	
	Format(sQuery, sizeof(sQuery), "CREATE TABLE IF NOT EXISTS `rp_building_XXX_doors` (  `PlayerID` int(10) NOT NULL, `BuildingID` int(10) NOT NULL, `AccessID` int(10) NOT NULL, PRIMARY KEY (`PlayerID`,`BuildingID`)) ENGINE=InnoDB DEFAULT CHARSET=utf8;");
	LogMessage("%s [%s] Query: %s", PL_PRE_N, PL_NAME, sQuery);
	SQL_TQuery(g_hSQL, SQL_CreateTableCallback, sQuery, _, DBPrio_High);
	
	ResetXXXDoorAccess();
	LoadXXXDoorAccess();
}

public SQL_CreateTableCallback(Handle:owner, Handle:hndl, const String:error[], any:data)
{
	if (owner == INVALID_HANDLE || hndl == INVALID_HANDLE)
	{
		LogError("%s [%s] (SQL_CreateTableCallback) %s", PL_PRE_N, PL_NAME, error);
	}
}

ResetXXXDoorAccess()
{
	ClearArray(g_hXXXDoorAccess);
	g_hXXXDoorAccess = CreateArray(sizeof(nXXXDoorAccessTeamplate));
}

LoadXXXDoorAccess()
{
	decl String:sQuery[2048];
	Format(sQuery, sizeof(sQuery), "SELECT `PlayerID`, `AccessID`, `BuildingID` FROM `rp_building_XXX_doors`;");
	SQL_TQuery(g_hSQL, SQL_LoadXXXDoorAccessCallback, sQuery, _, DBPrio_Low);
}

public SQL_LoadXXXDoorAccessCallback(Handle:owner, Handle:hndl, const String:error[], any:data)
{
	if (owner == INVALID_HANDLE || hndl == INVALID_HANDLE)
	{
		LogError("%s [%s] (SQL_LoadXXXDoorAccessCallback) %s", PL_PRE_N, PL_NAME, error);
	}
	
	while (SQL_FetchRow(hndl))
	{
		new nNew[RP_XXXAccess];
		
		nNew[XXXAccess_PlayerID] = SQL_FetchInt(hndl, 0);
		nNew[XXXAccess_AccessID] = SQL_FetchInt(hndl, 1);
		nNew[XXXAccess_BuildingID] = SQL_FetchInt(hndl, 2);
		
		PushArrayArray(g_hXXXDoorAccess, nNew[0]);
	}
}

public RP_OnSqlConnected(Handle:db)
{
	g_hSQL = db;
	SQLConnectionReady();
}

public RP_OnSqlStop()
{
	g_hSQL = INVALID_HANDLE;
}

SQLConnectionReady()
{
	//Database is now ready to use
}

public RP_OnPlayerReady(client, playerID, bool:create)
{
	//PlayerID is now cached
}

public RP_OnDoorUse(doorID,type,client)
{
	if(0 >= client || client > MaxClients + 1)
		return;
	
	if(!IsClientInGame(client))
		return;
	
	if(!IsPlayerAlive(client))
		return;
	
	if(type == Door_XXX)
	{
		
	}
}

GetPlayerXXXAccess(client, buildingID)
{
	if(0 >= client || client > MaxClients + 1)
		return -1;
	
	if(!IsClientInGame(client))
		return -1;
	
	if(!IsPlayerAlive(client))
		return -1;
	
	new playerID = RP_GetPlayerID(client);
	
	for (new i = 0; i < GetArraySize(g_hXXXDoorAccess); i++)
	{
		new nNew[RP_XXXAccess];
		GetArrayArray(g_hXXXDoorAccess, i, nNew[0]);
		
		if (nNew[XXXAccess_PlayerID] == playerID && nNew[BankAccess_BuildingID] == buildingID)
		{
			return nNew[XXXAccess_AccessID];
		}
	}
	
	return -1;

}

SetPlayerXXXAccess(client, buildingID, new_accessID)
{
	if(0 >= client || client > MaxClients + 1)
		return;
	
	if(!IsClientInGame(client))
		return;
	
	if(!IsPlayerAlive(client))
		return;
	
	new playerID = RP_GetPlayerID(client);
	new bool:insert = true;
	
	for (new i = 0; i < GetArraySize(g_hXXXDoorAccess); i++)
	{
		new nNew[RP_XXXAccess];
		GetArrayArray(g_hXXXDoorAccess, i, nNew[0]);
		
		if (nNew[XXXAccess_PlayerID] == playerID && nNew[BankAccess_BuildingID] == buildingID)
		{
			nNew[XXXAccess_AccessID] = new_accessID;
			SetArrayArray(g_hXXXDoorAccess, i, nNew[0]); 
			insert = false;
		}
	}
	
	if(insert)
	{
		decl String:sQuery[2048];
	
		Format(sQuery, sizeof(sQuery), "INSERT INTO `rp_building_XXX_doors` ( PlayerID, BuildingID , AccessID) VALUES (%d, %d, %d);",playerID, buildingID,new_accessID);
		LogMessage("%s [%s] Query: %s", PL_PRE_N, PL_NAME, sQuery);
		SQL_TQuery(g_hSQL, SQL_InsertPlayerXXXAccessTableCallback, sQuery, _, DBPrio_High);
	}
}

public SQL_InsertPlayerXXXAccessTableCallback(Handle:owner, Handle:hndl, const String:error[], any:data)
{
	if (owner == INVALID_HANDLE || hndl == INVALID_HANDLE)
	{
		LogError("%s [%s] (SQL_InsertPlayerXXXAccessTableCallback) %s", PL_PRE_N, PL_NAME, error);
	}
}

public Native_GetPlayerXXXAccess(Handle:plugin, numParams)
{
	return GetPlayerXXXAccess(GetNativeCell(1),GetNativeCell(2));
}

public Native_SetPlayerXXXAccess(Handle:plugin, numParams)
{
	SetPlayerXXXAccess(GetNativeCell(1),GetNativeCell(2),GetNativeCell(3));
}