#if defined _zcore_lootspawner_included
  #endinput
#endif
#define _zcore_lootspawner_included

#define TYPE_NONE -1

#define MAX_LOOTSPAWNS 1024

#define LS_FLAG_TOUCH				(1 << 0)
#define LS_FLAG_USE					(1 << 1)
#define LS_FLAG_NOSHADOWS			(1 << 2)
#define LS_FLAG_NORECEIVESHADOWS	(1 << 3)
#define LS_FLAG_USESPAWNCENTER		(1 << 4)

/* Forwards */

forward void ZCore_LootSpawner_OnPluginStart();
forward bool ZCore_LootSpawner_OnLootSpawned(int entity, int type);
forward bool ZCore_LootSpawner_OnPlayerLoot(int client, int entity, int type);

/* Natives */

native int ZCore_LootSpawner_RegisterLootType(char name[32], char model[256], int weight, int roundStartWeight, int maxSpawned, int flags, int minDistance, int maxDistance);

native int ZCore_LootSpawner_GetType(int entity);
native int ZCore_LootSpawner_RemoveLoot(int entity);

native int ZCore_LootSpawner_WipeEntitysAll();
native int ZCore_LootSpawner_WipeEntitysByType(int type);

native int ZCore_LootSpawner_ForceSpawn(int type, float pos[3]);

public void __pl_zcore_lootspawner_SetNTVOptional() 
{
	MarkNativeAsOptional("ZCore_LootSpawner_RegisterLootType");
	MarkNativeAsOptional("ZCore_LootSpawner_GetType");
	MarkNativeAsOptional("ZCore_LootSpawner_RemoveLoot");
	MarkNativeAsOptional("ZCore_LootSpawner_WipeEntitysAll");
	MarkNativeAsOptional("ZCore_LootSpawner_WipeEntitysByType");
	MarkNativeAsOptional("ZCore_LootSpawner_ForceSpawn");
}