#include "roleplay/roleplay"

#define PL_NAME		"RP_ADMIN_MENU_BUILDINGS"

new bool:g_LateLoaded;

/* Database */
new Handle:g_hSQL;

/*Saves */
new String:g_SelectedBuildingName[MAXPLAYERS + 1][64];
new g_SelectedBuildingID[MAXPLAYERS + 1];
new g_SelectedAppartmentPrice[MAXPLAYERS + 1];
new g_SelectedInhibitants[MAXPLAYERS + 1];
new g_SelectedDoorType[MAXPLAYERS + 1];

new g_SelectedAppartmentID[MAXPLAYERS + 1];

public Plugin:myinfo = 
{
	name = PL_NAME,
	author = PL_AUTHOR,
	description = "",
	version = PL_VERSION,
	url = PL_URL
}

public APLRes:AskPluginLoad2(Handle:myself, bool:late, String:error[], err_max)
{
	g_LateLoaded = late;
	RegPluginLibrary(PL_NAME);
	
	CreateNative("RP_ShowBuildingMainAdminMenu", Native_ShowBuildingMainAdminMenu);
	
	return APLRes_Success;
}

public OnPluginStart()
{
	if(g_LateLoaded)
	{
		g_hSQL = Handle:RP_GetSql();
		
		if(g_hSQL != INVALID_HANDLE)
			SQLConnectionReady();
		
		g_LateLoaded = false;
	}
}

public RP_OnSqlConnected(Handle:db)
{
	g_hSQL = db;
	SQLConnectionReady();
}

public RP_OnSqlStop()
{
	g_hSQL = INVALID_HANDLE;
}

SQLConnectionReady()
{
	//Database is now ready to use
}

Menu_BuildingMain(client)
{	
	new Handle:menu = CreateMenu(MenuHandler_BuildingMain);
	SetMenuTitle(menu, "[RP] Manage Buildings");
	
	AddMenuItemEx(menu, false, "0", "Create Building");
	AddMenuItemEx(menu, false, "1", "Edit Buildings");
	AddMenuItemEx(menu, false, "998", "Back to Building Main");
	AddMenuItemEx(menu, false, "999", "Back to Main");

	SetMenuExitButton(menu, true);
	DisplayMenu(menu, client, MENU_TIME_FOREVER);
}

public MenuHandler_BuildingMain(Handle:menu, MenuAction:action, client, param2)
{
	if(0 >= client || client > MaxClients + 1)
		return;
	
	if(!IsClientInGame(client))
		return;
	
	if(!IsPlayerAlive(client))
		return;
	
	if (action == MenuAction_Select)
	{
		decl String:info[100], String:info2[100];
		new bool:found = GetMenuItem(menu, param2, info, sizeof(info), _, info2, sizeof(info2));
		
		if(found)
		{
			new selection = StringToInt(info);
			
			if(selection == 0)
			{
				RP_SetClientSelectedString(client, "Default Building");
				Menu_SelectBuildingName(client);
			}
			else if(selection == 1)
			{
				Menu_SelectBuilding(client);
			}
			else if(selection == 999)
			{
				RP_ShowMainAdminMenu(client);
			}
			return;
		}
	}
}

Menu_SelectBuildingName(client)
{
	new Handle:menu = CreateMenu(MenuHandler_SelectBuildingName);
	SetMenuTitle(menu, "[RP] Select Building Name");

	new String:buffer[64];
	RP_GetClientSelectedString(client, buffer, sizeof(buffer));
	
	PrintToChat(client,"Write /s \"name\" , to set the name!");
	
	AddMenuItemEx(menu, true, "900", "Selected Name: %s", buffer);
	AddMenuItemEx(menu, false, "0", "Refresh");
	AddMenuItemEx(menu, false, "1", "Accept");
	AddMenuItemEx(menu, false, "998", "Back to Building Main");
	AddMenuItemEx(menu, false, "999", "Back to Main");
	
	SetMenuExitButton(menu, true);
	DisplayMenu(menu, client, MENU_TIME_FOREVER);
}

public MenuHandler_SelectBuildingName(Handle:menu, MenuAction:action, client, param2)
{
	if(0 >= client || client > MaxClients + 1)
		return;
	
	if(!IsClientInGame(client))
		return;
	
	if(!IsPlayerAlive(client))
		return;
	
	if (action == MenuAction_Select)
	{
		decl String:info[100], String:info2[100];
		new bool:found = GetMenuItem(menu, param2, info, sizeof(info), _, info2, sizeof(info2));
		
		if(found)
		{
			new selection = StringToInt(info);
			
			
			if(selection == 0)
			{
				Menu_SelectBuildingName(client);
			}
			else if(selection == 1)
			{
				RP_GetClientSelectedString(client, g_SelectedBuildingName[client], sizeof(g_SelectedBuildingName[]));
				Menu_SelectBuildingType(client);
			}
			else if(selection == 998)
			{
				Menu_BuildingMain(client);
			}
			else if(selection == 999)
			{
				RP_ShowMainAdminMenu(client);
			}
			else if(selection == 900)
			{
				Menu_SelectBuildingName(client);
			}
			return;
		}
	}
}

Menu_SelectBuildingType(client)
{
	new Handle:menu = CreateMenu(MenuHandler_SelectBuildingType);
	SetMenuTitle(menu, "Buildingtype Selection");
	
	new maxbu = RP_GetMaxBuildingType();
	new String:buffer[64]
	new String:sindex[10];
	
	for (new i = 0; i < maxbu; i++)
	{
		RP_GetBuildingTypeName(i, buffer, sizeof(buffer));
			
		IntToString(i, sindex, sizeof(sindex));
		AddMenuItemEx(menu, false, sindex, "%s", buffer);

	}
	AddMenuItemEx(menu, false, "998", "Back to Building Main");
	AddMenuItemEx(menu, false, "999", "Back to Main");
	
	SetMenuExitButton(menu, true);
	DisplayMenu(menu, client, MENU_TIME_FOREVER);
}

public MenuHandler_SelectBuildingType(Handle:menu, MenuAction:action, client, param2)
{
	if(0 >= client || client > MaxClients + 1)
		return;
	
	if(!IsClientInGame(client))
		return;
	
	if(!IsPlayerAlive(client))
		return;
	
	if (action == MenuAction_Select)
	{
		decl String:info[100], String:info2[100];
		new bool:found = GetMenuItem(menu, param2, info, sizeof(info), _, info2, sizeof(info2));

		if(found)
		{
			new selection = StringToInt(info);
			
			
			if(selection == 998)
			{
				Menu_BuildingMain(client);
			}
			else if(selection == 999)
			{
				RP_ShowMainAdminMenu(client);
			}
			else
			{
				RP_CreateBuilding(g_SelectedBuildingName[client] ,selection);
				PrintToChat(client, "Created Building %s with Type %d", g_SelectedBuildingName[client], selection);
				Menu_BuildingMain(client);
			}
			return;
		}
	}
}

Menu_SelectBuilding(client)
{	
	new Handle:menu = CreateMenu(MenuHandler_SelectBuilding);
	SetMenuTitle(menu, "[RP] Select Building to edit it");

	for (new i = 0; i < RP_GetBuildingCount(); i++)
	{
		
		new buildingID = RP_GetBuildingIDByArrayIndex(i);

		if (buildingID != -1)
		{
			new String:buffer[64];
			new String:buffer2[8];
			new String:typebuffer[64];
			RP_GetBuildingName(buildingID, buffer, sizeof(buffer));
			IntToString(buildingID, buffer2, sizeof(buffer2));
			RP_GetBuildingTypeName(RP_GetBuildingType(buildingID), typebuffer, sizeof(typebuffer));
			AddMenuItemEx(menu, false, buffer2, "[%d] %s | %s",buildingID,buffer,typebuffer);
		}
	}
	AddMenuItemEx(menu, false, "998", "Back to Building Main");
	AddMenuItemEx(menu, false, "999", "Back to Main");

	SetMenuExitButton(menu, true);
	DisplayMenu(menu, client, MENU_TIME_FOREVER);
}

public MenuHandler_SelectBuilding(Handle:menu, MenuAction:action, client, param2)
{
	if(0 >= client || client > MaxClients + 1)
		return;
	
	if(!IsClientInGame(client))
		return;
	
	if(!IsPlayerAlive(client))
		return;
	
	if (action == MenuAction_Select)
	{
		decl String:info[100], String:info2[100];
		new bool:found = GetMenuItem(menu, param2, info, sizeof(info), _, info2, sizeof(info2));
		
		if(found)
		{
			new selection = StringToInt(info);
			
			if(selection == 999)
			{
				RP_ShowMainAdminMenu(client);
			}
			else if(selection == 998)
			{
				Menu_BuildingMain(client);
			}
			else 
			{
				g_SelectedBuildingID[client] = selection;
				Menu_EditBuilding(client);
			}
			return;
		}
	}
}

Menu_EditBuilding(client)
{	
	new Handle:menu = CreateMenu(MenuHandler_EditBuilding);
	new String:buffer[64];
	RP_GetBuildingName(g_SelectedBuildingID[client],buffer, sizeof(buffer));
	new String:playernamebuffer[64];
	RP_GetBuildingOwnerName(g_SelectedBuildingID[client],playernamebuffer, sizeof(playernamebuffer));
	new String:typenamebuffer[64];
	RP_GetBuildingTypeName(RP_GetBuildingType(g_SelectedBuildingID[client]),typenamebuffer, sizeof(typenamebuffer));
	new buildingtype = RP_GetBuildingType(g_SelectedBuildingID[client]);
	new buildingOwner = RP_GetBuildingOwnerID(g_SelectedBuildingID[client]);
	
	SetMenuTitle(menu, "[RP] Edit Building [%d] %s ",g_SelectedBuildingID[client],buffer);

	AddMenuItemEx(menu, false, "0", "Edit Owner / [%d] %s",buildingOwner,playernamebuffer);
	AddMenuItemEx(menu, false, "1", "Edit Name / %s",buffer);
	AddMenuItemEx(menu, false, "2", "Edit Type / [%d] %s", buildingtype,typenamebuffer);
	if(buildingtype == BD_AppartmentHouse)
	{
		AddMenuItemEx(menu, false, "10", "Add Building Entrance Door");
		AddMenuItemEx(menu, false, "11", "Create Appartment for Building");
		AddMenuItemEx(menu, false, "12", "Edit Appartments of Building");
	}
	else if(buildingtype == BD_PoliceDepartment)
	{
		AddMenuItemEx(menu, false, "20", "Add door to policedepartment");
	}
	else if(buildingtype == BD_Shop)
	{
		AddMenuItemEx(menu, false, "30", "Add Entrance to Shop");
		AddMenuItemEx(menu, false, "31", "Add Worker Door to Shop");
	}
	else if(buildingtype == BD_Bank)
	{
		AddMenuItemEx(menu, false, "40", "Add Entrance to Bank");
		AddMenuItemEx(menu, false, "41", "Add Worker Door to Bank");
	}
	
	AddMenuItemEx(menu, false, "998", "Back to Building Main");
	AddMenuItemEx(menu, false, "999", "Back to Main");

	SetMenuExitButton(menu, true);
	DisplayMenu(menu, client, MENU_TIME_FOREVER);
}

public MenuHandler_EditBuilding(Handle:menu, MenuAction:action, client, param2)
{
	if(0 >= client || client > MaxClients + 1)
		return;
	
	if(!IsClientInGame(client))
		return;
	
	if(!IsPlayerAlive(client))
		return;
	
	if (action == MenuAction_Select)
	{
		decl String:info[100], String:info2[100];
		new bool:found = GetMenuItem(menu, param2, info, sizeof(info), _, info2, sizeof(info2));
		
		if(found)
		{
			new selection = StringToInt(info);
			
			if(selection == 0)
			{
				Menu_SetBuildingOwner(client);
			}
			else if(selection == 1)
			{
				Menu_EditBuildingName(client);
			}
			else if(selection == 2)
			{
				Menu_EditBuildingType(client);
			}
			else if(selection == 10)
			{
				Menu_AddAppartmentHouseEntrance(client);
			}
			else if(selection == 11)
			{
				g_SelectedAppartmentPrice[client] = 0;
				Menu_SelectAppartmentPrice(client);
			}
			else if(selection == 12)
			{
				g_SelectedAppartmentID[client] = -1;
				Menu_SelectAppartment(client);
			}
			else if(selection == 20)
			{
				Menu_SelectPoliceDPDoorType(client);
			}
			else if(selection == 30)
			{
				g_SelectedDoorType[client] = Door_Shop_Entrance;
				Menu_AddShopDoor(client);
			}
			else if(selection == 31)
			{
				g_SelectedDoorType[client] = Door_Shop_Staff;
				Menu_AddShopDoor(client);
			}
			else if(selection == 40)
			{
				g_SelectedDoorType[client] = Door_Bank_Entrance;
				Menu_AddBankDoor(client);
			}
			else if(selection == 41)
			{
				g_SelectedDoorType[client] = Door_Bank_Staff;
				Menu_AddBankDoor(client);
			}
			//Menu_AddBankDoor(client)
			else if(selection == 998)
			{
				Menu_BuildingMain(client);
			}
			else if(selection == 999)
			{
				RP_ShowMainAdminMenu(client);
			}
			return;
		}
	}
}

Menu_SetBuildingOwner(client)
{	
	new Handle:menu = CreateMenu(MenuHandler_SetBuildingOwner);
	SetMenuTitle(menu, "[RP] Edit Building Owner");
	new String:buffer[8];
	new String:namebuffer[64];
		
	AddMenuItemEx(menu, false, "900", "No Owner");
	for (new i = 1; i < MAXPLAYERS; i++)
	{		
		if(!IsClientInGame(i))
			continue;
		
		if(IsFakeClient(i))
			continue;
		
		GetClientName(i, namebuffer, sizeof(namebuffer));
		
		IntToString(RP_GetPlayerID(i),buffer,sizeof(buffer));
		AddMenuItemEx(menu, false, buffer, "[%d] %s",RP_GetPlayerID(i),namebuffer);
	}
	AddMenuItemEx(menu, false, "998", "Back to Building Main");
	AddMenuItemEx(menu, false, "999", "Back to Main");

	SetMenuExitButton(menu, true);
	DisplayMenu(menu, client, MENU_TIME_FOREVER);
}

public MenuHandler_SetBuildingOwner(Handle:menu, MenuAction:action, client, param2)
{
	if(0 >= client || client > MaxClients + 1)
		return;
	
	if(!IsClientInGame(client))
		return;
	
	if(!IsPlayerAlive(client))
		return;
	
	if (action == MenuAction_Select)
	{
		decl String:info[100], String:info2[100];
		new bool:found = GetMenuItem(menu, param2, info, sizeof(info), _, info2, sizeof(info2));
		
		if(found)
		{
			new selection = StringToInt(info);
			
			if(selection == 999)
			{
				RP_ShowMainAdminMenu(client);
			}
			else if(selection == 998)
			{
				Menu_BuildingMain(client);
			}
			else if(selection == 900)
			{
				RP_SetBuildingOwnerID(g_SelectedBuildingID[client], -1);
				RP_SetBuildingOwnerName(g_SelectedBuildingID[client], "World");
				Menu_EditBuilding(client);
			}
			else
			{
				new String:namebuffer[64];
				GetClientName(selection, namebuffer, sizeof(namebuffer));
				
				RP_SetBuildingOwnerID(g_SelectedBuildingID[client], selection);
				RP_SetBuildingOwnerName(g_SelectedBuildingID[client],namebuffer);
				Menu_EditBuilding(client);
			}
			return;
		}
	}
}

Menu_EditBuildingName(client)
{
	new Handle:menu = CreateMenu(MenuHandler_EditBuildingName);
	SetMenuTitle(menu, "[RP] Edit Building Name");

	new String:buffer[64];
	RP_GetClientSelectedString(client, buffer, sizeof(buffer));
	
	PrintToChat(client,"Write /s \"name\" , to set the name!");
	
	AddMenuItemEx(menu, true, "900", "Selected Name: %s", buffer);
	AddMenuItemEx(menu, false, "0", "Refresh");
	AddMenuItemEx(menu, false, "1", "Accept");
	AddMenuItemEx(menu, false, "998", "Back to Building Main");
	AddMenuItemEx(menu, false, "999", "Back to Main");
	
	SetMenuExitButton(menu, true);
	DisplayMenu(menu, client, MENU_TIME_FOREVER);
}

public MenuHandler_EditBuildingName(Handle:menu, MenuAction:action, client, param2)
{
	if(0 >= client || client > MaxClients + 1)
		return;
	
	if(!IsClientInGame(client))
		return;
	
	if(!IsPlayerAlive(client))
		return;
	
	if (action == MenuAction_Select)
	{
		decl String:info[100], String:info2[100];
		new bool:found = GetMenuItem(menu, param2, info, sizeof(info), _, info2, sizeof(info2));
		
		if(found)
		{
			new selection = StringToInt(info);
			
			
			if(selection == 0)
			{
				Menu_EditBuildingName(client);
			}
			else if(selection == 1)
			{
				RP_GetClientSelectedString(client, g_SelectedBuildingName[client], sizeof(g_SelectedBuildingName[]));
				RP_SetBuildingName(g_SelectedBuildingID[client], g_SelectedBuildingName[client]);
				Menu_EditBuilding(client);
			}
			else if(selection == 998)
			{
				Menu_BuildingMain(client);
			}
			else if(selection == 999)
			{
				RP_ShowMainAdminMenu(client);
			}
			else if(selection == 900)
			{
				RP_GetClientSelectedString(client, g_SelectedBuildingName[client], sizeof(g_SelectedBuildingName[]));
				RP_SetBuildingName(g_SelectedBuildingID[client], g_SelectedBuildingName[client]);
				Menu_EditBuildingName(client);
			}
			return;
		}
	}
}

Menu_EditBuildingType(client)
{
	new Handle:menu = CreateMenu(MenuHandler_EditBuildingType);
	SetMenuTitle(menu, "Edit Buildingtype");
	
	new maxbu = RP_GetMaxBuildingType();
	new String:buffer[64]
	new String:sindex[10];
	
	for (new i = 0; i < maxbu; i++)
	{
		RP_GetBuildingTypeName(i, buffer, sizeof(buffer));
			
		IntToString(i, sindex, sizeof(sindex));
		AddMenuItemEx(menu, false, sindex, "%s", buffer);

	}
	AddMenuItemEx(menu, false, "998", "Back to Building Main");
	AddMenuItemEx(menu, false, "999", "Back to Main");
	
	SetMenuExitButton(menu, true);
	DisplayMenu(menu, client, MENU_TIME_FOREVER);
}

public MenuHandler_EditBuildingType(Handle:menu, MenuAction:action, client, param2)
{
	if(0 >= client || client > MaxClients + 1)
		return;
	
	if(!IsClientInGame(client))
		return;
	
	if(!IsPlayerAlive(client))
		return;
	
	if (action == MenuAction_Select)
	{
		decl String:info[100], String:info2[100];
		new bool:found = GetMenuItem(menu, param2, info, sizeof(info), _, info2, sizeof(info2));

		if(found)
		{
			new selection = StringToInt(info);
			
			
			if(selection == 998)
			{
				Menu_BuildingMain(client);
			}
			else if(selection == 999)
			{
				RP_ShowMainAdminMenu(client);
			}
			else
			{
				RP_SetBuildingType(g_SelectedBuildingID[client], selection);
				Menu_EditBuilding(client);
			}
			return;
		}
	}
}

Menu_AddAppartmentHouseEntrance(client)
{	
	new Handle:menu = CreateMenu(MenuHandler_AddAppartmentHouseEntrance);
	SetMenuTitle(menu, "[RP] Add Entrance To AppartmentHouse");

	AddMenuItemEx(menu, false, "900", "Add door in view");
	AddMenuItemEx(menu, false, "998", "Back to Building Edit");
	AddMenuItemEx(menu, false, "999", "Back to Main");

	SetMenuExitButton(menu, true);
	DisplayMenu(menu, client, MENU_TIME_FOREVER);
}

public MenuHandler_AddAppartmentHouseEntrance(Handle:menu, MenuAction:action, client, param2)
{
	if(0 >= client || client > MaxClients + 1)
		return;
	
	if(!IsClientInGame(client))
		return;
	
	if(!IsPlayerAlive(client))
		return;
	
	if (action == MenuAction_Select)
	{
		decl String:info[100], String:info2[100];
		new bool:found = GetMenuItem(menu, param2, info, sizeof(info), _, info2, sizeof(info2));
		
		if(found)
		{
			new selection = StringToInt(info);
			
			if(selection == 900)
			{
				//Add Door in view
				new entity = GetClientAimTarget(client, false);
				if(RP_IsValidDoorEnt(entity))
				{
					new doorID = RP_GetDoorIDbyEntity(entity)
					
					RP_SetDoorBuildingID(doorID,g_SelectedBuildingID[client]);
					RP_SetDoorType(doorID, Door_AppartmentHouse_Entrance);
					
					PrintToChat(client, "-Added Door-");
					Menu_EditBuilding(client);
				}
			}
			else if(selection == 998)
			{
				Menu_EditBuilding(client);
			}
			else if(selection == 999)
			{
				RP_ShowMainAdminMenu(client);
			}
			return;
		}
	}
}

Menu_SelectAppartmentPrice(client)
{
	new Handle:menu = CreateMenu(MenuHandler_SelectAppartmentPrice);
	SetMenuTitle(menu, "[RP] Select Appartment Price (%d)", g_SelectedAppartmentPrice[client]);

	AddMenuItemEx(menu, false, "1", "+10");
	AddMenuItemEx(menu, false, "2", "+100");
	AddMenuItemEx(menu, false, "3", "+1000");

	AddMenuItemEx(menu, !(g_SelectedAppartmentPrice[client] >= 10), "11", "-10");
	AddMenuItemEx(menu, !(g_SelectedAppartmentPrice[client] >= 100), "12", "-100");
	AddMenuItemEx(menu, !(g_SelectedAppartmentPrice[client] >= 1000), "13", "-1000");

	AddMenuItemEx(menu, false, "900", "Accept");
	AddMenuItemEx(menu, false, "999", "Back to Main");

	SetMenuExitButton(menu, true);
	DisplayMenu(menu, client, MENU_TIME_FOREVER);
}

public MenuHandler_SelectAppartmentPrice(Handle:menu, MenuAction:action, client, param2)
{
	if(0 >= client || client > MaxClients + 1)
		return;
	
	if(!IsClientInGame(client))
		return;
	
	if(!IsPlayerAlive(client))
		return;
	
	if (action == MenuAction_Select)
	{
		decl String:info[100], String:info2[100];
		new bool:found = GetMenuItem(menu, param2, info, sizeof(info), _, info2, sizeof(info2));
		
		if(found)
		{
			new selection = StringToInt(info);
			
			if(selection == 1)
			{
				g_SelectedAppartmentPrice[client] += 10;
				Menu_SelectAppartmentPrice(client);
			}
			else if(selection == 2)
			{
				g_SelectedAppartmentPrice[client] += 100;
				Menu_SelectAppartmentPrice(client);
			}
			else if(selection == 3)
			{
				g_SelectedAppartmentPrice[client] += 1000;
				Menu_SelectAppartmentPrice(client);
			}
			else if(selection == 11)
			{
				if(g_SelectedAppartmentPrice[client] >= 10)
				{
					g_SelectedAppartmentPrice[client] -= 10;
					Menu_SelectAppartmentPrice(client);
				}
			}
			else if(selection == 12)
			{
				if(g_SelectedAppartmentPrice[client] >= 100)
				{
					g_SelectedAppartmentPrice[client] -= 100;
					Menu_SelectAppartmentPrice(client);
				}
			}
			else if(selection == 13)
			{
				if(g_SelectedAppartmentPrice[client] >= 1000)
				{
					g_SelectedAppartmentPrice[client] -= 1000;
					Menu_SelectAppartmentPrice(client);
				}
			}
			else if(selection == 900)
			{
				g_SelectedInhibitants[client] = 1;
				Menu_SelectAppartmentMaxInh(client);
			}
			else if(selection == 999)
			{
				RP_ShowMainAdminMenu(client);
			}
			return;
		}
	}
}

Menu_SelectAppartmentMaxInh(client)
{
	new Handle:menu = CreateMenu(MenuHandler_SelectAppartmentMaxInh);
	SetMenuTitle(menu, "[RP] Select Max Inhibitants (%d)", g_SelectedInhibitants[client]);

	AddMenuItemEx(menu, false, "1", "+1");
	AddMenuItemEx(menu, false, "2", "+5");
	AddMenuItemEx(menu, false, "3", "+10");

	AddMenuItemEx(menu, !(g_SelectedInhibitants[client] > 1), "11", "-1");
	AddMenuItemEx(menu, !(g_SelectedInhibitants[client] > 5), "12", "-5");
	AddMenuItemEx(menu, !(g_SelectedInhibitants[client] > 10), "13", "-10");

	AddMenuItemEx(menu, false, "900", "Accept");
	AddMenuItemEx(menu, false, "999", "Back to Main");

	SetMenuExitButton(menu, true);
	DisplayMenu(menu, client, MENU_TIME_FOREVER);
}

public MenuHandler_SelectAppartmentMaxInh(Handle:menu, MenuAction:action, client, param2)
{
	if(0 >= client || client > MaxClients + 1)
		return;
	
	if(!IsClientInGame(client))
		return;
	
	if(!IsPlayerAlive(client))
		return;
	
	if (action == MenuAction_Select)
	{
		decl String:info[100], String:info2[100];
		new bool:found = GetMenuItem(menu, param2, info, sizeof(info), _, info2, sizeof(info2));
		
		if(found)
		{
			new selection = StringToInt(info);
			
			if(selection == 1)
			{
				g_SelectedInhibitants[client] += 1;
				Menu_SelectAppartmentMaxInh(client);
			}
			else if(selection == 2)
			{
				g_SelectedInhibitants[client] += 5;
				Menu_SelectAppartmentMaxInh(client);
			}
			else if(selection == 3)
			{
				g_SelectedInhibitants[client] += 10;
				Menu_SelectAppartmentMaxInh(client);
			}
			else if(selection == 11)
			{
				if(g_SelectedInhibitants[client] > 1)
				{
					g_SelectedInhibitants[client] -= 1;
					Menu_SelectAppartmentMaxInh(client);
				}
			}
			else if(selection == 12)
			{
				if(g_SelectedInhibitants[client] > 5)
				{
					g_SelectedInhibitants[client] -= 5;
					Menu_SelectAppartmentMaxInh(client);
				}
			}
			else if(selection == 13)
			{
				if(g_SelectedInhibitants[client] > 10)
				{
					g_SelectedInhibitants[client] -= 10;
					Menu_SelectAppartmentMaxInh(client);
				}
			}
			else if(selection == 900)
			{
				Menu_SelectAppartmentName(client);
			}
			else if(selection == 999)
			{
				RP_ShowMainAdminMenu(client);
			}
			return;
		}
	}
}

Menu_SelectAppartmentName(client)
{
	new Handle:menu = CreateMenu(MenuHandler_SelectAppartmentName);
	SetMenuTitle(menu, "[RP] Select Appartment Roomadress");

	new String:buffer[64];
	RP_GetClientSelectedString(client, buffer, sizeof(buffer));
	
	PrintToChat(client,"Write /s \"name\" , to set the name!");
	
	AddMenuItemEx(menu, true, "900", "Selected Name: %s", buffer);
	AddMenuItemEx(menu, false, "0", "Refresh");
	AddMenuItemEx(menu, false, "1", "Accept");
	AddMenuItemEx(menu, false, "998", "Back to Building Edit");
	AddMenuItemEx(menu, false, "999", "Back to Main");
	
	SetMenuExitButton(menu, true);
	DisplayMenu(menu, client, MENU_TIME_FOREVER);
}

public MenuHandler_SelectAppartmentName(Handle:menu, MenuAction:action, client, param2)
{
	if(0 >= client || client > MaxClients + 1)
		return;
	
	if(!IsClientInGame(client))
		return;
	
	if(!IsPlayerAlive(client))
		return;
	
	if (action == MenuAction_Select)
	{
		decl String:info[100], String:info2[100];
		new bool:found = GetMenuItem(menu, param2, info, sizeof(info), _, info2, sizeof(info2));
		
		if(found)
		{
			new selection = StringToInt(info);
			
			
			if(selection == 0)
			{
				Menu_SelectAppartmentName(client);
			}
			else if(selection == 1)
			{
				new String:buffer[16];
				
				RP_GetClientSelectedString(client, buffer, sizeof(buffer));
				RP_CreateAppartment(g_SelectedAppartmentPrice[client], g_SelectedInhibitants[client], g_SelectedBuildingID[client],buffer);
				Menu_EditBuilding(client);
			}
			else if(selection == 998)
			{
				Menu_EditBuilding(client);
			}
			else if(selection == 999)
			{
				RP_ShowMainAdminMenu(client);
			}
			else if(selection == 900)
			{
				Menu_SelectAppartmentName(client);
			}
			return;
		}
	}
}

Menu_SelectAppartment(client)
{
	new Handle:menu = CreateMenu(MenuHandler_SelectAppartment);
	SetMenuTitle(menu, "Select Appartment to Edit");
	
	new maxapp = RP_GetAppartmentCount();
	new appID = -1;
	new String:sappID[8];
	new String:bufferX[16];
	
	new counter = 0;
	
	for (new i = 0; i < maxapp; i++)
	{
		appID = RP_GetAppartmentIDByIndex(i);
		
		if(appID >= 0)
		{
			RP_GetAppartmentRoomnumber(appID, bufferX, sizeof(bufferX));
			IntToString(appID, sappID, sizeof(sappID));
			AddMenuItemEx(menu, false, sappID, "[%d] %s",appID, bufferX);
			counter++;
		}

	}
	AddMenuItemEx(menu, false, "998", "Back to Edit Building");
	AddMenuItemEx(menu, false, "999", "Back to Main");
	
	SetMenuExitButton(menu, true);
	if(counter > 0)
	{
		DisplayMenu(menu, client, MENU_TIME_FOREVER);
	}
	else
	{
		PrintToChat(client, "There are no appartments in this building");
		Menu_EditBuilding(client);
	}
}

public MenuHandler_SelectAppartment(Handle:menu, MenuAction:action, client, param2)
{
	if(0 >= client || client > MaxClients + 1)
		return;
	
	if(!IsClientInGame(client))
		return;
	
	if(!IsPlayerAlive(client))
		return;
	
	if (action == MenuAction_Select)
	{
		decl String:info[100], String:info2[100];
		new bool:found = GetMenuItem(menu, param2, info, sizeof(info), _, info2, sizeof(info2));

		if(found)
		{
			new selection = StringToInt(info);
			
			
			if(selection == 998)
			{
				Menu_EditBuilding(client);
			}
			else if(selection == 999)
			{
				RP_ShowMainAdminMenu(client);
			}
			else
			{
				g_SelectedAppartmentID[client] = selection;
				Menu_EditAppartment(client);
			}
			return;
		}
	}
}

Menu_EditAppartment(client)
{	
	new Handle:menu = CreateMenu(MenuHandler_EditAppartment);
	
	new ownerID = RP_GetAppartmentPlayerID(g_SelectedAppartmentID[client]);
	new ownerIndex = RP_GetClient(ownerID);
	
	new String:roomnamebuffer[16];
	RP_GetAppartmentRoomnumber(g_SelectedAppartmentID[client], roomnamebuffer, sizeof(roomnamebuffer));
	new String:ownernamebuffer[64];
	if(ownerIndex >= 0 && ownerIndex < (MaxClients + 1))
		GetClientName(ownerIndex, ownernamebuffer, sizeof(ownernamebuffer));
	else
		FormatEx(ownernamebuffer, sizeof(ownernamebuffer), "No Owner");
	
	SetMenuTitle(menu, "[RP] Edit Appartment [%d] %s ",g_SelectedAppartmentID[client],roomnamebuffer);

	AddMenuItemEx(menu, false, "0", "Edit Owner / [%d] %s",ownerID,ownernamebuffer);
	AddMenuItemEx(menu, false, "1", "Edit Roomadress / %s", roomnamebuffer);
	AddMenuItemEx(menu, false, "2", "Edit Max. Inhibitants / [%d]", RP_GetAppartmentMaxInh(g_SelectedAppartmentID[client]));
	AddMenuItemEx(menu, false, "3", "Edit Building / [%d]",RP_GetAppartmentbuildingID(g_SelectedAppartmentID[client]));
	AddMenuItemEx(menu, false, "4", "Edit Price / [%d]",RP_GetAppartmentPrice(g_SelectedAppartmentID[client]));
	AddMenuItemEx(menu, false, "5", "Toggle IsSold? / [%s]", RP_IsAppartmenSold(g_SelectedAppartmentID[client]) ? "yes" : "no" );
	AddMenuItemEx(menu, false, "6", "Add Door To appartment");
	AddMenuItemEx(menu, false, "7", "Remove door from appartment");

	AddMenuItemEx(menu, false, "998", "Back to Building Edit");
	AddMenuItemEx(menu, false, "999", "Back to Main");

	SetMenuExitButton(menu, true);
	DisplayMenu(menu, client, MENU_TIME_FOREVER);
}

public MenuHandler_EditAppartment(Handle:menu, MenuAction:action, client, param2)
{
	if(0 >= client || client > MaxClients + 1)
		return;
	
	if(!IsClientInGame(client))
		return;
	
	if(!IsPlayerAlive(client))
		return;
	
	if (action == MenuAction_Select)
	{
		decl String:info[100], String:info2[100];
		new bool:found = GetMenuItem(menu, param2, info, sizeof(info), _, info2, sizeof(info2));
		
		if(found)
		{
			new selection = StringToInt(info);
			
			if(selection == 0)
			{
				Menu_EditAppartmentOwner(client);
			}
			else if(selection == 1)
			{
				Menu_EditAppartmentName(client);
			}
			else if(selection == 2)
			{
				Menu_EditAppartmentMaxInh(client);
			}
			else if(selection == 3)
			{
				Menu_EditAppartmentBuilding(client);
			}
			else if(selection == 4)
			{
				Menu_EditAppartmentPrice(client);
			}
			else if(selection == 5)
			{
				if(RP_IsAppartmenSold(g_SelectedAppartmentID[client]))
					RP_SetAppartmentSold(g_SelectedAppartmentID[client], false);
				else
					RP_SetAppartmentSold(g_SelectedAppartmentID[client], true);
					
				Menu_EditAppartment(client);
			}
			else if(selection == 6)
			{
				Menu_AddAppartmentDoor(client);
			}
			else if(selection == 7)
			{
				Menu_DeleteAppartmentDoor(client);
			}
			else if(selection == 998)
			{
				Menu_EditBuilding(client);
			}
			else if(selection == 999)
			{
				RP_ShowMainAdminMenu(client);
			}
			return;
		}
	}
}

Menu_EditAppartmentOwner(client)
{	
	new Handle:menu = CreateMenu(MenuHandler_EditAppartmentOwner);
	SetMenuTitle(menu, "[RP] Edit Appartment Owner");
	new String:buffer[8];
	new String:namebuffer[64];
		
	AddMenuItemEx(menu, false, "900", "No Owner");
	for (new i = 1; i < MAXPLAYERS; i++)
	{		
		if(!IsClientInGame(i))
			continue;
		
		if(IsFakeClient(i))
			continue;
		
		GetClientName(i, namebuffer, sizeof(namebuffer));
		
		IntToString(RP_GetPlayerID(i),buffer,sizeof(buffer));
		AddMenuItemEx(menu, false, buffer, "[%d] %s",RP_GetPlayerID(i),namebuffer);
	}
	AddMenuItemEx(menu, false, "998", "Back to Building Edit");
	AddMenuItemEx(menu, false, "999", "Back to Main");

	SetMenuExitButton(menu, true);
	DisplayMenu(menu, client, MENU_TIME_FOREVER);
}

public MenuHandler_EditAppartmentOwner(Handle:menu, MenuAction:action, client, param2)
{
	if(0 >= client || client > MaxClients + 1)
		return;
	
	if(!IsClientInGame(client))
		return;
	
	if(!IsPlayerAlive(client))
		return;
	
	if (action == MenuAction_Select)
	{
		decl String:info[100], String:info2[100];
		new bool:found = GetMenuItem(menu, param2, info, sizeof(info), _, info2, sizeof(info2));
		
		if(found)
		{
			new selection = StringToInt(info);
			
			if(selection == 999)
			{
				RP_ShowMainAdminMenu(client);
			}
			else if(selection == 998)
			{
				Menu_EditBuilding(client);
			}
			else if(selection == 900)
			{				
				RP_SetAppartmentPlayerID(g_SelectedAppartmentID[client], -1);	
				RP_SetAppartmentSold(g_SelectedAppartmentID[client], false);
				Menu_EditAppartment(client);
			}
			else
			{
				RP_SetAppartmentPlayerID(g_SelectedAppartmentID[client], selection);
				RP_SetAppartmentSold(g_SelectedAppartmentID[client], true);
				Menu_EditAppartment(client);
			}
			return;
		}
	}
}

Menu_EditAppartmentPrice(client)
{
	new appPrice = RP_GetAppartmentPrice(g_SelectedAppartmentID[client]);
	
	new Handle:menu = CreateMenu(MenuHandler_EditAppartmentPrice);
	SetMenuTitle(menu, "[RP] Select Appartment Price (%d)", appPrice);

	AddMenuItemEx(menu, false, "1", "+10");
	AddMenuItemEx(menu, false, "2", "+100");
	AddMenuItemEx(menu, false, "3", "+1000");

	AddMenuItemEx(menu, !(appPrice >= 10), "11", "-10");
	AddMenuItemEx(menu, !(appPrice >= 100), "12", "-100");
	AddMenuItemEx(menu, !(appPrice >= 1000), "13", "-1000");

	AddMenuItemEx(menu, false, "900", "Back to Appartment Edit");
	AddMenuItemEx(menu, false, "999", "Back to Main");

	SetMenuExitButton(menu, true);
	DisplayMenu(menu, client, MENU_TIME_FOREVER);
}

public MenuHandler_EditAppartmentPrice(Handle:menu, MenuAction:action, client, param2)
{
	if(0 >= client || client > MaxClients + 1)
		return;
	
	if(!IsClientInGame(client))
		return;
	
	if(!IsPlayerAlive(client))
		return;
	
	if (action == MenuAction_Select)
	{
		decl String:info[100], String:info2[100];
		new bool:found = GetMenuItem(menu, param2, info, sizeof(info), _, info2, sizeof(info2));
		
		if(found)
		{
			new selection = StringToInt(info);			
			new appPrice = RP_GetAppartmentPrice(g_SelectedAppartmentID[client]);
			
			if(selection == 1)
			{
				RP_SetAppartmentPrice(g_SelectedAppartmentID[client] , appPrice + 10);
				Menu_EditAppartmentPrice(client);
			}
			else if(selection == 2)
			{
				RP_SetAppartmentPrice(g_SelectedAppartmentID[client] , appPrice + 100);
				Menu_EditAppartmentPrice(client);
			}
			else if(selection == 3)
			{
				RP_SetAppartmentPrice(g_SelectedAppartmentID[client] , appPrice + 1000);
				Menu_EditAppartmentPrice(client);
			}
			else if(selection == 11)
			{
				if(appPrice >= 10)
				{
					RP_SetAppartmentPrice(g_SelectedAppartmentID[client] , appPrice - 10);
					Menu_EditAppartmentPrice(client);
				}
			}
			else if(selection == 12)
			{
				if(appPrice >= 100)
				{
					RP_SetAppartmentPrice(g_SelectedAppartmentID[client] , appPrice - 100);
					Menu_EditAppartmentPrice(client);
				}
			}
			else if(selection == 13)
			{
				if(appPrice >= 1000)
				{
					RP_SetAppartmentPrice(g_SelectedAppartmentID[client] , appPrice - 1000);
					Menu_EditAppartmentPrice(client);
				}
			}
			else if(selection == 900)
			{
				Menu_EditAppartment(client);
			}
			else if(selection == 999)
			{
				RP_ShowMainAdminMenu(client);
			}
			return;
		}
	}
}

Menu_EditAppartmentBuilding(client)
{	
	new Handle:menu = CreateMenu(MenuHandler_EditAppartmentBuilding);
	SetMenuTitle(menu, "[RP] Select Building to edit it");

	new counter = 0;

	for (new i = 0; i < RP_GetBuildingCount(); i++)
	{
		
		new buildingID = RP_GetBuildingIDByArrayIndex(i);

		if (buildingID != -1 && RP_GetBuildingType(buildingID) == BD_AppartmentHouse)
		{
			new String:buffer[64];
			new String:buffer2[8];
			RP_GetBuildingName(buildingID, buffer, sizeof(buffer));
			IntToString(buildingID, buffer2, sizeof(buffer2));
			
			AddMenuItemEx(menu, false, buffer2, "[%d] %s | %d",buildingID,buffer,RP_GetBuildingType(buildingID));
			counter++;
		}
	}
	AddMenuItemEx(menu, false, "998", "Back to Appartment Edit");
	AddMenuItemEx(menu, false, "999", "Back to Main");

	SetMenuExitButton(menu, true);
	if(counter > 0)
		DisplayMenu(menu, client, MENU_TIME_FOREVER);
	else
	{
		PrintToChat(client, "No Building with the right type found");
		Menu_BuildingMain(client);
	}
}

public MenuHandler_EditAppartmentBuilding(Handle:menu, MenuAction:action, client, param2)
{
	if(0 >= client || client > MaxClients + 1)
		return;
	
	if(!IsClientInGame(client))
		return;
	
	if(!IsPlayerAlive(client))
		return;
	
	if (action == MenuAction_Select)
	{
		decl String:info[100], String:info2[100];
		new bool:found = GetMenuItem(menu, param2, info, sizeof(info), _, info2, sizeof(info2));
		
		if(found)
		{
			new selection = StringToInt(info);
			
			if(selection == 999)
			{
				RP_ShowMainAdminMenu(client);
			}
			else if(selection == 998)
			{
				Menu_EditAppartment(client);
			}
			else 
			{
				RP_SetAppartmentbuildingID(g_SelectedAppartmentID[client], selection);
				Menu_EditAppartment(client);
			}
			return;
		}
	}
}

Menu_EditAppartmentMaxInh(client)
{
	new maxInh = RP_GetAppartmentMaxInh(g_SelectedAppartmentID[client]);
	
	new Handle:menu = CreateMenu(MenuHandler_EditAppartmentMaxInh);
	SetMenuTitle(menu, "[RP] Select Max Inhibitants (%d)", maxInh);

	AddMenuItemEx(menu, false, "1", "+1");
	AddMenuItemEx(menu, false, "2", "+5");
	AddMenuItemEx(menu, false, "3", "+10");

	AddMenuItemEx(menu, !(maxInh > 1), "11", "-1");
	AddMenuItemEx(menu, !(maxInh > 5), "12", "-5");
	AddMenuItemEx(menu, !(maxInh > 10), "13", "-10");

	AddMenuItemEx(menu, false, "900", "Back to Appartment Edit");
	AddMenuItemEx(menu, false, "999", "Back to Main");

	SetMenuExitButton(menu, true);
	DisplayMenu(menu, client, MENU_TIME_FOREVER);
}

public MenuHandler_EditAppartmentMaxInh(Handle:menu, MenuAction:action, client, param2)
{
	if(0 >= client || client > MaxClients + 1)
		return;
	
	if(!IsClientInGame(client))
		return;
	
	if(!IsPlayerAlive(client))
		return;
	
	if (action == MenuAction_Select)
	{
		decl String:info[100], String:info2[100];
		new bool:found = GetMenuItem(menu, param2, info, sizeof(info), _, info2, sizeof(info2));
		
		if(found)
		{
			new selection = StringToInt(info);
			new maxInh = RP_GetAppartmentMaxInh(g_SelectedAppartmentID[client]);
			
			if(selection == 1)
			{
				RP_SetAppartmentMaxInh(g_SelectedAppartmentID[client], maxInh + 1);
				Menu_EditAppartmentMaxInh(client);
			}
			else if(selection == 2)
			{
				RP_SetAppartmentMaxInh(g_SelectedAppartmentID[client], maxInh + 5);
				Menu_EditAppartmentMaxInh(client);
			}
			else if(selection == 3)
			{
				RP_SetAppartmentMaxInh(g_SelectedAppartmentID[client], maxInh + 10);
				Menu_EditAppartmentMaxInh(client);
			}
			else if(selection == 11)
			{
				if(maxInh > 1)
				{
					RP_SetAppartmentMaxInh(g_SelectedAppartmentID[client], maxInh - 1);
					Menu_EditAppartmentMaxInh(client);
				}
			}
			else if(selection == 12)
			{
				if(maxInh > 5)
				{
					RP_SetAppartmentMaxInh(g_SelectedAppartmentID[client], maxInh - 5);
					Menu_EditAppartmentMaxInh(client);
				}
			}
			else if(selection == 13)
			{
				if(maxInh > 10)
				{
					RP_SetAppartmentMaxInh(g_SelectedAppartmentID[client], maxInh - 10);
					Menu_EditAppartmentMaxInh(client);
				}
			}
			else if(selection == 900)
			{
				Menu_EditAppartment(client);
			}
			else if(selection == 999)
			{
				RP_ShowMainAdminMenu(client);
			}
			return;
		}
	}
}

Menu_EditAppartmentName(client)
{
	new Handle:menu = CreateMenu(MenuHandler_EditAppartmentName);
	SetMenuTitle(menu, "[RP] Edit Appartment Roomadress");

	new String:buffer[64];
	RP_GetClientSelectedString(client, buffer, sizeof(buffer));
	
	PrintToChat(client,"Write /s \"name\" , to set the name!");
	
	AddMenuItemEx(menu, true, "900", "Selected Name: %s", buffer);
	AddMenuItemEx(menu, false, "0", "Refresh");
	AddMenuItemEx(menu, false, "1", "Accept");
	AddMenuItemEx(menu, false, "998", "Back to Appartment Edit");
	AddMenuItemEx(menu, false, "999", "Back to Main");
	
	SetMenuExitButton(menu, true);
	DisplayMenu(menu, client, MENU_TIME_FOREVER);
}

public MenuHandler_EditAppartmentName(Handle:menu, MenuAction:action, client, param2)
{
	if(0 >= client || client > MaxClients + 1)
		return;
	
	if(!IsClientInGame(client))
		return;
	
	if(!IsPlayerAlive(client))
		return;
	
	if (action == MenuAction_Select)
	{
		decl String:info[100], String:info2[100];
		new bool:found = GetMenuItem(menu, param2, info, sizeof(info), _, info2, sizeof(info2));
		
		if(found)
		{
			new selection = StringToInt(info);
			
			
			if(selection == 0)
			{
				Menu_EditAppartmentName(client);
			}
			else if(selection == 1)
			{
				new String:buffer[16];
				
				RP_GetClientSelectedString(client, buffer, sizeof(buffer));
				RP_SetAppartmentRoomnumber(g_SelectedAppartmentID[client],buffer);
				PrintToChat(client, "Set Roomadress \"%s\" to Appartment", buffer);
				Menu_EditAppartment(client);
			}
			else if(selection == 998)
			{
				Menu_EditAppartment(client);
			}
			else if(selection == 999)
			{
				RP_ShowMainAdminMenu(client);
			}
			else if(selection == 900)
			{
				Menu_EditAppartmentName(client);
			}
			return;
		}
	}
}

Menu_AddAppartmentDoor(client)
{	
	new Handle:menu = CreateMenu(MenuHandler_AddAppartmentDoor);
	SetMenuTitle(menu, "[RP] Add Door To Appartment");

	AddMenuItemEx(menu, false, "900", "Add door in view");
	AddMenuItemEx(menu, false, "998", "Back to Appartment Edit");
	AddMenuItemEx(menu, false, "999", "Back to Main");

	SetMenuExitButton(menu, true);
	DisplayMenu(menu, client, MENU_TIME_FOREVER);
}

public MenuHandler_AddAppartmentDoor(Handle:menu, MenuAction:action, client, param2)
{
	if(0 >= client || client > MaxClients + 1)
		return;
	
	if(!IsClientInGame(client))
		return;
	
	if(!IsPlayerAlive(client))
		return;
	
	if (action == MenuAction_Select)
	{
		decl String:info[100], String:info2[100];
		new bool:found = GetMenuItem(menu, param2, info, sizeof(info), _, info2, sizeof(info2));
		
		if(found)
		{
			new selection = StringToInt(info);
			
			if(selection == 900)
			{
				//Add Door in view
				new entity = GetClientAimTarget(client, false);
				if(RP_IsValidDoorEnt(entity))
				{
					new doorID = RP_GetDoorIDbyEntity(entity)
					
					RP_SetAppartmentDoor(doorID,g_SelectedAppartmentID[client]);
					RP_SetDoorBuildingID(doorID,g_SelectedBuildingID[client]);
					RP_SetDoorType(doorID, Door_AppartmentHouse_Appartment);
					
					PrintToChat(client, "-Added Door-");
					Menu_EditAppartment(client);
				}
				else
				{
					PrintToChat(client, "You don't look at a door");
					Menu_AddAppartmentDoor(client);
				}
			}
			else if(selection == 998)
			{
				Menu_EditAppartment(client);
			}
			else if(selection == 999)
			{
				RP_ShowMainAdminMenu(client);
			}
			return;
		}
	}
}

Menu_DeleteAppartmentDoor(client)
{	
	new Handle:menu = CreateMenu(MenuHandler_DeleteAppartmentDoor);
	SetMenuTitle(menu, "[RP] Remove Door From Appartment");

	new bool:foundDoors = false;
	new appID;
	new doorID;

	for (new i = 0; i < RP_GetAppartmentDoorsCount(); i++)
	{
		doorID = RP_GetAppartmentDoorIDByIndex(i);
		appID = RP_GetAppartmentDoorAppIDByIndex(i);

		if(appID == g_SelectedAppartmentID[client])
		{
			new String:buffer[64];
			RP_GetDoorName(doorID, buffer, sizeof(buffer));
			new String:buffer2[8];
			IntToString(doorID, buffer2, sizeof(buffer2));

			AddMenuItemEx(menu, false, buffer2, "[%d] %s",doorID,buffer);
			
			foundDoors = true;
		}
	}
	AddMenuItemEx(menu, false, "998", "Back to Appartment Edit");
	AddMenuItemEx(menu, false, "999", "Back to Main");

	SetMenuExitButton(menu, true);
	if(foundDoors)
	{
		DisplayMenu(menu, client, MENU_TIME_FOREVER);
	}
	else
	{
		PrintToChat(client, "No Door found for this Appartment");
		Menu_EditAppartment(client);
	}
}

public MenuHandler_DeleteAppartmentDoor(Handle:menu, MenuAction:action, client, param2)
{
	if(0 >= client || client > MaxClients + 1)
		return;
	
	if(!IsClientInGame(client))
		return;
	
	if(!IsPlayerAlive(client))
		return;
	
	if (action == MenuAction_Select)
	{
		decl String:info[100], String:info2[100];
		new bool:found = GetMenuItem(menu, param2, info, sizeof(info), _, info2, sizeof(info2));
		
		if(found)
		{
			new selection = StringToInt(info);
			
			if(selection == 998)
			{
				Menu_EditAppartment(client);
			}
			else if(selection == 999)
			{
				RP_ShowMainAdminMenu(client);
			}
			else
			{
				RP_DeleteAppartmentDoor(selection);
				PrintToChat(client, "Deleted Door from appartment");
				Menu_EditAppartment(client);
			}
			return;
		}
	}
}

Menu_SelectPoliceDPDoorType(client)
{	
	new Handle:menu = CreateMenu(MenuHandler_SelectPoliceDPDoorType);
	SetMenuTitle(menu, "[RP] Select PD Door Type");

	for (new i = 0; i < RP_GetPDDoorTypeCount(); i++)
	{
		new String:buffer[8];
		IntToString(i, buffer, sizeof(buffer));
		new String:typenamebuffer[64];
		RP_GetPDDoorTypeName(i, typenamebuffer, sizeof(typenamebuffer));

		AddMenuItemEx(menu, false, buffer, "[%d] %s",i,typenamebuffer);
	}
	AddMenuItemEx(menu, false, "998", "Back to Building Edit");
	AddMenuItemEx(menu, false, "999", "Back to Main");

	SetMenuExitButton(menu, true);
	DisplayMenu(menu, client, MENU_TIME_FOREVER);
}

public MenuHandler_SelectPoliceDPDoorType(Handle:menu, MenuAction:action, client, param2)
{
	if(0 >= client || client > MaxClients + 1)
		return;
	
	if(!IsClientInGame(client))
		return;
	
	if(!IsPlayerAlive(client))
		return;
	
	if (action == MenuAction_Select)
	{
		decl String:info[100], String:info2[100];
		new bool:found = GetMenuItem(menu, param2, info, sizeof(info), _, info2, sizeof(info2));
		
		if(found)
		{
			new selection = StringToInt(info);
			
			if(selection == 998)
			{
				Menu_EditBuilding(client);
			}
			else if(selection == 999)
			{
				RP_ShowMainAdminMenu(client);
			}
			else
			{
				g_SelectedDoorType[client] = selection;
				Menu_AddPoliceDPDoor(client);
			}
			return;
		}
	}
}

Menu_AddPoliceDPDoor(client)
{	
	new Handle:menu = CreateMenu(MenuHandler_AddPoliceDPDoor);
	SetMenuTitle(menu, "[RP] Add Door To Appartment");

	AddMenuItemEx(menu, false, "900", "Add door in view");

	AddMenuItemEx(menu, false, "998", "Back to Building Edit");
	AddMenuItemEx(menu, false, "999", "Back to Main");

	SetMenuExitButton(menu, true);
	DisplayMenu(menu, client, MENU_TIME_FOREVER);
}

public MenuHandler_AddPoliceDPDoor(Handle:menu, MenuAction:action, client, param2)
{
	if(0 >= client || client > MaxClients + 1)
		return;
	
	if(!IsClientInGame(client))
		return;
	
	if(!IsPlayerAlive(client))
		return;
	
	if (action == MenuAction_Select)
	{
		decl String:info[100], String:info2[100];
		new bool:found = GetMenuItem(menu, param2, info, sizeof(info), _, info2, sizeof(info2));
		
		if(found)
		{
			new selection = StringToInt(info);
			
			if(selection == 900)
			{
				//Add Door in view
				new entity = GetClientAimTarget(client, false);
				if(RP_IsValidDoorEnt(entity))
				{
					new doorID = RP_GetDoorIDbyEntity(entity);
					
					RP_SetDoorBuildingID(doorID, g_SelectedBuildingID[client]);
					RP_SetDoorType(doorID, g_SelectedDoorType[client]);
					
					PrintToChat(client, "-Added Door-");
					Menu_EditBuilding(client);
				}
				else
				{
					PrintToChat(client, "You don't look at a door");
					Menu_AddPoliceDPDoor(client);
				}
			}
			else if(selection == 998)
			{
				Menu_EditBuilding(client);
			}
			else if(selection == 999)
			{
				RP_ShowMainAdminMenu(client);
			}
			return;
		}
	}
}

Menu_AddShopDoor(client)
{	
	new Handle:menu = CreateMenu(MenuHandler_AddShopDoor);
	SetMenuTitle(menu, "[RP] Add %s Door To Shop", g_SelectedDoorType[client] ? "Staff" : "Entrance");

	AddMenuItemEx(menu, false, "900", "Add door in view");

	AddMenuItemEx(menu, false, "998", "Back to Building Edit");
	AddMenuItemEx(menu, false, "999", "Back to Main");

	SetMenuExitButton(menu, true);
	DisplayMenu(menu, client, MENU_TIME_FOREVER);
}

public MenuHandler_AddShopDoor(Handle:menu, MenuAction:action, client, param2)
{
	if(0 >= client || client > MaxClients + 1)
		return;
	
	if(!IsClientInGame(client))
		return;
	
	if(!IsPlayerAlive(client))
		return;
	
	if (action == MenuAction_Select)
	{
		decl String:info[100], String:info2[100];
		new bool:found = GetMenuItem(menu, param2, info, sizeof(info), _, info2, sizeof(info2));
		
		if(found)
		{
			new selection = StringToInt(info);
			
			if(selection == 900)
			{
				//Add Door in view
				new entity = GetClientAimTarget(client, false);
				if(RP_IsValidDoorEnt(entity))
				{
					new doorID = RP_GetDoorIDbyEntity(entity);
					
					RP_SetDoorBuildingID(doorID, g_SelectedBuildingID[client]);
					RP_SetDoorType(doorID, g_SelectedDoorType[client]);
					
					PrintToChat(client, "-Added Door-");
					Menu_EditBuilding(client);
				}
				else
				{
					PrintToChat(client, "You don't look at a door");
					Menu_AddShopDoor(client);
				}
			}
			else if(selection == 998)
			{
				Menu_EditBuilding(client);
			}
			else if(selection == 999)
			{
				RP_ShowMainAdminMenu(client);
			}
			return;
		}
	}
}

Menu_AddBankDoor(client)
{	
	new Handle:menu = CreateMenu(MenuHandler_AddBankDoor);
	SetMenuTitle(menu, "[RP] Add %s Door To Bank", g_SelectedDoorType[client] ? "Staff" : "Entrance");

	AddMenuItemEx(menu, false, "900", "Add door in view");

	AddMenuItemEx(menu, false, "998", "Back to Building Edit");
	AddMenuItemEx(menu, false, "999", "Back to Main");

	SetMenuExitButton(menu, true);
	DisplayMenu(menu, client, MENU_TIME_FOREVER);
}

public MenuHandler_AddBankDoor(Handle:menu, MenuAction:action, client, param2)
{
	if(0 >= client || client > MaxClients + 1)
		return;
	
	if(!IsClientInGame(client))
		return;
	
	if(!IsPlayerAlive(client))
		return;
	
	if (action == MenuAction_Select)
	{
		decl String:info[100], String:info2[100];
		new bool:found = GetMenuItem(menu, param2, info, sizeof(info), _, info2, sizeof(info2));
		
		if(found)
		{
			new selection = StringToInt(info);
			
			if(selection == 900)
			{
				//Add Door in view
				new entity = GetClientAimTarget(client, false);
				if(RP_IsValidDoorEnt(entity))
				{
					new doorID = RP_GetDoorIDbyEntity(entity);
					
					RP_SetDoorBuildingID(doorID, g_SelectedBuildingID[client]);
					RP_SetDoorType(doorID, g_SelectedDoorType[client]);
					
					PrintToChat(client, "-Added Door-");
					Menu_EditBuilding(client);
				}
				else
				{
					PrintToChat(client, "You don't look at a door");
					Menu_AddBankDoor(client);
				}
			}
			else if(selection == 998)
			{
				Menu_EditBuilding(client);
			}
			else if(selection == 999)
			{
				RP_ShowMainAdminMenu(client);
			}
			return;
		}
	}
}

/* Natives */

public Native_ShowBuildingMainAdminMenu(Handle:plugin, numParams)
{
	new client = GetNativeCell(1);
	
	if(0 < client && client <= (MaxClients + 1) && IsClientInGame(client) && IsPlayerAlive(client))
		Menu_BuildingMain(client);
		
}