#include "roleplay/roleplay"

#define PL_NAME		"RP_ADMIN_MENU_MAIN"
#define MAXMODELS 32

new bool:g_LateLoaded;

/* Database */
new Handle:g_hSQL;

public Plugin:myinfo = 
{
	name = PL_NAME,
	author = PL_AUTHOR,
	description = "",
	version = PL_VERSION,
	url = PL_URL
}

public APLRes:AskPluginLoad2(Handle:myself, bool:late, String:error[], err_max)
{
	g_LateLoaded = late;
	RegPluginLibrary(PL_NAME);
	
	CreateNative("RP_ShowMainAdminMenu", Native_ShowMainAdminMenu);
	
	return APLRes_Success;
}

public RP_OnSqlConnected(Handle:db)
{
	g_hSQL = db;
	SQLConnectionReady();
}

public RP_OnSqlStop()
{
	g_hSQL = INVALID_HANDLE;
}

SQLConnectionReady()
{
	
}

public RP_OnPlayerReady(client, playerID, bool:create)
{
	//PlayerID is now cached
}

public OnPluginStart()
{
	if(g_LateLoaded)
	{
		g_hSQL = Handle:RP_GetSql();
		
		if(g_hSQL != INVALID_HANDLE)
			SQLConnectionReady();
		
		g_LateLoaded = false;
	}
	
	RegAdminCmd("rp_admin", Command_Adminmenu, ADMFLAG_ROOT, "Opens Roleplay Admin Menu");
}

public Action:Command_Adminmenu(client, args)
{
	if(0 >= client || client > MaxClients + 1)
		return Plugin_Handled;
	
	if(!IsClientInGame(client))
		return Plugin_Handled;
	
	if(!IsPlayerAlive(client))
		return Plugin_Handled;
	
	Menu_Main(client);
	
	return Plugin_Handled;
}

Menu_Main(client)
{
	new Handle:menu = CreateMenu(MenuHandler_Main);
	SetMenuTitle(menu, "[RP] Admin Menu");

	AddMenuItemEx(menu, false, "0", "Edit Objekt in View");
	AddMenuItemEx(menu, false, "1", "Player Management");
	AddMenuItemEx(menu, false, "2", "Building Management");
	AddMenuItemEx(menu, false, "3", "Item Management");
	AddMenuItemEx(menu, false, "4", "NPC Management");
	AddMenuItemEx(menu, false, "5", "Police Department Management");

	SetMenuExitButton(menu, true);
	DisplayMenu(menu, client, MENU_TIME_FOREVER);
}

public MenuHandler_Main(Handle:menu, MenuAction:action, client, param2)
{
	if(0 >= client || client > MaxClients + 1)
		return;
	
	if(!IsClientInGame(client))
		return;
	
	if(!IsPlayerAlive(client))
		return;
	
	if (action == MenuAction_Select)
	{
		decl String:info[100], String:info2[100];
		new bool:found = GetMenuItem(menu, param2, info, sizeof(info), _, info2, sizeof(info2));
		
		if(found)
		{
			new selection = StringToInt(info);
			
			if(selection == 0)
			{
				new entity = GetClientAimTarget(client, false);
				if(RP_GetNpcID(entity) != -1)
				{
					RP_ShowNPCEditAdminMenu(client, RP_GetNpcID(entity));
				}
			}				
			else if(selection == 1)
			{
				RP_ShowPlayerMainAdminMenu(client);
			}
			else if(selection == 2)
			{
				RP_ShowBuildingMainAdminMenu(client);
			}
			else if(selection == 3)
			{
				//RP_ShowItemMainAdminMenu(client);
			}
			else if(selection == 4)
			{
				RP_ShowNPCMainAdminMenu(client);
			}
			else if(selection == 5)
			{
				RP_ShowPDMainAdminMenu(client);
			}
			return;
		}
	}
}

/* Natives */

public Native_ShowMainAdminMenu(Handle:plugin, numParams)
{
	new client = GetNativeCell(1);
	
	if(0 < client && client <= (MaxClients + 1) && IsClientInGame(client) && IsPlayerAlive(client))
		Menu_Main(client);
}