#include "roleplay/roleplay"

#define PL_NAME		"RP_ADMIN_MENU_PD"

new bool:g_LateLoaded;

/* Database */
new Handle:g_hSQL;

/* Menu */
new g_SelectedJailtype[MAXPLAYERS + 1];
new bool:g_EditJailtype[MAXPLAYERS + 1];


public Plugin:myinfo = 
{
	name = PL_NAME,
	author = PL_AUTHOR,
	description = "",
	version = PL_VERSION,
	url = PL_URL
}

public APLRes:AskPluginLoad2(Handle:myself, bool:late, String:error[], err_max)
{
	g_LateLoaded = late;
	RegPluginLibrary(PL_NAME);
	
	CreateNative("RP_ShowPDMainAdminMenu", Native_ShowPDMainAdminMenu);
	
	return APLRes_Success;
}

public OnPluginStart()
{
	if(g_LateLoaded)
	{
		g_hSQL = Handle:RP_GetSql();
		
		if(g_hSQL != INVALID_HANDLE)
			SQLConnectionReady();
		
		g_LateLoaded = false;
	}
}

public RP_OnSqlConnected(Handle:db)
{
	g_hSQL = db;
	SQLConnectionReady();
}

public RP_OnSqlStop()
{
	g_hSQL = INVALID_HANDLE;
}

SQLConnectionReady()
{
	//Database is now ready to use
}

public RP_OnPlayerReady(client, playerID, bool:create)
{
	//PlayerID is now cached
}

Menu_MainPD(client)
{
	new Handle:menu = CreateMenu(MenuHandler_MainPD);
	SetMenuTitle(menu, "[RP] Police Department Admin Menu");

	AddMenuItemEx(menu, false, "0", "Create Jail");
	AddMenuItemEx(menu, false, "1", "Edit Jail");
	AddMenuItemEx(menu, false, "2", "Delete Jail");

	SetMenuExitButton(menu, true);
	DisplayMenu(menu, client, MENU_TIME_FOREVER);
}


public MenuHandler_MainPD(Handle:menu, MenuAction:action, client, param2)
{
	if(0 >= client || client > MaxClients + 1)
		return;
	
	if(!IsClientInGame(client))
		return;
	
	if(!IsPlayerAlive(client))
		return;
	
	if (action == MenuAction_Select)
	{
		decl String:info[100], String:info2[100];
		new bool:found = GetMenuItem(menu, param2, info, sizeof(info), _, info2, sizeof(info2));
		
		if(found)
		{
			new selection = StringToInt(info);
			
			if(selection == 0)
			{
				g_EditJailtype[client] = false;
				Menu_SelectJailType(client);
			}				
			else if(selection == 1)
			{
				//Menu_EditJail(client);
			}
			else if(selection == 2)
			{
				//Menu_DeleteJail(client);
			}
			return;
		}
	}
}

Menu_SelectJailType(client)
{
	new Handle:menu = CreateMenu(MenuHandler_SelectJailType);
	SetMenuTitle(menu, "[RP] Select Jailtype");
	
	new maxjails = RP_GetJailtypeCount();
	new String:buffer[32];
	new String:sindex[10];
	
	for (new i = 0; i < maxjails; i++)
	{
		RP_GetJailtypeName(i, buffer, sizeof(buffer));
				
		IntToString(i, sindex, sizeof(sindex));
		AddMenuItemEx(menu, false, sindex, "%s", buffer);
	}
	AddMenuItemEx(menu, false, "998", "Back to Jail Main");
	AddMenuItemEx(menu, false, "999", "Back to Main");

	SetMenuExitButton(menu, true);
	DisplayMenu(menu, client, MENU_TIME_FOREVER);
}

public MenuHandler_SelectJailType(Handle:menu, MenuAction:action, client, param2)
{
	if(0 >= client || client > MaxClients + 1)
		return;
	
	if(!IsClientInGame(client))
		return;
	
	if(!IsPlayerAlive(client))
		return;
	
	if (action == MenuAction_Select)
	{
		decl String:info[100], String:info2[100];
		new bool:found = GetMenuItem(menu, param2, info, sizeof(info), _, info2, sizeof(info2));

		if(found)
		{
			new selection = StringToInt(info);
			
			if(selection == 998)
			{
				Menu_MainPD(client);
			}
			else if(selection == 999)
			{
				RP_ShowMainAdminMenu(client);
			}
			else
			{
				g_SelectedJailtype[client] = selection;
				Menu_SelectBuilding(client);
			}
			return;
		}
	}
}

Menu_SelectBuilding(client)
{	
	new Handle:menu = CreateMenu(MenuHandler_SelectBuilding);
	SetMenuTitle(menu, "[RP] Select Building to edit it");

	for (new i = 0; i < RP_GetBuildingCount(); i++)
	{
		
		new buildingID = RP_GetBuildingIDByArrayIndex(i);

		if (buildingID != -1)
		{
			new String:buffer[64];
			new String:buffer2[8];
			new String:typebuffer[64];
			RP_GetBuildingName(buildingID, buffer, sizeof(buffer));
			IntToString(buildingID, buffer2, sizeof(buffer2));
			RP_GetBuildingTypeName(RP_GetBuildingType(buildingID), typebuffer, sizeof(typebuffer));
			AddMenuItemEx(menu, false, buffer2, "[%d] %s | %s",buildingID,buffer,typebuffer);
		}
	}
	AddMenuItemEx(menu, false, "998", "Back to Building Main");
	AddMenuItemEx(menu, false, "999", "Back to Main");

	SetMenuExitButton(menu, true);
	DisplayMenu(menu, client, MENU_TIME_FOREVER);
}

public MenuHandler_SelectBuilding(Handle:menu, MenuAction:action, client, param2)
{
	if(0 >= client || client > MaxClients + 1)
		return;
	
	if(!IsClientInGame(client))
		return;
	
	if(!IsPlayerAlive(client))
		return;
	
	if (action == MenuAction_Select)
	{
		decl String:info[100], String:info2[100];
		new bool:found = GetMenuItem(menu, param2, info, sizeof(info), _, info2, sizeof(info2));
		
		if(found)
		{
			new selection = StringToInt(info);
			
			if(selection == 999)
			{
				RP_ShowMainAdminMenu(client);
			}
			else if(selection == 998)
			{
				Menu_MainPD(client);
			}
			else 
			{
				RP_CreateJail(client, g_SelectedJailtype[client], selection);
				PrintToChat(client, "Created Jail where you stand");
				Menu_MainPD(client);
			}
			return;
		}
	}
}

/* Natives */

public Native_ShowPDMainAdminMenu(Handle:plugin, numParams)
{
	decl client;
	client = GetNativeCell(1);
	if(0 < client && client <= (MaxClients + 1) && IsClientInGame(client) && IsPlayerAlive(client))
		Menu_MainPD(client);
}