#include "roleplay/roleplay"

#define PL_NAME		"RP_MENU_PLAYERS"

new bool:g_LateLoaded;

/* Database */
new Handle:g_hSQL;

/* Menu */
new g_SelectedPlayer[MAXPLAYERS + 1];
new g_SelectedPlayerMethod[MAXPLAYERS + 1];
new String:g_SelectedPlayerMethodS[MAXPLAYERS + 1][64];

new g_SelectedItemType[MAXPLAYERS + 1];
new String:g_SelectedItemTypeS[MAXPLAYERS + 1][64];

new g_SelectedItem[MAXPLAYERS + 1];
new String:g_SelectedItemS[MAXPLAYERS + 1][64];

public Plugin:myinfo = 
{
	name = PL_NAME,
	author = PL_AUTHOR,
	description = "",
	version = PL_VERSION,
	url = PL_URL
}

public APLRes:AskPluginLoad2(Handle:myself, bool:late, String:error[], err_max)
{
	g_LateLoaded = late;
	RegPluginLibrary(PL_NAME);
	
	CreateNative("RP_ShowPlayerMainAdminMenu", Native_ShowPlayerMainAdminMenu);
	
	return APLRes_Success;
}

public OnPluginStart()
{
	if(g_LateLoaded)
	{
		g_hSQL = Handle:RP_GetSql();
		
		if(g_hSQL != INVALID_HANDLE)
			SQLConnectionReady();
		
		g_LateLoaded = false;
	}
}

public RP_OnSqlConnected(Handle:db)
{
	g_hSQL = db;
	SQLConnectionReady();
}

public RP_OnSqlStop()
{
	g_hSQL = INVALID_HANDLE;
}

SQLConnectionReady()
{
	//Database is now ready to use
}

public RP_OnPlayerReady(client, playerID, bool:create)
{
	//PlayerID is now cached
}

Menu_PlayerMain(client)
{	
	new Handle:menu = CreateMenu(MenuHandler_PlayerMain);
	SetMenuTitle(menu, "[RP] Choose a Player");
	new String:buffer[8];
	new String:namebuffer[64];

	for (new i = 1; i < MAXPLAYERS; i++)
	{		
		if(!IsClientInGame(i))
			continue;
		
		if(IsFakeClient(i))
			continue;
		
		GetClientName(i, namebuffer, sizeof(namebuffer));
		
		IntToString(i,buffer,sizeof(buffer));
		AddMenuItemEx(menu, false, buffer, "[%d] %s",RP_GetPlayerID(i),namebuffer);
	}
	AddMenuItemEx(menu, false, "999", "Back to Main");

	SetMenuExitButton(menu, true);
	DisplayMenu(menu, client, MENU_TIME_FOREVER);
}

public MenuHandler_PlayerMain(Handle:menu, MenuAction:action, client, param2)
{
	if(0 >= client || client > MaxClients + 1)
		return;
	
	if(!IsClientInGame(client))
		return;
	
	if(!IsPlayerAlive(client))
		return;
	
	if (action == MenuAction_Select)
	{
		decl String:info[100], String:info2[100];
		new bool:found = GetMenuItem(menu, param2, info, sizeof(info), _, info2, sizeof(info2));
		
		if(found)
		{
			new selection = StringToInt(info);
			
			if(selection == 999)
			{
				RP_ShowMainAdminMenu(client);
			}
			else
			{
				g_SelectedPlayer[client] = selection;
				Menu_PlayerOptions(client);
			}
			return;
		}
	}
}

Menu_PlayerOptions(client)
{	
	new Handle:menu = CreateMenu(MenuHandler_PlayerOptions);
	new String:namebuffer[64];
	GetClientName(g_SelectedPlayer[client], namebuffer, sizeof(namebuffer));
	SetMenuTitle(menu, "[RP] Manage Player [%d] %s", RP_GetPlayerID(g_SelectedPlayer[client]), namebuffer);
	
	AddMenuItemEx(menu, false, "0", "Information");
	AddMenuItemEx(menu, false, "1", "Money");
	AddMenuItemEx(menu, false, "2", "Crime / Bounty");
	AddMenuItemEx(menu, false, "3", "Add Item to Inventory");
	AddMenuItemEx(menu, false, "4", "Edit Inventory");
	AddMenuItemEx(menu, false, "998", "Back to Playerselection");
	AddMenuItemEx(menu, false, "999", "Back to Main");

	SetMenuExitButton(menu, true);
	DisplayMenu(menu, client, MENU_TIME_FOREVER);
}

public MenuHandler_PlayerOptions(Handle:menu, MenuAction:action, client, param2)
{
	if(0 >= client || client > MaxClients + 1)
		return;
	
	if(!IsClientInGame(client))
		return;
	
	if(!IsPlayerAlive(client))
		return;
	
	if (action == MenuAction_Select)
	{
		decl String:info[100], String:info2[100];
		new bool:found = GetMenuItem(menu, param2, info, sizeof(info), _, info2, sizeof(info2));
		
		if(found)
		{
			new selection = StringToInt(info);
			
			if(selection == 0)
			{
				Menu_PlayerPanel(client);
			}
			else if(selection == 1)
			{
				Menu_MoneyManagementMethod(client);
			}
			else if(selection == 2)
			{
				Menu_CrimeManagementMethod(client);
			}
			else if(selection == 3)
			{
				Menu_SelectItemType(client);
			}
			else if(selection == 4)
			{
				Menu_SelectItemFromInventory(client);
			}
			else if(selection == 998)
			{
				Menu_PlayerMain(client);
			}
			else if(selection == 999)
			{
				RP_ShowMainAdminMenu(client);
			}
			return;
		}
	}
}

Menu_MoneyManagementMethod(client)
{	
	new Handle:menu = CreateMenu(MenuHandler_MoneyManagementMethod);
	new String:namebuffer[64];
	GetClientName(g_SelectedPlayer[client], namebuffer, sizeof(namebuffer));
	SetMenuTitle(menu, "[RP] %s [%d,%d]",namebuffer,RP_GetMoney(g_SelectedPlayer[client]),RP_GetMoneyBank(g_SelectedPlayer[client]));

	AddMenuItemEx(menu, false, "0", "Add Money",namebuffer,RP_GetMoney(g_SelectedPlayer[client]),RP_GetMoneyBank(g_SelectedPlayer[client]));
	AddMenuItemEx(menu, false, "1", "Take Money",namebuffer,RP_GetMoney(g_SelectedPlayer[client]),RP_GetMoneyBank(g_SelectedPlayer[client]));
	AddMenuItemEx(menu, false, "2", "Add Money to Bank",namebuffer,RP_GetMoney(g_SelectedPlayer[client]),RP_GetMoneyBank(g_SelectedPlayer[client]));
	AddMenuItemEx(menu, false, "3", "Take Money from Bank",namebuffer,RP_GetMoney(g_SelectedPlayer[client]),RP_GetMoneyBank(g_SelectedPlayer[client]));

	AddMenuItemEx(menu, false, "998", "Back to Player Overview");
	AddMenuItemEx(menu, false, "999", "Back to Main");

	SetMenuExitButton(menu, true);
	DisplayMenu(menu, client, MENU_TIME_FOREVER);
}

public MenuHandler_MoneyManagementMethod(Handle:menu, MenuAction:action, client, param2)
{
	if(0 >= client || client > MaxClients + 1)
		return;
	
	if(!IsClientInGame(client))
		return;
	
	if(!IsPlayerAlive(client))
		return;
	
	if (action == MenuAction_Select)
	{
		decl String:info[100], String:info2[100];
		new bool:found = GetMenuItem(menu, param2, info, sizeof(info), _, info2, sizeof(info2));
		
		if(found)
		{
			new selection = StringToInt(info);
			
			if(selection == 998)
			{
				Menu_PlayerOptions(client);
			}
			else if(selection == 999)
			{
				RP_ShowMainAdminMenu(client);
			}
			else if(selection == 0)
			{
				g_SelectedPlayerMethod[client] = 0;
				g_SelectedPlayerMethodS[client] = "Add Money to";
				Menu_MoneyManagementTransfer(client);
			}
			else if(selection == 1)
			{
				g_SelectedPlayerMethod[client] = 1;
				g_SelectedPlayerMethodS[client] = "Take Money from";
				Menu_MoneyManagementTransfer(client);
			}
			else if(selection == 2)
			{
				g_SelectedPlayerMethod[client] = 2;
				g_SelectedPlayerMethodS[client] = "Add Money to Bank of";
				Menu_MoneyManagementTransfer(client);
			}
			else if(selection == 3)
			{
				g_SelectedPlayerMethod[client] = 3;
				g_SelectedPlayerMethodS[client] = "Take Money from Bank of";
				Menu_MoneyManagementTransfer(client);
			}
			return;
		}
	}
}

Menu_MoneyManagementTransfer(client)
{
	new Handle:menu = CreateMenu(MenuHandler_MoneyManagementTransfer);
	new String:namebuffer[64];
	GetClientName(g_SelectedPlayer[client], namebuffer, sizeof(namebuffer));
	if(g_SelectedPlayerMethod[client] == 0 || g_SelectedPlayerMethod[client] == 1)
		SetMenuTitle(menu, "[RP] [%d] %s %s", RP_GetMoney(g_SelectedPlayer[client]) , g_SelectedPlayerMethodS[client],namebuffer);
	else
		SetMenuTitle(menu, "[RP] [%d] %s %s", RP_GetMoneyBank(g_SelectedPlayer[client]),g_SelectedPlayerMethodS[client],namebuffer);

	AddMenuItemEx(menu, false, "1", "1$");
	AddMenuItemEx(menu, false, "10", "10$");
	AddMenuItemEx(menu, false, "100", "100$");
	AddMenuItemEx(menu, false, "1000", "1000$");
	AddMenuItemEx(menu, false, "10000", "10000$");

	AddMenuItemEx(menu, false, "997", "Back to Moneycontrol");
	AddMenuItemEx(menu, false, "998", "Back to Player Overview");
	AddMenuItemEx(menu, false, "999", "Back to Main");

	SetMenuExitButton(menu, true);
	DisplayMenu(menu, client, MENU_TIME_FOREVER);
}

public MenuHandler_MoneyManagementTransfer(Handle:menu, MenuAction:action, client, param2)
{
	if(0 >= client || client > MaxClients + 1)
		return;
	
	if(!IsClientInGame(client))
		return;
	
	if(!IsPlayerAlive(client))
		return;
	
	if (action == MenuAction_Select)
	{
		decl String:info[100], String:info2[100];
		new bool:found = GetMenuItem(menu, param2, info, sizeof(info), _, info2, sizeof(info2));
		
		if(found)
		{
			new selection = StringToInt(info);
			
			if(selection == 997)
			{
				Menu_MoneyManagementMethod(client);
			}
			else if(selection == 998)
			{			
				Menu_PlayerOptions(client);
			}
			else if(selection == 999)
			{
				RP_ShowMainAdminMenu(client);
			}
			else
			{
				if(g_SelectedPlayerMethod[client] == 0)
				{
					RP_AddMoney(g_SelectedPlayer[client], selection);
					Menu_MoneyManagementTransfer(client);
				}
				else if(g_SelectedPlayerMethod[client] == 1)
				{
					RP_TakeMoney(g_SelectedPlayer[client], selection);
					Menu_MoneyManagementTransfer(client);
				}
				else if(g_SelectedPlayerMethod[client] == 2)
				{
					RP_AddMoneyBank(g_SelectedPlayer[client], selection);
					Menu_MoneyManagementTransfer(client);
				}
				else
				{
					RP_TakeMoneyBank(g_SelectedPlayer[client], selection);
					Menu_MoneyManagementTransfer(client);
				}
			}
			return;
		}
	}
}

Menu_CrimeManagementMethod(client)
{	
	new Handle:menu = CreateMenu(MenuHandler_CrimeManagementMethod);
	new String:namebuffer[64];
	GetClientName(g_SelectedPlayer[client], namebuffer, sizeof(namebuffer));
	SetMenuTitle(menu, "[RP] %s [%d,%d]",namebuffer,RP_GetCrime(g_SelectedPlayer[client]),RP_GetBounty(g_SelectedPlayer[client]));

	AddMenuItemEx(menu, false, "0", "Add Crime");
	AddMenuItemEx(menu, false, "1", "Take Crime");
	AddMenuItemEx(menu, false, "2", "Add Bounty");
	AddMenuItemEx(menu, false, "3", "Take Bounty");

	AddMenuItemEx(menu, false, "998", "Back to Player Overview");
	AddMenuItemEx(menu, false, "999", "Back to Main");

	SetMenuExitButton(menu, true);
	DisplayMenu(menu, client, MENU_TIME_FOREVER);
}

public MenuHandler_CrimeManagementMethod(Handle:menu, MenuAction:action, client, param2)
{
	if(0 >= client || client > MaxClients + 1)
		return;
	
	if(!IsClientInGame(client))
		return;
	
	if(!IsPlayerAlive(client))
		return;
	
	if (action == MenuAction_Select)
	{
		decl String:info[100], String:info2[100];
		new bool:found = GetMenuItem(menu, param2, info, sizeof(info), _, info2, sizeof(info2));
		
		if(found)
		{
			new selection = StringToInt(info);
			
			if(selection == 998)
			{
				Menu_PlayerOptions(client);
			}
			else if(selection == 999)
			{
				RP_ShowMainAdminMenu(client);
			}
			else if(selection == 0)
			{
				g_SelectedPlayerMethod[client] = 0;
				g_SelectedPlayerMethodS[client] = "Add Crime to";
				Menu_CrimeManagementTransfer(client);
			}
			else if(selection == 1)
			{
				g_SelectedPlayerMethod[client] = 1;
				g_SelectedPlayerMethodS[client] = "Take Crime from";
				Menu_CrimeManagementTransfer(client);
			}
			else if(selection == 2)
			{
				g_SelectedPlayerMethod[client] = 2;
				g_SelectedPlayerMethodS[client] = "Add Bounty to";
				Menu_CrimeManagementTransfer(client);
			}
			else if(selection == 3)
			{
				g_SelectedPlayerMethod[client] = 3;
				g_SelectedPlayerMethodS[client] = "Take Bounty from";
				Menu_CrimeManagementTransfer(client);
			}
			return;
		}
	}
}

Menu_CrimeManagementTransfer(client)
{
	new Handle:menu = CreateMenu(MenuHandler_CrimeManagementTransfer);
	new String:namebuffer[64];
	GetClientName(g_SelectedPlayer[client], namebuffer, sizeof(namebuffer));
	if(g_SelectedPlayerMethod[client] == 0 || g_SelectedPlayerMethod[client] == 1)
		SetMenuTitle(menu, "[RP] [%d] %s %s", RP_GetCrime(g_SelectedPlayer[client]) , g_SelectedPlayerMethodS[client], namebuffer);
	else
		SetMenuTitle(menu, "[RP] [%d] %s %s", RP_GetBounty(g_SelectedPlayer[client]), g_SelectedPlayerMethodS[client], namebuffer);
		
	AddMenuItemEx(menu, false, "1", "1");
	AddMenuItemEx(menu, false, "10", "10");
	AddMenuItemEx(menu, false, "100", "100");
	AddMenuItemEx(menu, false, "1000", "1000");
	AddMenuItemEx(menu, false, "10000", "10000");

	AddMenuItemEx(menu, false, "997", "Back to Crime Control");
	AddMenuItemEx(menu, false, "998", "Back to Player Overview");
	AddMenuItemEx(menu, false, "999", "Back to Main");

	SetMenuExitButton(menu, true);
	DisplayMenu(menu, client, MENU_TIME_FOREVER);
}

public MenuHandler_CrimeManagementTransfer(Handle:menu, MenuAction:action, client, param2)
{
	if(0 >= client || client > MaxClients + 1)
		return;
	
	if(!IsClientInGame(client))
		return;
	
	if(!IsPlayerAlive(client))
		return;
	
	if (action == MenuAction_Select)
	{
		decl String:info[100], String:info2[100];
		new bool:found = GetMenuItem(menu, param2, info, sizeof(info), _, info2, sizeof(info2));
		
		if(found)
		{
			new selection = StringToInt(info);
			
			if(selection == 997)
			{
				Menu_CrimeManagementMethod(client);
			}
			else if(selection == 998)
			{
				Menu_PlayerOptions(client);
			}
			else if(selection == 999)
			{
				RP_ShowMainAdminMenu(client);
			}
			else
			{
				if(g_SelectedPlayerMethod[client] == 0)
				{
					RP_AddCrime(g_SelectedPlayer[client], selection,"Admin");
					Menu_CrimeManagementTransfer(client);
				}
				else if(g_SelectedPlayerMethod[client] == 1)
				{
					RP_TakeCrime(g_SelectedPlayer[client], selection);
					Menu_CrimeManagementTransfer(client);
				}
				else if(g_SelectedPlayerMethod[client] == 2)
				{
					RP_AddBounty(g_SelectedPlayer[client], selection);
					Menu_CrimeManagementTransfer(client);
				}
				else
				{
					RP_TakeBounty(g_SelectedPlayer[client], selection);
					Menu_CrimeManagementTransfer(client);
				}
			}
			return;
		}
	}
}

Menu_PlayerPanel(client)
{	
	new Handle:panel = CreateMenuEx(_,MenuHandler_PlayerPanel,MENU_ACTIONS_ALL);
	SetMenuPagination(panel,4);
	new String:text[255];
	new String:temp[255];
	
	Format(temp,sizeof(temp),"[%d] %N \n",RP_GetPlayerID(g_SelectedPlayer[client]) ,g_SelectedPlayer[client]);
	StrCat(text,255,temp);
	AddMenuItem(panel,"",text);
	text="";
	
	Format(temp,sizeof(temp),"Money: %d / Bank: %d \n",RP_GetMoney(g_SelectedPlayer[client]),RP_GetMoneyBank(g_SelectedPlayer[client]));
	StrCat(text,255,temp);
	AddMenuItem(panel,"",text);
	text="";
	
	Format(temp,sizeof(temp),"Crime: %d / Bounty: %d \n",RP_GetCrime(g_SelectedPlayer[client]),RP_GetBounty(g_SelectedPlayer[client]));
	StrCat(text,255,temp);
	AddMenuItem(panel,"",text);
	text="";
	
	Format(temp,sizeof(temp),"Level: %d / Items: %d \n",RP_GetLevel(g_SelectedPlayer[client]),RP_GetPlayerInventoryItemCount(g_SelectedPlayer[client]));
	StrCat(text,255,temp);
	AddMenuItem(panel,"",text);
	text="";

	Format(temp,sizeof(temp),"Back to Player Overview \n");
	StrCat(text,255,temp);
	AddMenuItem(panel,"998",text);
	text="";

	Format(temp,sizeof(temp),"Back to Main \n");
	StrCat(text,255,temp);
	AddMenuItem(panel,"999",text);
	text="";

	DisplayMenu(panel,client,MENU_TIME_FOREVER);
}

public MenuHandler_PlayerPanel(Handle:menu, MenuAction:action, client, param2)
{
	if(0 >= client || client > MaxClients + 1)
		return;
	
	if(!IsClientInGame(client))
		return;
	
	if(!IsPlayerAlive(client))
		return;
	
	if (action == MenuAction_Select)
	{
		decl String:info[100], String:info2[100];
		new bool:found = GetMenuItem(menu, param2, info, sizeof(info), _, info2, sizeof(info2));
		
		if(found)
		{
			new selection = StringToInt(info);
			
			if(selection == 998)
			{
				Menu_PlayerOptions(client);
			}
			else if(selection == 999)
			{
				RP_ShowMainAdminMenu(client);
			}
			return;
		}
	}
	
	if (action == MenuAction_End)
	{
		CloseHandle(menu);
	}
}

Menu_SelectItemType(client)
{
	new Handle:menu = CreateMenu(MenuHandler_SelectItemType);
	SetMenuTitle(menu, "Itemtype Selection");
	
	new maxit = RP_GetMaxItemType();
	new String:buffer[64]
	new String:sindex[10];
	
	for (new i = 0; i < maxit; i++)
	{
		if(RP_GetItemTypeUsed(i))
		{
			RP_GetItemTypeName(i, buffer, sizeof(buffer));
			
			IntToString(i, sindex, sizeof(sindex));
			AddMenuItemEx(menu, false, sindex, "%s", buffer);
			
		}
	}
	AddMenuItemEx(menu, false, "998", "Back to Player Overview");
	AddMenuItemEx(menu, false, "999", "Back to Main");
	SetMenuExitButton(menu, true);
	DisplayMenu(menu, client, MENU_TIME_FOREVER);
}

public MenuHandler_SelectItemType(Handle:menu, MenuAction:action, client, param2)
{
	if(0 >= client || client > MaxClients + 1)
		return;
	
	if(!IsClientInGame(client))
		return;
	
	if(!IsPlayerAlive(client))
		return;
	
	if (action == MenuAction_Select)
	{
		decl String:info[100], String:info2[100];
		new bool:found = GetMenuItem(menu, param2, info, sizeof(info), _, info2, sizeof(info2));
		
		new String:buffer[64];
		
		if(found)
		{
			new selection = StringToInt(info);
			
			
			if(selection == 998)
			{
				Menu_PlayerOptions(client);
			}
			else if(selection == 999)
			{
				RP_ShowMainAdminMenu(client);
			}
			else
			{
				g_SelectedItemType[client] = selection;
				RP_GetItemTypeName(selection, buffer, sizeof(buffer));
				g_SelectedItemTypeS[client] = buffer;
				Menu_SelectItem(client);
			}
			return;
		}
	}
}

Menu_SelectItem(client)
{
	new items = RP_GetItemCount();
	new Handle:menu = CreateMenu(MenuHandler_SelectItem);
	SetMenuTitle(menu, "[%s] Select Item", g_SelectedItemTypeS[client]);

	new String:sItemID[10];
	
	for (new i = 0; i < items; i++)
	{
		new itemID = RP_GetItemID(i);
		
		if(RP_GetItemType(itemID) == g_SelectedItemType[client])
		{
			decl String:sItemName[64];
			RP_GetItemName(itemID, sItemName, sizeof(sItemName));
			IntToString(itemID, sItemID, sizeof(sItemID));
			AddMenuItemEx(menu, false, sItemID, "[%d] %s", itemID, sItemName);
		}
	}
	
	AddMenuItemEx(menu, false, "997", "Back to Itemtype Selection");
	AddMenuItemEx(menu, false, "998", "Back to Player Overview");
	AddMenuItemEx(menu, false, "999", "Back to Main");
	
	SetMenuExitButton(menu, true);
	DisplayMenu(menu, client, MENU_TIME_FOREVER);
}

public MenuHandler_SelectItem(Handle:menu, MenuAction:action, client, param2)
{
	if(0 >= client || client > MaxClients + 1)
		return;
	
	if(!IsClientInGame(client))
		return;
	
	if(!IsPlayerAlive(client))
		return;
	
	if (action == MenuAction_Select)
	{
		decl String:info[100], String:info2[100];
		new bool:found = GetMenuItem(menu, param2, info, sizeof(info), _, info2, sizeof(info2));
		new String:buffer[64];
		
		if(found)
		{
			new selection = StringToInt(info);
			
			if(selection == 997)
			{
				Menu_SelectItemType(client);
			}
			if(selection == 998)
			{
				Menu_PlayerOptions(client);
			}
			else if(selection == 999)
			{
				RP_ShowMainAdminMenu(client);
			}
			else
			{
				g_SelectedItem[client] = selection;
				RP_GetItemName(selection, buffer, sizeof(buffer));
				g_SelectedItemS[client] = buffer;
				Menu_AddItemToClient(client);
			}
			return;
		}
	}
}

Menu_AddItemToClient(client)
{
	new Handle:menu = CreateMenu(MenuHandler_AddItemToClient);
	new String:namebuffer[64];
	GetClientName(g_SelectedPlayer[client], namebuffer, sizeof(namebuffer));
	if(RP_HasPlayerInventoryItem(client, g_SelectedItem[client]) >= 1)
		SetMenuTitle(menu, "[RP] %s got %dx %s", namebuffer,RP_HasPlayerInventoryItem(g_SelectedPlayer[client],g_SelectedItem[client]) ,g_SelectedItemS[client]);
	else
		SetMenuTitle(menu, "[RP] %s got 0x %s", namebuffer ,g_SelectedItemS[client]);

	AddMenuItemEx(menu, false, "1", "+1");
	AddMenuItemEx(menu, false, "2", "+10");
	AddMenuItemEx(menu, false, "3", "+100");
	
	AddMenuItemEx(menu, !(RP_HasPlayerInventoryItem(client, g_SelectedItem[client]) >= 1), "11", "-1");
	AddMenuItemEx(menu, !(RP_HasPlayerInventoryItem(client, g_SelectedItem[client]) >= 10), "12", "-10");
	AddMenuItemEx(menu, !(RP_HasPlayerInventoryItem(client, g_SelectedItem[client]) >= 100), "13", "-100");

	AddMenuItemEx(menu, false, "996", "Back to Player Overview");
	AddMenuItemEx(menu, false, "997", "Back to Player Inventory");
	AddMenuItemEx(menu, false, "998", "Back to Itemtypelist");
	AddMenuItemEx(menu, false, "999", "Back to Main");

	SetMenuExitButton(menu, true);
	DisplayMenu(menu, client, MENU_TIME_FOREVER);
}

public MenuHandler_AddItemToClient(Handle:menu, MenuAction:action, client, param2)
{
	if(0 >= client || client > MaxClients + 1)
		return;
	
	if(!IsClientInGame(client))
		return;
	
	if(!IsPlayerAlive(client))
		return;
	
	if (action == MenuAction_Select)
	{
		decl String:info[100], String:info2[100];
		new bool:found = GetMenuItem(menu, param2, info, sizeof(info), _, info2, sizeof(info2));
		
		if(found)
		{
			new selection = StringToInt(info);
			
			if(selection == 1)
			{
				RP_AddPlayerInventoryItem(g_SelectedPlayer[client], g_SelectedItem[client], 1);
				Menu_AddItemToClient(client);
			}
			else if(selection == 2)
			{
				RP_AddPlayerInventoryItem(g_SelectedPlayer[client], g_SelectedItem[client], 10);
				Menu_AddItemToClient(client);
			}
			else if(selection == 3)
			{
				RP_AddPlayerInventoryItem(g_SelectedPlayer[client], g_SelectedItem[client], 100);
				Menu_AddItemToClient(client);
			}
			else if(selection == 11)
			{
				RP_TakePlayerItem(g_SelectedPlayer[client], g_SelectedItem[client], 1);
				Menu_AddItemToClient(client);
			}
			else if(selection == 12)
			{
				RP_TakePlayerItem(g_SelectedPlayer[client], g_SelectedItem[client], 10);
				Menu_AddItemToClient(client);
			}
			else if(selection == 13)
			{
				RP_TakePlayerItem(g_SelectedPlayer[client], g_SelectedItem[client], 100);
				Menu_AddItemToClient(client);
			}
			else if(selection == 996)
			{
				Menu_PlayerOptions(client);
			}
			else if(selection == 997)
			{
				Menu_SelectItemFromInventory(client);
			}
			else if(selection == 998)
			{
				Menu_SelectItemType(client);
			}
			else if(selection == 999)
			{
				RP_ShowMainAdminMenu(client);
			}
			return;
		}
	}
}

Menu_SelectItemFromInventory(client)
{
	new items = RP_GetPlayerInventoryItemCount(g_SelectedPlayer[client]);
	new String:namebuffer[64];
	GetClientName(g_SelectedPlayer[client], namebuffer, sizeof(namebuffer));
	new Handle:menu = CreateMenu(MenuHandler_SelectItemFromInventory);
	SetMenuTitle(menu, "[RP] Inventory of %s [Items: %d]", namebuffer,items);
	
	for (new i = 0; i < items; i++)
	{
		new itemID = RP_GetPlayerInventoryItem(g_SelectedPlayer[client], i);
		new durability = RP_HasPlayerInventoryItem(g_SelectedPlayer[client], itemID);
		
		decl String:sItemID[10];
		IntToString(itemID, sItemID, sizeof(sItemID));
		
		decl String:sItemName[64];
		RP_GetItemName(itemID, sItemName, sizeof(sItemName));
		
		AddMenuItemEx(menu, false, sItemID, "%dx %s", durability, sItemName);
	}
	
	AddMenuItemEx(menu, false, "9998", "Back to Player Overview");
	AddMenuItemEx(menu, false, "9999", "Back to Main");
	
	SetMenuExitButton(menu, true);
	DisplayMenu(menu, client, MENU_TIME_FOREVER);
}

public MenuHandler_SelectItemFromInventory(Handle:menu, MenuAction:action, client, param2)
{
	if(0 >= client || client > MaxClients + 1)
		return;
	
	if(!IsClientInGame(client))
		return;
	
	if(!IsPlayerAlive(client))
		return;
	
	if (action == MenuAction_Select)
	{
		decl String:info[100], String:info2[100];
		new bool:found = GetMenuItem(menu, param2, info, sizeof(info), _, info2, sizeof(info2));
		new String:buffer[64];
		
		if(found)
		{
			new selection = StringToInt(info);
			
			if(selection == 9998)
			{
				Menu_PlayerOptions(client);
			}
			else if(selection == 9999)
			{
				RP_ShowMainAdminMenu(client);
			}
			else
			{
				g_SelectedItem[client] = selection;
				RP_GetItemName(selection, buffer, sizeof(buffer));
				g_SelectedItemS[client] = buffer;
				Menu_AddItemToClient(client);
			}
			return;
		}
	}
}

/* Natives */

public Native_ShowPlayerMainAdminMenu(Handle:plugin, numParams)
{
	new client = GetNativeCell(1);
	
	if(0 < client && client < (MaxClients + 1) && IsClientInGame(client) && IsPlayerAlive(client))
		Menu_PlayerMain(client);
}