#include "roleplay/roleplay"

#define PL_NAME		"RP_BUILDING_APPARTMENTS"

new bool:g_LateLoaded;

/* Database */
new Handle:g_hSQL;

new nAppartmentsTeamplate[RP_Appartments];
new Handle:g_hAppartments = INVALID_HANDLE;

new nAppartmentDoorsTeamplate[RP_AppartmentDoors];
new Handle:g_hAppartmentDoors = INVALID_HANDLE;

public Plugin:myinfo = 
{
	name = PL_NAME,
	author = PL_AUTHOR,
	description = "",
	version = PL_VERSION,
	url = PL_URL
}

public APLRes:AskPluginLoad2(Handle:myself, bool:late, String:error[], err_max)
{
	g_LateLoaded = late;
	RegPluginLibrary(PL_NAME);
	
	CreateNative("RP_GetAppartmentCount", Native_GetAppartmentCount);
	
	CreateNative("RP_GetAppartmentIDByIndex", Native_GetAppartmentIDByIndex);
	CreateNative("RP_GetAppartmentIDByPlayerID", Native_GetAppartmentIDByPlayerID);
	
	CreateNative("RP_CreateAppartment", Native_CreateAppartment);
	CreateNative("RP_DeleteAppartment", Native_DeleteAppartment);
	
	CreateNative("RP_GetAppartmentPlayerID", Native_GetAppartmentPlayerID);
	CreateNative("RP_SetAppartmentPlayerID", Native_SetAppartmentPlayerID);

	CreateNative("RP_GetAppartmentPrice", Native_GetAppartmentPrice);
	CreateNative("RP_SetAppartmentPrice", Native_SetAppartmentPrice);
	
	CreateNative("RP_IsAppartmenSold", Native_IsAppartmentSold);
	CreateNative("RP_SetAppartmentSold", Native_SetAppartmentSold);
	
	CreateNative("RP_GetAppartmentMaxInh", Native_GetAppartmentMaxInh);
	CreateNative("RP_SetAppartmentMaxInh", Native_SetAppartmentMaxInh);
	
	CreateNative("RP_GetAppartmentbuildingID", Native_GetAppartmentbuildingID);
	CreateNative("RP_SetAppartmentbuildingID", Native_SetAppartmentbuildingID);
	
	CreateNative("RP_GetAppartmentRoomnumber", Native_GetAppartmentRoomnumber);
	CreateNative("RP_SetAppartmentRoomnumber", Native_SetAppartmentRoomnumber);
	
	CreateNative("RP_GetAppartmentDoors", Native_GetAppartmentDoors);
	
	CreateNative("RP_SetAppartmentDoor", Native_SetAppartmentDoor);
	CreateNative("RP_GetDoorAppartmentID", Native_GetDoorAppartmentID);
	CreateNative("RP_DeleteAppartmentDoor", Native_DeleteAppartmentDoor);
	
	CreateNative("RP_GetAppartmentDoorsCount", Native_GetAppartmentDoorsCount);
	CreateNative("RP_GetAppartmentDoorIDByIndex", Native_GetAppartmentDoorIDByIndex);
	CreateNative("RP_GetAppartmentDoorAppIDByIndex", Native_GetAppartmentDoorAppIDByIndex);
	
	CreateNative("RP_SellAppartment", Native_SellAppartment);
	
	return APLRes_Success;
}

public OnPluginStart()
{
	// Init ADT arrays
	g_hAppartments = CreateArray(sizeof(nAppartmentsTeamplate));
	nAppartmentsTeamplate[Appartment_ID] = 0;
	
	// Init ADT arrays
	g_hAppartmentDoors = CreateArray(sizeof(nAppartmentDoorsTeamplate));
	nAppartmentDoorsTeamplate[App_Door_ID] = 0;
	
	if(g_LateLoaded)
	{
		g_hSQL = Handle:RP_GetSql();
		
		if(g_hSQL != INVALID_HANDLE)
			SQLConnectionReady();
		
		g_LateLoaded = false;
	}
}

public RP_OnSqlConnected(Handle:db)
{
	g_hSQL = db;
	SQLConnectionReady();
}

public RP_OnSqlStop()
{
	g_hSQL = INVALID_HANDLE;
}

SQLConnectionReady()
{
	decl String:sQuery[2048];
	Format(sQuery, sizeof(sQuery), "CREATE TABLE IF NOT EXISTS `rp_appartments` (`appartmentID` int(10) NOT NULL AUTO_INCREMENT PRIMARY KEY, `playerID` int(10) NOT NULL, `price` int(10) NOT NULL, `sold` BOOL NOT NULL DEFAULT '0', `maxinhabitants` int(10) NOT NULL,`buildingID` int(10) NOT NULL,`roomnumber` varchar(64) NOT NULL) ENGINE=InnoDB DEFAULT CHARSET=utf8;");
	LogMessage("%s [%s] Query: %s", PL_PRE_N, PL_NAME, sQuery);
	SQL_TQuery(g_hSQL, SQL_CreateTableCallback, sQuery, _, DBPrio_High);
	
	Format(sQuery, sizeof(sQuery), "CREATE TABLE IF NOT EXISTS `rp_appartment_doors` (`doorID` int(10) NOT NULL PRIMARY KEY, `appartmentID` int(10) NOT NULL) ENGINE=InnoDB DEFAULT CHARSET=utf8;");
	LogMessage("%s [%s] Query: %s", PL_PRE_N, PL_NAME, sQuery);
	SQL_TQuery(g_hSQL, SQL_CreateTableCallback, sQuery, _, DBPrio_High);
	
	ResetAppartments();
	LoadAppartments();
	
	ResetAppartmentDoors();
	LoadAppartmentDoors();
}

public SQL_CreateTableCallback(Handle:owner, Handle:hndl, const String:error[], any:data)
{
	if (owner == INVALID_HANDLE || hndl == INVALID_HANDLE)
	{
		LogError("%s [%s] (SQL_CreateTableCallback) %s", PL_PRE_N, PL_NAME, error);
	}
}

/* Appartments */

ResetAppartments()
{
	ClearArray(g_hAppartments);
	g_hAppartments = CreateArray(sizeof(nAppartmentsTeamplate));
}

LoadAppartments()
{
	decl String:sQuery[2048];
	Format(sQuery, sizeof(sQuery), "SELECT `appartmentID`,`sold`,`playerID`,`price`, `maxinhabitants`,`buildingID`,`roomnumber` FROM `rp_appartments`");
	SQL_TQuery(g_hSQL, SQL_LoadAppartmentsCallback, sQuery, _, DBPrio_Low);
}

public SQL_LoadAppartmentsCallback(Handle:owner, Handle:hndl, const String:error[], any:data)
{
	if (owner == INVALID_HANDLE || hndl == INVALID_HANDLE)
	{
		LogError("%s [%s] (SQL_LoadAppartmentsCallback) %s", PL_PRE_N, PL_NAME, error);
	}
	
	while (SQL_FetchRow(hndl))
	{
		new nNew[RP_Appartments];
		
		nNew[Appartment_ID] = SQL_FetchInt(hndl, 0);
		nNew[Appartment_Sold] = bool:SQL_FetchInt(hndl, 1);
		nNew[Appartment_PlayerID] = SQL_FetchInt(hndl, 2);
		nNew[Appartment_Price] = SQL_FetchInt(hndl, 3);
		nNew[Appartment_MaxInh] = SQL_FetchInt(hndl, 4);
		nNew[Building_ID] = SQL_FetchInt(hndl, 5);
		SQL_FetchString(hndl, 6, nNew[Appartment_Roomnumber], 16);
		
		PushArrayArray(g_hAppartments, nNew[0]);
	}
}

ResetAppartmentDoors()
{
	ClearArray(g_hAppartmentDoors);
	g_hAppartmentDoors = CreateArray(sizeof(nAppartmentDoorsTeamplate));
}

LoadAppartmentDoors()
{
	decl String:sQuery[2048];
	Format(sQuery, sizeof(sQuery), "SELECT `doorID`,`appartmentID` FROM `rp_appartment_doors`");
	SQL_TQuery(g_hSQL, SQL_LoadAppartmentDoorsCallback, sQuery, _, DBPrio_Low);
}

public SQL_LoadAppartmentDoorsCallback(Handle:owner, Handle:hndl, const String:error[], any:data)
{
	if (owner == INVALID_HANDLE || hndl == INVALID_HANDLE)
	{
		LogError("%s [%s] (SQL_LoadAppartmentDoorsCallback) %s", PL_PRE_N, PL_NAME, error);
	}
	
	while (SQL_FetchRow(hndl))
	{
		new nNew[RP_AppartmentDoors];
		
		nNew[App_Door_ID] = SQL_FetchInt(hndl, 0);
		nNew[App_ID] = SQL_FetchInt(hndl, 1);
		
		PushArrayArray(g_hAppartmentDoors, nNew[0]);
	}
}

SetAppartmentDoor(doorID,appartmentID)
{
	new bool:found = false;
	for (new i = 0; i < GetArraySize(g_hAppartmentDoors); i++)
	{
		new nNew[RP_AppartmentDoors];
		GetArrayArray(g_hAppartmentDoors, i, nNew[0]);
		
		if (nNew[App_Door_ID] == doorID)
		{
			found = true;
			nNew[App_ID] = appartmentID;
			RP_SetDoorBuildingID(doorID,RP_GetAppartmentbuildingID(appartmentID));
			RP_SetDoorType(doorID, 0);
			SetArrayArray(g_hAppartmentDoors, i, nNew[0]);
			break;
		}
	}
	//Not found create new Entry
	if(!found)
	{
		decl String:sQuery[2048];
		FormatEx(sQuery, sizeof(sQuery), "INSERT INTO `rp_appartment_doors` (doorID, appartmentID) VALUES (%d,%d)", doorID,appartmentID);
		SQL_TQuery(g_hSQL, SQL_AppartmentDoorsCreateCallback, sQuery, _, DBPrio_Normal);
		
		RP_SetDoorBuildingID(doorID,RP_GetAppartmentbuildingID(appartmentID));
		RP_SetDoorType(doorID, 0);
		
		new nNew[RP_AppartmentDoors];
		
		nNew[App_Door_ID] = doorID;
		nNew[App_ID] = appartmentID;
		
		PushArrayArray(g_hAppartmentDoors, nNew[0]);
	}
}

public SQL_AppartmentDoorsCreateCallback(Handle:owner, Handle:hndl, const String:error[], any:userid)
{
	if (owner == INVALID_HANDLE || hndl == INVALID_HANDLE)
	{
		LogError("%s [%s] (SQL_AppartmentDoorsCreateCallback) %s", PL_PRE_N, PL_NAME, error);
	}
}

DeleteAppartmentDoor(doorID)
{
	for (new i = 0; i < GetArraySize(g_hAppartmentDoors); i++)
	{
		new nNew[RP_AppartmentDoors];
		GetArrayArray(g_hAppartmentDoors, i, nNew[0]);
		
		if (nNew[App_Door_ID] == doorID)
		{
			decl String:sQuery[2048];
			FormatEx(sQuery, sizeof(sQuery), "DELETE FROM `rp_appartment_doors` WHERE doorID = %d", doorID);
			SQL_TQuery(g_hSQL, SQL_DeleteAppartmentDoorCallback, sQuery, _);
			
			RP_SetDoorBuildingID(doorID, -1);
			RP_SetDoorType(doorID, -1);
			
			RemoveFromArray(g_hAppartmentDoors, i);
			break;
		}
	}
}

public SQL_DeleteAppartmentDoorCallback(Handle:owner, Handle:hndl, const String:error[], any:userid)
{
	if (owner == INVALID_HANDLE || hndl == INVALID_HANDLE)
	{
		LogError("%s [%s] (SQL_DeleteAppartmentDoorCallback) %s", PL_PRE_N, PL_NAME, error);
	}
}

GetDoorAppartmentID(doorID)
{
	for (new i = 0; i < GetArraySize(g_hAppartmentDoors); i++)
	{
		new nNew[RP_AppartmentDoors];
		GetArrayArray(g_hAppartmentDoors, i, nNew[0]);
		
		if (nNew[App_Door_ID] == doorID)
		{
			return nNew[App_ID];
		}
	}
	return -1;
}

DeleteAppartment(appartmentID)
{
	decl String:sQuery[2048];
	FormatEx(sQuery, sizeof(sQuery), "DELETE FROM `rp_appartments` WHERE appartmentID = %d", appartmentID);
	SQL_TQuery(g_hSQL, SQL_DeleteAppartmentCallback, sQuery, _);
	
	for (new i = 0; i < GetArraySize(g_hAppartments); i++)
	{
		new nNew[RP_Appartments];
		GetArrayArray(g_hAppartments, i, nNew[0]);
		
		if (nNew[Appartment_ID] == appartmentID)
		{
			RemoveFromArray(g_hAppartments, i);
			break;
		}
	}
}

public SQL_DeleteAppartmentCallback(Handle:owner, Handle:hndl, const String:error[], any:userid)
{
	if (owner == INVALID_HANDLE || hndl == INVALID_HANDLE)
	{
		LogError("%s [%s] (SQL_DeleteAppartmentCallback) %s", PL_PRE_N, PL_NAME, error);
	}
}

CreateAppartment(price,maxinh,buildingID,String:roomAdress[])
{
	decl String:sQuery[2048];
	FormatEx(sQuery, sizeof(sQuery), "INSERT INTO `rp_appartments` (price, sold, playerID, maxinhabitants,buildingID,roomnumber) VALUES (%d, 0, 0, %d,%d,'%s')", price,maxinh,buildingID,roomAdress);
	SQL_TQuery(g_hSQL, SQL_AppartmentCreateCallback, sQuery, _, DBPrio_Normal);

	ResetAppartments();
	LoadAppartments();
}

public SQL_AppartmentCreateCallback(Handle:owner, Handle:hndl, const String:error[], any:userid)
{
	if (owner == INVALID_HANDLE || hndl == INVALID_HANDLE)
	{
		LogError("%s [%s] (SQL_AppartmentCreateCallback) %s", PL_PRE_N, PL_NAME, error);
	}
}

SetAppartmentPlayerID(appartmentID, playerID)
{
	for (new i = 0; i < GetArraySize(g_hAppartments); i++)
	{
		new nNew[RP_Appartments];
		GetArrayArray(g_hAppartments, i, nNew[0]);
		
		if (nNew[Appartment_ID] == appartmentID)
		{
			nNew[Appartment_PlayerID] = playerID;
			SetArrayArray(g_hAppartments, i, nNew[0]);
			break;
		}
	}
	
	decl String:sQuery[2048];
	FormatEx(sQuery, sizeof(sQuery), "UPDATE `rp_appartments` SET playerID = %d WHERE appartmentID = %d", playerID, appartmentID);
	SQL_TQuery(g_hSQL, SQL_AppartmentUpdateCallback, sQuery, _);
}

SetAppartmentPrice(appartmentID, price)
{
	for (new i = 0; i < GetArraySize(g_hAppartments); i++)
	{
		new nNew[RP_Appartments];
		GetArrayArray(g_hAppartments, i, nNew[0]);
		
		if (nNew[Appartment_ID] == appartmentID)
		{
			nNew[Appartment_Price] = price;
			SetArrayArray(g_hAppartments, i, nNew[0]);
			break;
		}
	}
	
	decl String:sQuery[2048];
	FormatEx(sQuery, sizeof(sQuery), "UPDATE `rp_appartments` SET price = %d WHERE appartmentID = %d", price, appartmentID);
	SQL_TQuery(g_hSQL, SQL_AppartmentUpdateCallback, sQuery, _);
}

SetAppartmentMaxInh(appartmentID, new_max)
{
	for (new i = 0; i < GetArraySize(g_hAppartments); i++)
	{
		new nNew[RP_Appartments];
		GetArrayArray(g_hAppartments, i, nNew[0]);
		
		if (nNew[Appartment_ID] == appartmentID)
		{
			nNew[Appartment_MaxInh] = new_max;
			SetArrayArray(g_hAppartments, i, nNew[0]);
			break;
		}
	}
	
	decl String:sQuery[2048];
	FormatEx(sQuery, sizeof(sQuery), "UPDATE `rp_appartments` SET maxinhabitants = %d WHERE appartmentID = %d", new_max, appartmentID);
	SQL_TQuery(g_hSQL, SQL_AppartmentUpdateCallback, sQuery, _);
}

public SQL_AppartmentUpdateCallback(Handle:owner, Handle:hndl, const String:error[], any:userid)
{
	if (owner == INVALID_HANDLE || hndl == INVALID_HANDLE)
	{
		LogError("%s [%s] (SQL_AppartmentUpdateCallback) %s", PL_PRE_N, PL_NAME, error);
	}
}

SetAppartmentSold(appartmentID, bool:sold)
{
	for (new i = 0; i < GetArraySize(g_hAppartments); i++)
	{
		new nNew[RP_Appartments];
		GetArrayArray(g_hAppartments, i, nNew[0]);
		
		if (nNew[Appartment_ID] == appartmentID)
		{
			nNew[Appartment_Sold] = sold;
			SetArrayArray(g_hAppartments, i, nNew[0]);
			break;
		}
	}
	
	decl String:sQuery[2048];
	FormatEx(sQuery, sizeof(sQuery), "UPDATE `rp_appartments` SET sold = %d WHERE appartmentID = %d", sold, appartmentID);
	SQL_TQuery(g_hSQL, SQL_AppartmentUpdateCallback, sQuery, _);
}

SetAppartmentbuildingID(appartmentID,new_buildingID)
{
	
	for (new i = 0; i < GetArraySize(g_hAppartments); i++)
	{
		new nNew[RP_Appartments];
		GetArrayArray(g_hAppartments, i, nNew[0]);
		
		if (nNew[Appartment_ID] == appartmentID)
		{
			nNew[Building_ID] = new_buildingID;
			SetArrayArray(g_hAppartments, i, nNew[0]);
			break;
		}
	}
	
	decl String:sQuery[2048];
	FormatEx(sQuery, sizeof(sQuery), "UPDATE `rp_appartments` SET buildingID = %d WHERE appartmentID = %d", new_buildingID, appartmentID);
	SQL_TQuery(g_hSQL, SQL_AppartmentUpdateCallback, sQuery, _);
}

SetAppartmentRoomnumber(appartmentID, String:new_roomnumber[])
{	
	for (new i = 0; i < GetArraySize(g_hAppartments); i++)
	{
		new nNew[RP_Appartments];
		GetArrayArray(g_hAppartments, i, nNew[0]);
		
		if (nNew[Appartment_ID] == appartmentID)
		{
			Format(nNew[Appartment_Roomnumber], sizeof(nNew[Appartment_Roomnumber]), "%s", new_roomnumber);
			SetArrayArray(g_hAppartments, i, nNew[0]);
			break;
		}
	}
	
	decl String:sQuery[2048];
	FormatEx(sQuery, sizeof(sQuery), "UPDATE `rp_appartments` SET roomnumber = '%s' WHERE appartmentID = %d", new_roomnumber, appartmentID);
	SQL_TQuery(g_hSQL, SQL_AppartmentUpdateCallback, sQuery, _);
}

GetAppartmentID(playerID)
{
	for (new i = 0; i < GetArraySize(g_hAppartments); i++)
	{
		new nNew[RP_Appartments];
		GetArrayArray(g_hAppartments, i, nNew[0]);
		
		if (nNew[Appartment_PlayerID] == playerID)
		{
			return nNew[Appartment_ID];
		}
	}
	
	return -1;
}

GetAppartmentPlayerID(appartmentID)
{
	for (new i = 0; i < GetArraySize(g_hAppartments); i++)
	{
		new nNew[RP_Appartments];
		GetArrayArray(g_hAppartments, i, nNew[0]);
		
		if (nNew[Appartment_ID] == appartmentID)
		{
			return nNew[Appartment_PlayerID];
		}
	}
	
	return -1;
}

GetAppartmentPrice(appartmentID)
{
	for (new i = 0; i < GetArraySize(g_hAppartments); i++)
	{
		new nNew[RP_Appartments];
		GetArrayArray(g_hAppartments, i, nNew[0]);
		
		if (nNew[Appartment_ID] == appartmentID)
		{
			return nNew[Appartment_Price];
		}
	}
	
	return -1;
}

bool:IsAppartmentSold(appartmentID)
{
	for (new i = 0; i < GetArraySize(g_hAppartments); i++)
	{
		new nNew[RP_Appartments];
		GetArrayArray(g_hAppartments, i, nNew[0]);
		
		if (nNew[Appartment_ID] == appartmentID)
		{
			return nNew[Appartment_Sold];
		}
	}
	
	return false;
}

GetAppartmentMaxInh(appartmentID)
{
	for (new i = 0; i < GetArraySize(g_hAppartments); i++)
	{
		new nNew[RP_Appartments];
		GetArrayArray(g_hAppartments, i, nNew[0]);
		
		if (nNew[Appartment_ID] == appartmentID)
		{
			return nNew[Appartment_MaxInh];
		}
	}
	
	return -1;
}

GetAppartmentbuildingID(appartmentID)
{
	for (new i = 0; i < GetArraySize(g_hAppartments); i++)
	{
		new nNew[RP_Appartments];
		GetArrayArray(g_hAppartments, i, nNew[0]);
		
		if (nNew[Appartment_ID] == appartmentID)
		{
			return nNew[Building_ID];
		}
	}
	
	return -1;
}

SellAppartment(appartmentID)
{
	for (new i = 0; i < GetArraySize(g_hAppartments); i++)
	{
		new nNew[RP_Appartments];
		GetArrayArray(g_hAppartments, i, nNew[0]);
		
		if (nNew[Appartment_ID] == appartmentID)
		{
			nNew[Appartment_PlayerID] = -1;
			nNew[Appartment_Sold] = false;
			
			SetArrayArray(g_hAppartments, i, nNew[0]);
			
			decl String:sQuery[2048];
			FormatEx(sQuery, sizeof(sQuery), "UPDATE `rp_appartments` SET sold = %d, playerID = -1  WHERE appartmentID = %d", false, appartmentID);
			SQL_TQuery(g_hSQL, SQL_AppartmentUpdateCallback, sQuery, _);
			break;
		}
	}
}

/* Player */

public RP_OnPlayerReady(client, playerID, bool:create)
{
	
}

/* Natives */

public Native_GetAppartmentCount(Handle:plugin, numParams)
{
	return GetArraySize(g_hAppartments);
}

public Native_GetAppartmentIDByIndex(Handle:plugin, numParams)
{
	new nNew[RP_Appartments];
	new index = GetNativeCell(1);
	
	if(index >= 0 && index < GetArraySize(g_hAppartments))
	{
		GetArrayArray(g_hAppartments, index, nNew[0]);
		return nNew[Appartment_ID];
	}
	return -1;
}

public Native_GetAppartmentIDByPlayerID(Handle:plugin, numParams)
{
	return GetAppartmentID(GetNativeCell(1));
}

public Native_CreateAppartment(Handle:plugin, numParams)
{
	decl String:buffer[16];
	GetNativeString(4,buffer, sizeof(buffer));
	
	CreateAppartment(GetNativeCell(1), GetNativeCell(2), GetNativeCell(3), buffer);
}

public Native_DeleteAppartment(Handle:plugin, numParams)
{
	DeleteAppartment(GetNativeCell(1));
}

public Native_SetAppartmentPlayerID(Handle:plugin, numParams)
{
	SetAppartmentPlayerID(GetNativeCell(1), GetNativeCell(2));
}

public Native_GetAppartmentPlayerID(Handle:plugin, numParams)
{
	return GetAppartmentPlayerID(GetNativeCell(1));
}

public Native_GetAppartmentPrice(Handle:plugin, numParams)
{
	return GetAppartmentPrice(GetNativeCell(1));
}

public Native_GetAppartmentMaxInh(Handle:plugin, numParams)
{
	return GetAppartmentMaxInh(GetNativeCell(1));
}

public Native_GetAppartmentbuildingID(Handle:plugin, numParams)
{
	return GetAppartmentbuildingID(GetNativeCell(1));
}

public Native_GetAppartmentRoomnumber(Handle:plugin, numParams)
{
	new appartmentID = GetNativeCell(1);
	new nlen = GetNativeCell(3);
	
	for (new i = 0; i < GetArraySize(g_hAppartments); i++)
	{
		new nNew[RP_Appartments];
		GetArrayArray(g_hAppartments, i, nNew[0]);
		
		decl String:buffer[nlen];
		FormatEx(buffer, nlen, "%s", nNew[Appartment_Roomnumber]);
		if (nNew[Appartment_ID] == appartmentID)
		{
			if (SetNativeString(2, buffer, nlen, true) == SP_ERROR_NONE)
				return true;
		}
	}
	return false;
}

public Native_SetAppartmentPrice(Handle:plugin, numParams)
{
	SetAppartmentPrice(GetNativeCell(1), GetNativeCell(2));
}

public Native_IsAppartmentSold(Handle:plugin, numParams)
{
	return IsAppartmentSold(GetNativeCell(1));
}

public Native_SetAppartmentSold(Handle:plugin, numParams)
{
	SetAppartmentSold(GetNativeCell(1), GetNativeCell(2));
}

public Native_SetAppartmentMaxInh(Handle:plugin, numParams)
{
	SetAppartmentMaxInh(GetNativeCell(1),GetNativeCell(2));
}

public Native_SetAppartmentbuildingID(Handle:plugin, numParams)
{
	SetAppartmentbuildingID(GetNativeCell(1),GetNativeCell(2));
}

public Native_SetAppartmentRoomnumber(Handle:plugin, numParams)
{
	decl String:buffer[16];
	GetNativeString(2,buffer, sizeof(buffer));
	SetAppartmentRoomnumber(GetNativeCell(1), buffer);
}

public Native_SetAppartmentDoor(Handle:plugin, numParams)
{
	SetAppartmentDoor(GetNativeCell(1),GetNativeCell(2));
}

public Native_DeleteAppartmentDoor(Handle:plugin, numParams)
{
	DeleteAppartmentDoor(GetNativeCell(1));
}

public Native_GetDoorAppartmentID(Handle:plugin, numParams)
{
	return GetDoorAppartmentID(GetNativeCell(1));
}

public Native_GetAppartmentDoorsCount(Handle:plugin, numParams)
{
	return GetArraySize(g_hAppartmentDoors);
}

public Native_GetAppartmentDoors(Handle:plugin, numParams)
{
	new appartmentID = GetNativeCell(1);
	new counter = 0;
	
	for (new i = 0; i < GetArraySize(g_hAppartmentDoors); i++)
	{
		new nNew[RP_AppartmentDoors];
		GetArrayArray(g_hAppartmentDoors, i, nNew[0]);
		
		if (nNew[App_ID] == appartmentID)
		{
			counter++;
		}
	}
	
	return counter;
}

public Native_GetAppartmentDoorIDByIndex(Handle:plugin, numParams)
{
	new nNew[RP_AppartmentDoors];
	new index = GetNativeCell(1);
	
	if(index >= 0 && index < GetArraySize(g_hAppartmentDoors))
	{
		GetArrayArray(g_hAppartmentDoors, index, nNew[0]);
		return nNew[App_Door_ID];
	}
	return -1;
}

public Native_GetAppartmentDoorAppIDByIndex(Handle:plugin, numParams)
{
	new nNew[RP_AppartmentDoors];
	new index = GetNativeCell(1);
	
	if(index >= 0 && index < GetArraySize(g_hAppartmentDoors))
	{
		GetArrayArray(g_hAppartmentDoors, index, nNew[0]);
		return nNew[App_ID];
	}
	return -1;
}

public Native_SellAppartment(Handle:plugin, numParams)
{
	SellAppartment(GetNativeCell(1));
}