#include "roleplay/roleplay"

#define PL_NAME		"RP_BUILDING_BANK_DOORS"
#define BANK_DOOR_INTERACTION_RANGE 200.0

new bool:g_LateLoaded;

/* Database */
new Handle:g_hSQL;

public Plugin:myinfo = 
{
	name = PL_NAME,
	author = PL_AUTHOR,
	description = "",
	version = PL_VERSION,
	url = PL_URL
}

public APLRes:AskPluginLoad2(Handle:myself, bool:late, String:error[], err_max)
{
	g_LateLoaded = late;
	RegPluginLibrary(PL_NAME);
	
	return APLRes_Success;
}

public OnPluginStart()
{
	
	if(g_LateLoaded)
	{
		g_hSQL = Handle:RP_GetSql();
		
		if(g_hSQL != INVALID_HANDLE)
			SQLConnectionReady();
		
		g_LateLoaded = false;
	}
}

public RP_OnSqlConnected(Handle:db)
{
	g_hSQL = db;
	SQLConnectionReady();
}

public RP_OnSqlStop()
{
	g_hSQL = INVALID_HANDLE;
}

SQLConnectionReady()
{
	//Database is now ready to use
}

public RP_OnPlayerReady(client, playerID, bool:create)
{
	//PlayerID is now cached
}

public RP_OnDoorLoaded(doorID,buildingType)
{
	if(buildingType == BD_Bank)
	{
		if(RP_GetDoorType(doorID) == Door_Bank_Entrance)
			RP_UnlockDoor(doorID);
	}
}

public RP_OnDoorUse(doorID,buildingType,client,Float:distance)
{
	if(buildingType == BD_Bank)
	{
		if(0 >= client || client > MaxClients + 1)
			return;
		
		if(!IsClientInGame(client))
			return;
		
		if(!IsPlayerAlive(client))
			return;
		
		if(RP_GetDoorType(doorID) == Door_Bank_Entrance)
		{
			if (RP_IsValidLinearDoorEnt(RP_GetDoorEntity(doorID)) && distance <= BANK_DOOR_INTERACTION_RANGE)
			{
				RP_ToggleOpenDoor(doorID);
			}
		}
	}
}