#include "roleplay/roleplay"

#define PL_NAME		"RP_BUILDING_HOSPITAL_ACCESS"

new bool:g_LateLoaded;

/* Database */
new Handle:g_hSQL;

/* ADT ARRAY */
new nHospitalDoorAccessTeamplate[RP_HospitalAccess];
new Handle:g_hHospitalDoorAccess = INVALID_HANDLE;

public Plugin:myinfo = 
{
	name = PL_NAME,
	author = PL_AUTHOR,
	description = "",
	version = PL_VERSION,
	url = PL_URL
}

public APLRes:AskPluginLoad2(Handle:myself, bool:late, String:error[], err_max)
{
	g_LateLoaded = late;
	RegPluginLibrary(PL_NAME);
	
	CreateNative("RP_GetPlayerHospitalAccess", Native_GetPlayerHospitalAccess);
	CreateNative("RP_SetPlayerHospitalAccess", Native_SetPlayerHospitalAccess);
	
	return APLRes_Success;
}

public OnPluginStart()
{
	g_hHospitalDoorAccess = CreateArray(sizeof(nHospitalDoorAccessTeamplate));
	nHospitalDoorAccessTeamplate[HospitalAccess_PlayerID] = 0;
	
	if(g_LateLoaded)
	{
		g_hSQL = Handle:RP_GetSql();
		
		if(g_hSQL != INVALID_HANDLE)
			SQLConnectionReady();
		
		g_LateLoaded = false;
	}
	
	decl String:sQuery[2048];
	
	Format(sQuery, sizeof(sQuery), "CREATE TABLE IF NOT EXISTS `rp_building_Hospital_doors` (  `PlayerID` int(10) NOT NULL, `BuildingID` int(10) NOT NULL, `AccessID` int(10) NOT NULL, PRIMARY KEY (`PlayerID`,`BuildingID`)) ENGINE=InnoDB DEFAULT CHARSET=utf8;");
	LogMessage("%s [%s] Query: %s", PL_PRE_N, PL_NAME, sQuery);
	SQL_TQuery(g_hSQL, SQL_CreateTableCallback, sQuery, _, DBPrio_High);
	
	ResetHospitalDoorAccess();
	LoadHospitalDoorAccess();
}

public SQL_CreateTableCallback(Handle:owner, Handle:hndl, const String:error[], any:data)
{
	if (owner == INVALID_HANDLE || hndl == INVALID_HANDLE)
	{
		LogError("%s [%s] (SQL_CreateTableCallback) %s", PL_PRE_N, PL_NAME, error);
	}
}

ResetHospitalDoorAccess()
{
	ClearArray(g_hHospitalDoorAccess);
	g_hHospitalDoorAccess = CreateArray(sizeof(nHospitalDoorAccessTeamplate));
}

LoadHospitalDoorAccess()
{
	decl String:sQuery[2048];
	Format(sQuery, sizeof(sQuery), "SELECT `PlayerID`, `AccessID`, `BuildingID` FROM `rp_building_Hospital_doors`;");
	SQL_TQuery(g_hSQL, SQL_LoadHospitalDoorAccessCallback, sQuery, _, DBPrio_Low);
}

public SQL_LoadHospitalDoorAccessCallback(Handle:owner, Handle:hndl, const String:error[], any:data)
{
	if (owner == INVALID_HANDLE || hndl == INVALID_HANDLE)
	{
		LogError("%s [%s] (SQL_LoadHospitalDoorAccessCallback) %s", PL_PRE_N, PL_NAME, error);
	}
	
	while (SQL_FetchRow(hndl))
	{
		new nNew[RP_HospitalAccess];
		
		nNew[HospitalAccess_PlayerID] = SQL_FetchInt(hndl, 0);
		nNew[HospitalAccess_AccessID] = SQL_FetchInt(hndl, 1);
		nNew[HospitalAccess_BuildingID] = SQL_FetchInt(hndl, 2);
		
		PushArrayArray(g_hHospitalDoorAccess, nNew[0]);
	}
}

public RP_OnSqlConnected(Handle:db)
{
	g_hSQL = db;
	SQLConnectionReady();
}

public RP_OnSqlStop()
{
	g_hSQL = INVALID_HANDLE;
}

SQLConnectionReady()
{
	//Database is now ready to use
}

public RP_OnPlayerReady(client, playerID, bool:create)
{
	//PlayerID is now cached
}

public RP_OnDoorUse(doorID,type,client)
{
	if(0 >= client || client > MaxClients + 1)
		return;
	
	if(!IsClientInGame(client))
		return;
	
	if(!IsPlayerAlive(client))
		return;
	
	if(type == Door_Hospital)
	{
		
	}
}

GetPlayerHospitalAccess(client, buildingID)
{
	if(0 >= client || client > MaxClients + 1)
		return -1;
	
	if(!IsClientInGame(client))
		return -1;
	
	if(!IsPlayerAlive(client))
		return -1;
	
	new playerID = RP_GetPlayerID(client);
	
	for (new i = 0; i < GetArraySize(g_hHospitalDoorAccess); i++)
	{
		new nNew[RP_HospitalAccess];
		GetArrayArray(g_hHospitalDoorAccess, i, nNew[0]);
		
		if (nNew[HospitalAccess_PlayerID] == playerID && nNew[BankAccess_BuildingID] == buildingID)
		{
			return nNew[HospitalAccess_AccessID];
		}
	}
	
	return -1;

}

SetPlayerHospitalAccess(client, buildingID, new_accessID)
{
	if(0 >= client || client > MaxClients + 1)
		return;
	
	if(!IsClientInGame(client))
		return;
	
	if(!IsPlayerAlive(client))
		return;
	
	new playerID = RP_GetPlayerID(client);
	new bool:insert = true;
	
	for (new i = 0; i < GetArraySize(g_hHospitalDoorAccess); i++)
	{
		new nNew[RP_HospitalAccess];
		GetArrayArray(g_hHospitalDoorAccess, i, nNew[0]);
		
		if (nNew[HospitalAccess_PlayerID] == playerID && nNew[BankAccess_BuildingID] == buildingID)
		{
			nNew[HospitalAccess_AccessID] = new_accessID;
			SetArrayArray(g_hHospitalDoorAccess, i, nNew[0]); 
			insert = false;
		}
	}
	
	if(insert)
	{
		decl String:sQuery[2048];
	
		Format(sQuery, sizeof(sQuery), "INSERT INTO `rp_building_Hospital_doors` ( PlayerID, BuildingID , AccessID) VALUES (%d, %d, %d);",playerID, buildingID,new_accessID);
		LogMessage("%s [%s] Query: %s", PL_PRE_N, PL_NAME, sQuery);
		SQL_TQuery(g_hSQL, SQL_InsertPlayerHospitalAccessTableCallback, sQuery, _, DBPrio_High);
	}
}

public SQL_InsertPlayerHospitalAccessTableCallback(Handle:owner, Handle:hndl, const String:error[], any:data)
{
	if (owner == INVALID_HANDLE || hndl == INVALID_HANDLE)
	{
		LogError("%s [%s] (SQL_InsertPlayerHospitalAccessTableCallback) %s", PL_PRE_N, PL_NAME, error);
	}
}

public Native_GetPlayerHospitalAccess(Handle:plugin, numParams)
{
	return GetPlayerHospitalAccess(GetNativeCell(1),GetNativeCell(2));
}

public Native_SetPlayerHospitalAccess(Handle:plugin, numParams)
{
	SetPlayerHospitalAccess(GetNativeCell(1),GetNativeCell(2),GetNativeCell(3));
}