#include "roleplay/roleplay"

#define PL_NAME		"RP_BUILDING_POLICEDEPARTMENT_ACCESS"
#define POLICEDEPARTMENT_DOOR_INTERACTION_RANGE 350.0
#define MAX_PD_DOORTYPES 5

new bool:g_LateLoaded;
new String:pdDoorTypes[MAX_PD_DOORTYPES][64] =  { "Entrance", "Police Only", "Jail", "VIP", "Deathchamber"};

/* Database */
new Handle:g_hSQL;

public Plugin:myinfo = 
{
	name = PL_NAME,
	author = PL_AUTHOR,
	description = "",
	version = PL_VERSION,
	url = PL_URL
}

public APLRes:AskPluginLoad2(Handle:myself, bool:late, String:error[], err_max)
{
	g_LateLoaded = late;
	RegPluginLibrary(PL_NAME);
	
	CreateNative("RP_GetPDDoorTypeName", Native_GetPDDoorTypeName);
	CreateNative("RP_GetPDDoorTypeCount", Native_GetPDDoorTypeCount);
	
	return APLRes_Success;
}

public OnPluginStart()
{
	if(g_LateLoaded)
	{
		g_hSQL = Handle:RP_GetSql();
		
		if(g_hSQL != INVALID_HANDLE)
			SQLConnectionReady();
		
		g_LateLoaded = false;
	}
}

public RP_OnSqlConnected(Handle:db)
{
	g_hSQL = db;
	SQLConnectionReady();
}

public RP_OnSqlStop()
{
	g_hSQL = INVALID_HANDLE;
}

SQLConnectionReady()
{
	//Database is now ready to use
}

public RP_OnPlayerReady(client, playerID, bool:create)
{
	//PlayerID is now cached
}

public RP_OnDoorUse(doorID,buildingType,client,Float:distance)
{
	if(buildingType == BD_PoliceDepartment)
	{
		if(0 >= client || client > MaxClients + 1)
			return;
		
		if(!IsClientInGame(client))
			return;
		
		if(!IsPlayerAlive(client))
			return;
		
		if(RP_IsCop(client) || RP_GetDoorType(doorID) == Door_Policedepartment_Entrance)
		{
			if (RP_IsValidLinearDoorEnt(RP_GetDoorEntity(doorID)) && distance <= POLICEDEPARTMENT_DOOR_INTERACTION_RANGE)
			{
				RP_ToggleOpenDoor(doorID);
			}
		}
	}
}

public Native_GetPDDoorTypeName(Handle:plugin, numParams)
{
	new nlen = GetNativeCell(3);
	new doorType = GetNativeCell(1);
	
	if(doorType < MAX_PD_DOORTYPES && doorType >= 0)
	{
		if (SetNativeString(2, pdDoorTypes[doorType], nlen, true) == SP_ERROR_NONE)
			return true;
	}
	return false;
}

public Native_GetPDDoorTypeCount(Handle:plugin, numParams)
{
	return MAX_PD_DOORTYPES;
}