#include "roleplay/roleplay"

#define PL_NAME		"RP_Doors"

#define DOORS_SEARCH_OFFSET 40.0;

new bool:g_LateLoaded;

/* Database */
new Handle:g_hSQL;

#define MAXENTITIES 2048
#define MAXDOORID 1024

new g_iDoorsEntToId[MAXENTITIES+1] = {-1,...};
new g_iDoorIdToArrayID[MAXDOORID+1] = {-1,...};

new nDoorTeamplate[RP_Doors];
new Handle:g_hDoors = INVALID_HANDLE;

new Handle:g_OnDoorUse = INVALID_HANDLE;
new Handle:g_OnDoorLoaded = INVALID_HANDLE;

new nDoor_SetUpHelperTeamplate[Door_SetUpHelper];
new Handle:g_hDoor_SetUpHelper = INVALID_HANDLE;

new bool:g_bMapLoaded = false;
new bool:g_bDoorsLoaded = false;

public Plugin:myinfo = 
{
	name = PL_NAME,
	author = PL_AUTHOR,
	description = "",
	version = PL_VERSION,
	url = PL_URL
}

public APLRes:AskPluginLoad2(Handle:myself, bool:late, String:error[], err_max)
{
	g_LateLoaded = late;
	RegPluginLibrary(PL_NAME);
	
	g_OnDoorUse = CreateGlobalForward("RP_OnDoorUse", ET_Event, Param_Cell, Param_Cell, Param_Cell, Param_Cell);
	g_OnDoorLoaded = CreateGlobalForward("RP_OnDoorLoaded", ET_Event, Param_Cell, Param_Cell);
	
	CreateNative("RP_IsValidDoorEnt", Native_IsValidDoorEnt);
	CreateNative("RP_IsValidLinearDoorEnt", Native_IsValidLinearDoorEnt);
	
	CreateNative("RP_GetDoorIDbyEntity", Native_GetDoorIDbyEntity);
	CreateNative("RP_GetDoorEntity", Native_GetDoorEntity);
	
	CreateNative("RP_OpenDoor", Native_OpenDoor);
	CreateNative("RP_CloseDoor", Native_CloseDoor);
	CreateNative("RP_ToggleOpenDoor", Native_ToggleOpenDoor);
	CreateNative("RP_ToggleLockDoor", Native_ToggleLockDoor);
	CreateNative("RP_LockDoor", Native_LockDoor);
	CreateNative("RP_UnlockDoor", Native_UnlockDoor);
	
	CreateNative("RP_OpenDoorByEntity", Native_OpenDoorByEntity);
	CreateNative("RP_CloseDoorByEntity", Native_CloseDoorByEntity);
	CreateNative("RP_ToggleLockDoorByEntity", Native_ToggleLockDoorByEntity);
	CreateNative("RP_LockDoorByEntity", Native_LockDoorByEntity);
	CreateNative("RP_UnlockDoorByEntity", Native_UnlockDoorByEntity);
	
	CreateNative("RP_GetDoorCount", Native_GetDoorCount);
	CreateNative("RP_GetDoorIDByArrayIndex", Native_GetDoorIDByArrayIndex);
	
	CreateNative("RP_GetDoorAlarmID", Native_GetDoorAlarmID);
	CreateNative("RP_GetDoorName", Native_GetDoorName);
	CreateNative("RP_GetDoorLockID", Native_GetDoorLockID);
	CreateNative("RP_GetDoorScannerID", Native_GetDoorScannerID);
	CreateNative("RP_GetDoorSensorID", Native_GetDoorSensorID);
	CreateNative("RP_GetDoorTrapID", Native_GetDoorTrapID);
	CreateNative("RP_GetDoorType", Native_GetDoorType);
	CreateNative("RP_GetDoorBuildingID", Native_GetDoorBuildingID);
	
	CreateNative("RP_IsDoorLocked", Native_IsDoorLocked);
	
	CreateNative("RP_SetDoorAlarmID", Native_SetDoorAlarmID);
	CreateNative("RP_SetDoorName", Native_SetDoorName);
	CreateNative("RP_SetDoorLockID", Native_SetDoorLockID);
	CreateNative("RP_SetDoorScannerID", Native_SetDoorScannerID);
	CreateNative("RP_SetDoorSensorID", Native_SetDoorSensorID);
	CreateNative("RP_SetDoorTrapID", Native_SetDoorTrapID);
	CreateNative("RP_SetDoorType", Native_SetDoorType);
	CreateNative("RP_SetDoorBuildingID", Native_SetDoorBuildingID);
	
	CreateNative("RP_ResetDoor", Native_ResetDoor);
	
	return APLRes_Success;
}

SQLConnectionReady()
{
	decl String:sQuery[2048];
	
	Format(sQuery, sizeof(sQuery), "CREATE TABLE IF NOT EXISTS `rp_doors` (`doorID` int(10) NOT NULL  AUTO_INCREMENT,  `alarmID` int(10) NOT NULL, `lockID` int(10) NOT NULL, `scannerID` int(10)  NOT NULL, `sensorID` int(10) NOT NULL, `trapID` int(10) NOT NULL, `locksAmount` int(10) NOT NULL, `doorName` varchar(128) NOT NULL, `x` float NOT NULL, `y` float NOT NULL, `z` float NOT NULL,`doorType` int(10) NOT NULL,`buildingID` int(10) NOT NULL, PRIMARY KEY (`doorID`)) ENGINE=InnoDB DEFAULT CHARSET=utf8;");
	LogMessage("%s [%s] Query: %s", PL_PRE_N, PL_NAME, sQuery);
	SQL_TQuery(g_hSQL, SQL_CreateTableCallback, sQuery, _, DBPrio_High);
	
	ResetDoors();
	LoadDoors();
}

public OnMapStart()
{
	g_bMapLoaded = true;
	
	LockAllDoors();
	LogMessage("Doors are %s loaded", g_bDoorsLoaded ? "already" : "not");
	if(g_bDoorsLoaded)
	{
		CreateTimer(5.0, ForwardSetUpDoors);
	}
}

public Action:ForwardSetUpDoors(Handle:timer)
{
	LogMessage("Forward Load Doors");
	for (new y = 0; y < GetArraySize(g_hDoors); y++)
	{
		new nNew[RP_Doors];
			
		GetArrayArray(g_hDoors, y, nNew[0]);
		
		/* Forward: g_OnDoorLoaded */
		Call_StartForward(g_OnDoorLoaded);
		Call_PushCell(nNew[Door_ID]);
		Call_PushCell(RP_GetBuildingType(nNew[Building_ID]));
		Call_Finish();
	}

	return Plugin_Continue;
}

public OnMapEnd()
{
	g_bMapLoaded = false;
}

public OnPluginStart()
{	
	// Init ADT array
	g_hDoors = CreateArray(sizeof(nDoorTeamplate));
	nDoorTeamplate[Door_ID] = 0;
	
	g_hDoor_SetUpHelper = CreateArray(sizeof(nDoor_SetUpHelperTeamplate));
	nDoor_SetUpHelperTeamplate[Door_Setup_Entity] = 0;	
	
	if(g_LateLoaded)
	{
		g_hSQL = Handle:RP_GetSql();
		
		if(g_hSQL != INVALID_HANDLE)
			SQLConnectionReady();
		
		g_LateLoaded = false;
	}
	
	HookEvent("round_start", OnRoundStart);
}

public SQL_CreateTableCallback(Handle:owner, Handle:hndl, const String:error[], any:data)
{
	if (owner == INVALID_HANDLE || hndl == INVALID_HANDLE)
	{
		LogError("%s [%s] (SQL_CreateTableCallback) %s", PL_PRE_N, PL_NAME, error);
	}
}

ResetDoors()
{
	ClearArray(g_hDoors);
	g_hDoors = CreateArray(sizeof(nDoorTeamplate));
	g_bDoorsLoaded = false;
}

LoadDoors()
{
	if(g_bMapLoaded)
	{
		decl String:sQuery[2048];
		Format(sQuery, sizeof(sQuery), "SELECT `doorID`,`alarmID`,`lockID`,`ScannerID`,`SensorID`,`TrapID`,`LocksAmount`,`DoorName`,`x`,`y`,`z`,`DoorType`,`BuildingID` FROM `rp_doors`;");
		SQL_TQuery(g_hSQL, SQL_LoadDoorsCallback, sQuery, _, DBPrio_Low);
	}
	else
	{
		CreateTimer(1.0, Timer_LoadDoors);
	}
}

public Action:OnRoundStart(Handle:event, const String:name[], bool:dontBroadcast)
{
	CreateTimer(5.0, Timer_SetUpDoorRoundstart);
}

public Action:Timer_SetUpDoorRoundstart(Handle:timer)
{
	for (new y = 0; y < GetArraySize(g_hDoors); y++)
	{
		new nNew[RP_Doors];
			
		GetArrayArray(g_hDoors, y, nNew[0]);

		/* Forward: g_OnDoorLoaded */
		Call_StartForward(g_OnDoorLoaded);
		Call_PushCell(nNew[Door_ID]);
		Call_PushCell(RP_GetBuildingType(nNew[Building_ID]));
		Call_Finish();
	}
}

public Action:Timer_LoadDoors(Handle:timer)
{
	LoadDoors();
	return Plugin_Handled;
}

public SQL_LoadDoorsCallback(Handle:owner, Handle:hndl, const String:error[], any:data)
{
	if (owner == INVALID_HANDLE || hndl == INVALID_HANDLE)
	{
		LogError("%s [%s] (SQL_LoadDoorsCallback) %s", PL_PRE_N, PL_NAME, error);
	}
	
	ResetDoors();
	
	LogMessage("---Start Loading Doors---");
	
	while (SQL_FetchRow(hndl))
	{
		
		new nNew[RP_Doors];
		
		nNew[Door_ID] = SQL_FetchInt(hndl, 0);
		nNew[Door_AlarmID] = SQL_FetchInt(hndl, 1);
		nNew[Door_LockID] = SQL_FetchInt(hndl, 2);
		nNew[Door_ScannerID] = SQL_FetchInt(hndl, 3);
		nNew[Door_SensorID] = SQL_FetchInt(hndl, 4);
		nNew[Door_TrapID] = SQL_FetchInt(hndl, 5);
		nNew[Door_LocksAmount] = SQL_FetchInt(hndl, 6);
		SQL_FetchString(hndl, 7, nNew[Door_Name], 128);
		nNew[Door_Pos][0] = SQL_FetchFloat(hndl, 8);
		nNew[Door_Pos][1] = SQL_FetchFloat(hndl, 9);
		nNew[Door_Pos][2] = SQL_FetchFloat(hndl, 10);
		nNew[Door_Type] = SQL_FetchInt(hndl, 11);
		nNew[Building_ID] = SQL_FetchInt(hndl, 12);
		nNew[Door_IsLocked] = true;
		
		PushArrayArray(g_hDoors, nNew[0]);
	}
	LogMessage("---Found %d Doors in DB---",GetArraySize(g_hDoors));
	new bool:reload = false;

	new MaxEntities = GetMaxEntities();
	new String:entclsname[64], String:entname[64];
	for (new i = MaxClients+1; i < MaxEntities; i++) 
	{
		if (IsValidDoorEnt(i)) 
		{
			new nNew[Door_SetUpHelper];
			
			new Float:buffer[3];
			GetEntityClassname(i, entclsname, sizeof(entclsname));
			
			GetEntityName(i, entname, sizeof(entname));
			Entity_GetAbsOrigin(i,buffer);
			
			nNew[Door_Setup_Entity] = i;
			nNew[Door_Setup_Pos] = buffer;
			
			PushArrayArray(g_hDoor_SetUpHelper, nNew[0]);
		}
	}
	LogMessage("---End Found %d Doors in Map---",GetArraySize(g_hDoor_SetUpHelper));
	new Float:offset = 5.0;
	new bool:foundDoor;
	
	for (new i = 0; i < GetArraySize(g_hDoor_SetUpHelper); i++)
	{
		new nNew[Door_SetUpHelper];
		GetArrayArray(g_hDoor_SetUpHelper, i, nNew[0]);
		foundDoor = false;

		for (new y = 0; y < GetArraySize(g_hDoors); y++)
		{
			new nNew2[RP_Doors];
			
			GetArrayArray(g_hDoors, y, nNew2[0]);
			
			//Look for Door in +-offset and Save the Entity and Pos
			if(
			(nNew2[Door_Pos][0] <= (nNew[Door_Setup_Pos][0] + offset)) 	&&
			(nNew2[Door_Pos][0] >= (nNew[Door_Setup_Pos][0] - offset))	&&
			(nNew2[Door_Pos][1] <= (nNew[Door_Setup_Pos][1] + offset))	&&
			(nNew2[Door_Pos][1] >= (nNew[Door_Setup_Pos][1] - offset))	&&
			(nNew2[Door_Pos][2] <= (nNew[Door_Setup_Pos][2] + offset))	&&
			(nNew2[Door_Pos][2] >= (nNew[Door_Setup_Pos][2] - offset)))
			{
				nNew2[Door_Entity] = nNew[Door_Setup_Entity];
				nNew2[Door_Pos] = nNew[Door_Setup_Pos];
				g_iDoorsEntToId[nNew2[Door_Entity]] = nNew2[Door_ID];
				g_iDoorIdToArrayID[nNew2[Door_ID]] = y;
				SetArrayArray(g_hDoors, y, nNew2[0]);
				foundDoor = true;
			}
			
		}
		//Door not known / Insert into Database and set reload = 1 to Reload doors again to get the Door_ID
		if(!foundDoor)
		{
			LogMessage("---Added Door %d from Map in Database---",nNew[Door_Setup_Entity]);
			decl String:sQuery[2048];
			Format(sQuery, sizeof(sQuery), "INSERT INTO `rp_doors` (alarmID, lockID, ScannerID, SensorID, TrapID, LocksAmount, DoorName, x, y, z, DoorType, BuildingID) VALUES ( -1, -1, -1, -1, -1,-1,'%s','%.2f','%.2f','%.2f',0,0)","Default Door Name",nNew[Door_Setup_Pos][0],nNew[Door_Setup_Pos][1],nNew[Door_Setup_Pos][2]);
			SQL_TQuery(g_hSQL, SQL_SaveDoorsCallback, sQuery, _, DBPrio_Low);
			reload = true;
		}
	}
	
	ClearArray(g_hDoor_SetUpHelper);
	g_hDoor_SetUpHelper = CreateArray(sizeof(nDoor_SetUpHelperTeamplate));
	
	if(reload)
	{
		ResetDoors();
		LoadDoors();
		return;
	}
	
	CreateTimer(5.0, ForwardSetUpDoors);
	
	g_bDoorsLoaded = true;
}

LockAllDoors()
{
	LogMessage("All Doors got Locked");
	new MaxEntities = GetMaxEntities();
	for (new i = MaxClients+1; i < MaxEntities; i++) 
	{
		if (RP_IsValidDoorEnt(i) && !RP_IsValidLinearDoorEnt(i))
		{
			AcceptEntityInput(i, "Lock");
		}
	}
}

SaveDoor(doorID)
{
	new i = g_iDoorIdToArrayID[doorID];
	new nNew[RP_Doors];
	if(i != -1)
	{
		GetArrayArray(g_hDoors, i, nNew[0]);
			
		if (nNew[Door_ID] == doorID)
		{
			decl String:sQuery[2048];
			
			decl buffer_len;
			buffer_len = sizeof(nNew[Door_Name]) * 2 + 1;
			decl String:saveDoorName[buffer_len];
 
			/* Ask the SQL driver to make sure our string is safely quoted */
			SQL_EscapeString(g_hSQL, nNew[Door_Name], saveDoorName, buffer_len);
			
			Format(sQuery, sizeof(sQuery), "UPDATE `rp_doors` SET alarmID = %d,lockID = %d,ScannerID = %d,SensorID = %d,TrapID = %d,LocksAmount = %d,DoorName = '%s', DoorType = %d,BuildingID = %d WHERE doorID = %d;",nNew[Door_AlarmID],nNew[Door_LockID],nNew[Door_ScannerID],nNew[Door_SensorID],nNew[Door_TrapID],nNew[Door_LocksAmount],saveDoorName,nNew[Door_Type],nNew[Building_ID],nNew[Door_ID]);
			SQL_TQuery(g_hSQL, SQL_SaveDoorsCallback, sQuery, _, DBPrio_Low);		
		}
	}
}

public SQL_SaveDoorsCallback(Handle:owner, Handle:hndl, const String:error[], any:data)
{
	if (owner == INVALID_HANDLE || hndl == INVALID_HANDLE)
	{
		LogError("%s [%s] (SQL_SaveDoorsCallback) %s", PL_PRE_N, PL_NAME, error);
	}
}

public RP_OnSqlConnected(Handle:db)
{
	g_hSQL = db;
	SQLConnectionReady();
}

public RP_OnSqlStop()
{
	g_hSQL = INVALID_HANDLE;
}

public RP_OnPlayerReady(client, playerID, bool:create)
{
	//PlayerID is now cached
}

public RP_OnUseDoorButton(client, entity)
{
	if(RP_IsValidDoorEnt(entity))
	{
		new nDoorID = RP_GetDoorIDbyEntity(entity);
		new nBuildingType = RP_GetBuildingType(RP_GetDoorBuildingID(nDoorID));
		new Float:clientOrigin[3];
		new Float:doorOrigin[3];
		new Float:distance;
		Entity_GetAbsOrigin(client,clientOrigin);
		Entity_GetAbsOrigin(entity,doorOrigin);
		
		distance = GetVectorDistance(clientOrigin, doorOrigin);
			
		/* Forward: g_OnDoorRoundstart */
		Call_StartForward(g_OnDoorUse);
		Call_PushCell(nDoorID);
		Call_PushCell(nBuildingType);
		Call_PushCell(client);
		Call_PushCell(distance);
		Call_Finish();
	}
}

IsValidDoorEnt(entity)
{
	if (entity <= -1)
		return false;
		
	if (!IsValidEntity(entity))
		return false;
	
	new String:clsname[64];
	
	GetEntityClassname(entity, clsname, sizeof(clsname));
	
	if(
	StrEqual("func_movelinear", clsname) 	||
	StrEqual("func_door", clsname) 			||
	StrEqual("func_door_rotating", clsname) ||
	StrEqual("prop_door_rotating", clsname)
	)
	{
		return true;
	}
	
	return false;
}

IsValidLinearDoorEnt(entity)
{
	if (entity <= -1)
		return false;
		
	if (!IsValidEntity(entity))
		return false;
	
	new String:clsname[64];
	
	GetEntityClassname(entity, clsname, sizeof(clsname));
	
	if(	StrEqual("func_movelinear", clsname) ||	StrEqual("func_door", clsname))
		return true;
	
	return false;
}

OpenDoor(doorID)
{
	new entity;
	new i = g_iDoorIdToArrayID[doorID];
	new nNew[RP_Doors];
	
	if(i != -1)
	{
		GetArrayArray(g_hDoors, i, nNew[0]);
			
		if (nNew[Door_ID] == doorID)
		{
			entity = nNew[Door_Entity];
		}
		
		if(RP_IsValidDoorEnt(entity))
		{
			AcceptEntityInput(entity, "Open");
		}
	}
}

ToggleOpenDoor(doorID)
{
	new entity;
	new i = g_iDoorIdToArrayID[doorID];
	new nNew[RP_Doors];
	
	if(i != -1)
	{
		GetArrayArray(g_hDoors, i, nNew[0]);
		entity = nNew[Door_Entity];
		
		if(RP_IsValidDoorEnt(entity))
		{
			AcceptEntityInput(entity, "Toggle");
		}
	}
}

CloseDoor(doorID)
{
	new entity;
	new i = g_iDoorIdToArrayID[doorID];
	new nNew[RP_Doors];
	
	if(i != -1)
	{
		GetArrayArray(g_hDoors, i, nNew[0]);
			
		if (nNew[Door_ID] == doorID)
		{
			entity = nNew[Door_Entity];
		}
		
		if(RP_IsValidDoorEnt(entity))
		{
			AcceptEntityInput(entity, "Close");
		}
	}
}

ToggleLockDoor(doorID)
{
	new entity;
	new i = g_iDoorIdToArrayID[doorID];
	new nNew[RP_Doors];
	
	if(i != -1)
	{
		GetArrayArray(g_hDoors, i, nNew[0]);
		
		if (nNew[Door_ID] == doorID)
		{
			entity = nNew[Door_Entity];
			if(nNew[Door_IsLocked])
			{
				AcceptEntityInput(entity, "Unlock");
				nNew[Door_IsLocked] = false;			
			}
			else
			{
				AcceptEntityInput(entity, "Lock");
				nNew[Door_IsLocked] = true;
			}
			SetArrayArray(g_hDoors, i, nNew[0]);
		}
	}
}

LockDoor(doorID)
{
	new entity;
	new i = g_iDoorIdToArrayID[doorID];
	
	new nNew[RP_Doors];
	if(i != -1)
	{
		GetArrayArray(g_hDoors, i, nNew[0]);
			
		if (nNew[Door_ID] == doorID)
		{
			entity = nNew[Door_Entity];
			nNew[Door_IsLocked] = true;
			SetArrayArray(g_hDoors, i, nNew[0]);
		}
		
		if(RP_IsValidDoorEnt(entity))
		{
			AcceptEntityInput(entity, "Lock");
		}
	}
}

UnlockDoor(doorID)
{
	new entity;
	new i = g_iDoorIdToArrayID[doorID];
	
	new nNew[RP_Doors];
	if(i != -1)
	{
		GetArrayArray(g_hDoors, i, nNew[0]);
		
		if (nNew[Door_ID] == doorID)
		{
			entity = nNew[Door_Entity];
			nNew[Door_IsLocked] = false;
			SetArrayArray(g_hDoors, i, nNew[0]);
		}
	}

	if(RP_IsValidDoorEnt(entity))
	{
		AcceptEntityInput(entity, "Unlock");
	}
}

OpenDoorByEntity(entity)
{
	if (RP_IsValidDoorEnt(entity))
	{
		AcceptEntityInput(entity, "Open");
	}
}

CloseDoorByEntity(entity)
{
	if (RP_IsValidDoorEnt(entity))
	{
		AcceptEntityInput(entity, "Close");
	}
}

ToggleLockDoorByEntity(entity)
{	
	new doorID = g_iDoorsEntToId[entity];
	new i = g_iDoorIdToArrayID[doorID];
	new nNew[RP_Doors];
	
	if(i != -1)
	{
		GetArrayArray(g_hDoors, i, nNew[0]);
		
		if (nNew[Door_Entity] == entity)
		{
			if(nNew[Door_IsLocked])
			{
				AcceptEntityInput(entity, "Unlock");
				nNew[Door_IsLocked] = false;
			}
			else
			{
				AcceptEntityInput(entity, "Lock");
				nNew[Door_IsLocked] = true;
			}
			SetArrayArray(g_hDoors, i, nNew[0]);
		}
	}
}

LockDoorByEntity(entity)
{
	if (RP_IsValidDoorEnt(entity))
	{
		AcceptEntityInput(entity, "Lock");
		new doorID = g_iDoorsEntToId[entity];
		new i = g_iDoorIdToArrayID[doorID];
		new nNew[RP_Doors];
		
		if(i != -1)
		{
			GetArrayArray(g_hDoors, i, nNew[0]);
			if (nNew[Door_Entity] == entity)
			{
				nNew[Door_IsLocked] = true;
				SetArrayArray(g_hDoors, i, nNew[0]);
			}
		}
	}
}

UnlockDoorByEntity(entity)
{
	if (RP_IsValidDoorEnt(entity))
	{
		AcceptEntityInput(entity, "Unlock");
		new doorID = g_iDoorsEntToId[entity];
		new i = g_iDoorIdToArrayID[doorID];
		new nNew[RP_Doors];
		
		if(i != -1)
		{
			GetArrayArray(g_hDoors, i, nNew[0]);
			
			if (nNew[Door_Entity] == entity)
			{
				nNew[Door_IsLocked] = false;
				SetArrayArray(g_hDoors, i, nNew[0]);
			}
		}
	}
}

GetDoorIDbyEntity(entity)
{
	return g_iDoorsEntToId[entity];
}

GetDoorAlarmID(doorID)
{
	if(doorID <= MAXDOORID && doorID >= 0)
	{
		new i = g_iDoorIdToArrayID[doorID];
		new nNew[RP_Doors];
		
		if(i != -1)
		{
			GetArrayArray(g_hDoors, i, nNew[0]);
			
			return nNew[Door_AlarmID];
		}
	}
	
	return -1;
}

GetDoorLockID(doorID)
{
	if(doorID <= MAXDOORID && doorID >= 0)
	{
		new i = g_iDoorIdToArrayID[doorID];
		new nNew[RP_Doors];
		
		if(i != -1)
		{
			GetArrayArray(g_hDoors, i, nNew[0]);
			
			return nNew[Door_LockID];
		}
	}
	
	return -1;
}

GetDoorScannerID(doorID)
{
	if(doorID <= MAXDOORID && doorID >= 0)
	{
		new i = g_iDoorIdToArrayID[doorID];
		new nNew[RP_Doors];
		
		if(i != -1)
		{
			GetArrayArray(g_hDoors, i, nNew[0]);
			
			return nNew[Door_ScannerID];
		}
	}
	
	return -1;
}

GetDoorSensorID(doorID)
{
	if(doorID <= MAXDOORID && doorID >= 0)
	{
		new i = g_iDoorIdToArrayID[doorID];
		new nNew[RP_Doors];
		
		if(i != -1)
		{
			GetArrayArray(g_hDoors, i, nNew[0]);
			
			return nNew[Door_SensorID];
		}
	}
	
	return -1;
}

GetDoorTrapID(doorID)
{
	if(doorID <= MAXDOORID && doorID >= 0)
	{
		new i = g_iDoorIdToArrayID[doorID];
		new nNew[RP_Doors];
		
		if(i != -1)
		{
			GetArrayArray(g_hDoors, i, nNew[0]);
			
			return nNew[Door_TrapID];
		}
	}
	
	return -1;
}

GetDoorType(doorID)
{
	if(doorID <= MAXDOORID && doorID >= 0)
	{
		new i = g_iDoorIdToArrayID[doorID];
		new nNew[RP_Doors];
		
		if(i != -1)
		{
			GetArrayArray(g_hDoors, i, nNew[0]);
			
			return nNew[Door_Type];
		}
	}
	
	return -1;
}

GetDoorBuildingID(doorID)
{
	if(doorID <= MAXDOORID && doorID >= 0)
	{
		new i = g_iDoorIdToArrayID[doorID];
		new nNew[RP_Doors];
		
		if(i != -1)
		{
			GetArrayArray(g_hDoors, i, nNew[0]);
			
			return nNew[Building_ID];
		}
	}
	
	return -1;
}

bool:IsDoorLocked(doorID)
{
	if(doorID <= MAXDOORID && doorID >= 0)
	{
		new i = g_iDoorIdToArrayID[doorID];
		new nNew[RP_Doors];
		
		if(i != -1)
		{
			GetArrayArray(g_hDoors, i, nNew[0]);
			
			return nNew[Door_IsLocked];
		}
	}
	
	return true;
}

SetDoorAlarmID(doorID,new_arlarmid)
{
	if(doorID <= MAXDOORID && doorID >= 0)
	{
		new i = g_iDoorIdToArrayID[doorID];
		new nNew[RP_Doors];
		
		if(i != -1)
		{
			GetArrayArray(g_hDoors, i, nNew[0]);
			nNew[Door_AlarmID] = new_arlarmid;
			SetArrayArray(g_hDoors, i, nNew[0]);
		}
		SaveDoor(doorID);
	}
}

SetDoorName(doorID,String:new_doorname[])
{
	if(doorID <= MAXDOORID && doorID >= 0)
	{
		new i = g_iDoorIdToArrayID[doorID];
		new nNew[RP_Doors];
		
		if(i != -1)
		{
			GetArrayArray(g_hDoors, i, nNew[0]);
			FormatEx(nNew[Door_Name], sizeof(nNew[Door_Name]), "%s", new_doorname);
			SetArrayArray(g_hDoors, i, nNew[0]);
		}
		SaveDoor(doorID);
	}
}

SetDoorLockID(doorID,new_lockid)
{
	if(doorID <= MAXDOORID && doorID >= 0)
	{
		new i = g_iDoorIdToArrayID[doorID];
		new nNew[RP_Doors];
		
		if(i != -1)
		{
			GetArrayArray(g_hDoors, i, nNew[0]);
			nNew[Door_LockID] = new_lockid;
			SetArrayArray(g_hDoors, i, nNew[0]);
		}
		SaveDoor(doorID);
	}
}

SetDoorScannerID(doorID,new_scannerid)
{
	if(doorID <= MAXDOORID && doorID >= 0)
	{
		new i = g_iDoorIdToArrayID[doorID];
		new nNew[RP_Doors];
		
		if(i != -1)
		{
			GetArrayArray(g_hDoors, i, nNew[0]);
			nNew[Door_ScannerID] = new_scannerid;
			SetArrayArray(g_hDoors, i, nNew[0]);
		}
		SaveDoor(doorID);
	}
}

SetDoorSensorID(doorID,new_sensorid)
{
	if(doorID <= MAXDOORID && doorID >= 0)
	{
		new i = g_iDoorIdToArrayID[doorID];
		new nNew[RP_Doors];
		
		if(i != -1)
		{
			GetArrayArray(g_hDoors, i, nNew[0]);
			nNew[Door_SensorID] = new_sensorid;
			SetArrayArray(g_hDoors, i, nNew[0]);
		}
	
		SaveDoor(doorID);
	}
}

SetDoorTrapID(doorID,new_trapid)
{
	if(doorID <= MAXDOORID && doorID >= 0)
	{
		new i = g_iDoorIdToArrayID[doorID];
		new nNew[RP_Doors];
		
		if(i != -1)
		{
			GetArrayArray(g_hDoors, i, nNew[0]);
			nNew[Door_TrapID] = new_trapid;
			SetArrayArray(g_hDoors, i, nNew[0]);
		}
	
		SaveDoor(doorID);
	}
}

ResetDoor(doorID)
{
	if(doorID <= MAXDOORID && doorID >= 0)
	{
		new i = g_iDoorIdToArrayID[doorID];
		if(i != -1)
		{
			new nNew[RP_Doors];
			GetArrayArray(g_hDoors, i, nNew[0]);
			
			if (nNew[Door_ID] == doorID)
			{
				nNew[Door_AlarmID] = -1;
				nNew[Door_LockID] = -1;
				nNew[Door_ScannerID] = -1;
				nNew[Door_SensorID] = -1;
				nNew[Door_TrapID] = -1;
				nNew[Door_LocksAmount] = 0;
				FormatEx(nNew[Door_Name], sizeof(nNew[Door_Name]), "Default Door Name");
				nNew[Door_Type] = 0;
				nNew[Building_ID] = -1;
				nNew[Door_IsLocked] = false;
			
				SetArrayArray(g_hDoors,i, nNew[0]);
				
				UnlockDoorByEntity(nNew[Door_Entity]);
			}
		}
	}
	
	decl String:sQuery[2048];
	Format(sQuery, sizeof(sQuery), "UPDATE `rp_doors` SET `alarmID` = -1,`lockID` = -1,`ScannerID` = -1,`SensorID` = -1,`TrapID` = -1,`LocksAmount` = 0,`DoorName`= `Default Door Name`, `DoorType` = 0,`BuildingID` = 0 WHERE `doorID` = %d;");
	SQL_TQuery(g_hSQL, SQL_SaveDoorsCallback, sQuery, _, DBPrio_Low);	
}

SetDoorType(doorID,new_doortype)
{
	if(doorID <= MAXDOORID && doorID >= 0)
	{
		new i = g_iDoorIdToArrayID[doorID];
		new nNew[RP_Doors];
		
		if(i != -1)
		{
			GetArrayArray(g_hDoors, i, nNew[0]);
			nNew[Door_Type] = new_doortype;
			SetArrayArray(g_hDoors, i, nNew[0]);
		}
		SaveDoor(doorID);
	}
}

SetDoorBuildingID(doorID,new_buildingID)
{
	if(doorID <= MAXDOORID && doorID >= 0)
	{
		new i = g_iDoorIdToArrayID[doorID];
		new nNew[RP_Doors];
		
		if(i != -1)
		{
			GetArrayArray(g_hDoors, i, nNew[0]);
			nNew[Building_ID] = new_buildingID;
			SetArrayArray(g_hDoors, i, nNew[0]);
		}
		SaveDoor(doorID);
	}
}

/*NATIVES*/

public Native_GetDoorCount(Handle:plugin, numParams)
{
	return GetArraySize(g_hDoors);
}

public Native_GetDoorIDByArrayIndex(Handle:plugin, numParams)
{
	new arrayIndex = GetNativeCell(1);
	if(arrayIndex >= 0 || GetArraySize(g_hDoors) > arrayIndex )
	{
		new nNew[RP_Doors];
		GetArrayArray(g_hDoors, arrayIndex, nNew[0]);
		return nNew[Door_ID];
	}
	
	return -1;
}

public Native_GetDoorAlarmID(Handle:plugin, numParams)
{
	return GetDoorAlarmID(GetNativeCell(1));
}

public Native_GetDoorName(Handle:plugin, numParams)
{
	new nlen = GetNativeCell(3);
	new doorID = GetNativeCell(1);
	
	if(doorID <= MAXDOORID && doorID >= 0)
	{
		new i = g_iDoorIdToArrayID[doorID];
		if(i != -1)
		{
			new nNew[RP_Doors];
			GetArrayArray(g_hDoors, i, nNew[0]);
			
			decl String:buffer[nlen];
			FormatEx(buffer, nlen, "%s", nNew[Door_Name]);
			if (SetNativeString(2, buffer, nlen, true) == SP_ERROR_NONE)
				return true;	
		}
	}
	return false;
}

public Native_GetDoorLockID(Handle:plugin, numParams)
{
	return GetDoorLockID(GetNativeCell(1));
}

public Native_GetDoorScannerID(Handle:plugin, numParams)
{
	return GetDoorScannerID(GetNativeCell(1));
}

public Native_GetDoorSensorID(Handle:plugin, numParams)
{
	return GetDoorSensorID(GetNativeCell(1));
}

public Native_GetDoorTrapID(Handle:plugin, numParams)
{
	return GetDoorTrapID(GetNativeCell(1));
}

public Native_GetDoorType(Handle:plugin, numParams)
{
	return GetDoorType(GetNativeCell(1));
}

public Native_GetDoorBuildingID(Handle:plugin, numParams)
{
	return GetDoorBuildingID(GetNativeCell(1));
}

public Native_IsDoorLocked(Handle:plugin, numParams)
{
	return IsDoorLocked(GetNativeCell(1));
}

public Native_SetDoorAlarmID(Handle:plugin, numParams)
{
	SetDoorAlarmID(GetNativeCell(1),GetNativeCell(2));
}

public Native_SetDoorName(Handle:plugin, numParams)
{
	new String:buffer[64];
	GetNativeString(2, buffer, 64);
	SetDoorName(GetNativeCell(1),buffer);
}

public Native_SetDoorLockID(Handle:plugin, numParams)
{
	SetDoorLockID(GetNativeCell(1),GetNativeCell(2));
}

public Native_SetDoorScannerID(Handle:plugin, numParams)
{
	SetDoorScannerID(GetNativeCell(1),GetNativeCell(2));
}

public Native_SetDoorSensorID(Handle:plugin, numParams)
{
	SetDoorSensorID(GetNativeCell(1),GetNativeCell(2));
}

public Native_SetDoorTrapID(Handle:plugin, numParams)
{
	SetDoorTrapID(GetNativeCell(1),GetNativeCell(2));
}

public Native_SetDoorType(Handle:plugin, numParams)
{
	SetDoorType(GetNativeCell(1),GetNativeCell(2));
}

public Native_SetDoorBuildingID(Handle:plugin, numParams)
{
	SetDoorBuildingID(GetNativeCell(1),GetNativeCell(2));
}

public Native_ResetDoor(Handle:plugin, numParams)
{
	ResetDoor(GetNativeCell(1));
}

public Native_OpenDoor(Handle:plugin, numParams)
{
	OpenDoor(GetNativeCell(1));
}

public Native_CloseDoor(Handle:plugin, numParams)
{
	CloseDoor(GetNativeCell(1));
}

public Native_ToggleOpenDoor(Handle:plugin, numParams)
{
	ToggleOpenDoor(GetNativeCell(1));
}

public Native_ToggleLockDoor(Handle:plugin, numParams)
{
	ToggleLockDoor(GetNativeCell(1));
}

public Native_LockDoor(Handle:plugin, numParams)
{
	LockDoor(GetNativeCell(1));
}

public Native_UnlockDoor(Handle:plugin, numParams)
{
	UnlockDoor(GetNativeCell(1));
}

public Native_OpenDoorByEntity(Handle:plugin, numParams)
{
	OpenDoorByEntity(GetNativeCell(1));
}

public Native_CloseDoorByEntity(Handle:plugin, numParams)
{
	CloseDoorByEntity(GetNativeCell(1));
}

public Native_ToggleLockDoorByEntity(Handle:plugin, numParams)
{
	ToggleLockDoorByEntity(GetNativeCell(1));
}

public Native_LockDoorByEntity(Handle:plugin, numParams)
{
	LockDoorByEntity(GetNativeCell(1));
}

public Native_UnlockDoorByEntity(Handle:plugin, numParams)
{
	UnlockDoorByEntity(GetNativeCell(1));
}

public Native_IsValidDoorEnt(Handle:plugin, numParams)
{
	return IsValidDoorEnt(GetNativeCell(1));
}

public Native_IsValidLinearDoorEnt(Handle:plugin, numParams)
{
	return IsValidLinearDoorEnt(GetNativeCell(1));
}

public Native_GetDoorIDbyEntity(Handle:plugin, numParams)
{
	return GetDoorIDbyEntity(GetNativeCell(1));
}

public Native_GetDoorEntity(Handle:plugin, numParams)
{
	new doorID = GetNativeCell(1);
	if(doorID <= MAXDOORID && doorID >= 0)
	{
		new i = g_iDoorIdToArrayID[doorID];
		new nNew[RP_Doors];
		
		if(i != -1)
		{
			GetArrayArray(g_hDoors, i, nNew[0]);
			return nNew[Door_Entity];
		}
	}
	return -1;
}