#include "roleplay/roleplay"

#define PL_NAME		"RP_ITEMS_FURNITURE"

new bool:g_LateLoaded;

/* Database */

public Plugin:myinfo = 
{
	name = PL_NAME,
	author = PL_AUTHOR,
	description = "Furniture items for player homes",
	version = PL_VERSION,
	url = PL_URL
}

public APLRes:AskPluginLoad2(Handle:myself, bool:late, String:error[], err_max)
{
	g_LateLoaded = late;
	RegPluginLibrary(PL_NAME);
	
	return APLRes_Success;
}

public OnPluginStart()
{
	// Perform action if plugin is late loaded
	if(g_LateLoaded)
	{
		g_LateLoaded = false;
	}
}

public RP_OnPlayerReady(client, playerID, bool:create)
{
	//PlayerID is now cached
}

public RP_OnUseItem(client, itemID, itemType)
{
	if(itemType != IT_Furniture)
		return;
	
	decl String:sModel[128],String:sName[64];
	
	RP_GetItemModel(itemID, sModel, 128);
	RP_GetItemName(itemID, sName, 64);	

	decl ent;
	decl Float:eyeAngles[3];
	decl Float:clientOrigin[3], Float:furnitureOrigin[3];

	GetClientAbsOrigin(client, clientOrigin);
	GetClientEyeAngles(client,eyeAngles);

	furnitureOrigin[0] = (clientOrigin[0] + (50 * Cosine(DegToRad(eyeAngles[1]))));
	furnitureOrigin[1] = (clientOrigin[1] + (50 * Sine(DegToRad(eyeAngles[1]))));
	furnitureOrigin[2] = (clientOrigin[2] + 100);

	CPrintToChat(client, "%s You spawn a %s", PL_PRE, sName);

	ent = CreateEntityByName("prop_physics_override");
	SetEntProp(ent, Prop_Data, "m_takedamage", 2, 1);

	DispatchKeyValue(ent, "solid", "6");
	
	DispatchKeyValue(ent, "model", sModel);

	DispatchSpawn(ent);
	TeleportEntity(ent, furnitureOrigin, NULL_VECTOR, NULL_VECTOR);

	RP_UsedPlayerInventoryItem(client, itemID, 1);
	return;
}