#include "roleplay/roleplay"

#define PL_NAME		"RP_JAIL"

#define RANDOMSPEEDMIN -250.0
#define RANDOMSPEEDMAX 250.0
#define MAXJAILTYPES 4

new bool:g_LateLoaded;

/* ADT ARRAYS */
new nJailTeamplate[RP_Jail];
new Handle:g_hJail = INVALID_HANDLE;

new g_iPlayers_Type[MAXPLAYERS + 1];
new g_iPlayers_Time[MAXPLAYERS + 1];
new g_iPlayers_JailedByID[MAXPLAYERS + 1];
new bool:g_bPlayers_IsJailed[MAXPLAYERS + 1];

/* Jails */
new jailTypeCount[MAXJAILTYPES] =  { 0, ... };
new jailLastUsed[MAXJAILTYPES] =  { 0, ... };
new String:jailTypeNames[MAXJAILTYPES][32] =  { "Normal Jail", "VIP Jail", "Deathchamber", "Release" };

/* Database */
new Handle:g_hSQL;

public Plugin:myinfo = 
{
	name = PL_NAME,
	author = PL_AUTHOR,
	description = "",
	version = PL_VERSION,
	url = PL_URL
}

public APLRes:AskPluginLoad2(Handle:myself, bool:late, String:error[], err_max)
{
	CreateNative("RP_CreateJail", Native_CreateJail);
	CreateNative("RP_ClientSendToJail", Native_ClientSendToJail);
	CreateNative("RP_HasJailType", Native_HasJailType);
	CreateNative("RP_CheckClientJailStatus", Native_CheckClientJailStatus);
	
	CreateNative("RP_GetJailtypeCount", Native_GetJailtypeCount);
	CreateNative("RP_GetJailtypeName", Native_GetJailtypeName);
	CreateNative("RP_GetPlayerJailType", Native_GetPlayerJailType);
	CreateNative("RP_GetPlayerJailTime", Native_GetPlayerJailTime);
	CreateNative("RP_GetPlayerJailedByID", Native_GetPlayerJailedByID);	
	CreateNative("RP_IsClientJailed", Native_IsClientJailed);
	
	g_LateLoaded = late;
	RegPluginLibrary(PL_NAME);
	return APLRes_Success;
}

public OnPluginStart()
{
	// Init ADT arrays
	g_hJail = CreateArray(sizeof(nJailTeamplate));
	nJailTeamplate[Jail_ID] = 0;
	
	CreateTimer(1.0, Timer_JailTimer, _, TIMER_REPEAT);
	
	if(g_LateLoaded)
	{
		g_hSQL = Handle:RP_GetSql();
		
		if(g_hSQL != INVALID_HANDLE)
			SQLConnectionReady();
		
		g_LateLoaded = false;
	}
}

public Action:Timer_JailTimer(Handle:timer)
{
	for (new i = 0; i < (MAXPLAYERS + 1); i++)
	{
		if(g_iPlayers_Time[i] > 0)
		{
			g_iPlayers_Time[i] -= 1;
			SavePlayer(i);
		}
		else
		{
			if(g_bPlayers_IsJailed[i] == true)
			{
				ReleaseFromJail(i);
			}
		}
	}
}

public RP_OnSqlConnected(Handle:db)
{
	g_hSQL = db;
	SQLConnectionReady();
}

public RP_OnSqlStop()
{
	g_hSQL = INVALID_HANDLE;
}

public RP_OnPlayerReady(client, playerID, bool:create)
{
	if(create)
	{
		decl String:sQuery[2048];
		//Playerid / Jailtype / timeinjail / jailedby
		Format(sQuery, sizeof(sQuery), "INSERT INTO `rp_jailed_players` (playerid, jailtype , timeInJail , jailedBy) VALUES (%d, %d, 0, -1)",playerID, Jailtype_Release);
		LogMessage("%s [%s] Query: %s", PL_PRE_N, PL_NAME, sQuery);
		SQL_TQuery(g_hSQL, SQL_CreatePlayerCallback, sQuery, _, DBPrio_High);
		
		g_iPlayers_Type[client] = Jailtype_Release;
		g_iPlayers_Time[client] = 0;
		g_iPlayers_JailedByID[client] = -1;
		g_bPlayers_IsJailed[client] = false;
	}
	else
	{
		LoadPlayer(client);
	}
}

public SQL_CreatePlayerCallback(Handle:owner, Handle:hndl, const String:error[], any:data)
{
	if (owner == INVALID_HANDLE || hndl == INVALID_HANDLE)
	{
		LogError("%s [%s] (SQL_CreatePlayerCallback) %s", PL_PRE_N, PL_NAME, error);
	}
}

public OnClientDisconnect(client)
{
	SavePlayer(client);
	
	g_iPlayers_Type[client] = -1;
	g_iPlayers_Time[client] = -1;
	g_iPlayers_JailedByID[client] = -1;
	g_bPlayers_IsJailed[client] = false;
}

LoadPlayer(client)
{
	decl playerID;
	playerID = RP_GetPlayerID(client);
	
	decl String:sQuery[2048];
	Format(sQuery, sizeof(sQuery), "SELECT `jailtype`, `timeInJail`, `jailedBy` FROM `rp_jailed_players` WHERE playerid = %d", playerID);
	SQL_TQuery(g_hSQL, SQL_LoadJailedPlayerCallback, sQuery, client, DBPrio_Low);
}

public SQL_LoadJailedPlayerCallback(Handle:owner, Handle:hndl, const String:error[], any:client)
{
	if (owner == INVALID_HANDLE || hndl == INVALID_HANDLE)
	{
		LogError("%s [%s] (SQL_LoadJailedPlayersCallback) %s", PL_PRE_N, PL_NAME, error);
	}
	
	if (SQL_FetchRow(hndl))
	{
		g_iPlayers_Type[client] = SQL_FetchInt(hndl, 0);
		g_iPlayers_Time[client] = SQL_FetchInt(hndl, 1);
		g_iPlayers_JailedByID[client] = SQL_FetchInt(hndl, 2);
		g_bPlayers_IsJailed[client] = false;
		if(g_iPlayers_Time[client] > 0)
			g_bPlayers_IsJailed[client] = true;
	}
	else
	{
		decl playerID;
		playerID = RP_GetPlayerID(client);
		decl String:sQuery[2048];
		//Playerid / Jailtype / timeinjail / jailedby
		Format(sQuery, sizeof(sQuery), "INSERT INTO `rp_jailed_players` (playerid, jailtype , timeInJail , jailedBy) VALUES (%d, %d, 0, -1)",playerID, Jailtype_Release);
		LogMessage("%s [%s] Query: %s", PL_PRE_N, PL_NAME, sQuery);
		SQL_TQuery(g_hSQL, SQL_CreatePlayerCallback, sQuery, _, DBPrio_High);
		
		g_iPlayers_Type[client] = Jailtype_Release;
		g_iPlayers_Time[client] = 0;
		g_iPlayers_JailedByID[client] = -1;
		g_bPlayers_IsJailed[client] = false;
	}
}

SavePlayer(client)
{
	decl String:sQuery[2048];
	Format(sQuery, sizeof(sQuery), "UPDATE `rp_jailed_players` SET jailtype = %d , timeInJail = %d , jailedBy = %d WHERE playerid = %d",g_iPlayers_Type[client],g_iPlayers_Time[client],g_iPlayers_JailedByID[client],RP_GetPlayerID(client));
	LogMessage("%s [%s] Query: %s", PL_PRE_N, PL_NAME, sQuery);
	SQL_TQuery(g_hSQL, SQL_SavePlayerCallback, sQuery, _, DBPrio_Normal);
}

public SQL_SavePlayerCallback(Handle:owner, Handle:hndl, const String:error[], any:data)
{
	if (owner == INVALID_HANDLE || hndl == INVALID_HANDLE)
	{
		LogError("%s [%s] (SQL_SavePlayerCallback) %s", PL_PRE_N, PL_NAME, error);
	}
}

SQLConnectionReady()
{
	decl String:sQuery[2048];
	//JailID / Jailtype / Policedepartment of Jail / Origion / Angel
	Format(sQuery, sizeof(sQuery), "CREATE TABLE IF NOT EXISTS `rp_jail` (`jailid` int(11) NOT NULL AUTO_INCREMENT, `jailtype` int(11) NOT NULL, `jailBuildingID` int(11) NOT NULL, `origionx` float NOT NULL,`origiony` float NOT NULL,`origionz` float NOT NULL, `angelx` float NOT NULL,`angely` float NOT NULL,`angelz` float NOT NULL, PRIMARY KEY (`jailid`)) ENGINE=InnoDB DEFAULT CHARSET=utf8;");
	LogMessage("%s [%s] Query: %s", PL_PRE_N, PL_NAME, sQuery);
	SQL_TQuery(g_hSQL, SQL_CreateTableCallback, sQuery, _, DBPrio_High);
	
	decl String:sQuery2[2048];
	//Playerid / Jailtype / timeinjail / jailedby
	Format(sQuery2, sizeof(sQuery2), "CREATE TABLE IF NOT EXISTS `rp_jailed_players` (`playerid` int(11) NOT NULL AUTO_INCREMENT, `jailtype` int(11) NOT NULL, `timeInJail` int(11) NOT NULL, `jailedBy` int(11) NOT NULL, PRIMARY KEY (`playerid`)) ENGINE=InnoDB DEFAULT CHARSET=utf8;");
	LogMessage("%s [%s] Query: %s", PL_PRE_N, PL_NAME, sQuery2);
	SQL_TQuery(g_hSQL, SQL_CreateTableCallback, sQuery2, _, DBPrio_High);
	
	LoadJails();
}

public SQL_CreateTableCallback(Handle:owner, Handle:hndl, const String:error[], any:data)
{
	if (owner == INVALID_HANDLE || hndl == INVALID_HANDLE)
	{
		LogError("%s [%s] (SQL_CreateTableCallback) %s", PL_PRE_N, PL_NAME, error);
	}
}

LoadJails()
{
	decl String:sQuery[2048];
	Format(sQuery, sizeof(sQuery), "SELECT `jailid`, `jailtype`, `jailBuildingID`, `origionx`,`origiony`,`origionz`,`angelx`,`angely`,`angelz` FROM `rp_jail`");
	SQL_TQuery(g_hSQL, SQL_LoadJailsCallback, sQuery, _, DBPrio_Low);
}

public SQL_LoadJailsCallback(Handle:owner, Handle:hndl, const String:error[], any:data)
{
	if (owner == INVALID_HANDLE || hndl == INVALID_HANDLE)
	{
		LogError("%s [%s] (SQL_LoadJailsCallback) %s", PL_PRE_N, PL_NAME, error);
	}
	
	for (new i = 0; i < MAXJAILTYPES; i++)
		jailTypeCount[i] = 0;
	
	while (SQL_FetchRow(hndl))
	{
		new nNew[RP_Jail];
		
		nNew[Jail_ID] = SQL_FetchInt(hndl, 0);
		nNew[Jail_Type] = SQL_FetchInt(hndl, 1);
		nNew[Jail_BuildingID] = SQL_FetchInt(hndl, 2);
		nNew[Jail_Pos][0] = SQL_FetchFloat(hndl, 3);
		nNew[Jail_Pos][1] = SQL_FetchFloat(hndl, 4);
		nNew[Jail_Pos][2] = SQL_FetchFloat(hndl, 5);
		nNew[Jail_Angle][0] = SQL_FetchFloat(hndl, 6);
		nNew[Jail_Angle][1] = SQL_FetchFloat(hndl, 7);
		nNew[Jail_Angle][2] = SQL_FetchFloat(hndl, 8);
		
		jailTypeCount[nNew[Jail_Type]] += 1;
		
		PushArrayArray(g_hJail, nNew[0]);
	}
}

public RP_OnDoubleUseButton(cop, criminal)
{
	if(cop > 0 && cop < MaxClients + 1 && IsClientInGame(cop) && IsPlayerAlive(cop)
	&& criminal > 0 && criminal < MaxClients + 1 && IsClientInGame(criminal) && IsPlayerAlive(criminal))
	{
		if(RP_IsCop(cop) && RP_IsClientCuffed(criminal) && !g_bPlayers_IsJailed[criminal])
		{
			ClientSendToJail(criminal, Jailtype_Normal, 600, RP_GetPlayerID(cop));
		}
	}
}

CreateJail(client,jtyp,policeDepartment)
{
	if(client > 0 && client < MaxClients + 1 && IsClientInGame(client) && IsPlayerAlive(client) && RP_GetBuildingType(policeDepartment) == BD_PoliceDepartment)
	{
		new Float:origion[3];
		new Float:angel[3];
	
		GetClientAbsOrigin(client,origion);
		GetClientAbsAngles(client,angel);
		
		new nNew[RP_Jail];
		
		nNew[Jail_Type] = jtyp;
		nNew[Jail_BuildingID] = policeDepartment;
		nNew[Jail_Pos] = origion;
		nNew[Jail_Angle] = angel;
		
		jailTypeCount[nNew[Jail_Type]] += 1;
		
		PushArrayArray(g_hJail, nNew[0]);

		decl String:sQuery[2048];
		FormatEx(sQuery, sizeof(sQuery), "INSERT INTO `rp_jail` (jailtype, jailBuildingID, origionx,origiony,origionz,angelx,angely,angelz) VALUES (%d,%d,%.2f,%.2f,%.2f,%.2f,%.2f,%.2f)", jtyp,policeDepartment,origion[0],origion[1],origion[2],angel[0],angel[1],angel[2]);
		LogMessage("%s [%s] Query: %s", PL_PRE_N, PL_NAME, sQuery);
		SQL_TQuery(g_hSQL, SQL_JailCreateCallback, sQuery, GetClientUserId(client), DBPrio_Normal);
		
		PrintToChat(client, "Created new Jail");
	}
	else
	{
		if(Client_IsValid(client))
			PrintToChat(client, "Building is no Police Department");
	}
}

public SQL_JailCreateCallback(Handle:owner, Handle:hndl, const String:error[], any:userid)
{
	if (owner == INVALID_HANDLE || hndl == INVALID_HANDLE)
	{
		LogError("%s [%s] (SQL_JailCreateCallback) %s", PL_PRE_N, PL_NAME, error);
	}
}

ClientSendToJail(client, type, time, copClientID)
{
	if(RP_HasJailType(type))
	{
		if(client > 0 && client < MaxClients + 1 && IsClientInGame(client))
		{
					
			if(type == Jailtype_Release)
			{
				ReleaseFromJail(client);
			}
			else
			{
				g_iPlayers_Time[client] = time;		
				g_iPlayers_Type[client] = type;
				g_bPlayers_IsJailed[client] = true;
				g_iPlayers_JailedByID[client] = copClientID;
				ClientJailTeleport(client, type);
			}				
			SavePlayer(client);
		}
	}
}

ReleaseFromJail(client)
{
	if(client > 0 && client < MaxClients + 1 && IsClientInGame(client))
	{
		g_iPlayers_Type[client] = Jailtype_Release;
		g_iPlayers_Time[client] = 0;
		g_iPlayers_JailedByID[client] = -1;
		g_bPlayers_IsJailed[client] = false;
		RP_UncuffClient(client);
		
		if (IsPlayerAlive(client))
		{
			ClientJailTeleport(client,Jailtype_Release);
		}				
	}
}

ClientJailTeleport(client, type)
{
	if(Client_IsValid(client) && IsClientInGame(client) && IsPlayerAlive(client))
	{
		new nNew[RP_Jail];
		new Float:posJail[3];
		new counter = jailLastUsed[type];
			
		jailLastUsed[type] += 1;
		if(jailLastUsed[type] >= jailTypeCount[type])
			jailLastUsed[type] = 0;
			
		//Search for the next Jail in Row
		for (new i = 0; i < GetArraySize(g_hJail); i++)
		{
			GetArrayArray(g_hJail, i, nNew[0]);
		
			if (nNew[Jail_Type] == type)
			{
				if(counter == 0)
				{
					posJail[0] = nNew[Jail_Pos][0];
					posJail[1] = nNew[Jail_Pos][1];
					posJail[2] = nNew[Jail_Pos][2];
					break;
				}
				else
				{
					counter--;					
				}
			}
		}
		//Remove client from Teleporter
		new Float:randomspeed[3];
		
		randomspeed[0] = GetRandomFloat(RANDOMSPEEDMIN, RANDOMSPEEDMAX);
		randomspeed[1] = GetRandomFloat(RANDOMSPEEDMIN, RANDOMSPEEDMAX);
		randomspeed[2] = GetRandomFloat(0.0, RANDOMSPEEDMAX);
		
		TeleportEntity(client,posJail,NULL_VECTOR,randomspeed);		
	}
}

CheckClientJailStatus(client)
{
	if(g_iPlayers_Time[client] <= 0)
	{
		if(g_bPlayers_IsJailed[client])
		{
			ReleaseFromJail(client);
		}
	}
	if(g_iPlayers_Time[client] > 0 && g_iPlayers_Type[client] != Jailtype_Release)
	{
		ClientSendToJail(client, g_iPlayers_Type[client], g_iPlayers_Time[client],g_iPlayers_JailedByID[client]);
		if(!RP_IsClientCuffed(client))
			RP_CuffClient(client);
	}
}

/* Natives */

public Native_CreateJail(Handle:plugin, numParams)
{
	CreateJail(GetNativeCell(1),GetNativeCell(2),GetNativeCell(3));
}

public Native_ClientSendToJail(Handle:plugin, numParams)
{
	ClientSendToJail(GetNativeCell(1),GetNativeCell(2),GetNativeCell(3),GetNativeCell(4));
}

public Native_HasJailType(Handle:plugin, numParams)
{
	decl type;
	type = GetNativeCell(1);
	
	if(type >= 0 && type < MAXJAILTYPES)
	{
		if(jailTypeCount[type] > 0)
			return true;
	}
	return false;
}

public Native_CheckClientJailStatus(Handle:plugin, numParams)
{
	CheckClientJailStatus(GetNativeCell(1));
}

public Native_GetJailtypeCount(Handle:plugin, numParams)
{
	return MAXJAILTYPES;
}

public Native_GetJailtypeName(Handle:plugin, numParams)
{
	new nlen = GetNativeCell(3);
	new jailType = GetNativeCell(1);
	
	if((jailType >= 0 && jailType < MAXJAILTYPES))
	{
		decl String:buffer[nlen];
		FormatEx(buffer, nlen, "%s", jailTypeNames[jailType]);
		if (SetNativeString(2, buffer, nlen, true) == SP_ERROR_NONE)
			return true;
	}
	return false;
}

public Native_IsClientJailed(Handle:plugin, numParams)
{
	decl client;
	client = GetNativeCell(1);
	
	if(Client_IsValid(client))
	{
		if(g_iPlayers_Time[client] > 0 && g_bPlayers_IsJailed[client])
			return true;
		else
			return false;
	}
	return false;
}

public Native_GetPlayerJailType(Handle:plugin, numParams)
{
	decl client;
	client = GetNativeCell(1);
	
	if(Client_IsValid(client) && IsClientInGame(client))
	{
		return g_iPlayers_Type[client];
	}
	return Jailtype_Release;
}

public Native_GetPlayerJailTime(Handle:plugin, numParams)
{
	decl client;
	client = GetNativeCell(1);
	
	if(Client_IsValid(client) && IsClientInGame(client))
	{
		return g_iPlayers_Time[client];
	}
	return 0;
}

public Native_GetPlayerJailedByID(Handle:plugin, numParams)
{
	decl client;
	client = GetNativeCell(1);
	
	if(Client_IsValid(client) && IsClientInGame(client))
	{
		return g_iPlayers_JailedByID[client];
	}
	return -1;
}