#include "roleplay/roleplay"

#define PL_NAME		"RP_MENUINPUT"

//Inputs
new g_SelectedInteger[MAXPLAYERS + 1] = {0, ...};
new String:g_SelectedString[MAXPLAYERS + 1][128];

public Plugin:myinfo = 
{
	name = PL_NAME,
	author = PL_AUTHOR,
	description = "",
	version = PL_VERSION,
	url = PL_URL
}

public APLRes:AskPluginLoad2(Handle:myself, bool:late, String:error[], err_max)
{
	RegPluginLibrary(PL_NAME);
	
	CreateNative("RP_GetClientSelectedInt", Native_GetClientSelectedInt);
	CreateNative("RP_GetClientSelectedString", Native_GetClientSelectedString);
	
	CreateNative("RP_SetClientSelectedInt", Native_SetClientSelectedInt);
	CreateNative("RP_SetClientSelectedString", Native_SetClientSelectedString);
	
	return APLRes_Success;
}

public OnPluginStart()
{
	RegAdminCmd("sm_s", CommandSetSelectedString, ADMFLAG_ROOT, "<String> - Select a String for menu");
	RegAdminCmd("sm_n", CommandSetSelectedInteger, ADMFLAG_ROOT, "<Integer> - Select a Integer for menu");
}

public Action:CommandSetSelectedInteger(client, args)
{
	if(args < 1)
	{
		
		CPrintToChat(client, "%s Usage: sm_n <Integer>", PL_PRE);
		
		return Plugin_Handled;
	}
	
	decl String:sInteger[32];
	GetCmdArg(1, sInteger, sizeof(sInteger));
	g_SelectedInteger[client] = StringToInt(sInteger);
	
	PrintToChat(client, "Selected Integer : %d", g_SelectedInteger[client]);
	
	return Plugin_Handled;
}

public Action:CommandSetSelectedString(client, args)
{
	if(args < 1)
	{
		
		CPrintToChat(client, "%s Usage: sm_s <String>", PL_PRE);
		
		return Plugin_Handled;
	}
	
	decl String:sString[128];
	GetCmdArg(1, sString, sizeof(sString));
	FormatEx(g_SelectedString[client], sizeof(g_SelectedString[]), "%s", sString);
	
	PrintToChat(client, "Selected String : %s", g_SelectedString[client]);
	
	return Plugin_Handled;
}

public Native_GetClientSelectedString(Handle:plugin, numParams)
{
	new client = GetNativeCell(1);
	new nlen = GetNativeCell(3);
	
	if (SetNativeString(2, g_SelectedString[client], nlen, true) == SP_ERROR_NONE)
		return true;

	return false;
}

public Native_GetClientSelectedInt(Handle:plugin, numParams)
{
	new client = GetNativeCell(1);
	
	if(0 >= client || client > MaxClients + 1)
		return g_SelectedInteger[client];
		
	return 0;
}

public Native_SetClientSelectedString(Handle:plugin, numParams)
{	
	new client = GetNativeCell(1);
	decl String:buffer[64];
	GetNativeString(2, buffer, 64);
	
	FormatEx(g_SelectedString[client], sizeof(g_SelectedString[]), "%s", buffer);
}

public Native_SetClientSelectedInt(Handle:plugin, numParams)
{
	new client = GetNativeCell(1);
	
	g_SelectedInteger[client] = GetNativeCell(2);
}