#include "roleplay/roleplay"

#define PL_NAME		"RP_MONEY_DROPS"

new bool:g_LateLoaded;

/* Database */
new Handle:g_hSQL;

/* ADT ARRAY */
new nDroppedMoneyTeamplate[RP_DroppedMoney];
new Handle:g_hDroppedMoney = INVALID_HANDLE;

public Plugin:myinfo = 
{
	name = PL_NAME,
	author = PL_AUTHOR,
	description = "",
	version = PL_VERSION,
	url = PL_URL
}

public APLRes:AskPluginLoad2(Handle:myself, bool:late, String:error[], err_max)
{
	g_LateLoaded = late;
	RegPluginLibrary(PL_NAME);
	return APLRes_Success;
}

public OnPluginStart()
{
	g_hDroppedMoney = CreateArray(sizeof(nDroppedMoneyTeamplate));
	nDroppedMoneyTeamplate[DroppedMoney_Entity] = 0;
	
	RegConsoleCmd("sm_drop", Command_TestDrop);
	
	if(g_LateLoaded)
	{
		g_hSQL = Handle:RP_GetSql();
		
		if(g_hSQL != INVALID_HANDLE)
			SQLConnectionReady();
		
		g_LateLoaded = false;
	}
}

public Action:Command_TestDrop(client, args)
{
	if(0 >= client || client > MaxClients + 1)
		return Plugin_Handled;
	
	if(!IsClientInGame(client))
		return Plugin_Handled;
	
	if(!IsPlayerAlive(client))
		return Plugin_Handled;
		
	DropMoneyClient(client);
	
	return Plugin_Handled;
}

public RP_OnSqlConnected(Handle:db)
{
	g_hSQL = db;
	SQLConnectionReady();
}

public RP_OnSqlStop()
{
	g_hSQL = INVALID_HANDLE;
}

SQLConnectionReady()
{
	//Database is now ready to use
}

public RP_OnPlayerReady(client, playerID, bool:create)
{
	//PlayerID is now cached
}

public Action:EventDeath(Handle:event, const String:name[], bool:broadcast)
{
	decl client, attacker;
	
	//Initialize:
	client = GetClientOfUserId(GetEventInt(event, "userid"));
	attacker = GetClientOfUserId(GetEventInt(event, "attacker"));
	
	if(!RP_IsCop(attacker))
	{
		DropMoneyClient(client);
	}
	
	return Plugin_Continue;
}

public RP_OnUseButton(client,entity)
{
	decl String:className[64];
	if(IsValidEdict(entity))
	{
		GetEdictClassname(entity, className, sizeof(className));
		
		if(StrEqual(className, "prop_physics"))
		{
			for (new i = 0; i < GetArraySize(g_hDroppedMoney); i++)
			{
				new nNew[RP_DroppedMoney];
				GetArrayArray(g_hDroppedMoney, i, nNew[0]);
				
				if (nNew[DroppedMoney_Entity] == entity)
				{
					RP_AddMoney(client, nNew[DroppedMoney_Value]);
					PrintToChat(client, "Picked up %d$", nNew[DroppedMoney_Value]);
					RemoveFromArray(g_hDroppedMoney, i);
					AcceptEntityInput(entity, "kill");				
					break;
				}
			}
		}
	}
}

DropMoneyClient(client)
{
	decl Float:position[3];
	new money = RP_GetMoney(client);
	
	RP_SetMoney(client, 0);
	
	GetClientAbsOrigin(client, position);
	
	while(money > 0)
	{
		if(money >= 10000)
		{
			CreateMoneyBox(position, 10000);
			money -= 10000;
		}
		else if(money >= 5000)
		{
			CreateMoneyBox(position, 5000);
			money -= 5000;
		}
		else if(money >= 1000)
		{
			CreateMoneyBox(position, 1000);
			money -= 1000;
		}
		else if(money >= 500)
		{
			CreateMoneyBox(position, 500);
			money -= 500;
		}
		else if(money >= 100)
		{
			CreateMoneyBox(position, 100);
			money -= 100;
		}
		else if(money >= 50)
		{
			CreateMoneyBox(position, 50);
			money -= 50;
		}
		else if(money >= 20)
		{
			CreateMoneyBox(position, 20);
			money -= 20;
		}
		else if(money >= 10)
		{
			CreateMoneyBox(position, 10);
			money -= 10;
		}
		else if(money >= 5)
		{
			CreateMoneyBox(position, 5);
			money -= 5;
		}
		else
		{
			CreateMoneyBox(position, money);
			money = 0;
			break;
		}
	}
}

CreateMoneyBox(Float:orgPos[3], value)
{
	decl collision;
	decl Float:position[3];
	new Float:angles[3] = {0.0, 0.0, 0.0};
	
	new entity = CreateEntityByName("prop_physics_override");
	
	new nNew[RP_DroppedMoney];
		
	nNew[DroppedMoney_Entity] = entity;
	nNew[DroppedMoney_Value] = value;
		
	PushArrayArray(g_hDroppedMoney, nNew[0]);
	
	//1-4
	if(value < 5)
		DispatchKeyValue(entity, "model", "models/money/broncoin.mdl");
	//5-9
	else if(value < 10)
		DispatchKeyValue(entity, "model", "models/money/silvcoin.mdl");
	//10-19
	else if(value < 20)
		DispatchKeyValue(entity, "model", "models/money/goldcoin.mdl");
	//20-49
	else if(value < 50)
		DispatchKeyValue(entity, "model", "models/money/note2.mdl");
	//50-99
	else if(value < 100)
		DispatchKeyValue(entity, "model", "models/money/note3.mdl");
	//100-499
	else if(value < 500)
		DispatchKeyValue(entity, "model", "models/money/note.mdl");
	//500-999
	else if(value < 1000)
		DispatchKeyValue(entity, "model", "models/money/goldbar.mdl");
		//DispatchKeyValue(entity, "model", "models/rupee/rupee_orang.mdl");
	//1000-4999
	else if(value < 5000)
		DispatchKeyValue(entity, "model", "models/money/goldbar.mdl");
		//DispatchKeyValue(entity, "model", "models/rupee/rupee_silve.mdl");
	//5000-9999
	else if(value < 10000)
		DispatchKeyValue(entity, "model", "models/money/goldbar.mdl");
		//DispatchKeyValue(entity, "model", "models/rupee/rupee_yello.mdl");
	//>= 10000
	else
		DispatchKeyValue(entity, "model", "models/money/goldbar.mdl");
		
	DispatchSpawn(entity);
	
	angles[0] = GetRandomFloat(0.0, 360.0);
	angles[1] = GetRandomFloat(0.0, 360.0);
	angles[2] = GetRandomFloat(0.0, 360.0);
	position[0] = orgPos[0] + GetRandomFloat(-35.0, 35.0);
	position[1] = orgPos[1] + GetRandomFloat(-35.0, 35.0);
	position[2] = orgPos[2] + GetRandomFloat(30.0, 65.0);
	
	collision = GetEntSendPropOffs(entity, "m_CollisionGroup");
	if(IsValidEntity(entity))
		SetEntData(entity, collision, 1, 1, true);
	
	TeleportEntity(entity, position, angles, NULL_VECTOR);
}