#include "roleplay/roleplay"

#define PL_NAME		"RP_Banker"

new bool:g_LateLoaded;

/* Database */
new Handle:g_hSQL;

new g_iSelectedNpcID[MAXPLAYERS + 1];

public Plugin:myinfo = 
{
	name = PL_NAME,
	author = PL_AUTHOR,
	description = "",
	version = PL_VERSION,
	url = PL_URL
}

public APLRes:AskPluginLoad2(Handle:myself, bool:late, String:error[], err_max)
{
	g_LateLoaded = late;
	RegPluginLibrary(PL_NAME);

	return APLRes_Success;
}

public OnPluginStart()
{	
	/* Perform action if plugin is late loaded*/
	if(g_LateLoaded)
	{
		g_hSQL = Handle:RP_GetSql();
		
		if(g_hSQL != INVALID_HANDLE)
			SQLConnectionReady();
		
		g_LateLoaded = false;
	}
}

public RP_OnSqlConnected(Handle:db)
{
	g_hSQL = db;
	SQLConnectionReady();
}

public RP_OnSqlStop()
{
	g_hSQL = INVALID_HANDLE;
}

SQLConnectionReady()
{
}

public RP_OnPlayerNpcUse(client, npcID)
{
	if(RP_GetNpcType(npcID) != NT_Banker)
		return;
	
	if(0 >= client || client > MaxClients + 1)
		return;
	
	if(!IsClientInGame(client))
		return;
	
	if(!IsPlayerAlive(client))
		return;
	
	g_iSelectedNpcID[client] = npcID;
	Menu_Banker(client);
}

Menu_Banker(client)
{
	new npcID = g_iSelectedNpcID[client];
	
	decl String:sName[64];
	RP_GetNpcName(npcID, sName, sizeof(sName));

	new Handle:menu = CreateMenu(MenuHandler_Banker);
	SetMenuTitle(menu, "Banker: %s", sName);
		
	AddMenuItemEx(menu, false, "0", "Withdraw Money");
	AddMenuItemEx(menu, false, "1", "Deposit Money");
	
	SetMenuExitButton(menu, true);
	DisplayMenu(menu, client, MENU_TIME_FOREVER);
}

public MenuHandler_Banker(Handle:menu, MenuAction:action, client, param2)
{
	if(0 >= client || client > MaxClients + 1)
		return;
	
	if(!Client_IsValid(client))
		return;
	
	if(!IsClientInGame(client))
		return;
	
	if(!IsPlayerAlive(client))
		return;
	
	if (action == MenuAction_Select)
	{
		decl String:info[100], String:info2[100];
		new bool:found = GetMenuItem(menu, param2, info, sizeof(info), _, info2, sizeof(info2));
		
		if(found)
		{
			new selection = StringToInt(info);
			
			if(selection == 0)
			{
				Menu_MoneyAmountSelectWithdraw(client);
			}
			else if(selection == 1)
			{
				Menu_MoneyAmountSelectDeposit(client);
			}
			return;
		}
	}
}

Menu_MoneyAmountSelectWithdraw(client)
{
	new cash = RP_GetMoney(client);
	new cashbank = RP_GetMoneyBank(client);
	
	new Handle:menu = CreateMenu(MenuHandler_MoneyAmountSelectWithdraw);

	SetMenuTitle(menu, "Withdraw Cash: $%d / Bank: $%d", cash, cashbank);

	AddMenuItemEx(menu, !(cashbank >= 1) , "1", "$1");
	AddMenuItemEx(menu, !(cashbank >= 10) , "10", "$10");
	AddMenuItemEx(menu, !(cashbank >= 100) , "100", "$100");
	AddMenuItemEx(menu, !(cashbank >= 1000) , "1000", "$1000");
	AddMenuItemEx(menu, !(cashbank >= 10000) , "10000", "$10000");
	AddMenuItemEx(menu, false , "2", "All: $%d", cashbank);
	AddMenuItemEx(menu, false, "0", "Back to Banker");
	
	SetMenuExitButton(menu, true);
	DisplayMenu(menu, client, MENU_TIME_FOREVER);
}

public MenuHandler_MoneyAmountSelectWithdraw(Handle:menu, MenuAction:action, client, param2)
{
	if(0 >= client || client > MaxClients + 1)
		return;
	
	if(!IsClientInGame(client))
		return;
	
	if(!IsPlayerAlive(client))
		return;
	
	if (action == MenuAction_Select)
	{
		decl String:info[100], String:info2[100];
		new bool:found = GetMenuItem(menu, param2, info, sizeof(info), _, info2, sizeof(info2));
		
		if(found)
		{
			new selection = StringToInt(info);
			new cashbank = RP_GetMoneyBank(client);
			
			
			if(selection == 0)
			{
				Menu_Banker(client);
			}
			else if(selection == 2)
			{
				RP_AddMoney(client, cashbank);
				RP_SetMoneyBank(client, 0);
				Menu_MoneyAmountSelectWithdraw(client);
			}
			else
			{
				if(cashbank >= selection)
				{
					RP_AddMoney(client, selection);
					RP_TakeMoneyBank(client, selection);
					Menu_MoneyAmountSelectWithdraw(client);
				}
			}
			return;
		}
	}
}

Menu_MoneyAmountSelectDeposit(client)
{
	new cash = RP_GetMoney(client);
	new cashbank = RP_GetMoneyBank(client);
	
	new Handle:menu = CreateMenu(MenuHandler_MoneyAmountSelectDeposit);
	SetMenuTitle(menu, "Deposit Cash: $%d / Bank: $%d", cash, cashbank);

	AddMenuItemEx(menu, false , "2", "All: $%d", cash);
	AddMenuItemEx(menu, !(cash >= 1) , "1", "$1");
	AddMenuItemEx(menu, !(cash >= 10) , "10", "$10");
	AddMenuItemEx(menu, !(cash >= 100) , "100", "$100");
	AddMenuItemEx(menu, !(cash >= 1000) , "1000", "$1000");
	AddMenuItemEx(menu, !(cash >= 10000) , "10000", "$10000");
	AddMenuItemEx(menu, false, "0", "Back to Banker");	
	
	SetMenuExitButton(menu, true);
	DisplayMenu(menu, client, MENU_TIME_FOREVER);
}

public MenuHandler_MoneyAmountSelectDeposit(Handle:menu, MenuAction:action, client, param2)
{
	if(0 >= client || client > MaxClients + 1)
		return;
	
	if(!IsClientInGame(client))
		return;
	
	if(!IsPlayerAlive(client))
		return;
	
	if (action == MenuAction_Select)
	{
		decl String:info[100], String:info2[100];
		new bool:found = GetMenuItem(menu, param2, info, sizeof(info), _, info2, sizeof(info2));
		
		if(found)
		{
			new selection = StringToInt(info);
			new cash = RP_GetMoney(client);
			
			if(selection == 0)
			{
				Menu_Banker(client);
			}
			else if(selection == 2)
			{
				RP_AddMoneyBank(client, cash);
				RP_SetMoney(client, 0);
				Menu_MoneyAmountSelectDeposit(client);
			}
			else
			{
				if(cash >= selection)
				{
					RP_AddMoneyBank(client, selection);
					RP_TakeMoney(client, selection);
					Menu_MoneyAmountSelectDeposit(client);
				}
			}
			return;
		}
	}
}