#include "roleplay/roleplay"

#define PL_NAME		"RP_PLAYER_INPUT"

/* Button Buffer */
new Float:g_iLastPressedShift[MAXPLAYERS+1];
new Float:g_iLastPressedUse[MAXPLAYERS+1];
new Float:g_iLastPressedUseDoor[MAXPLAYERS+1];

new iPrevButtons[MAXPLAYERS+1];
new iPrevDoorEnt[MAXPLAYERS+1];

new bool:iPrevDoubleUse[MAXPLAYERS+1];
new bool:iPrevDoubleShift[MAXPLAYERS+1];

/* Forwards */
new Handle:g_OnUseDoorButton = INVALID_HANDLE;

new Handle:g_OnSingleUseButton = INVALID_HANDLE;
new Handle:g_OnDoubleUseButton = INVALID_HANDLE;
new Handle:g_OnUseButton = INVALID_HANDLE;

new Handle:g_OnSingleShiftButton = INVALID_HANDLE;
new Handle:g_OnDoubleShiftButton = INVALID_HANDLE;
new Handle:g_OnShiftButton = INVALID_HANDLE;

public Plugin:myinfo = 
{
	name = PL_NAME,
	author = PL_AUTHOR,
	description = "",
	version = PL_VERSION,
	url = PL_URL
}

public APLRes:AskPluginLoad2(Handle:myself, bool:late, String:error[], err_max)
{
	RegPluginLibrary(PL_NAME);
	
	g_OnUseDoorButton = CreateGlobalForward("RP_OnUseDoorButton", ET_Event, Param_Cell, Param_Cell);
	
	g_OnSingleUseButton = CreateGlobalForward("RP_OnSingleUseButton", ET_Event, Param_Cell, Param_Cell);
	g_OnDoubleUseButton = CreateGlobalForward("RP_OnDoubleUseButton", ET_Event, Param_Cell, Param_Cell);
	g_OnUseButton = CreateGlobalForward("RP_OnUseButton", ET_Event, Param_Cell, Param_Cell);
	
	g_OnSingleShiftButton = CreateGlobalForward("RP_OnSingleShiftButton", ET_Event, Param_Cell, Param_Cell);
	g_OnDoubleShiftButton = CreateGlobalForward("RP_OnDoubleShiftButton", ET_Event, Param_Cell, Param_Cell);
	g_OnShiftButton = CreateGlobalForward("RP_OnShiftButton", ET_Event, Param_Cell, Param_Cell);
	
	return APLRes_Success;
}

public Action:OnPlayerRunCmd(client, &buttons, &impulse, Float:vel[3], Float:angles[3], &weapon, &subtype, &cmdnum, &tickcount, &seed, mouse[2])
{
	if(!IsPlayerAlive(client))
		return Plugin_Continue;
	
	new entity = GetClientAimTarget(client, false);
	new initButtons = buttons;

	//Anti Door Block
	if(buttons & IN_USE && RP_IsValidDoorEnt(entity) && !(iPrevButtons[client] & IN_USE))
	{
		if((g_iLastPressedUseDoor[client] >= (GetGameTime() - 0.9) && iPrevDoorEnt[client] == entity) || RP_IsClientCuffed(client))
		{
			buttons &= ~IN_USE;
		}
		else
		{
			g_iLastPressedUseDoor[client] = GetGameTime();
			Call_StartForward(g_OnUseDoorButton);
			Call_PushCell(client);
			Call_PushCell(entity);
			Call_Finish();
		}
		iPrevDoorEnt[client] = entity;
	}
	
	//Use Button
	if(buttons & IN_USE && !(iPrevButtons[client] & IN_USE))
	{
		if(g_iLastPressedUse[client] >= (GetGameTime() - 1.0) && !iPrevDoubleUse[client])
		{
			iPrevDoubleUse[client] = true;
			//forward Use double
			Call_StartForward(g_OnDoubleUseButton);
			Call_PushCell(client);
			Call_PushCell(entity);
			Call_Finish();
		}
		else
		{
			iPrevDoubleUse[client] = false;
			//Forward Use single
			Call_StartForward(g_OnSingleUseButton);
			Call_PushCell(client);
			Call_PushCell(entity);
			Call_Finish();
		}
		Call_StartForward(g_OnUseButton);
		Call_PushCell(client);
		Call_PushCell(entity);
		Call_Finish();
		
		g_iLastPressedUse[client] = GetGameTime();
	}
	
	//Walk Button
	if(buttons & IN_SPEED && !(iPrevButtons[client] & IN_SPEED))
	{
		if(g_iLastPressedShift[client] >= (GetGameTime() - 1.0) && !iPrevDoubleShift[client])
		{
			iPrevDoubleShift[client] = true;
			//forward shift double				
			Call_StartForward(g_OnDoubleShiftButton);
			Call_PushCell(client);
			Call_PushCell(entity);
			Call_Finish();
		}
		else
		{
			iPrevDoubleShift[client] = false;
			//Forward shift single
			Call_StartForward(g_OnSingleShiftButton);
			Call_PushCell(client);
			Call_PushCell(entity);
			Call_Finish();
		}
		Call_StartForward(g_OnShiftButton);
		Call_PushCell(client);
		Call_PushCell(entity);
		Call_Finish();
		
		g_iLastPressedShift[client] = GetGameTime();
	}
	
	//No Actions allowed if cuffed
	if(RP_IsClientCuffed(client))
	{
		buttons &= ~IN_USE;
		buttons &= ~IN_ATTACK;
		buttons &= ~IN_ATTACK2;
	}
	
	iPrevButtons[client] = buttons;
	
	if(initButtons != buttons)
		return Plugin_Changed;
    
	return Plugin_Continue;
}