#include "roleplay/roleplay"

#define PL_NAME		"RP_RADAR"

#define RADAR_MIN_CRIME		1000

new bool:g_LateLoaded;

/* Database */
new Handle:g_hSQL;

public Plugin:myinfo = 
{
	name = PL_NAME,
	author = PL_AUTHOR,
	description = "",
	version = PL_VERSION,
	url = PL_URL
}

public APLRes:AskPluginLoad2(Handle:myself, bool:late, String:error[], err_max)
{
	g_LateLoaded = late;
	RegPluginLibrary(PL_NAME);
	return APLRes_Success;
}

public OnPluginStart()
{
	if(g_LateLoaded)
	{
		g_hSQL = Handle:RP_GetSql();
		
		if(g_hSQL != INVALID_HANDLE)
			SQLConnectionReady();
		
		g_LateLoaded = false;
	}
}

public RP_OnSqlConnected(Handle:db)
{
	g_hSQL = db;
	SQLConnectionReady();
}

public RP_OnSqlStop()
{
	g_hSQL = INVALID_HANDLE;
}

SQLConnectionReady()
{
	//Database is now ready to use
}

public RP_OnPlayerReady(client, playerID, bool:create)
{
	//PlayerID is now cached
}

public OnClientPutInServer(client)
{
	SDKHook(client, SDKHook_ThinkPost, Hook_PlayerThinkPost);
}

public Hook_PlayerThinkPost(client)
{
	if(GetClientTeam(client) <= CS_TEAM_SPECTATOR)
		return;
		
	new bool:bSpotted;
	
	/* Show players with high crime */
	if(RADAR_MIN_CRIME >= 0 && RP_GetCrime(client) > RADAR_MIN_CRIME)
		bSpotted = true;
	
	/* Show players which are in combat */
	if(RP_IsPlayerInCombat(client))
		bSpotted = true;
	
	if(bSpotted)
		SetEntProp(client, Prop_Send, "m_bSpotted", 1);
	else SetEntProp(client, Prop_Send, "m_bSpotted", 0);
}  