#include "roleplay/roleplay"

#define PL_NAME		"RP_SURVIVAL"

new bool:g_LateLoaded;

/* Database */

new Handle:g_hSQL;

public Float:g_fSaturation[MAXPLAYERS+1];
public Float:g_fStomachContent[MAXPLAYERS+1];
public Float:g_fHydration[MAXPLAYERS+1];

public Float:g_fStamina[MAXPLAYERS+1];

/* CVARs */

new Handle:cvarHungerWalking = INVALID_HANDLE;
new Float:g_fHungerWalking;
new Handle:cvarHungerRunning = INVALID_HANDLE;
new Float:g_fHungerRunning;
new Handle:cvarSaturationRegen = INVALID_HANDLE;
new Float:g_fSaturationRegen;
new Handle:cvarThirstWalking = INVALID_HANDLE;
new Float:g_fThirstWalking;
new Handle:cvarThirstRunning = INVALID_HANDLE;
new Float:g_fThirstRunning;

public Plugin:myinfo = 
{
	name = PL_NAME,
	author = PL_AUTHOR,
	description = "",
	version = PL_VERSION,
	url = PL_URL
}

public APLRes:AskPluginLoad2(Handle:myself, bool:late, String:error[], err_max)
{
	g_LateLoaded = late;
	RegPluginLibrary(PL_NAME);
	
	CreateNative("RP_GetSaturation", Native_GetSaturation);
	CreateNative("RP_SetSaturation", Native_SetSaturation);
	CreateNative("RP_AddSaturation", Native_AddSaturation);
	CreateNative("RP_TakeSaturation", Native_TakeSaturation);
	
	CreateNative("RP_GetStomachContent", Native_GetStomachContent);
	CreateNative("RP_SetStomachContent", Native_SetStomachContent);
	CreateNative("RP_AddStomachContent", Native_AddStomachContent);
	CreateNative("RP_TakeStomachContent", Native_TakeStomachContent);
	
	CreateNative("RP_GetHydration", Native_GetHydration);
	CreateNative("RP_SetHydration", Native_SetHydration);
	CreateNative("RP_AddHydration", Native_AddHydration);
	CreateNative("RP_TakeHydration", Native_TakeHydration);
	
	CreateNative("RP_GetStamina", Native_GetStamina);
	CreateNative("RP_SetStamina", Native_SetStamina);
	CreateNative("RP_AddStamina", Native_AddStamina);
	CreateNative("RP_TakeStamina", Native_TakeStamina);
	
	return APLRes_Success;
}

public OnPluginStart()
{
	/* CVARs */
	cvarHungerWalking = CreateConVar("rp_hunger_walking", "0.1", "Increase hunger each second by this amount while walking/camping.", _, true, 0.0, true, 10.0);
	g_fHungerWalking = GetConVarFloat(cvarHungerWalking);
	HookConVarChange(cvarHungerWalking, OnSettingChanged);
	
	cvarHungerRunning = CreateConVar("rp_hunger_running", "0.5", "Increase hunger each second by this amount while running.", _, true, 0.0, true, 10.0);
	g_fHungerRunning = GetConVarFloat(cvarHungerRunning);
	HookConVarChange(cvarHungerRunning, OnSettingChanged);
	
	cvarSaturationRegen = CreateConVar("rp_hunger_regen", "1.7", "Transform this amount of food from your stomach each second.", _, true, 0.0, true, 10.0);
	g_fSaturationRegen = GetConVarFloat(cvarSaturationRegen);
	HookConVarChange(cvarSaturationRegen, OnSettingChanged);
	
	cvarThirstWalking = CreateConVar("rp_thirst_walking", "0.2", "Increase thirst each second by this amount while walking/camping.", _, true, 0.0, true, 10.0);
	g_fThirstWalking = GetConVarFloat(cvarThirstWalking);
	HookConVarChange(cvarThirstWalking, OnSettingChanged);
	
	cvarThirstRunning = CreateConVar("rp_thirst_running", "0.6", "Increase thirst each second by this amount while running.", _, true, 0.0, true, 10.0);
	g_fThirstRunning = GetConVarFloat(cvarThirstRunning);
	HookConVarChange(cvarThirstRunning, OnSettingChanged);
	
	AutoExecConfig(true, "rp_survival");
	
	/* Create Survival Timer */
	CreateTimer(1.0, Timer_Survival, 0, TIMER_REPEAT);
	
	/* Perform action if plugin is late loaded */
	if(g_LateLoaded)
	{
		g_hSQL = Handle:RP_GetSql();
		
		if(g_hSQL != INVALID_HANDLE)
			SQLConnectionReady();
		
		g_LateLoaded = false;
	}
}

public OnSettingChanged(Handle:convar, const String:oldValue[], const String:newValue[])
{
	if(convar == cvarHungerWalking)
		g_fHungerWalking = StringToFloat(newValue);
	else if(convar == cvarHungerRunning)
		g_fHungerRunning = StringToFloat(newValue);
	else if(convar == cvarSaturationRegen)
		g_fSaturationRegen = StringToFloat(newValue);
	else if(convar == cvarThirstWalking)
		g_fThirstWalking = StringToFloat(newValue);
	else if(convar == cvarThirstRunning)
		g_fThirstRunning = StringToFloat(newValue);
}

public RP_OnSqlConnected(Handle:db)
{
	g_hSQL = db;
	SQLConnectionReady();
}

public RP_OnSqlStop()
{
	g_hSQL = INVALID_HANDLE;
}

/* Create Table */

SQLConnectionReady()
{
	decl String:sQuery[2048];
	Format(sQuery, sizeof(sQuery), "CREATE TABLE IF NOT EXISTS `rp_survival` (`playerID` int(10) NOT NULL, `saturation` int(11) NOT NULL, `stomach` int(11) NOT NULL, `hydration` int(11) NOT NULL, PRIMARY KEY (`playerID`)) ENGINE=InnoDB DEFAULT CHARSET=utf8;");
	LogMessage("%s [%s] Query: %s", PL_PRE_N, PL_NAME, sQuery);
	SQL_TQuery(g_hSQL, SQL_CreateTableCallback, sQuery, _, DBPrio_High);
}

public SQL_CreateTableCallback(Handle:owner, Handle:hndl, const String:error[], any:data)
{
	if (owner == INVALID_HANDLE || hndl == INVALID_HANDLE)
	{
		LogError("%s [%s] (SQL_CreateTableCallback) %s", PL_PRE_N, PL_NAME, error);
	}
}

/* Save / Reset Stats OnClientDisconnect */

public OnClientDisconnect(client)
{
	SavePlayer(client);
	
	g_fSaturation[client] = 0.0;
	g_fStomachContent[client] = 0.0;
	g_fHydration[client] = 0.0;
	g_fStamina[client] = 100.0;
}

/* Load Player Stats */

public RP_OnPlayerReady(client, playerID, bool:create)
{
	if(create)
	{
		decl String:sQuery[2048];
		FormatEx(sQuery, sizeof(sQuery), "INSERT INTO `rp_survival` (playerID, saturation, stomach, hydration) VALUES (%d, 100, 100, 100)", playerID);
		SQL_TQuery(g_hSQL, SQL_ClientCreateCallback, sQuery, GetClientUserId(client), DBPrio_Normal);
		
		SetPlayerDefaults(client);
	}
	else
	{
		LoadPlayer(client);
	}
}

public SQL_ClientCreateCallback(Handle:owner, Handle:hndl, const String:error[], any:userid)
{
	if (owner == INVALID_HANDLE || hndl == INVALID_HANDLE)
	{
		LogError("%s [%s] (SQL_ClientCreateCallback) %s", PL_PRE_N, PL_NAME, error);
	}
}

LoadPlayer(client)
{
	decl String:sQuery[2048];
	Format(sQuery, sizeof(sQuery), "SELECT `saturation`,`stomach`,`hydration` FROM `rp_survival` WHERE `playerID` = %d", RP_GetPlayerID(client));
	SQL_TQuery(g_hSQL, SQL_ClientLoadCallback, sQuery, GetClientUserId(client), DBPrio_Low);
}

public SQL_ClientLoadCallback(Handle:owner, Handle:hndl, const String:error[], any:userid)
{
	if (owner == INVALID_HANDLE || hndl == INVALID_HANDLE)
	{
		LogError("%s [%s] (SQL_ClientConnectCallback) %s", PL_PRE_N, PL_NAME, error);
	}

	new client = GetClientOfUserId(userid);
	if(!client || !IsClientInGame(client))
		return;
	
	if(SQL_GetRowCount(hndl))
	{
		SQL_FetchRow(hndl);
		g_fSaturation[client] = SQL_FetchFloat(hndl, 0);
		g_fStomachContent[client] = SQL_FetchFloat(hndl, 1);
		g_fHydration[client] = SQL_FetchFloat(hndl, 2);
	}
}

SetPlayerDefaults(client)
{
	g_fSaturation[client] = 100.0;
	g_fStomachContent[client] = 100.0;
	g_fHydration[client] = 100.0;
}

/* Save Player Stats */

SavePlayer(client)
{
	decl String:sQuery[2048];
	FormatEx(sQuery, sizeof(sQuery), "UPDATE `rp_survival` SET saturation = %d, stomach = %d, hydration = %d WHERE playerID = %d", g_fSaturation[client], g_fStomachContent[client], g_fHydration[client], RP_GetPlayerID(client));
	SQL_TQuery(g_hSQL, SQL_ClientUpdateCallback, sQuery, _);
}

public SQL_ClientUpdateCallback(Handle:owner, Handle:hndl, const String:error[], any:userid)
{
	if (owner == INVALID_HANDLE || hndl == INVALID_HANDLE)
	{
		LogError("%s [%s] (SQL_ClientUpdateCallback) %s", PL_PRE_N, PL_NAME, error);
	}
}

/* Simulate Survival */

public Action:Timer_Survival(Handle:timer, any:data)
{
	for (new client = 1; client < MAXPLAYERS ; client++)
	{
		if(RP_GetPlayerID(client) <= 0)
			continue;
		
		if(!IsClientInGame(client))
			continue;
		
		if(!IsPlayerAlive(client))
			continue;
		
		decl Float:fVelocity[3];
		GetEntPropVector(client, Prop_Data, "m_vecVelocity", fVelocity); //velocity
		new Float:currentspeed = SquareRoot(Pow(fVelocity[0],2.0)+Pow(fVelocity[1],2.0)); //player speed (units per secound)
		
		/* Hunnger / Saturation */
		
		if(g_fStomachContent[client] == 0.0) // Empty stomach
		{
			//Player is running
			if(currentspeed > 160.0) g_fSaturation[client] -= g_fHungerRunning;
			//Player is walking
			else g_fSaturation[client] -= g_fHungerWalking;
			
			if(g_fSaturation[client] < 0.0)
				g_fSaturation[client] = 0.0;
		}
		else // Non-empty stomach
		{
			g_fStomachContent[client] -= g_fSaturationRegen;
			g_fSaturation[client] += g_fSaturationRegen;
			
			if(g_fSaturation[client] > 100.0)
				g_fSaturation[client] = 100.0;
			
			if(g_fStomachContent[client] < 0.0)
				g_fStomachContent[client] = 0.0;
		}
		// Starving
		if(g_fSaturation[client]+g_fStomachContent[client] <= 0.0)
		{
			new health = GetClientHealth(client);
			
			health--;
			SetEntityHealth(client, health);
			
			new todo_else_knockout_chance_then_dead;
		}
		// Regen Life
		else if(g_fSaturation[client]+g_fStomachContent[client] > 100.0)
		{
			new health = GetClientHealth(client);
			
			if(health < 100)
			{
				health++;
				SetEntityHealth(client, health);
			}
		}
		
		/* Thirst/ Hydration */
		
		/* Stamina recovery rate */
		new Float:eRegenRate = g_fHydration[client]/10.0 + (g_fStamina[client]*0.15);
		
		/* Player is running */
		if(currentspeed > 160.0)
		{
			g_fStamina[client] -= 1.1;
			g_fHydration[client] -= g_fThirstRunning;
		}
		/* Player is walking or camping */
		else
		{
			g_fStamina[client] += eRegenRate+6.0;
			g_fHydration[client] -= g_fThirstWalking;
		}
		
		/* Check invalid values */
		if(g_fStamina[client] > 100.0)
			g_fStamina[client] = 100.0;
		
		if(g_fHydration[client] > 100.0)
			g_fHydration[client] = 100.0;
		
		if(g_fStamina[client] < 0.0)
			g_fStamina[client] = 0.0;
		
		if(g_fHydration[client] < 0.0)
			g_fHydration[client] = 0.0;
		
		/* Set player speed based on his stamina*/
		
		if(g_fStamina[client] > 75.0)
			SetEntPropFloat(client, Prop_Data, "m_flLaggedMovementValue", 1.1);
		else if(g_fStamina[client] < 1.0)
			SetEntPropFloat(client, Prop_Data, "m_flLaggedMovementValue", 0.7);
		else if(g_fStamina[client] < 15.0)
			SetEntPropFloat(client, Prop_Data, "m_flLaggedMovementValue", 0.8);
		else if(g_fStamina[client] < 35.0)
			SetEntPropFloat(client, Prop_Data, "m_flLaggedMovementValue", 0.9);
		else SetEntPropFloat(client, Prop_Data, "m_flLaggedMovementValue", 1.0);
	}
}

/* Natives */

public Native_GetSaturation(Handle:plugin, numParams)
{
	return RoundToFloor(g_fSaturation[GetNativeCell(1)]);
}

public Native_SetSaturation(Handle:plugin, numParams)
{
	new client = GetNativeCell(1);
	new amount = GetNativeCell(2);
	g_fSaturation[client] = float(amount);
	
	return RoundToFloor(g_fSaturation[client]);
}

public Native_AddSaturation(Handle:plugin, numParams)
{
	new client = GetNativeCell(1);
	new amount = GetNativeCell(2);
	g_fSaturation[client] += float(amount);
	
	if(g_fSaturation[client] > 100.0)
		g_fSaturation[client] = 100.0;
	
	return RoundToFloor(g_fSaturation[client]);
}

public Native_TakeSaturation(Handle:plugin, numParams)
{
	new client = GetNativeCell(1);
	new amount = GetNativeCell(2);
	g_fSaturation[client] -= amount;
	
	if(g_fSaturation[client] < 0.0)
		g_fSaturation[client] = 0.0;
	
	return RoundToFloor(g_fSaturation[client]);
}

public Native_GetStomachContent(Handle:plugin, numParams)
{
	return RoundToFloor(g_fStomachContent[GetNativeCell(1)]);
}

public Native_SetStomachContent(Handle:plugin, numParams)
{
	new client = GetNativeCell(1);
	new amount = GetNativeCell(2);
	
	g_fStomachContent[client] = float(amount);
	
	return RoundToFloor(g_fStomachContent[client]);
}

public Native_AddStomachContent(Handle:plugin, numParams)
{
	new client = GetNativeCell(1);
	new amount = GetNativeCell(2);
	
	g_fStomachContent[client] += amount;
	
	if(g_fStomachContent[client] > 100.0)
		g_fStomachContent[client] = 100.0;
	
	return RoundToFloor(g_fStomachContent[client]);
}

public Native_TakeStomachContent(Handle:plugin, numParams)
{
	new client = GetNativeCell(1);
	new amount = GetNativeCell(2);
	
	g_fStomachContent[client] -= float(amount);
	
	if(g_fStomachContent[client] < 0.0)
		g_fStomachContent[client] = 0.0;
	
	return RoundToFloor(g_fStomachContent[client]);
}

public Native_GetHydration(Handle:plugin, numParams)
{
	return RoundToFloor(g_fHydration[GetNativeCell(1)]);
}

public Native_SetHydration(Handle:plugin, numParams)
{
	new client = GetNativeCell(1);
	new amount = GetNativeCell(2);
	
	g_fHydration[client] = float(amount);
	
	return RoundToFloor(g_fHydration[client]);
}

public Native_AddHydration(Handle:plugin, numParams)
{
	new client = GetNativeCell(1);
	new amount = GetNativeCell(2);
	
	g_fHydration[client] += float(amount);
	
	if(g_fHydration[client] > 100.0)
		g_fHydration[client] = 100.0;
	
	return RoundToFloor(g_fHydration[client]);
}

public Native_TakeHydration(Handle:plugin, numParams)
{
	new client = GetNativeCell(1);
	new amount = GetNativeCell(2);
	
	g_fHydration[client] -= amount;
	
	if(g_fHydration[client] < 0.0)
		g_fHydration[client] = 0.0;
	
	return RoundToFloor(g_fHydration[client]);
}

public Native_GetStamina(Handle:plugin, numParams)
{
	return RoundToFloor(g_fStamina[GetNativeCell(1)]);
}

public Native_SetStamina(Handle:plugin, numParams)
{
	new client = GetNativeCell(1);
	new amount = GetNativeCell(2);
	
	g_fStamina[client] = float(amount);
	
	return RoundToFloor(g_fStamina[client]);
}

public Native_AddStamina(Handle:plugin, numParams)
{
	new client = GetNativeCell(1);
	new amount = GetNativeCell(2);
	
	g_fStamina[client] += float(amount);
	
	if(g_fStamina[client] > 100.0)
		g_fStamina[client] = 100.0;
	
	return RoundToFloor(g_fStamina[client]);
}

public Native_TakeStamina(Handle:plugin, numParams)
{
	new client = GetNativeCell(1);
	new amount = GetNativeCell(2);
	
	g_fStamina[client] -= amount;
	
	if(g_fStamina[client] < 0.0)
		g_fStamina[client] = 0.0;
	
	return RoundToFloor(g_fStamina[client]);
}