#include "roleplay/roleplay"

#define PL_NAME		"RP_HOMES_MANAGER"

#define HOUSE_SEARCH_MIN_CRIME	300
#define DOOR_MIN_RANGE	128.0

new bool:g_LateLoaded;

/* Database */
new Handle:g_hSQL;

new nAccessTeamplate[RP_HomeDoorItems];
new Handle:g_hAccess = INVALID_HANDLE;

new g_iHomeSelection[MAXPLAYERS+1];

public Plugin:myinfo = 
{
	name = PL_NAME,
	author = PL_AUTHOR,
	description = "",
	version = PL_VERSION,
	url = PL_URL
}

public APLRes:AskPluginLoad2(Handle:myself, bool:late, String:error[], err_max)
{
	g_LateLoaded = late;
	RegPluginLibrary(PL_NAME);
	
	CreateNative("RP_GetHomeDoorCount", Native_GetHomeDoorCount);
	CreateNative("RP_GetPlayerAccess", Native_GetPlayerAccess);
	
	return APLRes_Success;
}

public OnPluginStart()
{
	g_hAccess = CreateArray(sizeof(nAccessTeamplate));
	nAccessTeamplate[HomeAccess_HomeID] = 0;
	
	if(g_LateLoaded)
	{
		g_hSQL = Handle:RP_GetSql();
		
		if(g_hSQL != INVALID_HANDLE)
			SQLConnectionReady();
		
		g_LateLoaded = false;
	}
	
	HookEvent("round_start", OnRoundStart);
}

public RP_OnSqlConnected(Handle:db)
{
	g_hSQL = db;
	SQLConnectionReady();
}

public RP_OnSqlStop()
{
	g_hSQL = INVALID_HANDLE;
}

SQLConnectionReady()
{
	decl String:sQuery[2048];
	
	Format(sQuery, sizeof(sQuery), "CREATE TABLE IF NOT EXISTS `rp_home_access` (`homeID` int(10) NOT NULL, `playerID` int(10) NOT NULL, `access` int(10) NOT NULL, PRIMARY KEY (`homeID`)) ENGINE=InnoDB DEFAULT CHARSET=utf8;");
	LogMessage("%s [%s] Query: %s", PL_PRE_N, PL_NAME, sQuery);
	SQL_TQuery(g_hSQL, SQL_CreateTableCallback, sQuery, _, DBPrio_High);
	
	ResetHomes();
	LoadHomes();
}

/* Homes */

LoadHomes()
{
	
	Format(sQuery, sizeof(sQuery), "SELECT `homeID`,`playerID`,`access` FROM `rp_home_access`;");
	SQL_TQuery(g_hSQL, SQL_LoadHomeAccessCallback, sQuery, _, DBPrio_Low);
}

public SQL_LoadHomeAccessCallback(Handle:owner, Handle:hndl, const String:error[], any:data)
{
	if (owner == INVALID_HANDLE || hndl == INVALID_HANDLE)
	{
		LogError("%s [%s] (SQL_LoadHomeAccessCallback) %s", PL_PRE_N, PL_NAME, error);
	}
	
	while (SQL_FetchRow(hndl))
	{
		new nNew[RP_HomeAccess];
		
		nNew[HomeAccess_HomeID] = SQL_FetchInt(hndl, 0);
		nNew[HomeAccess_PlayerID] = SQL_FetchInt(hndl, 1);
		nNew[HomeAccess_Access] = SQL_FetchInt(hndl, 2);
		
		PushArrayArray(g_hAccess, nNew[0]);
	}
}

CheckTargetDoor(client)
{
	
	/*new homeID = IsClientLookingAtHomeDoor(client);
	
	if(homeID <= 0)
	{
		g_iHomeSelection[client] = -1;
		return;
	}
	
	g_iHomeSelection[client] = homeID;*/
	Menu_DoorMain(client);
}

Menu_DoorMain(client)
{
	new homeID = g_iHomeSelection[client];
	new playerID = RP_GetPlayerID(client);
	new access = GetPlayerAccess(playerID, homeID);
	
	new Handle:menu = CreateMenu(MenuHandler_DoorMain);
	SetMenuTitle(menu, "Door Menu for ");
	
	AddMenuItemEx(menu, false, "info", "Home Info");
	
	/* Buy it! */
	if(!RP_IsHomeSold(homeID))
	{
		AddMenuItemEx(menu, false, "buy", "Buy for %d$", RP_GetHomePrice(homeID));
	}
	
	/* You're welcome */
	else if(access != -1)
	{
		/* Guest */
		AddMenuItemEx(menu, false, "open", "Open");
		AddMenuItemEx(menu, false, "close", "Close");
		AddMenuItemEx(menu, false, "lock", "Lock");
		
		/* Confidant */
		if(access <= 4)
			AddMenuItemEx(menu, false, "unlock", "Unlock");
		
		/* Insider */
		if(access <= 3)
			AddMenuItemEx(menu, false, "door", "Door Manager");
		
		/* Supporter */
		if(access <= 2)
			AddMenuItemEx(menu, false, "rent", "Pay Rent");
		
		/* Keeper */
		if(access <= 1)
			AddMenuItemEx(menu, false, "access", "Access Manager");
		
		/* Owner */
		if(access == 0)
			AddMenuItemEx(menu, false, "sell", "Sell Home");
	}
	
	/* Knock knock ... */
	else
	{
		new owner = RP_GetHomePlayerID(homeID);
		new bool:bOnline = RP_GetClient(owner) != -1;
		new bool:bAtHome = false; new todo_check_at_home;
		
		new todo_check_player_at_home;
		
		//...it's the police
		if(RP_IsCop(client))
		{
			if(RP_GetCrime(owner) > HOUSE_SEARCH_MIN_CRIME)
			{
				if(bOnline)
				{
					AddMenuItemEx(menu, false, "house_search", "House Search");
					
					if(bAtHome)
					{
						AddMenuItemEx(menu, false, "flash", "Flash Assault");
						AddMenuItemEx(menu, false, "gas", "Gas Assault");
					}
				}
			}
		}
		/* Break-In */
		else
		{
			AddMenuItemEx(menu, false, "crack", "Door Cracking");
		}
	}
}

public MenuHandler_DoorMain(Handle:menu, MenuAction:action, client, param2)
{
	if(0 >= client > MaxClients)
		return;
	
	if(!IsClientInGame(client))
		return;
	
	if(!IsPlayerAlive(client))
		return;
	
	if (action == MenuAction_Select)
	{
		decl String:info[100], String:info2[100];
		new bool:found = GetMenuItem(menu, param2, info, sizeof(info), _, info2, sizeof(info2));
		
		if(found)
		{
			new homeID = g_iHomeSelection[client];
			
			new todo_fix_fix_this_here;
			new entity = 0;
			
			if(!IsValidEntity(entity))
				return;
			
			/* All */
			if(StrEqual(info, "info"))
			{
				new todo_display_door_info;
			}
			else if(StrEqual(info, "buy"))
			{
				if(RP_IsHomeSold(homeID))
				{
					CPrintToChat(client, "%s  home is already sold.", PL_PRE);
					return;
				}
				
				new todo_buy_home;
			}
			
			/* Owner */
			else if(StrEqual(info, "open"))
			{
				AcceptEntityInput(entity, "open");
			}
			else if(StrEqual(info, "close"))
			{
				AcceptEntityInput(entity, "close");
			}
			else if(StrEqual(info, "lock"))
			{
				AcceptEntityInput(entity, "lock");
				CPrintToChat(client, "%s Door locked.", PL_PRE);
			}
			else if(StrEqual(info, "unlock"))
			{
				AcceptEntityInput(entity, "unlock");
				CPrintToChat(client, "%s Door unlocked.", PL_PRE);
			}
			else if(StrEqual(info, "door"))
			{
				new todo_display_door_mgr;
			}
			else if(StrEqual(info, "access"))
			{
				new todo_display_access_mgr;
			}
			else if(StrEqual(info, "sell"))
			{
				new todo_sell_home;
			}
			
			/* Officer */
			else if(StrEqual(info, "house_search"))
			{
				AcceptEntityInput(entity, "kill");
				CPrintToChat(client, "%s Door kicked.", PL_PRE);
				new todo_balance_cops;
			}
			else if(StrEqual(info, "gas"))
			{
				new todo_gas_assault;
			}
			else if(StrEqual(info, "flash"))
			{
				new todo_flash_assault;
			}
			else if(StrEqual(info, "crack"))
			{
				new todo_display_door_crack_mgr;
			}
		}
	}
}

/*Native_Methods*/

GetPlayerAccess(playerID, homeID)
{
	if(RP_GetHomeIDByPlayerID(playerID) == homeID)
		return 0;
	
	for (new i = 0; i < GetArraySize(g_hAccess); i++)
	{
		new nNew[RP_HomeAccess];
		GetArrayArray(g_hAccess, i, nNew[0]);
		
		if (nNew[HomeAccess_PlayerID] == playerID && nNew[Home_ID] == homeID)
			return nNew[HomeAccess_Access];
	}
	
	return -1;
}

public Native_GetPlayerAccess(Handle:plugin, numParams)
{
	return GetPlayerAccess(GetNativeCell(1), GetNativeCell(2))
}